/* Process model C form file: qos_attribute_definer_drradded.pr.c */
/* Portions of this file copyright 1992-2000 by OPNET, Inc. */



/* This variable carries the header into the object file */
static const char qos_attribute_definer_drradded_pr_c [] = "MIL_3_Tfile_Hdr_ 70B 30A op_runsim 7 3B38E1F6 3B38E1F6 1 luna nalborz 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                       ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include <math.h>
#include <string.h>
#include <opnet.h>
#include "oms_data_def.h"
#include "oms_pr.h"
#include "oms_qm.h"
#include "ip_qos_notif_log_support.h"
#include "ip_notif_log_support.h"
#include "ip_addr_v4.h"
#include "ip_rte_v4.h"
#include "gna_support.h"
#include "rsvp_app_support.h"
#include "rsvp.h"
#include "nato.h"
#include "oms_tan.h"


/* Macros used for RSVP attributes.	*/
#define 		RSVP_DEFAULT_BANDWIDTH		5000;
#define			RSVP_DEFAULT_BUFFER_SIZE	5000;

#define 		RSVP_NUM_DEFAULT_TSPEC		2
#define 		RSVP_DEF_TSPEC				0
#define 		RSVP_SENDER_SPEC_TSPEC		1

/* Internally Callable Procedures */

static void						ip_attr_notification_log_init (void);
static void 					attr_def_fifo_profiles_info_parse (void);
static void 					attr_def_wfq_profiles_info_parse (void);
static void 					attr_def_vc_profiles_info_parse  (void);
static void						arrt_def_drr_profiles_info_parse (void);
static void 					attr_def_priority_queuing_profiles_info_parse (void);
static void 					attr_def_custom_queuing_profiles_info_parse (void);
static void						attr_def_car_profile_parse (char* category_name);
static void						attr_def_red_parameters_get (OmsT_Qm_Attributes* qm_info_ptr, 
										int q_index, Objid queue_configuration_child_objid);
static void						attr_def_classification_scheme_get (OmsT_Qm_Attributes* qm_info_ptr, 
										int q_index, Objid queue_configuration_child_objid);

/* RSVP Functions prototypes.	*/
static void						attr_def_rsvp_tspec_info_parse (void);
static void						attr_def_rsvp_tspec_parse (Objid tspec_entry_objid);
static void						attr_def_rsvp_profile_no_flow_profile_error (char * profile_name);
static void						attr_def_rsvp_tspec_default_parse (void);

static void						attr_def_rsvp_profile_info_parse (void);
static void						attr_def_rsvp_profile_parse (Objid profile_entry_objid);
static GnaT_Rsvp_Flowdescr*		attr_def_rsvp_profile_flowspec_parse (Objid flow_spec_objid, char* profile_name, 
								RsvpT_Style resv_style, Boolean parsing_flowspecs);

static void						gna_attr_definer_error (char* msg1, char* msg2, char* msg3);
static void						attr_def_rsvp_profiles_print (GnaT_Rsvp_Profile_Params * rsvp_profile_ptr);
static void						attr_def_rsvp_sender_descr_print (GnaT_Rsvp_Flowdescr * flowspec_list_ptr);
static void						attr_def_rsvp_sender_print (char * sender_ptr);

static void						attr_def_rsvp_log_init (void);
static void						attr_def_rsvp_profile_num_senders_error (char * profile_name, int row_number, Boolean from_flow_descr, 
										int num_senders, RsvpT_Style resv_style);
static void						attr_def_rsvp_profile_all_senders_error (char * profile_name, int row_number, 
										Boolean from_flow_descr);
static void						attr_def_rsvp_profile_invalid_sender_error (char* sender_name, char* profile_name, 
										int row_number, Boolean from_flow_descr);


/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Objid	                  		my_objid;
	Log_Handle	             		ip_attr_conf_log_handle;
	Log_Handle	             		attr_def_rsvp_error_loghndl;
	} qos_attribute_definer_drradded_state;

#define pr_state_ptr            		((qos_attribute_definer_drradded_state*) SimI_Mod_State_Ptr)
#define my_objid                		pr_state_ptr->my_objid
#define ip_attr_conf_log_handle 		pr_state_ptr->ip_attr_conf_log_handle
#define attr_def_rsvp_error_loghndl		pr_state_ptr->attr_def_rsvp_error_loghndl

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	qos_attribute_definer_drradded_state *op_sv_ptr = pr_state_ptr;


/* Function Block */

enum { _block_origin = __LINE__ };
static void
attr_def_fifo_profiles_info_parse ()
	{
	Objid								queue_configuration_child_objid;
	Objid								queue_configuration_objid, qc_information_objid;
	Objid								queuing_type_objid;
	char								temp_str [256];
	OmsT_Qm_Attributes*					qm_info_ptr;
	int									temp, queuing_type_index, num_queuing_types;
	Objid								red_parameters_objid, red_parameters_child_objid;
	int									max_queue_size;
	
	/** This function parses the information defined in the compound		**/
	/** attribute "FIFO Profiles". It creates instances of the data type	**/
	/** 'QM Information', allocates	memory for the instances and stores the	**/
	/** parsed information into	them. Finally it registers these  			**/
	/** information chunks into attribute database to provide access to		**/
	/** them for the network objects. The OMS data definition sub-package	**/
	/** is used for registering and accessing the QM Information.			**/					
	FIN (attr_def_fifo_profiles_info_parse ());

	/* Get a handle to the compound attribute "FIFO Profiles".	*/
	op_ima_obj_attr_get (my_objid, "FIFO Profiles", &qc_information_objid);

	/* Determine the number of FIFO profiles.	*/
	num_queuing_types = op_topo_child_count (qc_information_objid, OPC_OBJTYPE_GENERIC);

	/* Go over the list, parse each of them and finally register into	*/
	/* network-wide attribute database.									*/
	for (queuing_type_index = 0; queuing_type_index < num_queuing_types; queuing_type_index ++)
		{
		/* Get a handle to the next row.	*/
		queuing_type_objid = op_topo_child (qc_information_objid, OPC_OBJTYPE_GENERIC, queuing_type_index);	

		/* Allocate memory to store the info about the current scheme.	*/	
		qm_info_ptr = (OmsT_Qm_Attributes *) op_prg_mem_alloc (sizeof (OmsT_Qm_Attributes));

		/* Set the maximum number of buffered packets on the interface to zero	*/
		/* since only individual queue sizes matter.							*/
		qm_info_ptr->max_total_no_buf_pkts = 0;

		/* Get the queuing profile name and store it in a char array			*/
		op_ima_obj_attr_get (queuing_type_objid, "Profile Name", temp_str);
		qm_info_ptr->name = (char *) op_prg_mem_alloc ((strlen(temp_str) + 1) * sizeof (char));
		strcpy (qm_info_ptr->name, temp_str);
		
		/* Determine the number of queues.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Details", &(queue_configuration_objid));
		qm_info_ptr->no_queues = 1;	

		/* Allocate memory for the queue. */
		qm_info_ptr->queue_configuration = (OmsT_Qm_Queue_Configuration **) 
				op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration*));
		qm_info_ptr->queue_configuration [0] = (OmsT_Qm_Queue_Configuration *) 
				op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration));

		/* Get a handle to the queue.	*/
		queue_configuration_child_objid = op_topo_child (queue_configuration_objid,
				OPC_OBJTYPE_GENERIC, 0);

		op_ima_obj_attr_get (queue_configuration_child_objid, "Maximum Queue Size", &max_queue_size);

		qm_info_ptr->queue_configuration[0]->max_size = (double) max_queue_size;
		
		/* Initialize fields, which won't be used.	*/
		qm_info_ptr->classification_list_ptr = OPC_NIL;
		qm_info_ptr->queue_configuration[0]->weight = 0.0;
		qm_info_ptr->queue_configuration[0]->byte_count_number = 0;

		/* Get all the RED parameters and store them in the data structure.	*/
		attr_def_red_parameters_get (qm_info_ptr, 0, queue_configuration_child_objid);

		/* Finally register the data into network-wide database by		*/
		/* passing the pointer to the data structure. That makes this	*/
		/* information accesible for all other objects in the network,	*/
		/* whichever needs it; for instance all IP routers.				*/
		oms_data_def_entry_insert ("FIFO Profiles", qm_info_ptr->name, qm_info_ptr); 
		}

	FOUT;
	}

static void
attr_def_wfq_profiles_info_parse ()
	{
	Objid								queue_configuration_child_objid;
	Objid								queue_configuration_objid,qc_information_objid;
	Objid								queuing_type_objid;
	Objid								classification_scheme_objid, classification_scheme_child_objid;
	char								temp_str [256];
	OmsT_Qm_Attributes*					qm_info_ptr;
	int									num_queues, q_index, temp, scheme_index, number_of_schemes;
	int									queuing_type_index, num_queuing_types;
	Objid								red_parameters_objid, red_parameters_child_objid;
	OmsT_Qm_Classification_Criteria*	classify_scheme;
	int									max_queue_size;
	
	/** This function parses the information defined in the compound		**/
	/** attribute "WFQ Profiles". It creates instances of the data type		**/
	/** 'QM Information', allocates	memory for the instances and stores the	**/
	/** parsed information into	them. Finally it registers these  			**/
	/** information chunks into attribute database to provide access to		**/
	/** them for the network objects. The OMS data definition sub-package	**/
	/** is used for registering and accessing the QM Information.			**/							
	FIN (attr_def_wfq_profiles_info_parse ());

	/* Get a handle to the compound attribute "WFQ Profiles".	*/
	op_ima_obj_attr_get (my_objid, "WFQ Profiles", &qc_information_objid);

	/* Determine the number of queuing profiles.	*/
	num_queuing_types = op_topo_child_count (qc_information_objid, OPC_OBJTYPE_GENERIC);

	/* Go over the list, parse each of them and finally register into	*/
	/* network-wide attribute database.									*/
	for (queuing_type_index = 0; queuing_type_index < num_queuing_types; queuing_type_index ++)
		{
		/* Get a handle to the next row.	*/
		queuing_type_objid = op_topo_child (qc_information_objid, OPC_OBJTYPE_GENERIC, queuing_type_index);	

		/* Allocate memory to store the info about the current scheme.	*/	
		qm_info_ptr = (OmsT_Qm_Attributes *) op_prg_mem_alloc (sizeof (OmsT_Qm_Attributes));

		/* Get the queuing profile name.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Profile Name", temp_str);
		qm_info_ptr->name = (char *) op_prg_mem_alloc ((strlen(temp_str) + 1) * sizeof (char));
		strcpy (qm_info_ptr->name, temp_str);
		
		/* Determine the number of queues.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Queues Configuration", &(queue_configuration_objid));
		num_queues = op_topo_child_count (queue_configuration_objid, OPC_OBJTYPE_GENERIC);	
		qm_info_ptr->no_queues = num_queues;	

		/* Allocate memory for all the queues. */
		qm_info_ptr->queue_configuration = (OmsT_Qm_Queue_Configuration **) 
			op_prg_mem_alloc (num_queues * sizeof (OmsT_Qm_Queue_Configuration*));

		/* Allocate memory for each queue. Pointers are used	*/
		/* to allow deltetion and creation of dynamic queues.	*/
		for (q_index = 0; q_index < num_queues; q_index ++)
			{
			qm_info_ptr->queue_configuration [q_index] = (OmsT_Qm_Queue_Configuration *) 
			op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration));
			}

		/* Create a list to store the classification schemes.	*/
		qm_info_ptr->classification_list_ptr = op_prg_list_create ();

		/* Set the maximum number of buffered packet for this interface.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Buffer Capacity", &qm_info_ptr->max_total_no_buf_pkts);
		
		/* Read the information from the attribute and fill the data	*/
		/* structure. Loop through the queues.							*/
		for (q_index = 0; q_index < num_queues; q_index++)
			{
			/* Get a handle to the next row.	*/
			queue_configuration_child_objid = op_topo_child (queue_configuration_objid,
				 OPC_OBJTYPE_GENERIC, q_index);
            
			/* Get all the attributes of the WFQ information row	*/
			/* and store them in the data structure.				*/
			
			op_ima_obj_attr_get (queue_configuration_child_objid, "Weight", 
				&(qm_info_ptr->queue_configuration[q_index]->weight));
			op_ima_obj_attr_get (queue_configuration_child_objid, "Maximum Queue Size", &max_queue_size);
			
			qm_info_ptr->queue_configuration[q_index]->max_size = (double) max_queue_size;
			
			qm_info_ptr->queue_configuration[q_index]->byte_count_number = 0;

			/* Get all the RED parameters and store them in the data structure.	*/
			attr_def_red_parameters_get (qm_info_ptr, q_index, queue_configuration_child_objid);

			/* Get all the classification criteria for this queue.	*/
			attr_def_classification_scheme_get (qm_info_ptr, q_index, queue_configuration_child_objid);
			}

		/* Finally register the data into network-wide database by		*/
		/* passing the pointer to the data structure. That makes this	*/
		/* information accesible for all other objects in the network,	*/
		/* whichever needs it; for instance all IP routers.				*/
		oms_data_def_entry_insert ("WFQ Profiles", qm_info_ptr->name, qm_info_ptr); 
		}

	FOUT;
	}





static void
attr_def_vc_profiles_info_parse ()
	{
	Objid								queue_configuration_child_objid;
	Objid								queue_configuration_objid,qc_information_objid;
	Objid								queuing_type_objid;
	Objid								classification_scheme_objid, classification_scheme_child_objid;
	char								temp_str [256];
	OmsT_Qm_Attributes*					qm_info_ptr;
	int									num_queues, q_index, temp, scheme_index, number_of_schemes;
	int									queuing_type_index, num_queuing_types;
	Objid								red_parameters_objid, red_parameters_child_objid;
	OmsT_Qm_Classification_Criteria*	classify_scheme;
	int									max_queue_size;
	
	/** This function parses the information defined in the compound		**/
	/** attribute "VC Profiles". It creates instances of the data type		**/
	/** 'QM Information', allocates	memory for the instances and stores the	**/
	/** parsed information into	them. Finally it registers these  			**/
	/** information chunks into attribute database to provide access to		**/
	/** them for the network objects. The OMS data definition sub-package	**/
	/** is used for registering and accessing the QM Information.			**/							
	FIN (attr_def_vc_profiles_info_parse ());

	/* Get a handle to the compound attribute "VC Profiles".	*/
	op_ima_obj_attr_get (my_objid, "VC Profiles", &qc_information_objid);

	/* Determine the number of queuing profiles.	*/
	num_queuing_types = op_topo_child_count (qc_information_objid, OPC_OBJTYPE_GENERIC);

	/* Go over the list, parse each of them and finally register into	*/
	/* network-wide attribute database.									*/
	for (queuing_type_index = 0; queuing_type_index < num_queuing_types; queuing_type_index ++)
		{
		/* Get a handle to the next row.	*/
		queuing_type_objid = op_topo_child (qc_information_objid, OPC_OBJTYPE_GENERIC, queuing_type_index);	

		/* Allocate memory to store the info about the current scheme.	*/	
		qm_info_ptr = (OmsT_Qm_Attributes *) op_prg_mem_alloc (sizeof (OmsT_Qm_Attributes));

		/* Get the queuing profile name.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Profile Name", temp_str);
		qm_info_ptr->name = (char *) op_prg_mem_alloc ((strlen(temp_str) + 1) * sizeof (char));
		strcpy (qm_info_ptr->name, temp_str);
		
		/* Determine the number of queues.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Queues Configuration", &(queue_configuration_objid));
		num_queues = op_topo_child_count (queue_configuration_objid, OPC_OBJTYPE_GENERIC);	
		qm_info_ptr->no_queues = num_queues;	

		/* Allocate memory for all the queues. */
		qm_info_ptr->queue_configuration = (OmsT_Qm_Queue_Configuration **) 
			op_prg_mem_alloc (num_queues * sizeof (OmsT_Qm_Queue_Configuration*));

		/* Allocate memory for each queue. Pointers are used	*/
		/* to allow deltetion and creation of dynamic queues.	*/
		for (q_index = 0; q_index < num_queues; q_index ++)
			{
			qm_info_ptr->queue_configuration [q_index] = (OmsT_Qm_Queue_Configuration *) 
			op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration));
			}

		/* Create a list to store the classification schemes.	*/
		qm_info_ptr->classification_list_ptr = op_prg_list_create ();

		/* Set the maximum number of buffered packet for this interface.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Buffer Capacity", &qm_info_ptr->max_total_no_buf_pkts);
		
		/* Read the information from the attribute and fill the data	*/
		/* structure. Loop through the queues.							*/
		for (q_index = 0; q_index < num_queues; q_index++)
			{
			/* Get a handle to the next row.	*/
			queue_configuration_child_objid = op_topo_child (queue_configuration_objid,
				 OPC_OBJTYPE_GENERIC, q_index);
            
			/* Get all the attributes of the VC information row	*/
			/* and store them in the data structure.				*/
			
			op_ima_obj_attr_get (queue_configuration_child_objid, "Arrival Rate", 
				&(qm_info_ptr->queue_configuration[q_index]->arrival_rate));
			op_ima_obj_attr_get (queue_configuration_child_objid, "Maximum Queue Size", &max_queue_size);
			
			qm_info_ptr->queue_configuration[q_index]->max_size = (double) max_queue_size;
			
			qm_info_ptr->queue_configuration[q_index]->byte_count_number = 0;

			/* Get all the RED parameters and store them in the data structure.	*/
			attr_def_red_parameters_get (qm_info_ptr, q_index, queue_configuration_child_objid);

			/* Get all the classification criteria for this queue.	*/
			attr_def_classification_scheme_get (qm_info_ptr, q_index, queue_configuration_child_objid);
			}

		/* Finally register the data into network-wide database by		*/
		/* passing the pointer to the data structure. That makes this	*/
		/* information accesible for all other objects in the network,	*/
		/* whichever needs it; for instance all IP routers.				*/
		oms_data_def_entry_insert ("VC Profiles", qm_info_ptr->name, qm_info_ptr); 
		}

	FOUT;
	}


static void
attr_def_drr_profiles_info_parse ()
	{
	Objid								queue_configuration_child_objid;
	Objid								queue_configuration_objid,qc_information_objid;
	Objid								queuing_type_objid;
	Objid								classification_scheme_objid, classification_scheme_child_objid;
	char								temp_str [256];
	OmsT_Qm_Attributes*					qm_info_ptr;
	int									num_queues, q_index, temp, scheme_index, number_of_schemes;
	int									queuing_type_index, num_queuing_types;
	Objid								red_parameters_objid, red_parameters_child_objid;
	OmsT_Qm_Classification_Criteria*	classify_scheme;
	int									max_queue_size;
	
	/** This function parses the information defined in the compound		**/
	/** attribute "DRR Profiles". It creates instances of the data type		**/
	/** 'QM Information', allocates	memory for the instances and stores the	**/
	/** parsed information into	them. Finally it registers these  			**/
	/** information chunks into attribute database to provide access to		**/
	/** them for the network objects. The OMS data definition sub-package	**/
	/** is used for registering and accessing the QM Information.			**/							
	FIN (attr_def_drr_profiles_info_parse ());

	/* Get a handle to the compound attribute "DRR Profiles".	*/
	op_ima_obj_attr_get (my_objid, "DRR Profiles", &qc_information_objid);

	/* Determine the number of queuing profiles.	*/
	num_queuing_types = op_topo_child_count (qc_information_objid, OPC_OBJTYPE_GENERIC);

	/* Go over the list, parse each of them and finally register into	*/
	/* network-wide attribute database.									*/
	for (queuing_type_index = 0; queuing_type_index < num_queuing_types; queuing_type_index ++)
		{
		/* Get a handle to the next row.	*/
		queuing_type_objid = op_topo_child (qc_information_objid, OPC_OBJTYPE_GENERIC, queuing_type_index);	

		/* Allocate memory to store the info about the current scheme.	*/	
		qm_info_ptr = (OmsT_Qm_Attributes *) op_prg_mem_alloc (sizeof (OmsT_Qm_Attributes));

		/* Get the queuing profile name.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Profile Name", temp_str);
		qm_info_ptr->name = (char *) op_prg_mem_alloc ((strlen(temp_str) + 1) * sizeof (char));
		strcpy (qm_info_ptr->name, temp_str);
		
		/* Determine the number of queues.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Queues Configuration", &(queue_configuration_objid));
		num_queues = op_topo_child_count (queue_configuration_objid, OPC_OBJTYPE_GENERIC);	
		qm_info_ptr->no_queues = num_queues;	

		/* Allocate memory for all the queues. */
		qm_info_ptr->queue_configuration = (OmsT_Qm_Queue_Configuration **) 
			op_prg_mem_alloc (num_queues * sizeof (OmsT_Qm_Queue_Configuration*));

		/* Allocate memory for each queue. Pointers are used	*/
		/* to allow deltetion and creation of dynamic queues.	*/
		for (q_index = 0; q_index < num_queues; q_index ++)
			{
			qm_info_ptr->queue_configuration [q_index] = (OmsT_Qm_Queue_Configuration *) 
			op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration));
			}

		/* Create a list to store the classification schemes.	*/
		qm_info_ptr->classification_list_ptr = op_prg_list_create ();

		/* Set the maximum number of buffered packet for this interface.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Buffer Capacity", &qm_info_ptr->max_total_no_buf_pkts);
		
		/* Read the information from the attribute and fill the data	*/
		/* structure. Loop through the queues.							*/
		for (q_index = 0; q_index < num_queues; q_index++)
			{
			/* Get a handle to the next row.	*/
			queue_configuration_child_objid = op_topo_child (queue_configuration_objid,
				 OPC_OBJTYPE_GENERIC, q_index);
            
			/* Get all the attributes of the DRR information row	*/
			/* and store them in the data structure.				*/
			
			op_ima_obj_attr_get (queue_configuration_child_objid, "Quantum", 
				&(qm_info_ptr->queue_configuration[q_index]->quantum));
			op_ima_obj_attr_get (queue_configuration_child_objid, "Maximum Queue Size", &max_queue_size);
			
			qm_info_ptr->queue_configuration[q_index]->max_size = (double) max_queue_size;
			
			qm_info_ptr->queue_configuration[q_index]->byte_count_number = 0;

			/* Get all the RED parameters and store them in the data structure.	*/
			attr_def_red_parameters_get (qm_info_ptr, q_index, queue_configuration_child_objid);

			/* Get all the classification criteria for this queue.	*/
			attr_def_classification_scheme_get (qm_info_ptr, q_index, queue_configuration_child_objid);
			}

		/* Finally register the data into network-wide database by		*/
		/* passing the pointer to the data structure. That makes this	*/
		/* information accesible for all other objects in the network,	*/
		/* whichever needs it; for instance all IP routers.				*/
		oms_data_def_entry_insert ("DRR Profiles", qm_info_ptr->name, qm_info_ptr); 
		}

	FOUT;
	}






static void
attr_def_priority_queuing_profiles_info_parse ()
	{
	Objid								queue_configuration_child_objid;
	Objid								queue_configuration_objid,qc_information_objid;
	Objid								queuing_type_objid;
	Objid								classification_scheme_objid, classification_scheme_child_objid;
	char								temp_str [256];
	OmsT_Qm_Attributes*					qm_info_ptr;
	int									num_queues, q_index, temp, scheme_index, number_of_schemes;
	int									queuing_type_index, num_queuing_types;
	Objid								red_parameters_objid, red_parameters_child_objid;
	OmsT_Qm_Classification_Criteria*	classify_scheme;
	int									max_queue_size;
	
	/** This function parses the information defined in the compound			**/
	/** attribute "Priority Queuing Profiles". It creates instances of the		**/
	/** data type QM Information', allocates memory for the instances and		**/
	/** stores the parsed information into	them. Finally it registers			**/
	/** these information chunks into attribute database to provide access		**/
	/** to them for the network objects. The OMS data definition sub-package	**/
	/** is used for registering and accessing the QM Information.				**/					
	FIN (attr_def_priority_queuing_profiles_info_parse ());

	/* Get a handle to the compound attribute "Priority Queuing Profiles".	*/
	op_ima_obj_attr_get (my_objid, "Priority Queuing Profiles", &qc_information_objid);

	/* Determine the number of queuing schemes.	*/
	num_queuing_types = op_topo_child_count (qc_information_objid, OPC_OBJTYPE_GENERIC);

	/* Go over the list, parse each of them and finally register into	*/
	/* network-wide attribute database.									*/
	for (queuing_type_index = 0; queuing_type_index < num_queuing_types; queuing_type_index ++)
		{
		/* Get a handle to the next row.	*/
		queuing_type_objid = op_topo_child (qc_information_objid, OPC_OBJTYPE_GENERIC, queuing_type_index);	

		/* Allocate memory to store the info about the current scheme.	*/	
		qm_info_ptr = (OmsT_Qm_Attributes *) op_prg_mem_alloc (sizeof (OmsT_Qm_Attributes));

		/* Set the maximum number of buffered packets on the interface to zero	*/
		/* since only individual queue sizes matter.							*/
		qm_info_ptr->max_total_no_buf_pkts = 0;

		/* Get the queuing profile name.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Profile Name", temp_str);
		qm_info_ptr->name = (char *) op_prg_mem_alloc ((strlen(temp_str) + 1) * sizeof (char));
		strcpy (qm_info_ptr->name, temp_str);
		
		/* Determine the number of queues.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Details", &(queue_configuration_objid));
		num_queues = op_topo_child_count (queue_configuration_objid, OPC_OBJTYPE_GENERIC);	
		qm_info_ptr->no_queues = num_queues;	

		/* Allocate memory for all the queues */
		qm_info_ptr->queue_configuration = (OmsT_Qm_Queue_Configuration **) 
			op_prg_mem_alloc (num_queues * sizeof (OmsT_Qm_Queue_Configuration *));

		/* Allocate memory for each queue. Pointers are used	*/
		/* to allow deltetion and creation of dynamic queues.	*/
		for (q_index = 0; q_index < num_queues; q_index ++)
			{
			qm_info_ptr->queue_configuration [q_index] = (OmsT_Qm_Queue_Configuration *) 
			op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration));
			}

		/* Create a list to store the classification schemes.	*/
		qm_info_ptr->classification_list_ptr = op_prg_list_create ();
		
		/* Read the information from the attribute and fill the data	*/
		/* structure. Loop through the queues.							*/
		for (q_index = 0; q_index < num_queues; q_index++)
			{
			/* Get a handle to the next row.	*/
			queue_configuration_child_objid = op_topo_child (queue_configuration_objid,
				 OPC_OBJTYPE_GENERIC, q_index);
            
			/* Get all the attributes of the queuing information row	*/
			/* and store them in the data structure.					*/
			
			qm_info_ptr->queue_configuration[q_index]->weight = 0.0;
			qm_info_ptr->queue_configuration[q_index]->byte_count_number = 0;
			op_ima_obj_attr_get (queue_configuration_child_objid, "Maximum Queue Size",
				&max_queue_size);

			qm_info_ptr->queue_configuration[q_index]->max_size = (double) max_queue_size;
			
			/* Get all the RED parameters and store them in the data structure.	*/
			attr_def_red_parameters_get (qm_info_ptr, q_index, queue_configuration_child_objid);

			/* Get all the classification criteria for this queue.	*/
			attr_def_classification_scheme_get (qm_info_ptr, q_index, queue_configuration_child_objid);
			}

		/* Finally register the data into network-wide database by		*/
		/* passing the pointer to the data structure. That makes this	*/
		/* information accesible for all other objects in the network,	*/
		/* whichever needs it; for instance all IP routers.				*/
		oms_data_def_entry_insert ("Priority Queuing Profiles", qm_info_ptr->name, qm_info_ptr); 
		}

	FOUT;
	}




static void
attr_def_custom_queuing_profiles_info_parse ()
	{
	Objid								queue_configuration_child_objid;
	Objid								queue_configuration_objid,qc_information_objid;
	Objid								queuing_type_objid;
	Objid								classification_scheme_objid, classification_scheme_child_objid;
	char								temp_str [256];
	OmsT_Qm_Attributes*					qm_info_ptr;
	int									num_queues, q_index, temp, scheme_index, number_of_schemes;
	int									queuing_type_index, num_queuing_types;
	Objid								red_parameters_objid, red_parameters_child_objid;
	OmsT_Qm_Classification_Criteria*	classify_scheme;
	int									max_queue_size;
	
	/** This function parses the information defined in the compound			**/
	/** attribute "Custom Queuing Profiles". It creates instances of the		**/
	/** data type QM Information', allocates memory for the instances and		**/
	/** stores the parsed information into	them. Finally it registers			**/
	/** these information chunks into attribute database to provide access		**/
	/** to them for the network objects. The OMS data definition sub-package	**/
	/** is used for registering and accessing the QM Information.				**/							
	FIN (attr_def_custom_queuing_profiles_info_parse ());

	/* Get a handle to the compound attribute "Custom Queuing Profiles".	*/
	op_ima_obj_attr_get (my_objid, "Custom Queuing Profiles", &qc_information_objid);

	/* Determine the number of queuing schemes.	*/
	num_queuing_types = op_topo_child_count (qc_information_objid, OPC_OBJTYPE_GENERIC);

	/* Go over the list, parse each of them and finally register into	*/
	/* network-wide attribute database.									*/
	for (queuing_type_index = 0; queuing_type_index < num_queuing_types; queuing_type_index ++)
		{
		/* Get a handle to the next row.	*/
		queuing_type_objid = op_topo_child (qc_information_objid, OPC_OBJTYPE_GENERIC, queuing_type_index);	

		/* Allocate memory to store the info about the current scheme.	*/	
		qm_info_ptr = (OmsT_Qm_Attributes *) op_prg_mem_alloc (sizeof (OmsT_Qm_Attributes));

		/* Set the maximum number of buffered packets on the interface to zero	*/
		/* since only individual queue sizes matter.							*/
		qm_info_ptr->max_total_no_buf_pkts = 0;

		/* Get the queuing profile name.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Profile Name", temp_str);
		qm_info_ptr->name = (char *) op_prg_mem_alloc ((strlen(temp_str) + 1) * sizeof (char));
		strcpy (qm_info_ptr->name, temp_str);
		
		/* Determine the number of queues.	*/
		op_ima_obj_attr_get (queuing_type_objid, "Details", &(queue_configuration_objid));
		num_queues = op_topo_child_count (queue_configuration_objid, OPC_OBJTYPE_GENERIC);	
		qm_info_ptr->no_queues = num_queues;	

		/* Allocate memory for all the queues */
		qm_info_ptr->queue_configuration = (OmsT_Qm_Queue_Configuration **) 
			op_prg_mem_alloc (num_queues * sizeof (OmsT_Qm_Queue_Configuration *));

		/* Allocate memory for each queue. Pointers are used	*/
		/* to allow deltetion and creation of dynamic queues.	*/
		for (q_index = 0; q_index < num_queues; q_index ++)
			{
			qm_info_ptr->queue_configuration [q_index] = (OmsT_Qm_Queue_Configuration *) 
			op_prg_mem_alloc (sizeof (OmsT_Qm_Queue_Configuration));
			}

		/* Create a list to store the classification schemes.	*/
		qm_info_ptr->classification_list_ptr = op_prg_list_create ();
		
		/* Read the information from the attribute and fill the data	*/
		/* structure. Loop through the queues.							*/
		for (q_index = 0; q_index < num_queues; q_index++)
			{
			/* Get a handle to the next row.	*/
			queue_configuration_child_objid = op_topo_child (queue_configuration_objid,
				 OPC_OBJTYPE_GENERIC, q_index);
            
			/* Get all the attributes of the queuing information row	*/
			/* and store them in the data structure.					*/
			
			qm_info_ptr->queue_configuration[q_index]->weight = 0.0;
			op_ima_obj_attr_get (queue_configuration_child_objid, "Byte Count", 
				&(qm_info_ptr->queue_configuration[q_index]->byte_count_number));
			op_ima_obj_attr_get (queue_configuration_child_objid, "Maximum Queue Size",
				&max_queue_size);

			qm_info_ptr->queue_configuration[q_index]->max_size = (double) max_queue_size;
			
			/* Get all the RED parameters and store them in the data structure.	*/
			attr_def_red_parameters_get (qm_info_ptr, q_index, queue_configuration_child_objid);

			/* Get all the classification criteria for this queue.	*/
			attr_def_classification_scheme_get (qm_info_ptr, q_index, queue_configuration_child_objid);
			}

		/* Finally register the data into network-wide database by		*/
		/* passing the pointer to the data structure. That makes this	*/
		/* information accesible for all other objects in the network,	*/
		/* whichever needs it; for instance all IP routers.				*/
		oms_data_def_entry_insert ("Custom Queuing Profiles", qm_info_ptr->name, qm_info_ptr); 
		}

	FOUT;
	}

static void
attr_def_red_parameters_get (OmsT_Qm_Attributes* qm_info_ptr, int q_index, Objid queue_configuration_child_objid)
	{
	Objid		red_parameters_objid, red_parameters_child_objid;

	/** Get all the RED parameters and store them in the data structure.	**/
	/** Writes a simulation log if the minimum threshold is superior to the	**/
	/** maximum threshold and set default values.							**/
	FIN (attr_def_red_parameters_get (qm_info_ptr, queue_configuration_child_objid))

	/* Get the RED attribute object identifier.	*/
	op_ima_obj_attr_get (queue_configuration_child_objid, "RED Parameters", 
		&red_parameters_objid);

	red_parameters_child_objid = op_topo_child (red_parameters_objid,
		 OPC_OBJTYPE_GENERIC, 0);

	/* Get all the parameters.	*/
	op_ima_obj_attr_get (red_parameters_child_objid, "RED Status", 
		&(qm_info_ptr->queue_configuration[q_index]->red_status));

	op_ima_obj_attr_get (red_parameters_child_objid, "Exponential Weight Factor", 
		&(qm_info_ptr->queue_configuration[q_index]->exponential_weight_factor));

	op_ima_obj_attr_get (red_parameters_child_objid, "Minimum Threshold", 
		&(qm_info_ptr->queue_configuration[q_index]->minimum_threshold));

	op_ima_obj_attr_get (red_parameters_child_objid, "Maximum Threshold", 
		&(qm_info_ptr->queue_configuration[q_index]->maximum_threshold));

	op_ima_obj_attr_get (red_parameters_child_objid, "Mark Probability Denominator", 
		&(qm_info_ptr->queue_configuration[q_index]->mark_probability_denominator));

	/* Check whether the maximum threshold is superior to the minimum threshold.	*/
	if (qm_info_ptr->queue_configuration[q_index]->maximum_threshold < qm_info_ptr->queue_configuration[q_index]->minimum_threshold)
		{
		/* Set the threshold to default values.	*/
		qm_info_ptr->queue_configuration[q_index]->maximum_threshold = 200;
		qm_info_ptr->queue_configuration[q_index]->minimum_threshold = 100;
	
		/* Write a simulation notification to tell that the	*/
		/* RED thresholds have been set to default values.	*/
		rednl_confwarn_threshold_misconfiguration (qm_info_ptr->name);
		}

	FOUT;
	}

static void
attr_def_classification_scheme_get (OmsT_Qm_Attributes* qm_info_ptr, int q_index, Objid queue_configuration_child_objid)
	{
	Objid									classification_scheme_objid, classification_scheme_child_objid;
	int										number_of_schemes, scheme_index;
	OmsT_Qm_Classification_Criteria *		classify_scheme;
	char									temp_str [256];

	/** Get classification schemes for one queue. A classification			**/
	/** scheme includes a set of criteria to assign a incoming packet to	**/
	/** this queue. A queue can have one or more classification schemes.	**/
	FIN (attr_def_classification_scheme_get (qm_info_ptr, q_index, queue_configuration_child_objid));

	/* Get the classification criteria.	*/
	op_ima_obj_attr_get (queue_configuration_child_objid, "Classification Scheme",
			&(classification_scheme_objid));

	/* Get the number of different criteria for each class.	*/
	number_of_schemes = op_topo_child_count (classification_scheme_objid, OPC_OBJTYPE_GENERIC);

	/* Loop through all the classification schemes in each queue.	*/
	for (scheme_index = 0; scheme_index < number_of_schemes; scheme_index ++)
		{
		/* Access a classification scheme for this queue.	*/
		classification_scheme_child_objid = op_topo_child (classification_scheme_objid,
		 		OPC_OBJTYPE_GENERIC, scheme_index);

		/* Allocate memory for all the criteria available for this queue.	*/
		classify_scheme = (OmsT_Qm_Classification_Criteria *) op_prg_mem_alloc (sizeof (OmsT_Qm_Classification_Criteria));

		/* Get the protocol criterion.	*/
		op_ima_obj_attr_get (classification_scheme_child_objid, "Protocol", 
				&(classify_scheme->protocol));

		/* Get the TOS criterion.	*/
		op_ima_obj_attr_get (classification_scheme_child_objid, "ToS", 
				&(classify_scheme->tos));

		/* Get the source address criterion.	*/
		op_ima_obj_attr_get (classification_scheme_child_objid, "Source Address", temp_str);
		
		/* Convert the string into IpT_Address type.	*/
		classify_scheme->source_address = ip_address_create (temp_str);

		/* Get the destination address criterion.	*/
		op_ima_obj_attr_get (classification_scheme_child_objid, "Destination Address", temp_str);

		/* Convert the string into IpT_Address type.	*/
		classify_scheme->dest_address = ip_address_create (temp_str);			

		/* Get the source port criterion.	*/
		op_ima_obj_attr_get (classification_scheme_child_objid, "Source Port", 
				&(classify_scheme->source_port));

		/* Get the destination port criterion.	*/
		op_ima_obj_attr_get (classification_scheme_child_objid, "Destination Port", 
				&(classify_scheme->dest_port));

		/* Get the incoming interface criterion.	*/
		op_ima_obj_attr_get (classification_scheme_child_objid, "Incoming Interface", 
				&(classify_scheme->incoming_iface));

		/* Register the queue index for this set of criteria.	*/
		classify_scheme->queue_id = q_index;

		/* Insert this set of criteria with the queue id in a list.	*/
		/* This list contains all the information to enqueue a 		*/
		/* packet in a specific queue. If there is no match in this	*/
		/* list the packet will be put in the default queue.		*/
		op_prg_list_insert (qm_info_ptr->classification_list_ptr, classify_scheme, OPC_LISTPOS_TAIL);
		}

	FOUT;
	}

static void
attr_def_car_profile_parse (char * category_name)
	{
	Objid					car_profiles_objid, car_profiles_child_objid, profile_objid, profile_child_objid;
	Objid					cos_definition_child_objid, cos_definition_objid, rate_limit_child_objid, rate_limit_objid;
	Objid					conforming_traffic_policy_child_objid, conforming_traffic_policy_objid;
	Objid					exceeding_traffic_policy_objid, exceeding_traffic_policy_child_objid;
	int						car_profile_index, num_car_profiles, num_cos, cos_index;
	OmsT_Qm_Car_Profile*	profile_ptr;
	char					temp_str [256];

	/** This function parses the information defined in the compound	  **/
	/** attribute "CAR Profiles". It creates instances of the data 		  **/
	/** structure 'QM Information', allocates memory for the instances	  **/
	/** and stores the parsed information into them. Finally it registers **/
	/** these  information chunks into attribute database to provide	  **/
	/** access to them for the network objects. The registration to the	  **/
	/** database is done by passing data structure pointers to the		  **/
	/** database to be stored under certain	category and entry names.     **/							
	FIN (attr_def_car_profile_parse (category_name));

	/* Get a handle to the compound attribute CAR Profiles.	*/
	op_ima_obj_attr_get (my_objid, "CAR Profiles", &car_profiles_objid);

	/* Determine the number of CAR Profiles.	*/
	num_car_profiles = op_topo_child_count (car_profiles_objid, OPC_OBJTYPE_GENERIC);

	/* Go over the list, parse each of them and finally register into	*/
	/* network-wide attribute database.									*/
	for (car_profile_index = 0; car_profile_index < num_car_profiles; car_profile_index ++)
		{
		/* Get a handle to the next row.	*/
		car_profiles_child_objid = op_topo_child (car_profiles_objid, OPC_OBJTYPE_GENERIC, car_profile_index);	

		/* Allocate memory to store the info about the current profile.	*/	
		profile_ptr = (OmsT_Qm_Car_Profile *) op_prg_mem_alloc (sizeof (OmsT_Qm_Car_Profile));

		/* Read the information from the attribute and fill the data structure	*/

		/* Get the profile name.	*/
		op_ima_obj_attr_get (car_profiles_child_objid, "Profile Name", temp_str);
		profile_ptr->name = (char *) op_prg_mem_alloc ((strlen(temp_str) + 1) * sizeof (char));
		strcpy (profile_ptr->name, temp_str);

		/* Get the profile.	*/
		op_ima_obj_attr_get (car_profiles_child_objid, "Details", &profile_objid);

		/* Determine the number of COS.	*/
		num_cos = op_topo_child_count (profile_objid, OPC_OBJTYPE_GENERIC);	
		profile_ptr->number_of_cos = num_cos;

		/* Set the CAR profile status to Enabled. If an IP router calls	*/
		/* this profile, it means that CAR will be enabled on the		*/
		/* corresponding interface.										*/
		profile_ptr->car_status = OPC_TRUE;

		/* Allocate memory for all the COS */
		profile_ptr->cos_definition = (OmsT_Qm_Cos_Definition *) op_prg_mem_alloc (num_cos * sizeof (OmsT_Qm_Cos_Definition));

		/* Read the information from the attribute and fill the data	*/
		/* structure.													*/
		for (cos_index = 0; cos_index < num_cos; cos_index++)
			{
			/* Get a handle to the next row.	*/
			profile_child_objid = op_topo_child (profile_objid, OPC_OBJTYPE_GENERIC, cos_index);

			/* Get the COS definition. A COS (Class of Service) is a set of criteria	*/
			/* to define a class for which a traffic contract is defined.				*/            
			op_ima_obj_attr_get (profile_child_objid, "COS Definition", &(cos_definition_objid));
			cos_definition_child_objid = op_topo_child (cos_definition_objid, OPC_OBJTYPE_GENERIC, 0);
			op_ima_obj_attr_get (cos_definition_child_objid, "TOS", &(profile_ptr->cos_definition[cos_index].tos));
			op_ima_obj_attr_get (cos_definition_child_objid, "Application Type", &(profile_ptr->cos_definition[cos_index].application_type));
			op_ima_obj_attr_get (cos_definition_child_objid, "Incoming Port", &(profile_ptr->cos_definition[cos_index].incoming_port));

			/* Get the rate limit for this COS.	*/
			op_ima_obj_attr_get (profile_child_objid, "Rate Limit", &(rate_limit_objid));
			rate_limit_child_objid = op_topo_child (rate_limit_objid, OPC_OBJTYPE_GENERIC, 0);
			op_ima_obj_attr_get (rate_limit_child_objid, "Average Rate", &(profile_ptr->cos_definition[cos_index].average_rate));
			op_ima_obj_attr_get (rate_limit_child_objid, "Normal Burst Size", &(profile_ptr->cos_definition[cos_index].normal_burst_size));
			op_ima_obj_attr_get (rate_limit_child_objid, "Excess Burst Size", &(profile_ptr->cos_definition[cos_index].excess_burst_size));

			/* Get the policy related to conforming traffic (IP precedence setting, action).	*/
			op_ima_obj_attr_get (profile_child_objid, "Conforming Traffic Policy", &(conforming_traffic_policy_objid));
			conforming_traffic_policy_child_objid = op_topo_child (conforming_traffic_policy_objid, OPC_OBJTYPE_GENERIC, 0);
			op_ima_obj_attr_get (conforming_traffic_policy_child_objid, "Set Precedence", &(profile_ptr->cos_definition[cos_index].conform_precedence));
			op_ima_obj_attr_get (conforming_traffic_policy_child_objid, "Action", &(profile_ptr->cos_definition[cos_index].conform_action));

			/* Get the policy related to exceeding traffic (IP precedence setting, action).	*/			
			op_ima_obj_attr_get (profile_child_objid, "Exceeding Traffic Policy", &(exceeding_traffic_policy_objid));
			exceeding_traffic_policy_child_objid = op_topo_child (exceeding_traffic_policy_objid, OPC_OBJTYPE_GENERIC, 0);
			op_ima_obj_attr_get (exceeding_traffic_policy_child_objid, "Set Precedence", &(profile_ptr->cos_definition[cos_index].excess_precedence));
			op_ima_obj_attr_get (exceeding_traffic_policy_child_objid, "Action", &(profile_ptr->cos_definition[cos_index].excess_action));		
			}

		/* Finally register the data into network-wide database by		*/
		/* passing the pointer to the data structure. That makes this	*/
		/* information accessible for all other objects in the network,	*/
		/* whichever needs it; for instance all IP routers.				*/
		oms_data_def_entry_insert ("CAR Profiles", profile_ptr->name, profile_ptr); 
		}

	FOUT;
	}


static void
ip_attr_notification_log_init (void)
    {
    int				ip_attr_conf_log_limit    = 64;
    static Boolean	ip_attr_notif_log_initialized = OPC_FALSE;

    /**	Initializes handles used for simulation notification	**/
    /**	logging.  Creates a log handle for each distinct tuple	**/
    /**	(i.e., <Category, Class, Subclass>) -- these handles	**/
    /**	are later used by other functions to log messages.		**/
    FIN (ip_attr_notification_log_init ());

    /*	Create log handles if not already created.				*/
    if (ip_attr_notif_log_initialized == OPC_FALSE)
		{
		/* Set flag to prevent re-initialization.				*/
		ip_attr_notif_log_initialized = OPC_TRUE;

		/* If present, obtain the values set for the maximum	*/
		/* number of log entries on a per "category" basis.		*/
		if (op_ima_sim_attr_exists (IPC_CONF_LOG_LIMIT))
			op_ima_sim_attr_get (OPC_IMA_INTEGER, IPC_CONF_LOG_LIMIT, &ip_attr_conf_log_limit);

		/* Configuration related notification handles.			*/
		ip_attr_conf_log_handle = op_prg_log_handle_create (OpC_Log_Category_Configuration, 
	    							"IP", "Setup", ip_attr_conf_log_limit);
		}

    FOUT;
    }

/**		RSVP-specific functions    **/

static void
attr_def_rsvp_tspec_info_parse (void)
	{
	Objid						tspec_objid, tspec_entry_objid;
	int							num_tspec, tspec_index;
	char						tspec_name [32];

	/** This function parses the information defined in the compound	  	**/
	/** attribute "RSVP Traffic Spec". It creates instances of the data  	**/
	/** structure 'GnaT_Rsvp_Profile_Tspec', allocates memory for the   	**/
	/** instances and stores the parsed information. Finally it registers**/
	/** these  information into attribute database to provide access to 	**/
	/** them for the network objects. The registration  to the database is**/
	/** done by passing	data structure pointers to the  database to be  	**/
	/** stored under certain category and entry names.     					**/	
	FIN (attr_def_rsvp_tspec_info_parse (void));

	/* Get a handle to the compound attribute RSVP Profiles.	*/
	op_ima_obj_attr_get (my_objid, "RSVP Flow Specification", &tspec_objid);

    /* Configure default parameters. */
	attr_def_rsvp_tspec_default_parse ();

	/* Determine the number of tspec. 	*/
	num_tspec = op_topo_child_count (tspec_objid, OPC_OBJTYPE_GENERIC);
	if (num_tspec > 0)
		{
		/** Some RSVP profiles were configured.	**/

		/* Initialize log message handle.	*/
		attr_def_rsvp_log_init ();
		}

	/* Go over the list, parse each of the tspec and finally 	*/
	/* register into network-wide attribute database.			*/
	for (tspec_index = 0; tspec_index < num_tspec; tspec_index++)
		{
		/* Get a handle to the row ( = one RSVP flow spec).	*/
		tspec_entry_objid = op_topo_child (tspec_objid, OPC_OBJTYPE_GENERIC, tspec_index);	

		/* Parse the traffic specs and register it into network-wide attribute database.	*/
		attr_def_rsvp_tspec_parse (tspec_entry_objid);
		}

	FOUT;
	}			


static void
attr_def_rsvp_tspec_parse (Objid tspec_entry_objid)
	{
	char						temp_str [256];
	GnaT_Rsvp_Profile_Tspec*	tspec_params_ptr;

	/** Allocates memory for RSVP profile and parses profile parameters.	**/
	FIN (attr_def_rsvp_tspec_parse (tspec_entry_objid));

	/* Allocate memory to store Tspec definition.	*/
	tspec_params_ptr = (GnaT_Rsvp_Profile_Tspec *) op_prg_mem_alloc (sizeof (GnaT_Rsvp_Profile_Tspec));

	/* Allocate memory to store Tspec definition.	*/
	tspec_params_ptr->tspec_ptr = (RsvpT_Tspec *) op_prg_mem_alloc (sizeof (RsvpT_Tspec));

	if ((tspec_params_ptr == OPC_NIL) || (tspec_params_ptr->tspec_ptr == OPC_NIL))
		{
		/* Memory allocation failed, abort the simulation.	*/
		gna_attr_definer_error ("Unable to allocate memory for RSVP Tspec Profile.", OPC_NIL, OPC_NIL);
		}

	op_ima_obj_attr_get (tspec_entry_objid, "Name", temp_str);
		
	tspec_params_ptr->tspec_name = (char *) op_prg_mem_alloc ((strlen (temp_str) + 1) * sizeof (char));
	strcpy (tspec_params_ptr->tspec_name, temp_str);
		
	/* Obtain the threshold and reservation style. */
	op_ima_obj_attr_get (tspec_entry_objid, "Bandwidth",   &(tspec_params_ptr->tspec_ptr->bucket_rate));
	op_ima_obj_attr_get (tspec_entry_objid, "Buffer Size", &(tspec_params_ptr->tspec_ptr->bucket_size));

	/* Finally register the data into network-wide database by	*/
	/* passing the pointer to the data structure. 				*/
	oms_data_def_entry_insert ("RSVP Flow Specification", tspec_params_ptr->tspec_name, tspec_params_ptr); 

	FOUT;
	}


static void
attr_def_rsvp_tspec_default_parse ()
	{
	char						profile_name;
	GnaT_Rsvp_Profile_Tspec*	tspec_params_ptr;
	int							index;

	/** Allocates memory for RSVP traffic specification profile and parses it.	**/
	FIN (attr_def_rsvp_tspec_default_parse (void));

	for (index = 0; index < RSVP_NUM_DEFAULT_TSPEC; index ++)
		{
		/* Allocate memory to store Tspec definition.	*/
		tspec_params_ptr = (GnaT_Rsvp_Profile_Tspec *) op_prg_mem_alloc (sizeof (GnaT_Rsvp_Profile_Tspec));

		/* Allocate memory to store Tspec definition.	*/
		tspec_params_ptr->tspec_ptr = (RsvpT_Tspec *) op_prg_mem_alloc (sizeof (RsvpT_Tspec));

		if ((tspec_params_ptr == OPC_NIL) || (tspec_params_ptr->tspec_ptr == OPC_NIL))
			{
			/* Memory allocation failed, abort the simulation.	*/
			gna_attr_definer_error ("Unable to allocate memory for RSVP Tspec Profile.", OPC_NIL, OPC_NIL);
			}
		switch (index)
			{
			case (RSVP_DEF_TSPEC):
				{
				tspec_params_ptr->tspec_name = (char *) op_prg_mem_alloc ((strlen ("Tspec_Std_Dft") + 1) * sizeof (char));
				strcpy (tspec_params_ptr->tspec_name, "Tspec_Std_Dft");
				tspec_params_ptr->tspec_ptr->bucket_rate = RSVP_DEFAULT_BANDWIDTH;
				tspec_params_ptr->tspec_ptr->bucket_size = RSVP_DEFAULT_BUFFER_SIZE;
				break;
				}
			case (RSVP_SENDER_SPEC_TSPEC):
				{
				tspec_params_ptr->tspec_name = (char *) op_prg_mem_alloc ((strlen ("Sender_Based_Std_Dft") + 1) * sizeof (char));
				strcpy (tspec_params_ptr->tspec_name, "Sender_Based_Std_Dft");
				tspec_params_ptr->tspec_ptr->bucket_rate	= RSVP_TSPEC_FROM_PATH_MSG;
				tspec_params_ptr->tspec_ptr->bucket_size	= RSVP_TSPEC_FROM_PATH_MSG;
				break;
				}
			default:
				break;
			}

		/* Finally register the data into network-wide database by	*/
		/* passing the pointer to the data structure. 				*/
		oms_data_def_entry_insert ("RSVP Flow Specification", tspec_params_ptr->tspec_name, tspec_params_ptr); 
		}

	FOUT;
	}


static void
attr_def_rsvp_profile_info_parse (void)
	{
	Objid		profile_objid, profile_entry_objid;
	int			num_profiles, profile_index;

	/** This function parses the information defined in the compound	  	**/
	/** attribute "RSVP Profiles". It creates instances of the data  		**/
	/** structure 'GnaT_Rsvp_Profile_Params', allocates memory for the   	**/
	/** instances and stores the parsed information. Finally it registers**/
	/** these  information into attribute database to provide access to 	**/
	/** them for the network objects. The registration  to the database is**/
	/** done by passing	data structure pointers to the  database to be  	**/
	/** stored under certain category and entry names.     					**/	
	FIN (attr_def_rsvp_profile_info_parse (void));

	/* Get a handle to the compound attribute RSVP Profiles.	*/
	op_ima_obj_attr_get (my_objid, "RSVP Profiles", &profile_objid);

	/* Determine the number of profiles. 						*/
	num_profiles = op_topo_child_count (profile_objid, OPC_OBJTYPE_GENERIC);

	/* Go over the list, parse each of the profile and finally 	*/
	/* register into network-wide attribute database.			*/
	for (profile_index = 0; profile_index < num_profiles; profile_index++)
		{
		/* Get a handle to the row ( = one RSVP Profile).	*/
		profile_entry_objid = op_topo_child (profile_objid, OPC_OBJTYPE_GENERIC, profile_index);	

		/* Parse the profile and register it into network-wide attribute database.	*/
		attr_def_rsvp_profile_parse (profile_entry_objid);
		}

	FOUT;
	}			


static void
attr_def_rsvp_profile_parse (Objid profile_entry_objid)
	{
	Objid						flow_spec_objid, flow_spec_row_objid, retry_objid;
	Objid						retry_policy_objid, retry_flow_spec_objid, retry_flow_spec_row_objid;
	char						temp_str [256];
	GnaT_Rsvp_Profile_Params*	profile_params_ptr;

	/** Allocates memory for RSVP profile and parses profile parameters.	**/
	FIN (attr_def_rsvp_profile_parse (profile_entry_objid));

	/* Allocate memory to store Profile definition.	*/
	profile_params_ptr = (GnaT_Rsvp_Profile_Params *) op_prg_mem_alloc (sizeof (GnaT_Rsvp_Profile_Params));
	if (profile_params_ptr == OPC_NIL)
		{
		/* Memory allocation failed, abort the simulation.	*/
		gna_attr_definer_error ("Unable to allocate memory for RSVP Profile.", OPC_NIL, OPC_NIL);
		}

	/* Get profile name. 	*/
	op_ima_obj_attr_get (profile_entry_objid, "Profile Name", temp_str);
	profile_params_ptr->profile_name = (char *) op_prg_mem_alloc ((strlen (temp_str) + 1) * sizeof (char));
	strcpy (profile_params_ptr->profile_name, temp_str);
		
	/* Obtain the threshold and reservation style. */
	op_ima_obj_attr_get (profile_entry_objid, "Threshold", &(profile_params_ptr->threshold));
	op_ima_obj_attr_get (profile_entry_objid, "Reservation Style", &(profile_params_ptr->resv_style));

	/* Get a handle to the compound attribute Reservation Parameters.	*/
	op_ima_obj_attr_get (profile_entry_objid, "Reservation Parameters", &flow_spec_objid);

	/* Get a handle to the row in Reservation parameters.	*/
	flow_spec_row_objid = op_topo_child (flow_spec_objid, OPC_OBJTYPE_GENERIC, 0);	

	/* Parse each flow descriptor defined in Flow specification.	*/
	profile_params_ptr->flowdescr_ptr = attr_def_rsvp_profile_flowspec_parse (flow_spec_row_objid, 
													profile_params_ptr->profile_name, 
													profile_params_ptr->resv_style, OPC_TRUE);

	/* Get a handle to the compound attribute Retry Policy.		*/
	op_ima_obj_attr_get (profile_entry_objid, "Retry Policy", &retry_policy_objid);

	/* Get a handle to the row.	There is just one row.	*/
	retry_objid = op_topo_child (retry_policy_objid, OPC_OBJTYPE_GENERIC, 0);	

	/* Get a handle to compound attribute Retry Policy.	*/
	op_ima_obj_attr_get (retry_objid, "Retry", &(profile_params_ptr->retry_policy));

	/** Read retry policy information only if retry is enabled.		**/
	if (profile_params_ptr->retry_policy == OPC_TRUE)
		{
		/** Retry attributes were defined.	**/

		/* Find retry timer.	*/
		op_ima_obj_attr_get (retry_objid, "Retry Timer", &profile_params_ptr->retry_timer);

		/* Get a handle to compound attribute Retry Flow Specification.	*/
		op_ima_obj_attr_get (retry_objid, "Reservation Parameters", &retry_flow_spec_objid);

		/* Get a handle to the Flowspec parameters.	*/
		retry_flow_spec_row_objid = op_topo_child (retry_flow_spec_objid, OPC_OBJTYPE_GENERIC, 0);

		/* Parse Retry Flowspec Parameters.	*/ 
		profile_params_ptr->retry_flowdescr_ptr = attr_def_rsvp_profile_flowspec_parse (retry_flow_spec_row_objid,
															profile_params_ptr->profile_name, 
															profile_params_ptr->resv_style, OPC_FALSE);
		}
	else
		{
		/** Retries will not be attempted. Indicate it setting the retry flow descriptor to OPC_NIL.	**/
		profile_params_ptr->retry_flowdescr_ptr = OPC_NIL;
		}

	/* Finally register the data into network-wide database by	*/
	/* passing the pointer to the data structure. 				*/
	oms_data_def_entry_insert ("RSVP Profiles", profile_params_ptr->profile_name, profile_params_ptr); 

	FOUT;
	}


static GnaT_Rsvp_Flowdescr*
attr_def_rsvp_profile_flowspec_parse (Objid flow_spec_objid, char* profile_name, RsvpT_Style resv_style, 
	Boolean parsing_flowspecs)
	{
	Objid							sender_list_objid, sender_objid;
	Objid							sender_node_objid;
	int								num_senders, sender_index;
	GnaT_Rsvp_Flowdescr*			flow_descr_ptr;
	GnaT_Rsvp_Profile_Tspec*		tspec_defs_ptr;
	char							temp_sender_str [256];
	char*							sender_ptr;
	char							tspec_name_str [256];
	Objid							my_subnet_id;
	Objid							own_node_objid;
	int*							sender_objid_ptr;

	/** Parse each flow descriptor specified in the interface.	**/
	/** This function is called when Flow descriptor and Retry 	**/
	/** Flow Descriptor are parsed.								**/
	FIN (attr_def_rsvp_profile_flowspec_parse (flow_spec_objid, profile_name, resv_style, parsing_flowspecs));

	/* Determine the object ID of the node.	*/
	own_node_objid = op_topo_parent (my_objid);

	/* Determine the object identifier of the surrounding subnet.	*/
	my_subnet_id = op_topo_parent (own_node_objid);

	/* Allocate memory for flow descriptor.	*/
	flow_descr_ptr = (GnaT_Rsvp_Flowdescr *) op_prg_mem_alloc (sizeof (GnaT_Rsvp_Flowdescr));

	/* If the memory allocation failed, write an error and abort the simulation.	*/
	if (flow_descr_ptr == OPC_NIL)
		{
		gna_attr_definer_error ("Unable to allocate memory for RSVP Profile", OPC_NIL, OPC_NIL);
		}	

	/* Get Flow Descriptor.	*/
	op_ima_obj_attr_get (flow_spec_objid, "Flow Description", tspec_name_str);

	if ((strcmp (tspec_name_str, "Specified by Sender") == 0))
		{
		/* The parameters were specified to be sender defined (for reservations).	*/

		/* Set the profile to be sender based.		*/
		/* Get a pointer to sender based values.	*/ 
		tspec_defs_ptr = (GnaT_Rsvp_Profile_Tspec *) oms_data_def_entry_access ("RSVP Flow Specification",
																				"Sender_Based_Std_Dft");

		/* Set traffic specification in reservation parameters DS.	*/
		flow_descr_ptr->tspec_ptr = tspec_defs_ptr->tspec_ptr;	
		}
	else
		{
		/* Search the database to find a flow with this name.	*/
		/* Find the matching profile in the profile database.	*/
		tspec_defs_ptr = (GnaT_Rsvp_Profile_Tspec *) oms_data_def_entry_access ("RSVP Flow Specification",
																				tspec_name_str);

		if (tspec_defs_ptr != OPC_NIL)
			{
			/** Corresponding TSPEC has been defined.					**/

			/* Set traffic specification in reservation parameters DS.	*/
			flow_descr_ptr->tspec_ptr = tspec_defs_ptr->tspec_ptr;
			}
		else
			{
			/** No TSPEC with the specified name has been defined.		**/

			/* Set parameters to be the default and write log message.	 */
			attr_def_rsvp_profile_no_flow_profile_error (tspec_name_str);
	
			/* The parameters were specified to be keep the value from the reservation (Hold).	*/

			/* Set the profile to be sender based.		*/
			/* Get a pointer to sender based values.	*/ 
			tspec_defs_ptr = (GnaT_Rsvp_Profile_Tspec *) oms_data_def_entry_access ("RSVP Flow Specification",
																				"Tspec_Std_Dft");	

			/* Set traffic specification in reservation parameters DS.	*/
			flow_descr_ptr->tspec_ptr = tspec_defs_ptr->tspec_ptr;	
			}
		}

	/** Read each sender.	**/

	/* Create the sender list data structures.	*/
	flow_descr_ptr->sender_objid_list_ptr = op_prg_list_create ();

	/* Get a handle to the compound attribute Senders List.		*/
	op_ima_obj_attr_get (flow_spec_objid, "Sender List", &sender_list_objid);

	/* Find the number of senders.	*/
	num_senders = op_topo_child_count (sender_list_objid, OPC_OBJTYPE_GENERIC);

	/* Make sure that the number of senders is in agreement with the reservation style.	*/
	/* If the style is not wild card, some senders must be specified.					*/
	if ((resv_style != RsvpC_Wild_Card) && (num_senders == 0))
		{
        /* Make sure all senders not there.	*/
		attr_def_rsvp_profile_num_senders_error (profile_name, 0, parsing_flowspecs, 
													num_senders, resv_style);
		}

	/* Read sender name.	*/
	for (sender_index = 0; sender_index < num_senders; sender_index++)
		{
		/* Get a handle to the row.	*/
		sender_objid = op_topo_child (sender_list_objid, OPC_OBJTYPE_GENERIC, sender_index);	

		/* Parse one sender.	*/
		op_ima_obj_attr_get (sender_objid, "Sender", &temp_sender_str);

		/* Make sure that no senders, (except for "Any Sender") are specified for wildcard style.	*/
		if ((sender_index == 0) && (resv_style == RsvpC_Wild_Card))
			{
			if (strcmp(temp_sender_str, "Any Sender") != 0)
				{
				/** The sender specification is not in agreement with the style.	**/

				/* Record that a configuration error has been found.	*/
				attr_def_rsvp_profile_num_senders_error (profile_name, sender_index, parsing_flowspecs, 
															num_senders, resv_style);
				
				/** Allocate memory for sender.	*/
				sender_objid_ptr = (int*) op_prg_mem_alloc (sizeof (int));

				*sender_objid_ptr = RSVP_ANY_SENDER;
				
				/* Insert the sender into the sender list.	*/
				op_prg_list_insert (flow_descr_ptr->sender_objid_list_ptr, sender_objid_ptr, OPC_LISTPOS_TAIL);
		
				break;	
				}
			else if (num_senders > 1)
				{
				/** The sender specification is not in agreement with the style.	**/

				/* Record that a configuration error has been found.	*/
				attr_def_rsvp_profile_num_senders_error (profile_name, sender_index, parsing_flowspecs, 
															num_senders, resv_style);

				/* Set the number fo senders to be 0 (what is expected for the style).	*/
				/** Allocate memory for sender.	*/
				sender_objid_ptr = (int*) op_prg_mem_alloc (sizeof (int));

				*sender_objid_ptr = RSVP_ANY_SENDER;
				
				/* Insert the sender into the sender list.	*/
				op_prg_list_insert (flow_descr_ptr->sender_objid_list_ptr, sender_objid_ptr, OPC_LISTPOS_TAIL);
				
				break;	
				}
			}

		if ((strcmp (temp_sender_str, "Any Sender") == 0) && (sender_index > 0))
			{
			/* Record that a configuration error has been found.	*/
			attr_def_rsvp_profile_all_senders_error (profile_name, sender_index, parsing_flowspecs);

			/* Do not consider this sender.	*/
			continue;
			}
		else
			{
			/** There is no configuration problem.		**/
				
			if ((strcmp (temp_sender_str, "Any Sender") != 0))
				{
				/* Find the object ID of the sender. Using object ID insetead of names	*/
				/* simplifies the process of finding a matching session after a path 	*/
				/* message is received at the node.										*/

				/* Determine if	a heirarchical name has been specified.		*/
				if (oms_tan_name_is_heirachical (temp_sender_str) == OPC_TRUE)
					{
					/* The destination name is heirarchical. Obtain the	*/
					/* object identifier of that node.					*/
					sender_node_objid = oms_tan_objid_from_hname_get (0, OPC_OBJTYPE_NDFIX, temp_sender_str);
					}
				else
					{
					/* The name is not heirarchical. This mean that the		*/
					/* destination must reside in the surrounding subnet.	*/
            		sender_node_objid = op_id_from_name (my_subnet_id, OPC_OBJTYPE_NDFIX, temp_sender_str);
            		}
				}
			else
				{
				sender_node_objid = RSVP_ANY_SENDER;
				}

			if (sender_node_objid != OPC_OBJID_INVALID)
				{
				/** Allocate memory for sender.	*/
				sender_objid_ptr = (int*) op_prg_mem_alloc (sizeof (int));

				*sender_objid_ptr = sender_node_objid;

				/* Insert the sender into the sender list.	*/
				op_prg_list_insert (flow_descr_ptr->sender_objid_list_ptr, sender_objid_ptr, OPC_LISTPOS_TAIL);
				}
			else
				{
				/** Specifier sender name is invalid (no node in the network has this name).	*/
				
				/* Write a log message.	*/
				attr_def_rsvp_profile_invalid_sender_error (temp_sender_str, profile_name, sender_index, parsing_flowspecs);
				}
			}
		}
	FRET (flow_descr_ptr);
	}


static void
gna_attr_definer_error (char* msg1, char* msg2, char* msg3)
	{
	FIN (gna_attr_definer_error (msg1, msg2, msg3));

	op_sim_end ("Error in RSVP Profile Specification", msg1, msg2, msg3);

	FOUT;
	}


static void
attr_def_rsvp_log_init (void)
	{
	int					rsvp_config_log_limit = 25;

	FIN (attr_def_rsvp_log_init ());
	/** Creates notification log handle	**/

	attr_def_rsvp_error_loghndl = op_prg_log_handle_create (OpC_Log_Category_Protocol, "RSVP",
															"Model Configuration Error",
															rsvp_config_log_limit);

	FOUT;
	}


static void
attr_def_rsvp_profile_num_senders_error (char * profile_name, int row_number, Boolean from_flow_descr, 
	int num_senders, RsvpT_Style resv_style)
	{
	char 			resv_style_str [64];
	char 			flowdescr [64];

	/** This message indicates problems with the number of senders	**/
	/** specified in the RSVP Profile model attribute.				**/
	FIN (attr_def_rsvp_profile_num_senders_error (profile_name, row_number, from_flow_descr, num_senders, 
			resv_style));

	/* Convert the reservation style into printable form	*/
	switch (resv_style)
		{
		case (RsvpC_Wild_Card):
			{
			strcpy (resv_style_str, "Wild Card");
			break;
			}
		case (RsvpC_Shared_Explicit):
			{
			strcpy (resv_style_str, "Shared Explicit");
			break;
			}
		default:
			{
			strcpy (resv_style_str, "Unknown");
			break;
			}
		}

	switch (from_flow_descr)
		{
		case (OPC_TRUE):
			{
			strcpy (flowdescr, "Flow Description");
			break;
			}
		default:
			{
			strcpy (flowdescr, "Retry Flow Description");
			break;
			}
		}

	op_prg_log_entry_write (attr_def_rsvp_error_loghndl,
	"WARNING(s):\n"
	"  The number of senders (%d) for RSVP\n"
	"  in the (%d) row of \"%s\"\n"		
	"  in reservation profile \"%s\"\n"	
	"  is not in agreement with the reservation style, which\n"
	"  was specified to be \"%s\".\n"
	"  \n"
	"ACTION(s):\n"
	"  The simulation will use \"Any Sender\" value,\n"
	"  which will result in attempting to reserve resources\n"
	"  for any sender.\n"
	"  \n"
	"SUGGESTION(s):\n"
	"  Modify \"Sender List\" specification attribute to\n"
	"  contain at least one sender.\n"
	"  If the reservation style is Wild Card, the sender\n"
	"  should be set to \"Any Sender\".\n",
	num_senders, row_number, flowdescr, profile_name, resv_style_str);
	FOUT;
	}


static void
attr_def_rsvp_profile_all_senders_error (char * profile_name, int row_number, Boolean from_flow_descr)
	{
	char 			flowdescr [64];

	/** This message indicates problems with the number of senders	**/
	/** specified in the RSVP Profile model attribute.				**/
	FIN (attr_def_rsvp_profile_all_flowdescr_error (profile_name, row_number, from_flow_descr));

	switch (from_flow_descr)
		{
		case (OPC_TRUE):
			{
			strcpy (flowdescr, "Flow Description");
			break;
			}
		default:
			{
			strcpy (flowdescr, "Retry Flow Description");
			break;
			}
		}

	op_prg_log_entry_write (attr_def_rsvp_error_loghndl,
	"WARNING(s):\n"
	"  Invalid sender specification. \n"
	"  Sender value \"Any Sender\" can be specified\n"
	"  only in the first row of \"Sender List\".\n"
	"  The value specified in the (%d) row of \"Sender List\"\n"
	"  for \"%s\" of \"%s\" profile is invalid.\n"
	"  \n"
	"ACTION(s):\n"
	"  Sender value \"Any Sender\" will be ignored.\n"
	"  \n"
	"SUGGESTION(s):\n"
	"  Delete \"Any Sender\" value, or insert it into the first row\n"
	"  of \"Sender List\".\n",	
	row_number, flowdescr, profile_name);

	FOUT;
	}


static void
attr_def_rsvp_profiles_print (GnaT_Rsvp_Profile_Params * rsvp_profile_ptr)
	{
	char 							disp_string0 [256];
	char 							disp_string1 [256];
	char 							disp_string2 [256];
	char 							disp_string3 [256];
	GnaT_Rsvp_Flowdescr *			sdescr_ptr;
	int								sdescr_index, num_sdescr;

    /** Display the RSVP Profiles for ODB.				**/
	FIN (attr_def_rsvp_profiles_print (rsvp_profile_ptr));

	sprintf (disp_string0, "Profile Name: %s ", rsvp_profile_ptr->profile_name);

 	op_prg_odb_print_major (disp_string0, OPC_NIL, OPC_NIL);

	sprintf(disp_string1, "Resv Threshold: 		%f ", rsvp_profile_ptr->threshold);

	switch (rsvp_profile_ptr->resv_style)
		{
		case (1):
			{
			sprintf(disp_string2, "Resv Style: 			Wild Card ");
			break;
			}
		case (2):
			{
			sprintf(disp_string2, "Resv Style: 			Fixed Filter ");
			break;
			}
		case (3):
			{
			sprintf(disp_string2, "Resv Style: 			Shared Explicit ");
			break;
			}
		default:
			{
			sprintf(disp_string2, "Resv Style: 			Unknown ");
			break;
			}
		}

	switch (rsvp_profile_ptr->retry_policy)
		{
		case (OPC_TRUE):
			{
			sprintf(disp_string3, "Retry Policy: 			Retry ");
			break;
			}
		case (OPC_FALSE):
			{
			sprintf(disp_string3, "Retry Policy: 			Do Not Retry ");
			break;
			}
		default:
			{
			sprintf(disp_string3, "Retry Policy: 			Unknown ");
			break;
			}
		}

	op_prg_odb_print_minor (disp_string1, disp_string2, disp_string3, OPC_NIL);

	/* Print sender descriptor.			*/
	sprintf(disp_string0, "**  Flow Descriptor  ** ");
	op_prg_odb_print_minor (disp_string0, OPC_NIL);

	/* Print the sender descriptor.	*/
	attr_def_rsvp_sender_descr_print (rsvp_profile_ptr->flowdescr_ptr);

	/* Print retry sender descriptor.	*/
	if (rsvp_profile_ptr->retry_policy == OPC_TRUE)
		{
		sprintf(disp_string0, "**  Retry Flow Descriptor  ** ");
		op_prg_odb_print_minor (disp_string0, OPC_NIL);

		/* Print the sender descriptor.	*/
		attr_def_rsvp_sender_descr_print (rsvp_profile_ptr->retry_flowdescr_ptr);
		}

	FOUT;
	}


static void
attr_def_rsvp_sender_descr_print (GnaT_Rsvp_Flowdescr * flowspec_ptr)
	{
	char 						disp_string0 [256];
	char 						disp_string1 [256];
	char 						disp_string2 [256];
	char*						sender_ptr;
	int							num_senders, sender_index;
	Objid						sender_objid;

	/** Prints a sender descriptor.	**/
	FIN (attr_def_rsvp_sender_descr_print (flowspec_ptr));
 
	if (flowspec_ptr->tspec_ptr->bucket_rate == 0)
		{
		sprintf(disp_string0, "Bandwidth: 			Specified by Sender");
		}
	else
		{
		sprintf(disp_string0, "Bandwidth: 			%f ", flowspec_ptr->tspec_ptr->bucket_rate);
		}

	if (flowspec_ptr->tspec_ptr->bucket_size == 0)
		{
		sprintf(disp_string1, "Buffer Size: 			Specified by Sender");
		}
	else
		{
		sprintf(disp_string1, "Buffer Size: 			%f ", flowspec_ptr->tspec_ptr->bucket_size);
		}

	/* Find the number of senders	*/
	num_senders = op_prg_list_size (flowspec_ptr->sender_objid_list_ptr);

	op_prg_odb_print_minor (disp_string0, disp_string1, OPC_NIL);

	if (num_senders == 0)
		{
		sprintf(disp_string2, "No Senders:");
		op_prg_odb_print_minor (disp_string2, OPC_NIL);
		}

	/* Print each sender		*/
	for (sender_index = 0; sender_index < num_senders; sender_index++)
		{
		/* Get sender name from the list.	*/
		sender_objid = (Objid) op_prg_list_access (flowspec_ptr->sender_objid_list_ptr, sender_index);

		/* Find the sender name.	*/
		op_ima_obj_attr_get (sender_objid, "name", &sender_ptr);

		if (sender_index == 0)
			{
			sprintf(disp_string0, "Senders:			%s ", sender_ptr);

			op_prg_odb_print_minor (disp_string0, OPC_NIL);
			}
		else
			{
			/* Print sender name.	*/
			attr_def_rsvp_sender_print (sender_ptr);
			}
		}

	FOUT;
	}


static void
attr_def_rsvp_sender_print (char * sender_ptr)
	{
	char 						disp_string0 [256];

	/** Prints sender.		**/
	FIN (attr_def_rsvp_sender_print (sender_ptr));

	sprintf(disp_string0, "				%s ", sender_ptr);

	op_prg_odb_print_minor (disp_string0, OPC_NIL);

	FOUT;
	}


static void
attr_def_rsvp_profile_no_flow_profile_error (char * profile_name)
	{
	/** This message indicates problems with Flow configuration.	**/
	FIN (attr_def_rsvp_profile_no_flow_profile_error (profile_name));

	op_prg_log_entry_write (attr_def_rsvp_error_loghndl,
	"WARNING(s):\n"
	" No traffic specification profile with the name\n"
	" \"%s\" was defined.\n"
	"\n"
	"ACTION(s):\n"
	" Default parameters with the following values will \n"
	" be used:\n"
	" Bandwidth: 		5,000 bytes/sec\n"
	" Buffer Size: 		5,000 bytes.\n"
	"\n"
	"SUGGESTION(s):\n"
	" Define the \"%s\" traffic specification profile.\n"
	" Traffic profiles are specified using the\n"
	" \"RSVP Flow Specification\" attribute at\n"
	" the QoS Attribute Configuration object.\n",
	 profile_name, profile_name, OPC_NIL);

	FOUT;
	}


static void
attr_def_rsvp_profile_invalid_sender_error (char* sender_name, char* profile_name, int row_number, Boolean from_flow_descr)
	{
	char 			flowdescr [64];

	/** This message indicates problems the sender specification.			**/
	/** It is printed if an invalid (non-existing sender) was specified.	**/
	FIN (attr_def_rsvp_profile_invalid_sender_error (sender_name, profile_name, row_number,from_flow_descr));

	switch (from_flow_descr)
		{
		case (OPC_TRUE):
			{
			strcpy (flowdescr, "Flow Description");
			break;
			}
		default:
			{
			strcpy (flowdescr, "Retry Flow Description");
			break;
			}
		}

	op_prg_log_entry_write (attr_def_rsvp_error_loghndl,
	"WARNING(s):\n"
	"  Invalid sender specification.\n"
	"  Sender with the name \"%s\"\n"
	"  does not exist in the network.\n"
	"  This value was specified at the QoS\n"
	"  Attribute Configuration object,\n"
	"  in the \"%s\"\n"
	"  profile definition,(%d) row\n"
	"  of \"Sender List\" of \"%s\". \n"
	"  \n"
	"ACTION(s):\n"
	"  Sender \"%s\" will be ignored.\n"
	"\n"
	"SUGGESTION(s):\n"
	"  Specify a correct name of a sender\n"
	"  for which a reservation is requested.\n"
	"  If the sender and QoS Configuration object are\n"
	"  in the same subnet, specify the sender using\n"
	"  its \"name\" attribute,\n"
	"  otherwise use sender's full hierarchical name.\n",
	sender_name, profile_name, row_number, flowdescr, sender_name);

	FOUT;
	}

/* End of Function Block */

#if defined (__cplusplus)
extern "C" {
#endif
	void qos_attribute_definer_drradded (void);
	Compcode qos_attribute_definer_drradded_init (void **);
	void qos_attribute_definer_drradded_diag (void);
	void qos_attribute_definer_drradded_terminate (void);
	void qos_attribute_definer_drradded_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
qos_attribute_definer_drradded (void)
	{
	int _block_origin = 0;
	FIN (qos_attribute_definer_drradded ());
	if (1)
		{
		Prohandle						own_prohandle;
		Objid							own_node_objid;
		char							proc_model_name [64];
		OmsT_Pr_Handle					own_process_record_handle;
		
		Objid							rsvp_profiles_objid;
		Objid					 		rsvp_entry_profile_objid;	
		char							temp_str [256];
		char							profile_name [128];
		
		int                     		index;
		int								num_rsvp_profiles;
		char*                   		entry_name;
		GnaT_Rsvp_Profile_Params*		rsvp_profile_ptr;
		


		FSM_ENTER (qos_attribute_definer_drradded)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (parse) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, state0_enter_exec, "parse", "qos_attribute_definer_drradded () [parse enter execs]")
				{
				/* Obtain commonly used identification information and store them into the 			*/
				/* corresponding state variables.													*/ 
				my_objid       = op_id_self ();
				own_node_objid = op_topo_parent (my_objid);
				own_prohandle  = op_pro_self ();
				op_ima_obj_attr_get (my_objid, "process model", proc_model_name);
				
				/* Register the process model into process registery. The existence of this node	*/
				/* will be checked by IP modules using oms_process_discover and protocol attribute.	*/
				own_process_record_handle = (OmsT_Pr_Handle) oms_pr_process_register (own_node_objid, my_objid, 
				                                                                      own_prohandle, proc_model_name);
				oms_pr_attr_set (own_process_record_handle,
								"protocol",		OMSC_PR_STRING,		"ip_qos_attribute_object",
								OPC_NIL);
				
				/* Initialize the simulation log handles.	*/
				ip_attr_notification_log_init ();
				
				/* Parse the compound attribute "FIFO Profiles", fill the data structures and		*/
				/* register them into network-wide attribute database.								*/
				attr_def_fifo_profiles_info_parse ();
				
				/* Parse the compound attribute "WFQ Profiles", fill the data structures and		*/
				/* register them into network-wide attribute database.								*/
				attr_def_wfq_profiles_info_parse ();
				
				/* Parse the compound attribute "VC Profiles", fill the data structures and 			*/
				/* register them into network-wide attribute database.									*/
				attr_def_vc_profiles_info_parse ();
				
				/* Parse the compound attribute "DRR Profiles", fill the data structures and 			*/
				/* register them into network-wide attribute database.									*/
				attr_def_drr_profiles_info_parse ();
				
				/* Parse the compound attribute "Priority Queuing Profiles", fill the data structures and	*/
				/* register them into network-wide attribute database.										*/
				attr_def_priority_queuing_profiles_info_parse ();
				
				/* Parse the compound attribute "Custom Queuing Profiles", fill the data structures and		*/
				/* register them into network-wide attribute database.										*/
				attr_def_custom_queuing_profiles_info_parse ();
				
				/* Parse the compound attribute "CAR Profiles", fill the data structures and			*/
				/* register them into network-wide attribute database.									*/
				attr_def_car_profile_parse ("CAR Profiles");
				
				/* Parse the compound attribute "RSVP Traffic Specification" , fill the data    	*/
				/* structures and register them into network-wide attribute database. 				*/
				attr_def_rsvp_tspec_info_parse ();
				
				/* Parse the compound attribute "RSVP Profiles" , fill the data structures and   	*/
				/* register them into network-wide attribute database.                              */
				attr_def_rsvp_profile_info_parse ();
				
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,qos_attribute_definer_drradded)


			/** state (parse) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, state0_exit_exec, "parse", "qos_attribute_definer_drradded () [parse exit execs]")
				{
				
				}


			/** state (parse) transition processing **/
			FSM_TRANSIT_MISSING ("parse")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,qos_attribute_definer_drradded)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
qos_attribute_definer_drradded_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (qos_attribute_definer_drradded_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (qos_attribute_definer_drradded)",
			sizeof (qos_attribute_definer_drradded_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((qos_attribute_definer_drradded_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
qos_attribute_definer_drradded_diag (void)
	{
	int _block_origin = __LINE__;

	FIN (qos_attribute_definer_drradded_diag ())

	if (1)
		{
		Prohandle						own_prohandle;
		Objid							own_node_objid;
		char							proc_model_name [64];
		OmsT_Pr_Handle					own_process_record_handle;
		
		Objid							rsvp_profiles_objid;
		Objid					 		rsvp_entry_profile_objid;	
		char							temp_str [256];
		char							profile_name [128];
		
		int                     		index;
		int								num_rsvp_profiles;
		char*                   		entry_name;
		GnaT_Rsvp_Profile_Params*		rsvp_profile_ptr;
		

		/* Diagnostic Block */


		BINIT
		

		/* End of Diagnostic Block */

		}

	FOUT;
	}




void
qos_attribute_definer_drradded_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (qos_attribute_definer_drradded_terminate (void))

	if (1)
		{
		Prohandle						own_prohandle;
		Objid							own_node_objid;
		char							proc_model_name [64];
		OmsT_Pr_Handle					own_process_record_handle;
		
		Objid							rsvp_profiles_objid;
		Objid					 		rsvp_entry_profile_objid;	
		char							temp_str [256];
		char							profile_name [128];
		
		int                     		index;
		int								num_rsvp_profiles;
		char*                   		entry_name;
		GnaT_Rsvp_Profile_Params*		rsvp_profile_ptr;
		

		/* Termination Block */


		BINIT
		

		/* End of Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in qos_attribute_definer_drradded_svar function. */
#undef my_objid
#undef ip_attr_conf_log_handle
#undef attr_def_rsvp_error_loghndl



void
qos_attribute_definer_drradded_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	qos_attribute_definer_drradded_state		*prs_ptr;

	FIN (qos_attribute_definer_drradded_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT;
		}
	prs_ptr = (qos_attribute_definer_drradded_state *)gen_ptr;

	if (strcmp ("my_objid" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->my_objid);
		FOUT;
		}
	if (strcmp ("ip_attr_conf_log_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_attr_conf_log_handle);
		FOUT;
		}
	if (strcmp ("attr_def_rsvp_error_loghndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->attr_def_rsvp_error_loghndl);
		FOUT;
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT;
	}
