/* Process model C form file: ip_rte_v4_vc.pr.c */
/* Portions of this file copyright 1992-2000 by OPNET, Inc. */



/* This variable carries the header into the object file */
static const char ip_rte_v4_vc_pr_c [] = "MIL_3_Tfile_Hdr_ 70B 30A op_runsim 7 3B3781DF 3B3781DF 1 luna nalborz 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                       ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

/***** Includes *****/
#include <ip_addr_v4.h>
#include <oms_data_def.h>

#include <ip_rte_v4.h>
#include <ip_cmn_rte_table.h>
#include <ip_dgram_sup.h>
#include <ip_notif_log_support.h>
#include <ip_qos_notif_log_support.h>
#include <ip_support.h>

#include <ip_frag_sup_v3.h>
#include <ip_rte_table_v4.h>
#include <ip_rte_sup_v4.h>
#include <ip_auto_addr_sup_v4.h>
#include <rsvp.h>

#include <nato.h>

#include <oms_pr.h>
#include <oms_qm.h>
#include <oms_tan.h>
#include <oms_devices.h>
#include <oms_dist_support.h>

/* Make use of the Opnet Model Support package for baseline traffic generation. */
#include <oms_basetraf_ext.h>

/* Make use of the Opnet Model Support package for calculating background utilization. */
#include <oms_bgutil.h>

/* Macros Used to Represent Transitions. */
#define SERVER_BUSY			(server_status == OmsC_Dv_Processor_Busy)
#define SERVICE_NEW_PK		(!SERVER_BUSY && insert_ok)
#define SERVICE_QUEUED_PK   (!queue_empty)
#define SVC_COMPLETION  	(intrpt_type == OPC_INTRPT_SELF &&  pk_from_child_process == OPC_FALSE)
#define ARRIVAL         	(intrpt_type == OPC_INTRPT_STRM ||  pk_from_child_process == OPC_TRUE)
#define	SELF_NOTIFICATION	(intrpt_type == OPC_INTRPT_SELF)
#define MCAST_RSVP			(intrpt_type == OPC_INTRPT_REMOTE)

/* Default value for the time-to-live counter.		*/
/* This value is assigned when a packet is received	*/
/* which does not already have a ttl field.			*/
#define IP_DEFAULT_TTL			32

#define	LOWER_BYTE_MASK	0xffffff00
#define UPPER_THREE_MASK 0x000000ff


static Boolean	ip_error_message_printed = OPC_FALSE;

/* Flag used to assure that only one IP module reads the 	*/
/* contents of a routing tables export file and sends intrpts	*/
/* to routing processes. It is used only if the simulation	*/
/* attribute "IP Routing Table Export/Import" is set to		*/
/* a value other than "Not Used".							*/
Boolean				ip_routing_table_from_file_imported = OPC_FALSE;

/* Pointer to the list of routing tables created from */
/* an external file.								  */
extern List*		global_route_table_list_ptr;

/* Global variables for "IP Routing Table Export/Import":    */ 
/* Selection of the simulation attribute "IP Routing */
/* Table Export/Import"								 */
int					routing_table_import_export_flag = IP_RTE_TABLE_NON_DET;

/* Variable used to assure that the export file is created only once */
Boolean				routing_table_export_file_created = OPC_FALSE;

#define	IP_ADDR_INDEX_INVALID			-1
#define IP_SRC_ADDR_UNDEFINED			-1
#define IP_OUTSTRM_INVALID				-1
#define	IP_BROADCAST_ALL_INTERFACES		-1
#define IP_NEIGHBOR_NOTIFICATION		-1

#define	LTRACE_GLOBAL_TABLE_ACTIVE	(op_prg_odb_ltrace_active ("global_table"))

#define LTRACE_FDSTRUCT_ACTIVE		(op_prg_odb_ltrace_active ("fields"))

#define LTRACE_COMPRESSION_ACTIVE	(op_prg_odb_ltrace_active ("ip_compression"))

#define CENTRAL_CPU							-1

/* Code for the self interrupts that indicates the	*/
/* completion of the central processor's service 	*/
/* for the packets that are forwarded from input 	*/
/* slots.											*/
#define	SLOT_TO_CENTRAL_FORWARD				-2

/* Size of the part of TCP/IP Header in bits that	*/
/* can be compressed by using the TCP/IP Header		*/
/* Compression approach described in RFC 1144.		*/
#define IP_TCP_COMPRESSABLE_HEADER_SIZE		320

/* Flags indicating the nature of IP transmission	*/
/* if the packet being processed is to be sent to	*/
/* the network.										*/
#define	IP_PKT_TXTYPE_UCAST					1
#define	IP_PKT_TXTYPE_MCAST					2
#define IP_PKT_TXTYPE_BCAST					3

/* Enumerated types describing the multicast routing	*/
/* protocol that can be specified.						*/
typedef enum IpT_Rte_Mcast_Rte_Proto_Type
	{
	IpC_Rte_Pim_Sm = 0,
	IpC_Rte_Custom_Mrp
	} IpT_Rte_Mcast_Rte_Proto_Type;

/***** Globals *****/
extern IpT_Address		IpI_Broadcast_Addr;
extern IpT_Address		IpI_Default_Addr;

/***** Procedure Declarations *****/
static void					ip_rte_v4_sv_init ();
static void					ip_stream_from_iface_index (int iface_index, int* in_stream_ptr, 
								int* out_stream_ptr, IpT_Interface_Type* interface_type_ptr);
static void					ip_local_dyn_route_protos_invoke (int protos, Boolean invoke_flag, List* active_custom_rte_proto_label_lptr);
static void					ip_rtab_init (void);
static void					ip_rte_determine_lan_node_context (void);
static void					ip_rtab_local_addr_register (IpT_Address ip_addr);
static void					ip_rtab_local_network_register (IpT_Address ip_net_addr);
static void					ip_networks_print (void);
static void					ip_interface_table_print (List *iface_table_ptr);

static void					ip_rtab_table_handle_register (void);
static void					ip_rtab_print (void);
static Compcode				ip_dest_reached (IpT_Address dest_addr, List *iface_table_ptr, int instream);
static void					ip_src_address_determine (IpT_Address dest_addr, IpT_Address *src_addr_ptr, 
			                	List *iface_table_ptr, int index);
static void					ip_rte_error (char* msg);
static void					ip_rte_warn (char *msg);
static Compcode				ip_rte_destination_local_network (IpT_Address dest_addr, int *intf_index_ptr,
								IpT_Interface_Info** interface_ptr, int *outstrm_ptr);
static void					ip_module_connectivity_check (Objid strm_id, Objid my_objid);
static IpT_Interface_Info*	ip_interface_info_create (void);
static void					ip_rte_next_hop_error (IpT_Address addr);
static Compcode				ip_rte_datagram_dest_get (Packet* pkptr, Ici* rsvp_ici_ptr, Boolean force_fwd, 
								Boolean broadcast_addr, IpT_Address dest_addr, int instrm, int fast_address, 
								int protocol_type, IpT_Address *next_addr_ptr, Boolean *broadcast_ptr, 
								Boolean *higher_layer_ptr, Boolean *destroy_pkt_ptr, int *output_intf_index_ptr, 
								IpT_Interface_Info **interface_ptr, int* minor_port_out_ptr);

static void					ip_rte_dgram_options_process (Boolean dgram_dest_reached, Packet* ip_pkptr, int output_iface_index);
static void					ip_rte_datagram_broadcast (IpT_Address dest_addr, Packet *pk_ptr, int interface_index, IpT_Rte_Ind_Ici_Fields* ici_fdstruct_ptr);
static void					ip_rte_datagram_higher_layer_forward (Packet *pk_ptr, IpT_Address dest_addr);
static void					ip_rte_datagram_interface_forward (IpT_Address dest_addr, IpT_Address next_addr, 
	                        	Packet *pk_ptr, int index, IpT_Rte_Ind_Ici_Fields* intf_ici_fdstruct_ptr);
static void					ip_forward_packet_to_output_queues (Packet *pk_ptr, int outstrm, Ici *iciptr, int pk_txtype, 
								int output_interface_index, int incoming_interface);
static void					ip_rte_pk_frag_send (Packet *pk_ptr, IpT_Address dest_addr, IpT_Address next_addr
								,int conn_class, IpT_Rte_Ind_Ici_Fields* intf_ici_fdstruct_ptr);
static Boolean				ip_address_multicast_accept (IpT_Address addr, int ip_interface);
static void					ip_rte_stathandle_init ();
static void					ip_rte_total_packets_received_stat_update (int pkt_dest_type, Packet * pk_ptr);
static void 				ip_rte_intf_ici_destroy (Ici* intf_iciptr);
static void					ip_inface_statistic_update (int output_strm, double pkt_bitsize, Packet * pk_ptr);
static void					ip_rte_qos_information_process ();
static double				ip_rte_decomp_delay_compute (Packet* pkptr, IpT_Dgram_Fields* pk_fd_ptr);
static double				ip_rte_comp_delay_and_size_compute (Packet* pkptr, IpT_Dgram_Fields* pk_fd_ptr, 
								Ici* intf_ici_ptr, IpT_Interface_Info* iface_info_ptr);
static void					ip_rte_comp_decomp_trace_print (Packet* pkptr, IpT_Compression_Method method, int old_size, 
								int new_size, char action [15]);
static void					ip_rte_pk_stats_update (Packet* pkptr, double * last_stat_update_time_ptr,
								OmsT_Bgutil_Routed_State * stat_bgutil_routed_state_ptr,
								Stathandle * packet_shandle_ptr);
static void					ip_rte_pk_stats_update_endsim (void * dummy_state, int dummy_code);
static void					ip_rte_dgram_discard (Packet* pkptr, Ici* intf_ici_ptr);
static void					ip_rte_bgutil_pkt_dest_handle (Packet* bgutil_pkptr);

extern int					ip_rtab_num_addrs_registered (void);
extern void					ip_rte_attr_config_info (void);
static void 				ip_dev_ipcloud_var_init (Objid node_objid, Objid module_objid);
static double 				ip_cloud_latency_determine (int access_rate, int strm_out, Packet *pkptr); 
static IpT_Address 			ip_obtain_neighbor_router_id (Objid link_objid);
static void					ip_register_routerid_as_local_netaddr ();
static void					ip_unnumbered_intf_router_id_assign ();
static int					ip_interface_routing_protocol_obtain (Objid iface_description_objid, char* rte_protocol_label_ptr);
static void					ip_rte_igmp_host_create_init (void);
static void					ip_rte_igmp_rte_intf_create_init (void);
static void					ip_rte_pim_sm_create_init (void);
static void					ip_rte_custom_mrp_create_init (void);
static Boolean				ip_rte_intf_mcast_enabled (int intf_num);
static Compcode				ip_rte_mcast_datagram_dest_get (Packet* pkptr, Ici* rsvp_ici_ptr, 
								IpT_Rte_Ind_Ici_Fields* intf_ici_fdstruct_ptr, IpT_Address dest_addr, 
								IpT_Address* next_addr_ptr, Boolean* higher_layer_ptr, Boolean* destroy_pkt_ptr, 
								int protocol_type,  int* output_intf_index_ptr, IpT_Interface_Info** interface_pptr);
static void					ip_rte_default_mcast_addr_register (void);
static void					ip_rte_car_init (int);
static 	Boolean				ip_rte_car_profile_get (OmsT_Qm_Car_Profile** car_profile, OmsT_Qm_Car_Information** car_info,
								int iface_id, char* direction, Objid ip_qos_info_objid);
static void					ip_rte_car_information_print ();

static Prohandle			ip_rtab_phandle_from_intf_get (RsvpT_TC_Ici_Struct *	ici_data_struct_ptr);
static void					ip_rte_rsvp_init_notify (void);
static Boolean				ip_rtab_rsvp_status_set (Objid iface_description_objid);


/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Boolean	                		is_ip_initialized;
	OmsT_Qm_Shared_Memory *			shared_mem_ptr;
	Prohandle	              		child_ptr;
	int	                    		queue_empty;
	int	                    		cpu_code;
	int	                    		num_interfaces;
	double	                 		service_rate;
	Objid	                  		own_id;
	Ici *	                  		arp_iciptr;
	ip_dgram_list *	        		dgram_list_ptr;
	int	                    		default_ttl;
	List *	                 		interface_table_ptr;
	List*	                  		radio_intf_list_ptr;
	List *	                 		slot_table_ptr;
	IpT_Info *	             		ip_info_ptr;
	Boolean	                		dynamic_routing_enabled;
	IpT_Cmn_Rte_Table*	     		ip_route_table;
	List*	                  		link_iface_table_ptr;
	Objid	                  		own_node_objid;
	Prohandle	              		own_prohandle;
	OmsT_Pr_Handle	         		own_process_record_handle;
	char	                   		proc_model_name [20];
	int	                    		instrm_from_ip_encap;
	int	                    		outstrm_to_ip_encap;
	Boolean	                		gateway_status;
	Boolean	                		gateway_known;
	IpT_Address	            		next_addr_gateway;
	Objid	                  		comp_attr_objid;
	Objid	                  		subnet_objid;
	int	                    		interface_table_size;
	List *	                 		mcast_addr_list_ptr;
	Boolean	                		do_bgutil;
	OmsT_Bgutil_Routed_State*			bgutil_routed_state_ptr;
	OmsT_Bgutil_Routed_State*			received_bgutil_routed_state_ptr;
	OmsT_Bgutil_Routed_State*			sent_bgutil_routed_state_ptr;
	double	                 		received_last_stat_update_time;
	double	                 		sent_last_stat_update_time;
	IpT_Ptc_Memory*	        		ip_ptc_mem_ptr;
	IpT_Address	            		default_gtwy_addr;
	Boolean	                		default_gtwy_available;
	int	                    		slot_count;
	OmsT_Dv_Proc_Status	    		server_status;
	OmsT_Dv_Proc_Status	    		central_server_status;
	OmsT_Dv_Proc_Scheme	    		processing_scheme;
	int*	                   		slot_iface_map_lptr;
	Stathandle	             		local_utilization_stathandle;
	Stathandle	             		locl_tot_pkts_sent_hndl;
	Stathandle	             		locl_num_mcasts_sent_hndl;
	Stathandle	             		locl_num_bcasts_sent_hndl;
	Stathandle	             		locl_tot_pkts_rcvd_hndl;
	Stathandle	             		locl_num_mcasts_rcvd_hndl;
	Stathandle	             		locl_num_bcasts_rcvd_hndl;
	Stathandle	             		locl_num_pkts_dropped_hndl;
	double	                 		locl_tot_pkts_sent;
	double	                 		locl_num_mcasts_sent;
	double	                 		locl_num_bcasts_sent;
	double	                 		locl_tot_pkts_rcvd;
	double	                 		locl_num_mcasts_rcvd;
	double	                 		locl_num_bcasts_rcvd;
	double	                 		locl_num_pkts_dropped;
	Stathandle	             		globl_num_pkts_dropped_hndl;
	double	                 		globl_num_pkts_dropped;
	Stathandle	             		ip_rte_pkt_latency_stathandle;
	int	                    		routing_protos;
	Stathandle	             		globl_tracer_ete_delay_hndl;
	Stathandle	             		local_tracer_in_ete_hndl;
	double	                 		dgram_compressed_size;
	IpT_Iface_Addressing_Mode			iface_addressing_mode;
	Boolean	                		within_lan_node;
	int	                    		ip_icmp_process_id;
	Prohandle	              		icmp_process_handle;
	int	                    		ip_basetraf_process_id;
	int	                    		dgram_id;
	FILE*	                  		routing_table_file_ptr;
	IpT_Compression_Info*	  		tcpip_header_comp_info_ptr;
	IpT_Compression_Info*	  		per_interface_comp_info_ptr;
	IpT_Compression_Info*	  		per_virtual_circuit_comp_info_ptr;
	Boolean	                		firewall_flag;
	List *	                 		proxy_info_table_lptr;
	Boolean	                		ipcloud_flag;
	double*	                		port_last_txn_end_time;
	double	                 		packet_discard_probability;
	OmsT_Dist_Handle	       		packet_latency_dist_handle;
	Stathandle	             		local_pkt_latency_stat;
	Boolean	                		router_id_assigned;
	Boolean	                		unnumbered_interface_exists;
	Prohandle	              		igmp_host_process_handle;
	Boolean	                		multicast_router;
	Prohandle	              		pim_sm_process_handle;
	OmsT_Qm_Car_Profile **	 		car_incoming_profile_ptr;
	OmsT_Qm_Car_Information **			car_incoming_info_ptr;
	OmsT_Qm_Car_Profile **	 		car_outgoing_profile_ptr;
	OmsT_Qm_Car_Information **			car_outgoing_info_ptr;
	OmsT_Qm_Car_Stat_Info *			car_stat_info_ptr;
	Prohandle	              		custom_mrp_process_handle;
	IpT_Rte_Mcast_Rte_Proto_Type			mcast_rte_protocol;
	Boolean	                		rsvp_status;
	Boolean	                		node_is_cache_server;
	} ip_rte_v4_vc_state;

#define pr_state_ptr            		((ip_rte_v4_vc_state*) SimI_Mod_State_Ptr)
#define is_ip_initialized       		pr_state_ptr->is_ip_initialized
#define shared_mem_ptr          		pr_state_ptr->shared_mem_ptr
#define child_ptr               		pr_state_ptr->child_ptr
#define queue_empty             		pr_state_ptr->queue_empty
#define cpu_code                		pr_state_ptr->cpu_code
#define num_interfaces          		pr_state_ptr->num_interfaces
#define service_rate            		pr_state_ptr->service_rate
#define own_id                  		pr_state_ptr->own_id
#define arp_iciptr              		pr_state_ptr->arp_iciptr
#define dgram_list_ptr          		pr_state_ptr->dgram_list_ptr
#define default_ttl             		pr_state_ptr->default_ttl
#define interface_table_ptr     		pr_state_ptr->interface_table_ptr
#define radio_intf_list_ptr     		pr_state_ptr->radio_intf_list_ptr
#define slot_table_ptr          		pr_state_ptr->slot_table_ptr
#define ip_info_ptr             		pr_state_ptr->ip_info_ptr
#define dynamic_routing_enabled 		pr_state_ptr->dynamic_routing_enabled
#define ip_route_table          		pr_state_ptr->ip_route_table
#define link_iface_table_ptr    		pr_state_ptr->link_iface_table_ptr
#define own_node_objid          		pr_state_ptr->own_node_objid
#define own_prohandle           		pr_state_ptr->own_prohandle
#define own_process_record_handle		pr_state_ptr->own_process_record_handle
#define proc_model_name         		pr_state_ptr->proc_model_name
#define instrm_from_ip_encap    		pr_state_ptr->instrm_from_ip_encap
#define outstrm_to_ip_encap     		pr_state_ptr->outstrm_to_ip_encap
#define gateway_status          		pr_state_ptr->gateway_status
#define gateway_known           		pr_state_ptr->gateway_known
#define next_addr_gateway       		pr_state_ptr->next_addr_gateway
#define comp_attr_objid         		pr_state_ptr->comp_attr_objid
#define subnet_objid            		pr_state_ptr->subnet_objid
#define interface_table_size    		pr_state_ptr->interface_table_size
#define mcast_addr_list_ptr     		pr_state_ptr->mcast_addr_list_ptr
#define do_bgutil               		pr_state_ptr->do_bgutil
#define bgutil_routed_state_ptr 		pr_state_ptr->bgutil_routed_state_ptr
#define received_bgutil_routed_state_ptr		pr_state_ptr->received_bgutil_routed_state_ptr
#define sent_bgutil_routed_state_ptr		pr_state_ptr->sent_bgutil_routed_state_ptr
#define received_last_stat_update_time		pr_state_ptr->received_last_stat_update_time
#define sent_last_stat_update_time		pr_state_ptr->sent_last_stat_update_time
#define ip_ptc_mem_ptr          		pr_state_ptr->ip_ptc_mem_ptr
#define default_gtwy_addr       		pr_state_ptr->default_gtwy_addr
#define default_gtwy_available  		pr_state_ptr->default_gtwy_available
#define slot_count              		pr_state_ptr->slot_count
#define server_status           		pr_state_ptr->server_status
#define central_server_status   		pr_state_ptr->central_server_status
#define processing_scheme       		pr_state_ptr->processing_scheme
#define slot_iface_map_lptr     		pr_state_ptr->slot_iface_map_lptr
#define local_utilization_stathandle		pr_state_ptr->local_utilization_stathandle
#define locl_tot_pkts_sent_hndl 		pr_state_ptr->locl_tot_pkts_sent_hndl
#define locl_num_mcasts_sent_hndl		pr_state_ptr->locl_num_mcasts_sent_hndl
#define locl_num_bcasts_sent_hndl		pr_state_ptr->locl_num_bcasts_sent_hndl
#define locl_tot_pkts_rcvd_hndl 		pr_state_ptr->locl_tot_pkts_rcvd_hndl
#define locl_num_mcasts_rcvd_hndl		pr_state_ptr->locl_num_mcasts_rcvd_hndl
#define locl_num_bcasts_rcvd_hndl		pr_state_ptr->locl_num_bcasts_rcvd_hndl
#define locl_num_pkts_dropped_hndl		pr_state_ptr->locl_num_pkts_dropped_hndl
#define locl_tot_pkts_sent      		pr_state_ptr->locl_tot_pkts_sent
#define locl_num_mcasts_sent    		pr_state_ptr->locl_num_mcasts_sent
#define locl_num_bcasts_sent    		pr_state_ptr->locl_num_bcasts_sent
#define locl_tot_pkts_rcvd      		pr_state_ptr->locl_tot_pkts_rcvd
#define locl_num_mcasts_rcvd    		pr_state_ptr->locl_num_mcasts_rcvd
#define locl_num_bcasts_rcvd    		pr_state_ptr->locl_num_bcasts_rcvd
#define locl_num_pkts_dropped   		pr_state_ptr->locl_num_pkts_dropped
#define globl_num_pkts_dropped_hndl		pr_state_ptr->globl_num_pkts_dropped_hndl
#define globl_num_pkts_dropped  		pr_state_ptr->globl_num_pkts_dropped
#define ip_rte_pkt_latency_stathandle		pr_state_ptr->ip_rte_pkt_latency_stathandle
#define routing_protos          		pr_state_ptr->routing_protos
#define globl_tracer_ete_delay_hndl		pr_state_ptr->globl_tracer_ete_delay_hndl
#define local_tracer_in_ete_hndl		pr_state_ptr->local_tracer_in_ete_hndl
#define dgram_compressed_size   		pr_state_ptr->dgram_compressed_size
#define iface_addressing_mode   		pr_state_ptr->iface_addressing_mode
#define within_lan_node         		pr_state_ptr->within_lan_node
#define ip_icmp_process_id      		pr_state_ptr->ip_icmp_process_id
#define icmp_process_handle     		pr_state_ptr->icmp_process_handle
#define ip_basetraf_process_id  		pr_state_ptr->ip_basetraf_process_id
#define dgram_id                		pr_state_ptr->dgram_id
#define routing_table_file_ptr  		pr_state_ptr->routing_table_file_ptr
#define tcpip_header_comp_info_ptr		pr_state_ptr->tcpip_header_comp_info_ptr
#define per_interface_comp_info_ptr		pr_state_ptr->per_interface_comp_info_ptr
#define per_virtual_circuit_comp_info_ptr		pr_state_ptr->per_virtual_circuit_comp_info_ptr
#define firewall_flag           		pr_state_ptr->firewall_flag
#define proxy_info_table_lptr   		pr_state_ptr->proxy_info_table_lptr
#define ipcloud_flag            		pr_state_ptr->ipcloud_flag
#define port_last_txn_end_time  		pr_state_ptr->port_last_txn_end_time
#define packet_discard_probability		pr_state_ptr->packet_discard_probability
#define packet_latency_dist_handle		pr_state_ptr->packet_latency_dist_handle
#define local_pkt_latency_stat  		pr_state_ptr->local_pkt_latency_stat
#define router_id_assigned      		pr_state_ptr->router_id_assigned
#define unnumbered_interface_exists		pr_state_ptr->unnumbered_interface_exists
#define igmp_host_process_handle		pr_state_ptr->igmp_host_process_handle
#define multicast_router        		pr_state_ptr->multicast_router
#define pim_sm_process_handle   		pr_state_ptr->pim_sm_process_handle
#define car_incoming_profile_ptr		pr_state_ptr->car_incoming_profile_ptr
#define car_incoming_info_ptr   		pr_state_ptr->car_incoming_info_ptr
#define car_outgoing_profile_ptr		pr_state_ptr->car_outgoing_profile_ptr
#define car_outgoing_info_ptr   		pr_state_ptr->car_outgoing_info_ptr
#define car_stat_info_ptr       		pr_state_ptr->car_stat_info_ptr
#define custom_mrp_process_handle		pr_state_ptr->custom_mrp_process_handle
#define mcast_rte_protocol      		pr_state_ptr->mcast_rte_protocol
#define rsvp_status             		pr_state_ptr->rsvp_status
#define node_is_cache_server    		pr_state_ptr->node_is_cache_server

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	ip_rte_v4_vc_state *op_sv_ptr = pr_state_ptr;


/* Function Block */

enum { _block_origin = __LINE__ };
static void
ip_rte_v4_sv_init ()
	{
	/** Initializes the state variables used by this process.	**/
	FIN (ip_rte_v4_sv_init ());
	
	/*	Get queue module's own object identifier.					*/
	own_id = op_id_self ();
  						
	/*	Obtain the node and subnet's objid.							*/
	own_node_objid = op_topo_parent (own_id);
	subnet_objid = op_topo_parent (own_node_objid);

	/* Check what kind of IP interface addressing is used for assigning	*/
	/* IP addresses to the various interfaces of this node.				*/
	iface_addressing_mode = ip_iface_addressing_mode_determine ();

	/*	Create the interface table.					*/
	interface_table_ptr = op_prg_list_create ();

	/*	Create the slot table.						*/
	slot_table_ptr = op_prg_list_create ();

	/* Initialize the routing_protos SV.			*/
	routing_protos = 0;

	/* Initialize the datagram identifier SV.		*/
	dgram_id = 1;

	/* Initialize RSVP status.						*/
	rsvp_status = OPC_FALSE;

	/* Check if the surrounding node is a cache server.	*/
	node_is_cache_server = oms_dv_device_is_cache_server (own_node_objid);
	
	FOUT;
	}


static void	
ip_rtab_init (void)
	{
	/** Create the underlying optimized address lookup structures	**/	
	/** if this has not been already done.							**/
    FIN (ip_rtab_init (void));

	/* Create a table to contain all possible IP interface			*/
	/* addresses in the network.									*/
	nato_table_build_start ("ip_table", NATOC_ONE_COMPONENT_ADDR);

	/* Create a tabel to contain possible IP networks in the model.	*/
	nato_table_build_start ("ip_networks_table", NATOC_ONE_COMPONENT_ADDR);

	FOUT;
	}

static void
ip_rtab_table_handle_register (void)
	{
	NatoT_Table_Handle		ip_table_handle;
	NatoT_Table_Handle		ip_networks_table_handle;

	/** This function is used to register the global IP address		**/
	/**	table handle in the model-wide registry.					**/
	FIN (ip_rtab_table_handle_register (void));

	/* Obtain the global IP table handle.							*/
	ip_table_handle = nato_table_handle_get ("ip_table");
	if (ip_table_handle == OPC_NIL)
		{
		op_sim_end ("Error at function ip_rtab_table_handle_register: global ip_table_handle is invalid.", OPC_NIL, OPC_NIL, OPC_NIL);
		}

	/* Obtain the global IP networks table handle.					*/
	ip_networks_table_handle = nato_table_handle_get ("ip_networks_table");
	if (ip_networks_table_handle == OPC_NIL)
		{
		op_sim_end ("Error at function ip_rtab_table_handle_register: global ip_networks_table_handle is invalid.", OPC_NIL, OPC_NIL, OPC_NIL);
		}

	/*	Publish handle to the IP table in the process registry.		*/
	oms_pr_attr_set (own_process_record_handle, 
		"ip table handle",			OMSC_PR_ADDRESS,	ip_table_handle, 
		"ip networks table handle",	OMSC_PR_ADDRESS,	ip_networks_table_handle, 
		OPC_NIL);

	FOUT;
	}

static void
ip_rte_stathandle_init (void)
	{
	/**	Register the stathandles to be used for collecting statistics	**/
	/**	from the IP layer.												**/
	FIN (ip_rte_stathandle_init (void));

	/* Register the statistics that will be maintained by this model.	*/
	local_utilization_stathandle = op_stat_reg ("IP.CPU Utilization",							OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
	locl_tot_pkts_sent_hndl      = op_stat_reg ("IP.Traffic Sent (packets/sec)",				OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
	locl_num_mcasts_sent_hndl    = op_stat_reg ("IP.Multicast Traffic Sent (packets/sec)",    	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
	locl_num_bcasts_sent_hndl    = op_stat_reg ("IP.Broadcast Traffic Sent (packets/sec)",     	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
	locl_tot_pkts_rcvd_hndl      = op_stat_reg ("IP.Traffic Received (packets/sec)",          	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
	locl_num_mcasts_rcvd_hndl    = op_stat_reg ("IP.Multicast Traffic Received (packets/sec)",	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
	locl_num_bcasts_rcvd_hndl    = op_stat_reg ("IP.Broadcast Traffic Received (packets/sec)",	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
	locl_num_pkts_dropped_hndl   = op_stat_reg ("IP.Traffic Dropped (packets/sec)",				OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
	globl_num_pkts_dropped_hndl	 = op_stat_reg ("IP.Traffic Dropped (packets/sec)",				OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
	globl_tracer_ete_delay_hndl  = op_stat_reg ("IP.Background Traffic Delay (sec)",			OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
	local_tracer_in_ete_hndl	 = op_stat_reg ("IP.Background Traffic Delay <-- (sec)",		OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);

	/* Initialize the state variables representing packet counts.		*/
	locl_tot_pkts_sent		= 0.0;
	locl_num_mcasts_sent	= 0.0;
	locl_num_bcasts_sent	= 0.0;
	locl_tot_pkts_rcvd		= 0.0;
	locl_num_mcasts_rcvd	= 0.0;
	locl_num_bcasts_rcvd	= 0.0;
	locl_num_pkts_dropped	= 0.0;
	globl_num_pkts_dropped	= 0.0;

	/* Register statistic handle to record packet latency through the	*/
	/* IP layer.														*/
	ip_rte_pkt_latency_stathandle = op_stat_reg ("IP.Processing Delay (sec)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);

	FOUT;
	}

static void
ip_rte_determine_lan_node_context ()
	{
	List*			proc_record_handle_list_ptr;
	int				record_handle_list_size;

	/** Checks if the surrounding node is acting like a LAN node (is needed		**/
	/** because if this surrounding node is a LAN object, then all the packets	**/
	/** received from the higher layer will be forwarded to the lower layer		**/
	/** (which may forward it back to the higher layer, if it is destined for	**/
	/** the same node.) If the node is not a LAN object, then higher layer		**/
	/** packets destined the same node will be directly sent back up.			**/
	FIN (ip_rte_determine_lan_node_context ());

	/* Initialize state variable used to indicate if this node is within a LAN.	*/
	within_lan_node = OPC_FALSE;

	/* Find out the node type from model wide process registry.	*/
	proc_record_handle_list_ptr = op_prg_list_create ();

	oms_pr_process_discover (OPC_OBJID_INVALID, proc_record_handle_list_ptr, 
			"node objid",	OMSC_PR_OBJID,		own_node_objid, 
			"node_type", 	OMSC_PR_STRING, 	"lan_mac", 
			OPC_NIL);

	/* Obtain the list size of the discovered processes.	*/
	record_handle_list_size = op_prg_list_size (proc_record_handle_list_ptr);
	if (record_handle_list_size == 1)
		{
		/* Set a flag indicating that this is a LAN node.	*/
		within_lan_node = OPC_TRUE;
		}

	/* Deallocate no longer needed process registry information.	*/
	while (op_prg_list_size (proc_record_handle_list_ptr))
		{
		op_prg_list_remove (proc_record_handle_list_ptr, OPC_LISTPOS_HEAD);
		}
	op_prg_mem_free (proc_record_handle_list_ptr);

	FOUT;
	}

static void
ip_rte_icmp_init ()
	{
	/** Creates an ICMP child process for this process. The ICMP	**/
	/** process will be used to transfer "ping" traffic with		**/
	/** different destinations as specified on the IP Ping Traffic	**/
	/** model attribute. The ICMP child process will generate ICMP	**/
	/** echo packets. A shared memory is also installed for later	**/
	/** use to get packets from the child process.					***/
	FIN (ip_rte_icmp_init ());

	/* Create an ICMP process and invoke it for initialization.		*/
	icmp_process_handle = op_pro_create ("ip_icmp", ip_ptc_mem_ptr);
	op_pro_invoke (icmp_process_handle, OPC_NIL);
		
	/* Store the process ID of this child process for later use. It	*/
	/* will be later used to distinguish that a packet came from	*/
	/* ICMP child process (as opposed to basetraf child process.	*/
	ip_icmp_process_id = op_pro_id (icmp_process_handle);

	FOUT;
	}

static void
ip_stream_from_iface_index (int iface_index, int* in_stream_ptr, int* out_stream_ptr, IpT_Interface_Type* interface_type_ptr)
	{
	int				num_dirs, assoc_dir;
	int				s, num_streams;
	int				assigned_iface_index;
	int				in_slot_index, out_slot_index;
	char			error_str [512];
	Objid			stream_objid;

	/* Find a stream connected to the IP-layer module that supports 	*/
	/* the specified interface. The interface is specified by its 		*/
	/* index in the interface table. 									*/
	FIN (ip_stream_from_iface_index (int iface_index, int* out_stream_ptr, int* in_stream_ptr, IpT_Interface_Type* interface_type_ptr))

	/*	Initialize the stream index output arguments to indicate that	*/
	/*	no streams were found. These values will be overwritten if the	*/
	/*	streams are found.												*/
	*in_stream_ptr = *out_stream_ptr = -1;

	/* Loop through all input and output streams to check for the 		*/
	/* presence and value of the "ip addr index" attribute. This 		*/
	/* extended attribute specifies the interface supported by the 		*/
	/* stream, if any. 													*/
	for (num_dirs = 0, assoc_dir = OPC_TOPO_ASSOC_IN; num_dirs < 2; 
		assoc_dir = OPC_TOPO_ASSOC_OUT, num_dirs++)
		{
		/* For each direction (in and out), now loop through the streams of that type. */
		num_streams = op_topo_assoc_count (own_id, assoc_dir, OPC_OBJTYPE_STRM);
		for (s = 0; s < num_streams; s++)
			{
			/* Obtain the object ID of the s_th stream. */
			stream_objid = op_topo_assoc (own_id, assoc_dir, OPC_OBJTYPE_STRM, s);
			
			/* The extended attribute might not exist on all connected streams, 	*/
			/* so check first for its presence. This avoids generating an error 	*/
			/* when getting the attribute value. 									*/
			if (op_ima_obj_attr_exists (stream_objid, "ip addr index") == OPC_TRUE)
				{
				/* Obtain the index of the interface assigned to the stream and 	*/
				/* compare to the sought interface index. 							*/
				op_ima_obj_attr_get (stream_objid, "ip addr index", &assigned_iface_index);
				if (assigned_iface_index == iface_index)
					{
					/*	Based on the direction of the packet stream (incoming to IP	*/
					/*	module or outgoing from IP module), determine the stream 	*/
					/*	index.														*/
					if (assoc_dir == OPC_TOPO_ASSOC_IN)
						{
						 op_ima_obj_attr_get (stream_objid, "dest stream", in_stream_ptr);
						}
					else
						{
						/* What is on the other side of the stream ?. If it happens */
						/* to be a transmitter, regarded as dumb, it cannot do 		*/
						/* anything useful with ICIs associated with the packets  	*/
						/* sent through this stream.								*/
						if (op_topo_assoc_count (stream_objid, OPC_TOPO_ASSOC_OUT, OPC_OBJMTYPE_XMIT) ==1)
							{
							 /* The stream is connected to a transmitter.			*/
							*interface_type_ptr = IpC_Intf_Type_Dumb;
							}
						else
							{
							/* The stream is connected to a module. The module is   */
							/* assumed to be smart enough to process the datagrams  */
							/* and the associated file.								*/
							*interface_type_ptr = IpC_Intf_Type_Smart;
							}
 
						op_ima_obj_attr_get (stream_objid, "src stream", out_stream_ptr);
						}
					}
				}
			}	
		}

	FOUT	
	}

static void
ip_local_dyn_route_protos_invoke (int protos, Boolean invoke_flag, List* active_custom_rte_proto_label_lptr)
	{
	int					bit_pos, max_bit_pos;
	char				proto_name [32];
	List*				proc_record_handle_list_ptr;
	OmsT_Pr_Handle		process_record_handle;		
	Objid				dyn_rte_objid;
	int 				i;
	int					num_custom_rte_protocols;
	char*				custom_rte_protocol_name_ptr;
	char				error_string [512];
	
	/** The input argument, protos, has bits set for those standard	**/
	/** routing protocols that have been "individually" activated   **/
	/** on those interfaces that have been discovered in this node. **/
	/** For each such routing protocol, the following is now donw   **/
	/**     1.  Get a reference to the OMS PR record for the        **/
	/**         routing protocol.                                   **/
	/**     2.  Store the result from 1 (above) in the appropriate  **/
	/**         member of the IpT_Cmn_Rte_Table object that         **/
	/**         represents the IP Routing Table for this node.      **/
	/**     3.  Get the parent module object ID of the routing      **/
	/**         protocol process instance in this node and issue    **/
	/**         a remote interrupt to it. This is done only if the	**/
	/**			second argument, invoke_flag, is set to OPC_TRUE.	**/
	/** The input argument, active_custom_rte_proto_label_lptr,		**/
	/** has a list of custom routing protocols that have been		**/
	/** individually activated on those interfaces that have been	**/
	/** discovered in this node. For each such routing protocol,	**/
	/** get the parent module object ID of the routing protocol 	**/
	/** instance in this node and issue a remote interrupt to it.	**/
	/** This is done only if the second argument, invoke_flag is	**/
	/** set to OPC_TRUE.											**/
	FIN (ip_local_dyn_route_protos_invoke (protos, invoke_flag, active_custom_rte_proto_label_lptr))

	/* Reading from LSB to MSB, currently, bits 0, 1, 2, 3, 4 are	*/
	/* used to flag the activation of RIP, IGRP, OSPF, BGP and		*/
	/* EIGRP respectively. The maximum bit position that needs to	*/
	/* be evaluated is four.										*/
	max_bit_pos = 4;

	/* Test bits 4, 3, 2, 1 and 0 (reading from MSB to LSB) that	*/
	/* correspond to EIGRP, BGP, OSPF, IGRP and RIP. And for each	*/	
	/* bit that is set to one, perform the tasks outlined above.	*/
	for (bit_pos = max_bit_pos; bit_pos >= 0; --bit_pos)
		{
		/* Is the bit_pos bit set?	*/
		if ((protos & (1<<bit_pos)) != 0)
			{
			/* Yes it is, depending on which one it is, we have to	*/
			/* initialize proto_name so that we query OMS PR for	*/
			/* the corresponding routing protocol's process record.	*/

			if (((1<<bit_pos) & IPC_RTE_PROTO_RIP) != 0)
				strcpy (proto_name, "rip");
			else if (((1<<bit_pos) & IPC_RTE_PROTO_IGRP) != 0)
				strcpy (proto_name, "igrp");
			else if (((1<<bit_pos) & IPC_RTE_PROTO_OSPF) != 0)
				strcpy (proto_name, "ospf");
			else if (((1<<bit_pos) & IPC_RTE_PROTO_BGP) != 0)
				strcpy (proto_name, "bgp");
			else if (((1<<bit_pos) & IPC_RTE_PROTO_EIGRP) != 0)
				strcpy (proto_name, "eigrp");

			/*	Search through the process registry to find the		*/
			/*	appropriate process.								*/
			proc_record_handle_list_ptr = op_prg_list_create ();

			oms_pr_process_discover (OPC_OBJID_INVALID, proc_record_handle_list_ptr, 
					"node objid",	OMSC_PR_OBJID,	own_node_objid, 
					"protocol",		OMSC_PR_STRING,	proto_name, 
					OPC_NIL);

			/* Sanity check.											*/
			if (op_prg_list_size (proc_record_handle_list_ptr) != 1)
				{
				/* An error message should be generated if zero or more	*/
				/* than one process record for a single routing protocol*/
				/* has been registered in OMS PR - in the local node.	*/
				op_sim_end (
					"Error: Found none, or more than one OMS Process Record(s) for",
					"a routing protocol (RIP/IGRP/OSPF/BGP/EIGRP) in this routing node.", "", "");
				}

			/* Get a reference to the process record.					*/
			process_record_handle = (OmsT_Pr_Handle) op_prg_list_access (
										proc_record_handle_list_ptr, OPC_LISTPOS_HEAD);

			/* Initialize the placeholder for the OMS PR record of	*/
			/* the corresponding routing protocol in the			*/
			/* IpT_Cmn_Rte_Table object. A reference to this is		*/
			/* available via the ip_route_table SV.					*/
			if (((1<<bit_pos) & IPC_RTE_PROTO_RIP) != 0)
				ip_route_table->rip_procreg_handle = process_record_handle;
			else if (((1<<bit_pos) & IPC_RTE_PROTO_IGRP) != 0)
				ip_route_table->igrp_procreg_handle = process_record_handle;
			else if (((1<<bit_pos) & IPC_RTE_PROTO_OSPF) != 0)
				ip_route_table->ospf_procreg_handle = process_record_handle;
			else if (((1<<bit_pos) & IPC_RTE_PROTO_BGP) != 0)
				ip_route_table->bgp_procreg_handle = process_record_handle;
			else if (((1<<bit_pos) & IPC_RTE_PROTO_EIGRP) != 0)
				ip_route_table->eigrp_procreg_handle = process_record_handle;

			if (invoke_flag == OPC_TRUE)
				{
	    		/*	Obtain the object id of the module performing the	*/
				/*	dynamic routing.									*/
				oms_pr_attr_get (process_record_handle,
					"module objid", OMSC_PR_OBJID, &dyn_rte_objid);

				/*	Schedule a remote interrupt to the local dynamic	*/
				/*	routing protocol process to notify it that the IP	*/
				/*	interface table can now be accessed.				*/
				op_intrpt_schedule_remote (op_sim_time (), 0, dyn_rte_objid);
				}

			/*	Deallocate no longer needed process registry information*/
			op_prg_mem_free (proc_record_handle_list_ptr);
			}
		}
	/** For each of the custom routing protocols running on	this node	**/
	/** discover their process handle and schedule a remote	interrupt	**/
	/** to invoke the custom routing protocol.							**/

	/* Is this node a router?									*/	

	if (invoke_flag == OPC_TRUE)
		{
		/* Get the number of custom routing protocols that are active on this node	*/
		num_custom_rte_protocols = op_prg_list_size (active_custom_rte_proto_label_lptr);
	
		/* Loop through the list of active custom routing protocols	*/
		for (i = 0; i < num_custom_rte_protocols; i++)
			{
			/* Access the ith protocol label from the list.			*/
			custom_rte_protocol_name_ptr = (char *) op_prg_list_access (active_custom_rte_proto_label_lptr, i);

		
			/* Search through the process registry to find the		*/
			/* appropriate process.									*/
			proc_record_handle_list_ptr = op_prg_list_create ();
		
			oms_pr_process_discover (OPC_OBJID_INVALID, proc_record_handle_list_ptr, 
					"node objid",	OMSC_PR_OBJID,	own_node_objid, 
					"protocol",		OMSC_PR_STRING,	custom_rte_protocol_name_ptr, 
					OPC_NIL);

			/* Sanity check.											*/
			if (op_prg_list_size (proc_record_handle_list_ptr) != 1)
				{
				/* An error message is generated if zero or more than	*/
				/* one process record for a single custom routing		*/
				/* protocol has been registered in OMS PR - in the local*/
				/* node.												*/
				sprintf (error_string, "%s in this routing node.", custom_rte_protocol_name_ptr);
				op_sim_end (
					"Error: Found none, or more than one OMS Process Record(s) for",
					error_string, OPC_NIL, OPC_NIL);
				}

			/* Get a reference to the process record.					*/
			process_record_handle = (OmsT_Pr_Handle) op_prg_list_access (
										proc_record_handle_list_ptr, OPC_LISTPOS_HEAD);

			
	   		/*	Obtain the object id of the module performing the	*/
			/*	dynamic routing.									*/
			oms_pr_attr_get (process_record_handle,
				"module objid", OMSC_PR_OBJID, &dyn_rte_objid);

			/*	Schedule a remote interrupt to the custom routing	*/
			/*	protocol process to notify it that the IP interface */
			/*	table can now be accessed.							*/
			op_intrpt_schedule_remote (op_sim_time (), 0, dyn_rte_objid);
				
			/* Deallocate no longer needed process registry information*/
			op_prg_mem_free (proc_record_handle_list_ptr);
			}
		}
	
	/* The list for active custom routing protocols is no longer	*/
	/* needed, free the elements of the list and memory allocated	*/
	/* to it.														*/
	op_prg_list_free (active_custom_rte_proto_label_lptr);
	op_prg_mem_free (active_custom_rte_proto_label_lptr);
	
	FOUT;
	}

static void
ip_rtab_local_addr_register (IpT_Address ip_addr)
	{
	int					status;
	int					int_ip_addr;
	NatoT_Table_Handle	ip_table_handle;
	char				ip_addr_str [20];

	/** Register local IP address within the network wide IP	**/
	/** optimized address conversion table.						**/
	FIN (ip_rtab_local_addr_register (ip_addr));

	/* Obtain a handle of the IP interface addresses global table.	*/
	ip_table_handle = nato_table_handle_get ("ip_table");
	if (ip_table_handle == OPC_NIL)
		{
		op_sim_end ("Error at function ip_rtab_local_addrs_register: global ip_table_handle is invalid", OPC_NIL, OPC_NIL, OPC_NIL);
		}

	/* Convert IP address to a integer representation, so that */
	/* it may be stored in the NATO table.                     */
	int_ip_addr = ip_address_to_int (ip_addr);

	/* Store this IP address along with its compacted (integer) form	*/
	/* in the global IP address table maintained in the NATO package.	*/
	/* Since NATO allows for storing address types with two components	*/
	/* and IP addresses are implemented as "single" component addresses	*/
	/* use zero for the second component argument of the registration	*/
	/* function below. Also, create an association between this IP		*/
	/* address and the object ID of the node in which this IP model		*/
	/* is present. This provides a convenient mapping of IP addresses	*/
	/* to containing node object IDs which helps in mapping addresses	*/
	/* to node names when printing out simulation log messages.			*/
    status = nato_table_address_register (ip_table_handle, int_ip_addr, 0, own_node_objid);

    /* If the registration was not successful, return an error. */
	if (status == NATOC_TABLE_FORM_INVALID)
		op_sim_end ("Error at function ip_rtab_local_addrs_register: global ip table",
			"is in usage mode and no registrations can be performed", OPC_NIL, OPC_NIL);

	FOUT;
	}

static void
ip_rtab_local_network_register (IpT_Address ip_network_address)
	{
	int					status;
	int					int_ip_net_addr;
	NatoT_Table_Handle	ip_networks_table_handle;

	/** Register the possible networks that exist across the interfaces	**/
	/** of this node. These indicate the networks that this node can	**/
	/** reach without using any routing protocols.						**/
	FIN (ip_rtab_local_network_register (ip_netork_address));

	/* Obtain a handle of the IP network addresses global table.		*/
	ip_networks_table_handle = nato_table_handle_get ("ip_networks_table");
	if (ip_networks_table_handle == OPC_NIL)
		{
		op_sim_end ("Error at function ip_rtab_local_network_register: global ip_networks_table_handle is invalid", OPC_NIL, OPC_NIL, OPC_NIL);
		}

	/* Convert IP address to a integer representation, so that it may	*/
	/* be stored in the NATO table.										*/
	int_ip_net_addr = ip_address_to_int (ip_network_address);

	/* Store this IP address along with its compacted (integer) form	*/
	/* in the global IP address table maintained in the NATO package.	*/
	/* Since NATO allows for storing address types with two components	*/
	/* and IP addresses are implemented as "single" component addresses	*/
	/* use "0" for the second component argument of the registration	*/
	/* function below.													*/

	/* Also, create an association between this IP network address and	*/
	/* the object ID of the surrounding node. This may provide a		*/
	/* convenient mapping of IP addresses to containing node object IDs	*/
	/* which helps in mapping IP networks addresses to associated node	*/
	/* names when printing out simulation log messages.					*/

	/* Check to see if this network address has already been registered	*/
	/* If it has been, then do not register it again.					*/
	if (nato_table_one_component_address_entry_exists (ip_networks_table_handle, int_ip_net_addr) == OPC_FALSE)
		{
		/* The IP network address has not yet been registered.			*/
		status = nato_table_address_register (ip_networks_table_handle, int_ip_net_addr, 0, own_node_objid);

		/* If the registration was not successful, return an error.		*/
		if (status == NATOC_TABLE_FORM_INVALID)
			{
			op_sim_end ("Error at function ip_rtab_local_network_register: global ip networks table",
						"is in usage mode and no further registrations can be performed", OPC_NIL, OPC_NIL);
			}
		}

	FOUT;
	}

static void
ip_interface_table_print (List *iface_table_ptr)
	{
    int						i;
	char					str0 [512];
	int						num_entries;
	IpT_Interface_Info *	ip_interface_info_ptr;
	char					addr_str [IPC_ADDR_STR_LEN];
	char					subnet_mask_str [IPC_ADDR_STR_LEN];

	/** This function is used to print out the contents of the ip interface table. **/
	FIN (ip_interface_table_print (iface_table_ptr));

	/* Print out the route table information only if the route table exists. */
	if (iface_table_ptr != OPC_NIL)
		{
		op_prg_odb_print_major ("IP Interface Table Contents\n", OPC_NIL);
		op_prg_odb_print_minor ("Interface\tAddress\t\tSubnet Mask\tOutput\tInput", OPC_NIL);
		op_prg_odb_print_minor ("---------\t-------\t\t-----------\t------\t-----\n", OPC_NIL);
	
		num_entries = op_prg_list_size (iface_table_ptr);

		for (i = 0; i < num_entries; i++)
			{
			ip_interface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (iface_table_ptr, i);

			/* Get string representations of the address and subnet mask. */
			ip_address_print (addr_str, ip_interface_info_ptr->addr_range_ptr->address);
			ip_address_print (subnet_mask_str, ip_interface_info_ptr->addr_range_ptr->subnet_mask);
			
			sprintf (str0, "  [%d]\t\t%s\t%s\t  %d\t  %d\n",
				ip_interface_info_ptr->addr_index, addr_str, subnet_mask_str, 
				ip_interface_info_ptr->port_num, ip_interface_info_ptr->in_port_num);

			op_prg_odb_print_minor (str0, OPC_NIL);
			}
		}
	else
		{
		/* Print out an error message saying that the route table does not exist. */
		op_prg_odb_print_major ("IP Interface Table does not exist\n", OPC_NIL);
		}

    FOUT;
	}

static void
ip_networks_print (void)
	{
	NatoT_Table_Handle	ip_networks_table_handle;
	int					status;
	int					num_networks;
	int					i_th_network;
	NatoT_Table_Entry *	table_entry_ptr;
	char				header_str [128], header2_str [128];
	char				table_entry_str [512], title_str [512], blank_str [512] = "";
	int					int_ip_net_addr;
	IpT_Address 		ip_net_addr;
	char				ip_net_addr_str [IPC_ADDR_STR_LEN];

	/** This function is used to print the global IP networks table.	**/
	FIN (ip_networks_print (void));

	/* Obtain a handle on the global IP network address table.			*/
	ip_networks_table_handle = nato_table_handle_get ("ip_networks_table");
	if (ip_networks_table_handle == OPC_NIL)
		{
		op_sim_end ("Error at function ip_networks_print: global ip_networks_table_handle is invalid", OPC_NIL, OPC_NIL, OPC_NIL);
		}

	/* Print the table header. */
	sprintf (title_str, "Global IP Network Address Information");
	sprintf (header_str,  "IP Network Address   Internal Address");
	sprintf (header2_str, "------------------   ----------------");
	op_prg_odb_print_minor (blank_str, title_str, blank_str, header_str, header2_str, OPC_NIL);

	/* Determine the total number of registered networks.		*/
	num_networks = nato_table_size (ip_networks_table_handle);

	/* Loop through all the networks and print informaiton.		*/
	for (i_th_network = 0; i_th_network < num_networks; i_th_network++)
		{
		/* Get the i_th network address entry.					*/
		table_entry_ptr = nato_table_entry_get (ip_networks_table_handle, i_th_network);

		/* Get the major address -- the IP network address.		*/
		int_ip_net_addr = nato_table_entry_major_addr_get (table_entry_ptr);

		/* Convert the integer adress to dotted-decimal form.	*/
		ip_net_addr = ip_address_from_int (int_ip_net_addr);

		/* Get string representation of the network address.	*/
		ip_address_print (ip_net_addr_str, ip_net_addr);

		/* Prepare the display string.							*/
		sprintf (table_entry_str, " %-15s          %3d", ip_net_addr_str, i_th_network);

		/* Print out table entry.								*/
		op_prg_odb_print_minor (table_entry_str, OPC_NIL);
		}

	FOUT;
	}

static void
ip_rtab_print (void)
	{
	NatoT_Table_Handle	ip_table_handle;
	int					status;
	int					table_size, table_index;
	NatoT_Table_Entry *	table_entry_ptr;
	char				header_str [128], header2_str [128];
	char				table_entry_str [512], title_str [512], blank_str [512] = "";
	int					int_ip_addr, phys_addr;
	IpT_Address 		ip_addr;
	char				ip_addr_str [IPC_ADDR_STR_LEN];
	int					lower_layer_addr;
	int					lower_layer_index;
	Boolean				phys_addr_found;

	/** This function is used to print the global address table. **/
	FIN (ip_rtab_print (void));
	
	ip_table_handle = nato_table_handle_get ("ip_table");

	/* An error message is printed out if the table handle is OPC_NIL. */
	if (ip_table_handle == OPC_NIL)
		op_sim_end ("Error at function ip_rtab_print: global ip_table_handle is invalid", 
			OPC_NIL, OPC_NIL, OPC_NIL);

	/* Print the table header. */
	sprintf (title_str, "Global IP Address Mapping Table:");
	sprintf (header_str, "IP Address\t\tLower Layer Address");
	sprintf (header2_str, "----------\t\t-------------------");
	op_prg_odb_print_minor (blank_str, title_str, blank_str, header_str, header2_str, OPC_NIL);

	/* We do not use the standard nato table print function, so */
	/* can print out IP addresses in a readable form.           */
	table_size = nato_table_size (ip_table_handle);
	
	for (table_index = 0; table_index < table_size; table_index++)
		{
		/* Get the current table entry. */
		table_entry_ptr = nato_table_entry_get (ip_table_handle, table_index);

		/* Get the major address, which is the IP address. */
		int_ip_addr = nato_table_entry_major_addr_get (table_entry_ptr);

		/* Convert the integer representation to an internal representation. */
		ip_addr = ip_address_from_int (int_ip_addr);

		/* Get string representation of address. */
		ip_address_print (ip_addr_str, ip_addr);

		/* Loop through the lower layer addresses, and print out the */
		/* address that's defined.                                   */
		phys_addr_found = OPC_FALSE;
		for (lower_layer_index = 0; lower_layer_index < NATOC_NUM_LOWER_LAYER_ADDRS; lower_layer_index++)
			{
			if ((lower_layer_addr = nato_table_entry_phys_addr_get (table_entry_ptr, lower_layer_index)) !=
				NATOC_LOWER_LAYER_ADDR_UNDEFINED)
				{
				sprintf (table_entry_str, "(%s)\t\t%d (Type %d)",
					ip_addr_str, lower_layer_addr, lower_layer_index);
				phys_addr_found = OPC_TRUE;
				}

			if (!phys_addr_found)
				sprintf (table_entry_str, "(%s)\t\t(No physical address)",
					ip_addr_str);
			}

		/* Print out table entry. */
		op_prg_odb_print_minor (table_entry_str, OPC_NIL);
		}

	FOUT;
	}

static Compcode
ip_dest_reached (IpT_Address dest_addr, List *iface_table_ptr, int instrm)
    {
	int						i, interface_list_size;
    IpT_Interface_Info *	iface_elem_ptr;

	/** This procedure is used to determine whether the IP datagram has reached its destination. **/
	FIN (ip_dest_reached (dest_addr, iface_table_ptr, instrm));

	/* Loop through all IP interfaces to see if the destination address matches anyone of them. */
	interface_list_size = op_prg_list_size (iface_table_ptr);

	for (i = 0; i < interface_list_size; i++)
		{
		iface_elem_ptr = (IpT_Interface_Info *) op_prg_list_access (iface_table_ptr, i);

		/* An IP datagram has reached its destination under the following conditions: */
		/*   1) The destination address matches the interface address.                */
		/*   2) The destination address is broadcast to the net the interface is      */
		/*      connected to, and the datagram was not originated by the local node.  */
		/*   3) The destination address is broadcast to all nets and nodes, and the   */
		/*      datagram was not originated by the local node.                        */

		if (iface_elem_ptr->intf_unnumbered == OPC_TRUE)
			{
			if (ip_address_equal (iface_elem_ptr->network_address, dest_addr))
				FRET (OPC_COMPCODE_SUCCESS);
			}

		/* This checks condition 1. */
		if (ip_address_equal (iface_elem_ptr->addr_range_ptr->address, dest_addr))
			FRET (OPC_COMPCODE_SUCCESS);

		/* This checks conditions 2 and 3. */
		if ((ip_address_is_broadcast (dest_addr, iface_elem_ptr->addr_range_ptr->subnet_mask)) &&
			(instrm != instrm_from_ip_encap) && (instrm != IpC_Pk_Instrm_Child))
			FRET (OPC_COMPCODE_SUCCESS);
		}


	/* None of the three conditions matched for any of the interfaces, */
	/* so the datagram has not reached its destination.                */
	FRET (OPC_COMPCODE_FAILURE);
	}

static void
ip_src_address_determine (IpT_Address dest_addr, IpT_Address *src_addr_ptr, List *iface_table_ptr,
							int output_intf_index)
	{
	int						i;
	IpT_Interface_Info *	iface_elem_ptr;
	char					error_string [512];
	char					dest_addr_str [IPC_ADDR_STR_LEN];
	int						iface_table_size;

	/** This procedure is used to determine the correct src address based **/
	/** on the next hop address.                                          **/
	FIN (ip_src_address_determine (dest_addr, src_addr_ptr, iface_table_ptr));

	/* Loop through the interfaces and see if the destination address falls within the */
	/* range of any of the interfaces.  If so, then return the address of the          */
	/* interface as the source address.                                                */
	iface_table_size = op_prg_list_size (iface_table_ptr);
	for (i = 0; i < iface_table_size; i++)
		{
		iface_elem_ptr = (IpT_Interface_Info *) op_prg_list_access (iface_table_ptr, i);

		/* Check if the interface is of type unnumbereed and the index matches */
		if (((output_intf_index == i  ) || (output_intf_index == -1))&& 
			iface_elem_ptr->intf_unnumbered == OPC_TRUE)
			{
			*src_addr_ptr = ip_address_copy (iface_elem_ptr->network_address);

			FOUT;
			}

		/* Does the destination address exist within the range of */
		/* addresses the interface connects to?                   */
		if (ip_address_range_check (dest_addr, iface_elem_ptr->addr_range_ptr))
			{
			/* Found the proper interface, so fill in the source address. */
			*src_addr_ptr = ip_address_copy (iface_elem_ptr->addr_range_ptr->address);

			FOUT;
			}
		}

	/* An error message is signaled, as no matching source address can be */
	/* found for the destination address.                                 */
	ip_address_print (dest_addr_str, dest_addr);
	sprintf (error_string, "No valid source address for next hop (%s)", dest_addr_str);
	ip_rte_error (error_string);

	FOUT;
	}

static void
ip_rte_error (char *msg)
	{
	/** Print an error message and exit the simulation. **/
	FIN (ip_rte_error (msg));

	op_sim_end (
		"Error in IP routing process model (ip_rte_v4):",
		msg,
		"Check simulation log messages from the IP model for more information.",
		"Simulation Logging can be enabled/disabled in the Simulation Editor."); 
	FOUT;
	}

static void
ip_rte_warn (char *msg)
	{
	/** Print a warning message and resume. **/
	FIN (ip_rte_warn (msg));

	op_sim_message ("Warning from IP routing process model (ip_rte_v4):", msg);

	FOUT;
	}


static Compcode
ip_rte_destination_local_network (IpT_Address dest_addr, int* output_intf_index_ptr, 
	IpT_Interface_Info** interface_ptr, int *outstrm_ptr)
    {
	int						i, iface_table_size;
    IpT_Interface_Info *	iface_elem_ptr;
	Compcode				result = OPC_COMPCODE_FAILURE;

	/** This procedure is used to determine whether the IP datagram is **/
	/** destined for a direct neighbor of this node.                   **/
	FIN (ip_rte_destination_local_network (dest_addr, output_intf_index_ptr, interface_ptr));

	/* Create a table to store the information of how to reach the	*/
	/* immediate neighbors. The table is a list of elements (Router	*/
	/* ID, interface_index). 										*/
	if (router_id_assigned == OPC_FALSE && 
		unnumbered_interface_exists == OPC_TRUE)
		{
		/* When dealing with unnumbered OSPF point-to-point interfaces,	*/
		/* the IP layer needs to know the neighboring router ID for		*/
		/* every interface. This is essential in order to route the		*/
		/* the routing protocol's traffic.								*/
		ip_unnumbered_intf_router_id_assign ();
		router_id_assigned = OPC_TRUE;
		}

	/* Loop through the IP interface table to see if the	*/
	/* destination address matches any of the interface's	*/
	/* router_id's or the network addresses.				*/
	iface_table_size = op_prg_list_size (interface_table_ptr);
	for (i = 0; i < iface_table_size; i++)
		{
		iface_elem_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, i);

		/* First check if the interface is for a unnumbered	*/
		/* point-to-point link. If so compare the router_id	*/
		/* stored in the interface with the destination 	*/
		/* address.	If a match is found then return	OPC_TRUE*/
		if (iface_elem_ptr->intf_unnumbered)
			{
			if (ip_address_equal (dest_addr, iface_elem_ptr->neighboring_rtr_id))
				{
				result = OPC_COMPCODE_SUCCESS;
				break;
				}
			}
		/* Else the interface is a numbered interface and	*/
		/* check the destination address to the in the same	*/
		/* range as the interface's network address by 		*/
		/* applying the subnet mask.						*/
		else if (ip_address_range_check (dest_addr, iface_elem_ptr->addr_range_ptr))
			{
			result = OPC_COMPCODE_SUCCESS;
			break;
			}
		}

	if (result == OPC_COMPCODE_SUCCESS)
		{
		/* Set the interface specific parameters to be	*/
		/* used to reach the specified next hop.		*/
		*interface_ptr = iface_elem_ptr;
		*output_intf_index_ptr = i;
		*outstrm_ptr = iface_elem_ptr->port_num;
		}

	FRET (result);
	}


static IpT_Interface_Info *
ip_interface_info_create (void)
	{
	IpT_Interface_Info *		iface_info_ptr;

	/** Create an interface information structure. **/
	FIN (ip_interface_info_create (void));

	/* Allocate memory for the structure. */
	iface_info_ptr = (IpT_Interface_Info *) op_prg_mem_alloc (sizeof (IpT_Interface_Info));

	/* Initialize fields of the structure. */
	iface_info_ptr->addr_index = 0;
	iface_info_ptr->addr_range_ptr = OPC_NIL;
	iface_info_ptr->mtu = 0;
	iface_info_ptr->port_num = 0;
	iface_info_ptr->in_port_num = 0;
	iface_info_ptr->connected_link_objid = OPC_OBJID_INVALID;
	iface_info_ptr->speed = 1E+15;
	iface_info_ptr->load_bits = 0.0;
	iface_info_ptr->load_bps = 0.0;
	iface_info_ptr->reliability = 1.0;
	iface_info_ptr->last_load_update_time = op_sim_time ();
	iface_info_ptr->multicast_enabled = OPC_FALSE;

	/* As an memory optimization, only allocate this 		*/
	/* background utilization routed state pointer when the */
	/* interface is used.									*/
	iface_info_ptr->load_bgutil_routed_state_ptr = OPC_NIL;
		
	FRET (iface_info_ptr);
	}

static void
ip_rte_next_hop_error (IpT_Address addr)
	{
	char			addr_str [IPC_ADDR_STR_LEN];

	/** Print out an error indicating an invalid next hop. **/
	FIN (ip_rte_next_hop_error (addr));

	/* Get a printable version of the next hop address.		*/
	ip_address_print (addr_str, addr);

	/* Write a message to the simulation log.				*/
	ipnl_proterr_nexthop_error (addr_str);

	FOUT;
	}

static Compcode
ip_rte_datagram_dest_get (Packet* pkptr, Ici* rsvp_ici_ptr, Boolean force_fwd, Boolean broadcast_addr, IpT_Address dest_addr, 
	int instrm, int fast_address, int protocol_type, IpT_Address *next_addr_ptr, Boolean *broadcast_ptr, Boolean *higher_layer_ptr,
	Boolean *destroy_pkt_ptr, int *output_intf_index_ptr, IpT_Interface_Info **interface_ptr, int* minor_port_out_ptr)
	{
	char					dest_addr_str [IPC_ADDR_STR_LEN];
	char					next_addr_str [IPC_ADDR_STR_LEN];
	char					interface_addr_str [IPC_ADDR_STR_LEN];
	char					error_str [512];
	Compcode				route_status;
	Ici *					pk_ici_ptr;
	int						outstrm;
	IpT_Interface_Info *	intf_info_ptr;
	RsvpT_Rte_Ici_Struct*	rsvp_route_info_ptr;
	IpT_Port_Info			port_info;
	int 					src_proto = 0;

	/** Retrieve and return the outstream, outslot and mtu to which we should **/
	/** send the datagram. This function may also return status flags		  **/
	/** indicating that the datagram should be broadcast, and/or the datagram **/
	/** should be forwarded to the higher layer.  If OPC_COMPCODE_SUCCESS is  **/
	/** returned, the datagram can be dispatched by the client of this		  **/
	/** procedure; if OPC_COMPCODE_FAILURE is returned, a routing message	  **/
	/** error shoud be generated, and the datagram should be destroyed.		  **/
	FIN (ip_rte_datagram_dest_get (pkptr, rsvp_ici_ptr, force_fwd, broadcast_addr, dest_addr, instrm, 
		fast_address, protocol_type, next_addr_ptr, broadcast_ptr, higher_layer_ptr, destroy_pkt_ptr, 
		output_intf_index_ptr, interface_ptr, minor_port_out_ptr));

	/* By default the packet should not be destroyed.							*/
	*destroy_pkt_ptr = OPC_FALSE;

	/* Initialize the flags to OPC_FALSE.	*/
	*higher_layer_ptr = OPC_FALSE;
	*destroy_pkt_ptr = OPC_FALSE;

	/* Check if the packet is received from higher or lower layer.	*/
	if (instrm == instrm_from_ip_encap || instrm == IpC_Pk_Instrm_Child)
		{
		/** The packet came from higher layer or a child process. **/

		/* If this is an RSVP packet, do not perform route query, 	*/
		/* but rather set the routing parameters.					*/
		if (protocol_type == IpC_Protocol_Rsvp)
			{
			/** This is an RSVP packet.		**/

			/* The packet should be accompanied by ICI.		*/
			/* Read the routing information in the ICI.		*/
			op_ici_attr_get (rsvp_ici_ptr, "RSVP Packet Route Info", &rsvp_route_info_ptr);

			/* Set the next hop address based on the next hop specified by RSVP and already	*/
			/* set in the forwarding ICI.													*/ 
			*next_addr_ptr = rsvp_route_info_ptr->next_hop_addr;

			/* Store the index of this interface object in intf_index.	*/
			*output_intf_index_ptr = rsvp_route_info_ptr->intf_index;

			/* Find the interface pointer.	*/
			intf_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, rsvp_route_info_ptr->intf_index);

			/* Store this interface object in interface_pptr.	*/
			*interface_ptr = intf_info_ptr;

			/* Deallocate memory allocated for the ICI DS.	*/
			op_prg_mem_free (rsvp_route_info_ptr);

			/* Destroy the RSVP ICI.							*/
			op_ici_destroy (rsvp_ici_ptr);

			FRET (OPC_COMPCODE_SUCCESS);
			}
		}
	else
		{
		/** Packet came from a lower layer.		**/
		
		/* Check if this node has RSVP enabled.	*/
		if ((rsvp_status == OPC_TRUE) && (protocol_type == IpC_Protocol_Rsvp))
			{
			/* All RSVP packets comming from the lower layer need to	*/
			/* be forwarded to the higher layer.							*/
			*higher_layer_ptr = OPC_TRUE;
			
			FRET (OPC_COMPCODE_SUCCESS);
			}

		
		/* Check if the node is a cache server.	*/
		if ((node_is_cache_server == OPC_TRUE) &&
			((protocol_type == IpC_Protocol_Tcp) || (protocol_type == IpC_Protocol_Udp)))
			{
			/* All TCP and UDP packets comming from the lower layer need to	*/
			/* be forwarded to the higher layer.							*/
			*higher_layer_ptr = OPC_TRUE;
			
			FRET (OPC_COMPCODE_SUCCESS);
			}
		}

	/* First make sure that this node is not the source of the packet. Check	*/
	/* this only when we do not have to force the IP datagram to the lower		*/
	/* layers. If this packet came from the higher layer (ip_encap) and is		*/
	/* destined for the same node, then also send it to the lower layer. When	*/
	/* the lower layer sends it back, this packet will be forwarded to the		*/
	/* higher layer.															*/
	if (force_fwd == OPC_FALSE)
		{	
		if (ip_dest_reached (dest_addr, interface_table_ptr, instrm) == OPC_COMPCODE_SUCCESS)
			{
			/* The destination address matches one of the IP addresses	*/
			/* on this node, and therefore has reached its final		*/
			/* destination.  The datagram should be forwarded to the 	*/
			/* higher layer.                                      		*/
			*broadcast_ptr = OPC_FALSE;
			*higher_layer_ptr = OPC_TRUE;

			FRET (OPC_COMPCODE_SUCCESS);
			}
		}

	/********************************************************************/
	/* We do not need to worry about the case when the destination is	*/
	/* a broadcast address because this case is handled directly in the	*/
	/* svc_compl executives. Specifically, when a datagram is being		*/
	/* sent to a broadcast address, svc_compl sets a flag indicating	*/
	/* this and all we have to do is check that flag and map it to the	*/
	/* flags set by this function, i.e. broadcast_ptr, higher_layer_ptr	*/
	/* and destroy_pkt_ptr.												*/
	/********************************************************************/
	if (broadcast_addr == OPC_TRUE)
		{
		/* This is a broadcast packet being sent out by a process on	*/
		/* this node. Set the appropriate flags and return.				*/
		*broadcast_ptr = OPC_TRUE;
		*higher_layer_ptr = OPC_FALSE;

		FRET (OPC_COMPCODE_SUCCESS);
		}

	/* The destination is neither a broadcast nor matches an IP interface on this node. */
	*broadcast_ptr = OPC_FALSE;
	*higher_layer_ptr = OPC_FALSE;

	/* Initialize the port info object.								*/
	port_info.major_port = OPC_INT_UNDEF;
	port_info.minor_port = OPC_INT_UNDEF;

	/* Destroy the packet if its comming from the lower layer and is not destined for this node.*/
	/* The packet is only processed if the node is a gateway.									*/
	if ((instrm != instrm_from_ip_encap) && (instrm != IpC_Pk_Instrm_Child) && (gateway_status == OPC_FALSE))
		{
		/* Destroy the packet if it is not destined for this node.	*/
		*destroy_pkt_ptr = OPC_TRUE;

		FRET (OPC_COMPCODE_SUCCESS);
		}

	/* Check first to see if the destination is local. */
	if (ip_rte_destination_local_network (dest_addr, output_intf_index_ptr, interface_ptr, &outstrm) 
		== OPC_COMPCODE_SUCCESS)
		{
		/* If we got an invalid outstrm, then give an error message. */
		if (outstrm == IP_OUTSTRM_INVALID)
			{
			/* Write out a message to the sim. log.	*/
			ip_rte_next_hop_error (dest_addr);

			FRET (OPC_COMPCODE_FAILURE);
			}

		*next_addr_ptr = dest_addr;
    	
		/* We have enough information for the client to dispatch to the next hop. */
		FRET (OPC_COMPCODE_SUCCESS);
		}

	/* The node does not know how to route this datagram; forward it to a:		*/
	/*   1) Default Gateway, if specified using the "default gateway" process	*/
	/*      model attribute, or													*/
	/*	 2) Local Gateway, which can be determined if not known.				*/
	/* The default gateway attribute can be used both by the end stations as	*/
	/* well as gateways to forward the datagram to the next hop, whereas, a 	*/
	/* local gateway is used only by the end stations. Determine if this node	*/
	/* functions like a gateway.												*/
	if (gateway_status == OPC_FALSE)
		{
		/* This node is not a gateway. Determine if a next hop gateway is		*/
		/* already known or not.												*/
		if (gateway_known == OPC_FALSE)
			{
			/* The gateway is not yet known. Determine if a defaut gateway has	*/
			/* been specified. If specified, use this as the next hop; else		*/
			/* find a local gateway to which the datagram should be forwarded	*/
			/* as its next hop.													*/
			if (default_gtwy_available == OPC_TRUE)
				{
				/* A defaut gateway has been specified. Update the state	*/
				/* information to reflect this								*/
				next_addr_gateway = default_gtwy_addr; 
				gateway_known = OPC_TRUE;
				}
			else
				{
				/* A default gateway is not available and we need to forward	*/
				/* the datagram to a gateway, but the gateway is not yet known.	*/
				/* Determine the local gateway.                 				*/
				if (ip_rte_local_gateway_find (interface_table_ptr, next_addr_ptr) == OPC_COMPCODE_SUCCESS)
					{
					/* Found the local gateway. Update the state information	*/
					/* to reflect this. 										*/
					next_addr_gateway = *next_addr_ptr;
					gateway_known = OPC_TRUE;
					}
				else
					{
					/* A router interface was not found in any of the	*/
					/* IP subnets to which this node is connected. Set	*/
					/* the flag indicating that this packet must be		*/
					/* dropped from further processing.					*/
					*destroy_pkt_ptr = OPC_TRUE;

					FRET (OPC_COMPCODE_SUCCESS);
					}
				}
			}

		/* Determine interface parameters for next hop. */
		outstrm = ip_rte_dgram_fwding_parameters_obtain (ip_route_table, interface_table_ptr, &next_addr_gateway, 
							output_intf_index_ptr, interface_ptr, &port_info, &src_proto);

		/* Is the stream valid?							*/
		if (outstrm == IP_OUTSTRM_INVALID)
			{
			/* Write out a message to the sim. log.	*/
			ip_rte_next_hop_error (next_addr_gateway);
			
			FRET (OPC_COMPCODE_FAILURE);
			}

		/* Copy the gateway address to the next hop.	*/
		*next_addr_ptr = ip_address_copy (next_addr_gateway);
		
		/* We have enough information for the client to dispatch to the next hop. */
		FRET (OPC_COMPCODE_SUCCESS);
		}
	else
		{
		/* The IP node is a router, and the final destination is not on a		*/
		/* network the router connects to.  At this point, we need to find a 	*/
		/* "next hop". This can be found using:									*/
		/*  1) Performing a routing table lookup.	 							*/
		/*	2) The routing table may provide us a "next hop", but that "next	*/
		/*     hop" may not be a directly connected network to the surrounding	*/
		/*     router -- in this case, we need to recursively loop till we		*/
		/*     cannot find an entry in the routing table.						*/
		/*  3) Using the "default gateway" specification, if the routing 		*/
		/*	   table lookup fails.     											*/

		/* Invoke routing table lookup.	*/
		route_status = ip_cmn_rte_table_lookup (fast_address, ip_route_table, dest_addr, next_addr_ptr, &port_info, &src_proto);

		/* If the routing table lookup fails, look for a default gateway.		*/
		if (route_status == OPC_COMPCODE_FAILURE)
			{
			if (default_gtwy_available == OPC_TRUE)
				{
				/* A default gateway has been specified.						*/
				*next_addr_ptr = ip_address_copy (default_gtwy_addr);

				/* Indicate that a valid next hop route is available.			*/
				route_status = OPC_COMPCODE_SUCCESS;
				}
			else
				{
				/* Create a printable version of the destination IP address being			*/
				/* processed.																*/
				ip_address_print (dest_addr_str, dest_addr);

				/* A route to the destination address cannot be found. Report	*/
				/* an error. Construct error string.							*/
				sprintf (error_str, "Unable to find a gateway while routing datagram destined for (%s)", dest_addr_str);

				/* Write a message to the simulation log file.	*/
				ipnl_proterr_noroute_ripospf (
					dest_addr_str, "RIP/OSPF/IGRP/STATIC", op_pk_id (pkptr), op_pk_tree_id (pkptr));

				/* Set the boolean flag indicating that this packet	*/
				/* should be destroyed by the client.				*/
				*destroy_pkt_ptr = OPC_TRUE;
				FRET (OPC_COMPCODE_SUCCESS);
				}
			}

		/* We have a valid route (and a valid next hop). Next find the	*/
		/* interface this hop corresponds to.							*/
		outstrm = ip_rte_dgram_fwding_parameters_obtain (ip_route_table, interface_table_ptr, next_addr_ptr, 
						output_intf_index_ptr, interface_ptr, &port_info, &src_proto);
		
		/* Is this a valid outstream?	*/
		if (outstrm == IP_OUTSTRM_INVALID)
			{
			if (src_proto >= IPC_INITIAL_CUSTOM_RTE_PROTOCOL_ID)
				{
				/* The major port specified in the route entry of	*/
				/* a custom routing protocol is invalid.			*/
				/* Just drop this packet. 							*/
				FRET (OPC_COMPCODE_FAILURE);
				}
			else
				{
				/* Write out a message to the sim. log.	*/
				ip_rte_next_hop_error (*next_addr_ptr);

				FRET (OPC_COMPCODE_FAILURE);
				}
			}

		/* Set the minor port value.	*/
		if (port_info.minor_port != OPC_INT_UNDEF)
			*minor_port_out_ptr = port_info.minor_port;
		
		}
	
	FRET (route_status);
	}


static void
ip_rte_dgram_options_process (Boolean dgram_dest_reached, Packet* ip_pkptr, int output_iface_index)
	{
	IpT_Dgram_Options*		ip_dgram_options_ptr;
	IpT_Interface_Info*		iface_ptr;
	IpT_Address				iface_address;

	/** IP supports setting "options" while transmitting datagrams	**/
	/** across source-destination pairs - currently the only option	**/
	/** supported in this model is the "Record Route" option,		**/
	/** wherein every router in the path records the address of the	**/
	/** interface it uses to forward the packet to the next hop.	**/
	FIN (ip_rte_dgram_options_process (ip_pkptr, output_iface_index));

	/* Obtain the "options" fields from the IP datagram.	*/
	op_pk_nfd_access (ip_pkptr, "options", &ip_dgram_options_ptr);

	/* Currently the model only supports IP record route option	*/
	/* Check if that option is being used.						*/
	if (ip_dgram_options_ptr->type == IpC_Option_Record_Route)
		{
		/* The record route option is set only by nodes that will	*/
		/* forward this IP datagram. If the datagram destined for	*/
		/* this node, then do not process further.					*/
		if (dgram_dest_reached == OPC_TRUE)
			{
			/* No further processing required. */
			}
		else
			{
			/* Obtain the IP address of the output interface to be 	*/
			/* used to forward this datagram to the next node.		*/
			iface_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, output_iface_index);
			iface_address = iface_ptr->addr_range_ptr->address;

			/* Insert this address in the route data field of the	*/
			/* options data structure.								*/
			op_prg_list_insert (ip_dgram_options_ptr->route_data_lptr, iface_address, OPC_LISTPOS_TAIL);

			/* Increment the lenth of the entries in the route data list.	*/
			ip_dgram_options_ptr->length++;
			}
		}

	FOUT;
	}

static void
ip_rte_datagram_broadcast (IpT_Address dest_addr, Packet *pk_ptr, int interface_index, 
	IpT_Rte_Ind_Ici_Fields* ici_fdstruct_ptr)
	{
	int						num_ifaces;
	IpT_Interface_Info *	iface_ptr;
	Packet *				pk_copy_ptr;
	IpT_Dgram_Fields*		pkt_fields_ptr;
	Ici*					pk_ici_ptr;
	double					comp_size;
		
	/** Broadcast a datagram on all applicable interfaces. **/
	FIN (ip_rte_datagram_broadcast (dest_addr, pk_ptr, interface_index));
	
	/* If interface_index == IP_BROADCAST_ALL_INTERFACES, 	*/
	/* then this is a broadcast that needs to be sent out	*/
	/* on all the IP interfaces connected to this node. 	*/
	/* Else, interface_index points to the position in the	*/
	/* interface list of the interface over which the 		*/
	/* broadcast has to be sent out.						*/
	if (interface_index == IP_BROADCAST_ALL_INTERFACES)
		{
		/* Loop through all interfaces, and send a copy of the	*/
		/*	packet on each applicable interface.				*/
		num_ifaces = op_prg_list_size (interface_table_ptr);

		for (interface_index = 0; interface_index < num_ifaces; interface_index++)
			{
			/* Obtain a handle on the i_th interface. */
			iface_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, interface_index);

			/* If the interface we are working with is not the	*/
			/* last one then we need to create a copy of the	*/
			/* packet and send out the copy. The orig. packet	*/
			/* will be sent out the last interface in the list.	*/
			if (interface_index < (num_ifaces - 1))
				pk_copy_ptr = op_pk_copy (pk_ptr);
			else
				pk_copy_ptr = pk_ptr;
			
			/*	Access the datagram field information structure	*/
			/* 	to assign source address information.			*/
			op_pk_nfd_access (pk_copy_ptr, "fields", &pkt_fields_ptr);

			/* Set the source address before forwarding the packet. */
			pkt_fields_ptr->src_addr = iface_ptr->addr_range_ptr->address;
	
			/* Since for unnumbered OSPF point-to-point interfaces	*/
			/* the interface address is just the interface number,	*/
			/* a different check is performed.						*/ 
			if (iface_ptr->intf_unnumbered == OPC_FALSE)
				pkt_fields_ptr->src_internal_addr =	ip_rtab_addr_convert (iface_ptr->addr_range_ptr->address);
			else
				pkt_fields_ptr->src_internal_addr = ip_rtab_addr_convert (iface_ptr->network_address);

			/* Check whether datagram compression is used at	*/
			/* this interface. If it is and if we use central	*/
			/* based processing then we need to compress packet	*/
			/* now since the packet will not processed again.	*/
			if ((processing_scheme == OmsC_Dv_Centralized) && (iface_ptr->comp_info->method != IpC_No_Compression))
				{
				/* Retrieve the ICI associated with the packet.	*/
				pk_ici_ptr = op_pk_ici_get (pk_copy_ptr);
				if (pk_ici_ptr == OPC_NIL)
					ip_rte_error ("Error in extracting the associated ICI from the IP datagram.");

				/* Compute the compressed size. If compression	*/
				/* is applicable it will be stored into the ICI.*/
				ip_rte_comp_delay_and_size_compute (pk_copy_ptr, pkt_fields_ptr, pk_ici_ptr, iface_ptr);

				/* Retrieve the data and check whether we need	*/
				/* to compress.									*/
				comp_size = ici_fdstruct_ptr->compressed_size;
				if (comp_size != IPC_COMPRESSION_NOT_USED)
					{
					/* If Per-Interface compression is used and	*/
					/* the size of the datagram will be still	*/
					/* greater than mtu after compression, then	*/
					/* we will not compress the packet now, but	*/
					/* will compress it after the fragmentation.*/
					/* Also check this case before compressing	*/
					/* the datagram.							*/
					if (!((pkt_fields_ptr->compression_method == IpC_Per_Interface_Comp) && 
                          ((int)comp_size > iface_ptr->mtu * 8)))
						{
						/* Store the packet's original size,	*/
						/* which will be used for decompression.*/
						pkt_fields_ptr->original_size = op_pk_total_size_get (pk_copy_ptr);

						/* Compress the packet with resizing.	*/
						op_pk_total_size_set (pk_copy_ptr, (int) comp_size);

						/* Issue a trace statement.				*/
						if (LTRACE_COMPRESSION_ACTIVE || op_prg_odb_pktrace_active (pk_copy_ptr))
							ip_rte_comp_decomp_trace_print (pk_copy_ptr, pkt_fields_ptr->compression_method, pkt_fields_ptr->original_size, (int) comp_size, "compression");
						}

					/* Reset the ICI field.						*/
					ici_fdstruct_ptr->compressed_size = IPC_COMPRESSION_NOT_USED;
					}	
				}
			
			ip_rte_datagram_interface_forward (dest_addr, dest_addr, pk_copy_ptr, 
				iface_ptr->addr_index, ici_fdstruct_ptr);
			}
		}
	else
		{
		iface_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, interface_index);

		pk_copy_ptr = pk_ptr;

		/*	Access the datagram field information structure	*/
		/* 	to assign source address information.			*/
		op_pk_nfd_access (pk_copy_ptr, "fields", &pkt_fields_ptr);

		/* Set the source address before forwarding the packet. */
		pkt_fields_ptr->src_addr =  iface_ptr->addr_range_ptr->address;

		/* For unnumbered interfaces the address representation	*/
		/* is different and that is why a seperate comparision	*/
		/* is required.											*/
		if (iface_ptr->intf_unnumbered == OPC_FALSE)
			pkt_fields_ptr->src_internal_addr =	ip_rtab_addr_convert (iface_ptr->addr_range_ptr->address);
		else
			pkt_fields_ptr->src_internal_addr = ip_rtab_addr_convert (iface_ptr->network_address);

		ip_rte_datagram_interface_forward (dest_addr, dest_addr, pk_copy_ptr, iface_ptr->addr_index,
			ici_fdstruct_ptr); 
		}

	FOUT;
	}

static void
ip_rte_datagram_higher_layer_forward (Packet *pk_ptr, IpT_Address dest_addr)
	{
	Packet *						ip_pkptr;
	Packet*							bgutil_pkptr;
	char							str0 [512];
	char							dest_addr_str [IPC_ADDR_STR_LEN];
	Ici *							intf_ici_ptr;
	IpT_Dgram_Fields*				pkt_fields_ptr;
	Ici* 							test_iciptr;
	IpT_Interface_Info*				intf_info_ptr;
	IpT_Rte_Ind_Ici_Fields*			intf_ici_fdstruct_ptr=OPC_NIL;
	double							latency;
	Boolean							ip_mcast_data_pkt_on_rte = OPC_FALSE;
	
	/** Forward a datagram to the higher layer. Note that IP also	**/
	/** has four child processes -- ip_basetraf_src for background	**/
	/** traffic, ip_icmp for ICMP messages, ip_igmp_rte_intf or		**/
	/** ip_igmp_host for IGMP messages and ip_pim_sm for PIM and IP	**/
	/** multicast messages. Conceptually, these processes are at a	**/
	/** higher layer than IP (as they supply datagrams to IP to		**/
	/** route across the network.) Thus, this function also checks	**/
	/** packets destined for these processes.						**/
	FIN (ip_rte_datagram_higher_layer_forward (pk_ptr, dest_addr));

	/** First Check if this is a multicast router and the			**/
	/** packet is a multicast data packet.							**/
	/** Note: On a multicast router, since PIM-SM child process 	**/
	/** acts as a forwarding agent for IP multicast data packets	**/
	/** these packets shouldn't be reassembled before sending		**/
	/** to PIM-SM child process. IP multicast data packets are 		**/
	/** those whose dest_addr is a multicast address and which		**/
	/** needs to be forwarded by this multicast router. If this	 	**/
	/** router hasn't joined the multicast group to which the		**/
	/** packets are sent, then this router forwards the packets.	**/

	/*  Obtain a handle on the information carried in the "fields" data structure	*/
	/*	in the incoming IP datagram.												*/
	op_pk_nfd_access (pk_ptr, "fields", &pkt_fields_ptr);

	if ((multicast_router == OPC_TRUE)
		&& (ip_address_is_multicast (pkt_fields_ptr->dest_addr) == OPC_TRUE)
		&& (pkt_fields_ptr->protocol != IpC_Protocol_Rsvp))
		{
		/* Get the ICI associated with the packet. If no ICI exists,	*/
		/* report an error message and terminate the simulation.		*/
		if ((intf_ici_ptr = op_pk_ici_get (pk_ptr)) == OPC_NIL)
			{
			op_sim_end ("Error in IP routing process model (ip_rte_v4): ",
						"No ip_rte_ind_v4 ICI has been associated with the",
						"multicast packet.", OPC_NIL);			
			}

		/* Get the "rte_info_fields" field from the ICI					*/
		op_ici_attr_get (intf_ici_ptr, "rte_info_fields", &intf_ici_fdstruct_ptr);

		/* If the interface on which the multicast packet was received is not 	*/
		/* specified in the ICI, its an error. Report an error message and		*/
		/* terminate the simulation.											*/
		if (intf_ici_fdstruct_ptr->intf_recvd_index == -1)
			{
			op_sim_end ("Error in IP routing process model (ip_rte_v4): ",
						"The interface on which the multicast packet was received is",
						"not specified in the packet's ICI.", OPC_NIL);
			}

		/* If the router did not join the multicast address, we set the flag	*/
		/* ip_mcast_data_pkt_on_rte to OPC_TRUE so that the multicast packets	*/
		/* are not reassembled before sending it to the child process.			*/
		if (ip_address_multicast_accept (pkt_fields_ptr->dest_addr, intf_ici_fdstruct_ptr->major_port_received) == OPC_FALSE)
			{
			ip_mcast_data_pkt_on_rte = OPC_TRUE;
			ip_pkptr = pk_ptr;
			}
		}

	/* Call the fragment reassembly procedure to determine if    */
	/* a complete packet has arrived.  Note that the packet      */
	/* will be destroyed in this procedure call unless it is     */
	/* itself the complete datagram (i.e., it isn't a fragment). */
	/* If this node is a multicast router and the packet is a 	 */
	/* multicast data packet, send the packet to the PIM-SM		 */
	/* process without reassembling.							 */
	if ((ip_mcast_data_pkt_on_rte == OPC_TRUE)
		|| ((ip_pkptr = ip_frag_sup_insert (dgram_list_ptr, pk_ptr)) != OPC_NIL))
		{
		/* In debug mode, issue a  trace statement. */
		if (op_prg_odb_ltrace_active ("ip_frag"))
			{
			ip_address_print (dest_addr_str, dest_addr);
			sprintf (str0, "Complete Datagram Received at (%s)", dest_addr_str);
			op_prg_odb_print_major (str0, OPC_NIL);
			}

		/*  Obtain a handle on the information carried in the "fields" data structure	*/
		/*	in the incoming IP datagram.												*/
		op_pk_nfd_access (ip_pkptr, "fields", &pkt_fields_ptr);

		/* Set the destination address before sending the packet. */
		/* Only set the destination address if the field is not set. */
		if (pkt_fields_ptr->dest_addr == IPC_ADDR_INVALID)
			{
			pkt_fields_ptr->dest_addr = dest_addr;
			}

		
		/* Check the 'interface received' ICI.  If the ICI isn't set in the packet,  */
		/* set it with IP default address (0.0.0.0) as the interface received. This	 */
		/* corresponds to the situation where the higher layer sends a packet to     */
		/* itself (except in the case of broadcast).                                 */
		if ((intf_ici_ptr = op_pk_ici_get (ip_pkptr)) == OPC_NIL)
			{
			intf_ici_ptr = op_ici_create ("ip_rte_ind_v4");
			intf_ici_fdstruct_ptr = ip_rte_ind_ici_fdstruct_create ();
			
			/* Set the interface_received and minor port recieved to	*/
			/* to their default values.									*/
			intf_ici_fdstruct_ptr->interface_received = ip_address_copy (IpI_Default_Addr);
			intf_ici_fdstruct_ptr->minor_port_received = IPC_MINOR_PORT_DEFAULT;
			
			/* Set the rte_info_fields of the ICI.						*/
			op_ici_attr_set (intf_ici_ptr, "rte_info_fields", intf_ici_fdstruct_ptr);

			/* Attach the interface information with the packet.			*/
			op_pk_ici_set (ip_pkptr, intf_ici_ptr);
			}

		/* The source address is unlikely to be set, simply set to the destination address. */
		if (pkt_fields_ptr->src_addr == IPC_ADDR_INVALID)
			{
			pkt_fields_ptr->src_addr = dest_addr;
			}

		/* Always refresh the rte_info_fields from the returned packet's	*/
		/* ICI, in case the original ICI is destroyed during the reassembly	*/
		/* of IP fragments.													*/
		op_ici_attr_get (intf_ici_ptr, "rte_info_fields", &intf_ici_fdstruct_ptr);
	
		/* Check if this packet is destined for ICMP process within this	*/
		/* node. Note that ICMP packets are handled by a child process of	*/
		/* this process -- ip_icmp. If it is for the ICMP process, invoke	*/
		/* the ICMP child process and pass the packet to it.				*/
		if (pkt_fields_ptr->protocol == IpC_Protocol_Icmp)
			{
			/* Install the IP packet in the memory being shared with ICMP	*/
			ip_ptc_mem_ptr->child_pkptr = ip_pkptr;

			/* Invoke ICMP process model, which processes the ICMP packet	*/
			/* contained in the IP datagram.								*/
			op_pro_invoke (icmp_process_handle, OPC_NIL);
			}
		else if ((pkt_fields_ptr->protocol == IpC_Protocol_Igmp) &&
				(mcast_rte_protocol == IpC_Rte_Pim_Sm))
			{
			/** An IGMP message has been received. Invoke the corresponding	**/
			/** IGMP child process to process this message					**/

			/* Check if this node is a multicast router */
			if (multicast_router)
				{
				/** This node is a multicast router. Invoke the IGMP Router	**/
				/** Interface child process to process this message			**/
				
				/* Install the IP packet in the memory being shared with	*/
				/* IGMP Router Interface child process						*/
				ip_ptc_mem_ptr->child_pkptr = ip_pkptr;
			
				if (intf_ici_fdstruct_ptr->intf_recvd_index != -1)
					{
					/* Access the IpT_Interface_Info object for the interface	*/
					/* on which this packet was received						*/
					intf_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, 
										intf_ici_fdstruct_ptr->intf_recvd_index);

					/* Invoke the IGMP Router Interface child process of the	*/
					/* interface												*/
					op_pro_invoke (intf_info_ptr->igmp_rte_iface_ph, OPC_NIL);
					}
				else
					{
					op_sim_end ("Error in IP routing process model (ip_rte_v4): ",
						"The interface on which the IGMP packet was received is",
						"not specified in the packet's ICI.", OPC_NIL);
					}
				}
			else
				{
				/** This node is a multicast host. Invoke the IGMP Host		**/
				/** child process to process this IGMP message				**/

				/* Install the IP packet in the memory being shared with	*/
				/* IGMP Host child process									*/
				ip_ptc_mem_ptr->child_pkptr = ip_pkptr;

				/* Set other fields of the shared memory					*/
				ip_ptc_mem_ptr->ip_igmp_ptc_info.type = IpC_Igmp_Host_Other;
				if (intf_ici_fdstruct_ptr->major_port_received != -1)
					{
					ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port = intf_ici_fdstruct_ptr->major_port_received;
					ip_ptc_mem_ptr->ip_igmp_ptc_info.minor_port = intf_ici_fdstruct_ptr->minor_port_received;
					}
				else
					{
					op_sim_end ("Error in IP routing process model (ip_rte_v4): ",
						"The interface on which the IGMP packet was received is",
						"not specified in the packet's ICI.", OPC_NIL);
					}

				/* Invoke the IGMP Host child process						*/
				op_pro_invoke (igmp_host_process_handle, OPC_NIL);
				}

			/* Destroy the associated interface ici which we obtained above. */
			ip_rte_intf_ici_destroy (intf_ici_ptr);
			}
		else if ((pkt_fields_ptr->protocol == IpC_Protocol_Pim) || 
					((multicast_router == OPC_TRUE) && 
					(ip_address_is_multicast (pkt_fields_ptr->dest_addr) == OPC_TRUE)))
			{
			/** A PIM-SM control packet or multicast data packet has been	**/
			/** received. Invoke the PIM-SM child process or the custom_mrp	**/
			/** child process to process this message.						**/

			/** Note: The limitation of IP Multicast model is that any 		**/
			/** layer above IP can't join an IP multicast group in a		**/
			/** Multicast router node . But, OSPF model joins certain		**/
			/** multicast groups. The following if statement handles this	**/
			if (pkt_fields_ptr->protocol == IpC_Protocol_Rsvp)
				{
				/** The multicast packet is for the RSVP layer.	**/

				if (rsvp_status == OPC_TRUE)
					{
					/** RSVP is enabled on the node.	**/

					/* Forward the packet to the higher layer   */
					op_pk_send (ip_pkptr, outstrm_to_ip_encap);
					}
				else
					{
					/* Destroy the packet.	*/ 
					ip_rte_dgram_discard (ip_pkptr, intf_ici_ptr);

					/* Write a log message.	*/
					rsvpnl_no_intf_support ();
					}
				}
			else if ((pkt_fields_ptr->protocol == IpC_Protocol_Ospf) &&
				(ip_address_multicast_accept (pkt_fields_ptr->dest_addr, intf_ici_fdstruct_ptr->major_port_received) == OPC_TRUE))
				{
				/** The multicast packet is for OSPF model	**/

				/* Forward it to higher layer	*/
				op_pk_send (ip_pkptr, outstrm_to_ip_encap);
				}
			else
				{
				/**	Send the multicast packet to the multicast child process	**/
				/** so that it can be routed.									**/
				/** For custom multicasting if the router joined the multicast	**/
				/** groups address forward the packet to higher layer.			**/
				/** Note: If the SV mcast_rte_protocol is "IpC_Rte_Pim_Sm" we	**/
				/** invoke PIM-SM else custom_mrp is invoked.					**/

				if (multicast_router == OPC_FALSE)
					{
					/* Received a packet for PIM-SM or custom multicast child	*/
					/* process. But, the child process is not created as the	*/
					/* multicast routing capability is disabled on this node.	*/
					/* Report a log message and terminate the simulation.	*/
					ipnl_cfgerr_pim_sm_child_process_not_created ();
					ip_rte_error ("The multicast child process, ip_pim_sm, doesn't exist on this node.");
					}
				
				/* Install the IP packet in the memory being shared	*/
				/* with the multicast child process.				*/
				ip_ptc_mem_ptr->child_pkptr = ip_pkptr;

				/* Set other fields of the shared memory			*/
				if (intf_ici_fdstruct_ptr->major_port_received != -1)
					{
					ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port = intf_ici_fdstruct_ptr->major_port_received;
					ip_ptc_mem_ptr->ip_igmp_ptc_info.minor_port = intf_ici_fdstruct_ptr->minor_port_received;
					}
				else
					{
					op_sim_end ("Error in IP routing process model (ip_rte_v4): ",
						"The interface on which the PIM-SM control or multicast data",
						"packet was received is not specified in the packet's ICI", OPC_NIL);
					}
				
				if (mcast_rte_protocol == IpC_Rte_Pim_Sm)
					{
					/* Invoke the PIM-SM child process						*/
					op_pro_invoke (pim_sm_process_handle, OPC_NIL);

					/* Destroy the associated interface ici, which we obtained above. */
					ip_rte_intf_ici_destroy (intf_ici_ptr);
                    }
				else 
					{
					/* Custom multicasting is being used. If the router joined the	*/
					/* multicast address send the packet to higher layer, else send	*/
					/* the packet to custom_mrp child process for routing.			*/
					if (ip_address_multicast_accept (pkt_fields_ptr->dest_addr, intf_ici_fdstruct_ptr->major_port_received) == OPC_TRUE)
						{
						/* Forward it to higher layer	*/
						op_pk_send (ip_pkptr, outstrm_to_ip_encap);
						}
					else
						{
						/* Invoke the Custom_Mrp child process						*/
						op_pro_invoke (custom_mrp_process_handle, OPC_NIL);

						/* Destroy the associated interface ici, which we obtained above. */
						ip_rte_intf_ici_destroy (intf_ici_ptr);
						}
					}
				}
			}
		else if (pkt_fields_ptr->protocol == IpC_Protocol_Basetraf)
			{
			/* This packet was generated by the ip_basetraf_src proceess.	*/
			/* We will destroy the packet here.								*/
			
			/* Check here if the packet to be forwarded to the higher		*/
			/* layer contains a backgroung traffic tracer packet.			*/
			/* (destination to source packets do not contain a tracer pk).	*/
			if (op_pk_encap_flag_is_set (pk_ptr, OMSC_BGUTIL_ENCAP_FLAG_INDEX) == OPC_TRUE)
				{
				/* This is a tracer packet destined for here. The packet	*/
				/* has served its purpose, so instead of forwarding it to	*/
				/* the ip_basetraf_src model, we can safely destroy the		*/
				/* packet here. Write the ETE statistic before destroying	*/
				/* the tracer packet. Drill to get the actual tracer packet	*/
				op_pk_encap_pk_get (pk_ptr, "bgutil_tracer", &bgutil_pkptr);
				
				/* Handle processing of the incoming tracer packet.	*/
				if (bgutil_pkptr != OPC_NIL)
					{
					ip_rte_bgutil_pkt_dest_handle (bgutil_pkptr);
					}
				}
			
			/* Destroy the associated interface ici which we obtained above. */
			ip_rte_intf_ici_destroy (intf_ici_ptr);

			/* Now destroy the IP packet.	*/
			op_pk_destroy (pk_ptr);
			}
		else if (pkt_fields_ptr->protocol == IpC_Protocol_Rsvp)
			{
			/** The multicast packet is for the RSVP layer.	**/

			if (rsvp_status == OPC_TRUE)
				{
				/** RSVP is enabled on the node.	**/

				/* Forward the packet to the higher layer   */
				op_pk_send (ip_pkptr, outstrm_to_ip_encap);
				}
			else
				{
				/* Destroy the packet.	*/ 
				ip_rte_dgram_discard (ip_pkptr, intf_ici_ptr);

				/* Write a log message.	*/
				rsvpnl_no_intf_support ();
				}
			}
		else
			{
			/* Forward the complete packet to the higher layer. */
			if (ipcloud_flag == OPC_TRUE)
				{
				/* Find the delay experienced through this cloud object.	*/
				/* The first argument to the following function call is the	*/
				/* transmission data rate used to compute the transmission	*/
				/* delay together with the packet size. Since there is no	*/
				/* transmission involved in forwarding this packet, set the	*/
				/* rate to infinity for zero delay.							*/
				latency = ip_cloud_latency_determine (OPC_INT_INFINITY, outstrm_to_ip_encap, ip_pkptr);

				/* Write the statistics for the Packet Latency time */
				op_stat_write (local_pkt_latency_stat, latency);

				/* Send the packet after the latency delay on the   */
				/* desired output stream.                           */
				op_pk_send_delayed (ip_pkptr, outstrm_to_ip_encap, latency);
				}
			else
		    	{
		    	/* Send the packet as a forced interrupt so that	*/
				/* the contents of the ICI are not overwritten.		*/
		    	op_pk_send (ip_pkptr, outstrm_to_ip_encap);
		    	}
			}
		}

	FOUT;
	}


static void
ip_rte_bgutil_pkt_dest_handle (Packet* bgutil_pkptr)
	{
	double			stamp_time;
	double			ete_delay;
	double			bgutil_bandwidth;
	Stathandle*		ete_stathndl_ptr;

	/** Handles tracer packets destined for thsi node. The packets	**/
	/** have served their purpose, so instead of forwarding it to	**/
	/** the ip_basetraf_src model, we can safely destroy them here.	**/
	/** Write the ETE statistic before destroying the tracer packet	**/
	FIN (ip_rte_bgutil_pkt_dest_handle (bgutil_pkptr));

	/* Get the stamp time of the tracer packet.			*/
	stamp_time = op_pk_stamp_time_get (bgutil_pkptr);

	/* Calculate the end to end delay incurred by this 	*/
	/* tracer packet.									*/
	ete_delay = op_sim_time () - stamp_time;

	/* Retrieve the bandwidth that this tracer packet 	*/
	/* carries. Do not record the ete stat if the 		*/
	/* bandwidth is zero.								*/
	op_pk_nfd_get (bgutil_pkptr, "bandwidth", &bgutil_bandwidth);

	/* If the bandwidth is equal to or lesser than 0.0	*/
	/* it does not represent the end to end delay due	*/
	/* to background utilization. The value will not be */
	/* lesser than zero, but it could be equal to 0.0	*/
	/* for the tracer packets that are sent out to make	*/
	/* sure that the background utilization expires 	*/
	/* the specified interval.							*/
	if (bgutil_bandwidth > 0.0)
		{
		/* Get the stathandle that is embedded in the tracer*/
		/* packet.											*/
		op_pk_nfd_get (bgutil_pkptr, "ETE Stathandle", &ete_stathndl_ptr);

		/* Check for the validity of the stathandle pointer.*/
		/* write out the statistic only if it is valid.		*/
		if (ete_stathndl_ptr != OPC_NIL)
			{
			/* Write out the local end to end delay statistic	*/
			/* for packets originating from the node where this */
			/* tracer packet originated.						*/
			op_stat_write (*ete_stathndl_ptr, ete_delay);

			/* Free up the memory allocated to the stathandle	*/
			op_prg_mem_free (ete_stathndl_ptr);
			}

		/* Write thelocal stat for the packet coming in.	*/
		op_stat_write (local_tracer_in_ete_hndl, ete_delay);

		/* Write out the global end to end delay.	*/
		op_stat_write (globl_tracer_ete_delay_hndl, ete_delay);
		}

	/* Destroy the tracer packet.	*/
	op_pk_destroy (bgutil_pkptr);

	FOUT;
	}

static void
ip_rte_datagram_interface_forward (IpT_Address dest_addr, IpT_Address next_addr, 
	Packet* pk_ptr, int output_intf_index, IpT_Rte_Ind_Ici_Fields* intf_ici_fdstruct_ptr)
	{
	int							ttl;
	char						str0 [512], str1 [512];
	char						dest_addr_str [IPC_ADDR_STR_LEN];
	char						next_addr_str [IPC_ADDR_STR_LEN];
	char						intf_addr_str [IPC_ADDR_STR_LEN];
	int							conn_class;
	IpT_Address					src_addr;
	IpT_Address					intf_addr;
	int 						ip_fast_addr;
	Ici*                        intf_ici_ptr;
	int							processed, inslot, outslot;
	int							packet_size;
	double						pk_svc_time;
	double						dgram_arrival_time = 0.0;
	Evhandle					evh;
	OmsT_Dv_Slot_Info*			slot_info_ptr;
	int							pkt_dest_type;
	IpT_Dgram_Fields*			pk_fd_ptr;
	IpT_Interface_Info* 		iface_info_ptr;
	double						comp_delay = 0.0, bgutil_delay;
	int							broadcast, broadcast_intf_index;
	Boolean						ip_rte_trace;

	/** Forward a datagram to a particular IP interface (specified by a	**/
	/** stream and MTU). We need to forward the packet to the central	**/
	/** processor if slot based processing scheme is used and the 		**/
	/** input and output ports of the packet are not on the same slot	**/
	/** (slot-to-slot forward). Similarly, again when slot based 		**/
	/** processing scheme is used, the packets that orginally came from	**/
	/** the higher layer are put into the buffer of output slot instead	**/
	/** of being forwarded to the output IP interface.					**/
	FIN (ip_rte_datagram_interface_forward (dest_addr, next_addr, pk_ptr, output_intf_index,
		intf_ici_fdstruct_ptr));

	/* Obtain the whether the labeled trace on "ip_rte" is enabled 	*/
	ip_rte_trace = op_prg_odb_ltrace_active ("ip_rte");

	/*  Obtain the interface ICI from the packet. The ICI contains  */
	/*  information on the interface this IP datagram arrived.      */
	intf_ici_ptr = op_pk_ici_get (pk_ptr);

	/*	 Retrieve the ICI associated with the packet.					*/
	if (intf_ici_fdstruct_ptr == OPC_NIL)
		{
		ip_rte_error ("Error in extracting the associated ICI from the IP datagram.");
		}
	else 
		{	
		/* Determine whether it has been processed before or not.		*/
		processed = intf_ici_fdstruct_ptr->processed;

		/* Determine the slot which the input port belongs to.			*/
		inslot = intf_ici_fdstruct_ptr->slot_index;

		/*  Determine the slot which the output port belongs to.		*/
		outslot = intf_ici_fdstruct_ptr->outslot;

		/* Obtain the time at which datagram arrived at the IP layer.	*/
		dgram_arrival_time = intf_ici_fdstruct_ptr->pkt_insertion_time;

		/* Obtain the packet received interface address					*/
		intf_addr = ip_address_copy (intf_ici_fdstruct_ptr->interface_received);
		}
	
	/*	Access "fields" structure from ip datagram.						*/
	op_pk_nfd_access (pk_ptr, "fields", &pk_fd_ptr);

	/* Forward the packet if											*/
	/* 1. the processing scheme is slot based,							*/
	/* 2. or it is a port-to-port transmission							*/
	/* 3. or it has been processed before by the server of input slot	*/
	/*    and forwarded to the output slot through the central 			*/
	/*    which is ready to be forwarded to the output IP interface.	*/
	if ((processing_scheme == OmsC_Dv_Centralized) || (inslot == intf_ici_fdstruct_ptr->outslot) || 
		(processed == OPC_TRUE))
		{
		/*	Decrement packet's time to live field, if the packet came from		*/
		/*	lower layer and is not being sent to higher layer. If this becomes	*/
		/*	zero, discard the packet											*/
		if (intf_ici_fdstruct_ptr->instrm != instrm_from_ip_encap && 
				intf_ici_fdstruct_ptr->instrm != IpC_Pk_Instrm_Child &&
				intf_ici_fdstruct_ptr->higher_layer == OPC_FALSE)
			pk_fd_ptr->ttl--;
		
		if (pk_fd_ptr->ttl == 0)
			{
			/* Create string references to the destination and next addresses. 			*/
			ip_address_print (dest_addr_str, dest_addr);

			/* Get a printable version of the interface addr. on which this pkt.	*/
			/* was received.														*/
			ip_address_print (intf_addr_str, intf_addr);

			/* In debug mode, indicate that a packet is destroyed due to expired ttl. */
			if (op_prg_odb_ltrace_active ("ip_errs"))
				{
				sprintf (str0, "Discarding packet (%d) with expired TTL", op_pk_id (pk_ptr));
				sprintf (str1, "Destination: (%s)", dest_addr_str);
				op_prg_odb_print_major (str0, str1, OPC_NIL);
				}

			/* Issue a simulation log message.									*/
			ipnl_reswarn_ttlexp (op_pk_id (pk_ptr), op_pk_tree_id (pk_ptr), intf_addr_str, dest_addr_str);

			/* Drop this unroutable IP datagram.	*/
			ip_rte_dgram_discard (pk_ptr, intf_ici_ptr);

			FOUT;
			}
		
		/** For interfaces using custom routing protocols, drop	**/
		/** the packet, if a packet is being sent on the same	**/
		/** major and minor port it came on. For interfaces 	**/	
		/** using standard routing protocols, packets are not 	**/
		/** dropped. This is ensured by setting					**/
		/** minor_port_received to OPC_INT_UNDEF. The			**/
		/** minor_port_out obtained from the common route table	**/
		/** route entry added by a standard routing protocol has**/
		/** a value of IPC_MINOR_PORT_DEFAULT.					**/
        if ((intf_ici_fdstruct_ptr->instrm == intf_ici_fdstruct_ptr->outstrm) && 
			(intf_ici_fdstruct_ptr->minor_port_received == intf_ici_fdstruct_ptr->minor_port_out))
            {

			/* Get a printable version of the interface addr. on which this pkt.	*/
			/* was received.														*/
			ip_address_print (intf_addr_str, intf_addr);

			/* Create string references to the destination and next addresses. 			*/
			ip_address_print (dest_addr_str, dest_addr);

			/* Print debugging information if tracing is on.			*/
			if (op_prg_odb_ltrace_active ("port_info_equal"))
				{
				sprintf (str0, "The In Port and Out Port information match.");
				sprintf (str1, "Packet id: (%d)", op_pk_id (pk_ptr));
				op_prg_odb_print_major ("Dropping the IP packet.", str0, str1, OPC_NIL);

				sprintf (str0, "Arrived interface address: (%s)", intf_addr_str);
				sprintf (str1, "Destination address: (%s)", dest_addr_str);
				op_prg_odb_print_minor (str0, str1, OPC_NIL);
				}

			/* Simply destroy the packet since a packet can not be sent	*/
			/* to the same address it came on.							*/
			op_pk_destroy (pk_ptr);

			FOUT;
			}

		/*	In debug mode, trace the routing action.					*/
		if (ip_rte_trace == OPC_TRUE)
			{
			/* Create string references to the destination and next addresses. 			*/
			ip_address_print (dest_addr_str, dest_addr);
			ip_address_print (next_addr_str, next_addr);

			sprintf (str0, "Routing packet ID (%d) towards (%s)", op_pk_id (pk_ptr), dest_addr_str);
			sprintf (str1, "Next hop (%s), output stream (%d)", next_addr_str, 
				intf_ici_fdstruct_ptr->outstrm);
			op_prg_odb_print_major (str0, str1, OPC_NIL);
			}

		/* Obtain the connection class from the packet.				*/
		conn_class = pk_fd_ptr->connection_class;

		/* If the source address is not set, set it here.			*/
		if (pk_fd_ptr->src_addr == IPC_ADDR_INVALID)
			{
			ip_src_address_determine (next_addr, &src_addr, interface_table_ptr, output_intf_index);
			pk_fd_ptr->src_internal_addr = ip_rtab_addr_convert (src_addr);
			pk_fd_ptr->src_addr			 = src_addr;
			}

		/* Set the destination address before sending the packet.	*/
		pk_fd_ptr->dest_addr = dest_addr;

		/* Compute packet latency through the IP layer. Since we	*/
		/* stored the time at which the datagram actually arrived	*/
		/* at IP, we can calculate "latency" as the difference of	*/
		/* of the current time to that time.						*/
		op_stat_write (ip_rte_pkt_latency_stathandle, (double) op_sim_time () - dgram_arrival_time);

		/* Disassociate the ici with the outgoing packet			*/
		if (intf_ici_fdstruct_ptr != OPC_NIL)
			op_pk_ici_set (pk_ptr, OPC_NIL);

		/* Then send the IP packet in fragments.					*/
		ip_rte_pk_frag_send (pk_ptr, dest_addr, next_addr, conn_class, intf_ici_fdstruct_ptr);

		/* Check the higher layer indication ICI.  If set, then remove it, since we	*/
		/* are not forwarding the packet to the higher layer. Also, deallocate the	*/
		/* contents of the ICI (interface address on which the dgram was received.)	*/
		if (intf_ici_fdstruct_ptr != OPC_NIL)
			{
			intf_addr = intf_ici_fdstruct_ptr->interface_received;

			/* Here there is no need to deallocate the memory used by two other		*/
			/* structure fields of the ICI, namely dest_addr and next_addr, 	 	*/
			/* since their contents may have passed as arguments to this function	*/
			/* that are accessed also in the rest of the function. In these cases 	*/
			/* this memory will be freed later on. For other cases, the contents of */
			/* these fields are NIL.												*/
	
			/* Get the value of the pkt_dest_type field so that we can correctly	*/
			/* categorize this packet as a unicast, multicast or broadcast.			*/
			pkt_dest_type = intf_ici_fdstruct_ptr->pkt_dest_type;

			/* Destroy the ICI.		*/
			ip_rte_ind_ici_fdstruct_destroy (intf_ici_fdstruct_ptr);
			op_ici_destroy (intf_ici_ptr);
			}
		}
	else
		{
		/* Slot based processing is used and the forward is not 	*/
		/* port-to-port, which means the input and output ports of 	*/
		/* the packet are on different slots or the packet is 		*/
		/* received from higher layer. In this case we need to put	*/
		/* the packet into the buffer of output slot and schedule	*/
		/* the service if the processor is available.				*/

		/* Store the information into ICI so that we do not 		*/
		/* recompute it.											*/
		intf_ici_fdstruct_ptr->processed = OPC_TRUE;
		intf_ici_fdstruct_ptr->next_addr = ip_address_copy (next_addr);

		/* Store the interface on which the datagram arrived. */
		intf_addr = ip_address_copy (intf_ici_fdstruct_ptr->interface_received);

		/* Place the packet in to central processor's queue. The	*/
		/* processor will process the packet and forward it to the	*/
		/* output slot. If the packet is from central processor,	*/
		/* which means the packet is from higher layer, then we can	*/
		/* put the packet directly into output slots's buffer and 	*/
		/* that slot will forward it through one of its ports.		*/
		if (inslot != CENTRAL_CPU)
			{
			/* This packet is from another slot. Insert it in the	*/
			/* central processor queue.								*/
			if (op_subq_pk_insert (0, pk_ptr, OPC_QPOS_TAIL) != OPC_QINS_OK)
				{
				/*	The insertion failed (due to a full queue).		*/
				/*	We need to drop the packet.						*/

				/*	Issue trace statement.							*/
				if ((ip_rte_trace == OPC_TRUE) && op_prg_odb_pktrace_active (pk_ptr))
					{
					sprintf (str0, "Packet ID (%d) arrived on slot %d and destined for slot %d has dropped because of full central buffer",
						op_pk_id (pk_ptr), inslot, outslot);
					op_prg_odb_print_minor (str0, OPC_NIL);
					}

				/* Drop this unroutable IP datagram.	*/
				ip_rte_dgram_discard (pk_ptr, intf_ici_ptr);

				ip_address_print (intf_addr_str, intf_addr);
				ipnl_reswarn_pktinsert (op_pk_id (pk_ptr), op_pk_tree_id (pk_ptr), intf_addr_str);
				}
			else
				{
				/*	Insertion was successful. Issue trace statement.*/
				if ((ip_rte_trace == OPC_TRUE) && op_prg_odb_pktrace_active (pk_ptr))
					{
					sprintf (str0, "Packet ID (%d) arrived on slot %d and destined for slot %d has been put into central buffer",
						op_pk_id (pk_ptr), inslot, outslot);
					op_prg_odb_print_minor (str0, OPC_NIL);
					}

				/* Check the status of the central processor. If it	*/
				/* is available, then it can immediately start 		*/
				/* processing the new packet. In that case schedule	*/
				/* the self interrupt to indicate the end of 		*/
				/* service.											*/
				if (central_server_status == OmsC_Dv_Processor_Idle)
					{
					/*	Determine the time required to complete		*/
					/*	service of the enqueued packet.				*/
					pk_svc_time = 1.0 / service_rate;

					if (do_bgutil)
						{
						/* This packet is about to start service.  We will 		*/
						/* consider as part of it's service time the time the 	*/
						/* packet spent waiting for background utilization		*/
						/* packets to be serviced.								*/
						bgutil_delay = oms_bgutil_router_delay_calculate (pk_ptr, op_sim_time (), pk_svc_time, &bgutil_routed_state_ptr);
						}
					else
						{
						bgutil_delay = 0.0;
						}

					/*	Schedule an interrupt for this process at 	*/
					/*	the time service ends.						*/
					evh = op_intrpt_schedule_self (op_sim_time () + pk_svc_time + bgutil_delay, SLOT_TO_CENTRAL_FORWARD);
					if (op_ev_valid (evh) == OPC_FALSE)
						ip_rte_warn ("Unable to schedule service completion.");
					else
						{
						/* Set the CPU Utilization stat to 100. A packet arrives	*/
						/* from a slot into the central queue when the central		*/
						/* processor was idle.										*/
						op_stat_write (local_utilization_stathandle, 100.0);

						/*	Mark the server to be busy now.			*/
						central_server_status = OmsC_Dv_Processor_Busy;
						}
 					}
				}
			}
		else
			{
			/* The packet is from higher layer and being processed 	*/
			/* by central processor. Place it into the queue of		*/
			/* output slot.											*/
			slot_info_ptr = op_prg_list_access (slot_table_ptr, outslot);

			/* Try to enqueue the packet.							*/
			packet_size = op_pk_total_size_get (pk_ptr);
			if (slot_info_ptr->buffer_usage + packet_size <= slot_info_ptr->buffer_capacity)
				{
				/* There is space in the buffer for the received	*/
				/* packet. Insert it to the tail of slot's buffer.	*/
				op_prg_list_insert (slot_info_ptr->packet_queue, pk_ptr, OPC_LISTPOS_TAIL);
				slot_info_ptr->buffer_usage += packet_size;
				slot_info_ptr->pkts_in_queue++;

				/* In output slot the datagram will be processed	*/
				/* for the the last time and then will be forwarded.*/
				/* Compute the compression delay if the output		*/
				/* interface uses a compression scheme and if it is */
				/* not a broadcast packet for all interfaces. If	*/
				/* the compression will not be applied then the		*/
				/* function will return 0.0. The function will also	*/
				/* store the new size into ICI if the datagram will */
				/* be compressed.									*/
				broadcast = intf_ici_fdstruct_ptr->broadcast;
				broadcast_intf_index = intf_ici_fdstruct_ptr->broadcast_intf_index;

				if (!broadcast || (broadcast_intf_index != IP_BROADCAST_ALL_INTERFACES))
					{
					/* First determine whether we use compression	*/
					/* at the output interface.						*/
					if (broadcast)
						iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, broadcast_intf_index);
					else
						{
						output_intf_index = intf_ici_fdstruct_ptr->output_intf_index;
						iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, output_intf_index);
						}

					if (iface_info_ptr->comp_info->method == IpC_No_Compression)
						comp_delay = 0.0;
					else
						comp_delay = ip_rte_comp_delay_and_size_compute (pk_ptr, pk_fd_ptr, intf_ici_ptr, iface_info_ptr);
					}

				/* Check the status of the slot's processor. If it	*/
				/* is available, then it can immediately start 		*/
				/* processing the new packet. In that case schedule	*/
				/* the self interrupt to indicate the end of the	*/
				/* service.											*/
				if (slot_info_ptr->slot_proc_status == OmsC_Dv_Processor_Idle)
					{
					/*	Determine the time required to complete		*/
					/*	service of the enqueued packet.				*/
					pk_svc_time = 1.0 / slot_info_ptr->forwarding_rate;

					if (do_bgutil)
						{
						/* This packet is about to start service.  We will 		*/
						/* consider as part of it's service time the time the 	*/
						/* packet spent waiting for background utilization		*/
						/* packets to be serviced.								*/
						bgutil_delay = oms_bgutil_router_delay_calculate (pk_ptr, op_sim_time (), pk_svc_time, &bgutil_routed_state_ptr);
						}
					else
						{
						bgutil_delay = 0.0;
						}

					/*	Schedule an interrupt for this process at	*/
					/*	the time service ends.						*/
					evh = op_intrpt_schedule_self (op_sim_time () + pk_svc_time + comp_delay + bgutil_delay, outslot);
					if (op_ev_valid (evh) == OPC_FALSE)
						{
						ip_rte_warn ("Unable to schedule service completion.");
						}
					else
						{
						/*	Mark the server to be busy now.			*/
						slot_info_ptr->slot_proc_status = OmsC_Dv_Processor_Busy;
    					}
					}
				else
					{
					/* Slot's server is busy, so the datagram will be	*/
					/* processed later. Associate the compression delay	*/
					/* with the datagram. This delay will be added to	*/
					/* the service time when the service is scheduled.	*/
					intf_ici_fdstruct_ptr->comp_decomp_delay = comp_delay;
					}
				}	
			else
				{
				/* The insertion failed (due to a full queue).		*/
				/* We need to drop the packet.						*/

				/*	Issue trace statement.							*/
				if ((ip_rte_trace == OPC_TRUE) && op_prg_odb_pktrace_active (pk_ptr))
					{
					sprintf (str0, "Packet ID (%d) being forwarded from central processor to output slot %d dropped because of full queue",
						op_pk_id (pk_ptr), outslot);
					op_prg_odb_print_minor (str0, OPC_NIL);
					}

				/* Drop this unroutable IP datagram.	*/
				ip_rte_dgram_discard (pk_ptr, intf_ici_ptr);

				ip_address_print (intf_addr_str, intf_addr);
				ipnl_reswarn_slot_pktinsert (op_pk_id (pk_ptr), op_pk_tree_id (pk_ptr), intf_addr_str, outslot);
				}
			}
		}

	FOUT;
	}

static void
ip_forward_packet_to_output_queues (Packet* pk_ptr, int outstrm, Ici* iciptr, int pkt_txtype, int output_interface_index, int incoming_iface)
	{
	IpT_Interface_Info*		iface_info_ptr;

	/** This function is in charge of sending a packet when	**/
	/** a output queuing processing scheme such as WFQ, 	**/
	/** FIFO, Priority Queuing or Custom Queuing is chosen.	**/
	/** It is called after being put in the	main queue in 	**/
	/** the case of "Central Processing", or after being 	**/
	/** put in the output slot queue in the case of "slot	**/
	/** based processing". NOTE that the output queues		**/
	/** process might discard packets, when it determines	**/	
	/**	that there is congestion.							**/
	FIN (ip_forward_packet_to_output_queues (pk_ptr, outstream, iciptr, pkt_txtype, output_interface_index, incoming_iface));

	/* Set the incoming interface in the ICI.	*/
	if (op_ici_attr_set (iciptr, "incoming_iface", incoming_iface) == OPC_COMPCODE_FAILURE)
            			ip_rte_error ("Unable to set incoming interface in ICI.");

	/* Set the IP Packet Type in order to write a statistic for	*/
	/* the specific type of packet sent. (multicast...)			*/
	if (op_ici_attr_set (iciptr, "pkt_txtype", pkt_txtype) == OPC_COMPCODE_FAILURE)
            			ip_rte_error ("Unable to set packet type in ICI.");

	/* Associate the ICI to the current packet	*/
	op_pk_ici_set (pk_ptr, iciptr);	

	/* Give to the child process via the shared		*/
	/* via the shared memory the outstream where	*/
	/* the packet will be sent and a specific IP	*/
	/* function which reads IP attributes.			*/
	shared_mem_ptr->outstream = outstrm;
	shared_mem_ptr->iface_index = output_interface_index;
	
	/* Call the output_iface child process in charge of the output queues.	*/
	iface_info_ptr = op_prg_list_access (interface_table_ptr, output_interface_index);
	op_pro_invoke (iface_info_ptr->output_iface_prohandle, pk_ptr);

	FOUT;
	}

static void
ip_rte_pk_frag_send (Packet *pk_ptr, IpT_Address dest_addr, IpT_Address next_addr, 
	int conn_class, IpT_Rte_Ind_Ici_Fields* intf_ici_ptr)
	{
	int						frag_size, data_size, header_size, len;
	int						num_frags, frag_index, frag_accum, original_size_accum;
	char					str0 [512];
	Packet *				ip_pkptr;
	Packet *				data_pkptr;
	Packet *				frag_ptr;
	int						frag;
	IpT_Dgram_Fields*		pk_fd_ptr;
	IpT_Dgram_Fields*		frag_pk_fd_ptr;
	Ici * 					iciptr;
	double					latency;
	int						mtu;
	int 					outstrm;
	double					speed;	
	int						interface_type;
	int						pkt_txtype;
	int						interface_index;
	IpT_Interface_Info*		iface_info_ptr;
	int						ip_queuing_scheme;
	int 					minor_port;

	/**	Fragment the IP packet and send the fragments over the given  **/
	/**	Also assocaites an ICI if the interface can process an ICI	  **/
	/**	(e.g., ARP) -- such interfaces are called smart interfaces.	  **/
	/** Point-to-Point duplex link comes in the category of a "Dumb"  **/
	/**	interface as it cannot process an incoming ICI, and will, 	  **/
	/**	teherfore, leak memory, if installed for such interfaces.	  **/
	FIN (ip_rte_pk_frag_send (pk_ptr, dest_addr, next_addr, conn_class, intf_ici_ptr));

	/* Obtain the interface parameters from the Interface ICI		*/
	mtu 			= intf_ici_ptr->output_mtu;
	speed 			= intf_ici_ptr->iface_speed;
	outstrm 		= intf_ici_ptr->outstrm;
	interface_type 	= intf_ici_ptr->interface_type;
	pkt_txtype		= intf_ici_ptr->pkt_dest_type;
	interface_index = intf_ici_ptr->output_intf_index;
	minor_port		= intf_ici_ptr->minor_port_out;
		
	/* Get the output interface index.	*/
	if ((intf_ici_ptr->broadcast) && (intf_ici_ptr->broadcast_intf_index != IP_BROADCAST_ALL_INTERFACES))
		{
		interface_index = intf_ici_ptr->broadcast_intf_index;
		}

	/* Applies the CAR policy. CAR limits the traffic based on application	*/
	/* type, incoming port or TOS. Non conforming traffic might be dropped.	*/
	if (car_outgoing_profile_ptr [interface_index]->car_status == OPC_TRUE)
		{
		/* Returns whether the packet has to dropped to follow the	*/
		/* policy. If the packet doesn't comply the policy, it is	*/
		/* necessarily dropped but only set to a lower precedence.	*/		
		if (Ip_Qos_Car_Policy_Limit (pk_ptr, intf_ici_ptr->major_port_received, car_outgoing_profile_ptr [interface_index], car_outgoing_info_ptr [interface_index]))
			{
			/* Write a statistic for packet dropped on this interface.	*/
			op_stat_write (car_stat_info_ptr [interface_index].out_traffic_dropped_in_bps_stathandle, op_pk_total_size_get (pk_ptr));
			op_stat_write (car_stat_info_ptr [interface_index].out_traffic_dropped_in_bps_stathandle, 0);

			op_stat_write (car_stat_info_ptr [interface_index].out_traffic_dropped_in_pps_stathandle, 1);
			op_stat_write (car_stat_info_ptr [interface_index].out_traffic_dropped_in_pps_stathandle, 0);

			if (op_prg_odb_ltrace_active ("car"))
				{
				sprintf (str0, "CAR drops packet %d to conform rate policies.", op_pk_id (pk_ptr));
				op_prg_odb_print_major (str0, OPC_NIL);
				}

			/* Drop the current IP datagram.	*/
			ip_rte_dgram_discard (pk_ptr, OPC_NIL);

			FOUT;
			}
		}

	/* Get the queuing scheme.	*/
	iface_info_ptr = op_prg_list_access (interface_table_ptr, interface_index);
	ip_queuing_scheme = iface_info_ptr->queuing_scheme;

	/* Associate an ICI to the datagram only if the interface type is  */
	/* smart,  i.e if the interface can process the ICI. Before 	  */
	/* make sure an interface has been identified.					  */
	if (interface_type == IpC_Intf_Type_Unspec)
		{
		ip_rte_error ("Interface of type \"unspecified\" encountered.");
		}

	/* Obtain the size in bytes of the packet. */
	frag_size = op_pk_total_size_get (pk_ptr) / 8;

	/*	Get the fields structure from ip datagram.					*/
	op_pk_nfd_access (pk_ptr, "fields", &pk_fd_ptr);

	/* Obtain the number of bytes of data carried in this fragment. */
	data_size = pk_fd_ptr->frag_len;

	/* Also obtain the difference between the packet size and */
	/* the length field; this is the size of the header.      */
	header_size = frag_size - data_size;

	/* If the fragment size is smaller than the MTU, send as is. 	*/
	/* Also make sure that if we will compress the packet it is		*/
	/* still smaller than MTU after compression. This rare case		*/
	/* can happen when Per-Interface compression method is used		*/
	/* (where packet are compressed after fragmentation if			*/
	/* fragmentation is necessary) and if the compression actually	*/
	/* results with a greater packet than original packet, which	*/
	/* may happen based on compression ratio PDF.					*/
	if ((frag_size <= mtu) && 
        (pk_fd_ptr->compression_method != IpC_Per_Interface_Comp || (int) dgram_compressed_size <= mtu * 8))
		{
		/* If an output queuing is enabled associate an ICI to each	*/
		/* datagram. It will carry the arival time of the datagram.	*/
		if (ip_queuing_scheme != IpC_No_Queuing)
			{
			/* Create an ICI pointer to the structure ici_wfq			*/
			/* The structure ici_wfq contains three fields:				*/
			/* arrival_time, connection_class, next_addr.				*/
			iciptr = op_ici_create ("ip_arp_req_v4");
    		}

		/*	Prepare ICI to carry "next_addr" information. This will be used	  */
		/*	by lower layer address resolution layer to convert the IP address */
		/*	to a lower layer address (e.g., ethernet, ATM, etc.)			  */ 
		if (interface_type == IpC_Intf_Type_Smart)
			{
			/* For multicast addresses, the next address should be the actual */
			/* destination, not the next hop.  The reason for this is we want */
			/* ARP to treat this packet as a one-hop broadcast, so as to find */
			/* all IP hosts on the network that are members of the multicast  */
			/* group indicated by the address.                                */
			if (ip_address_is_multicast (dest_addr))
				{
				/* Set up the ICI indicating to the lower layer what the next */
				/* IP hop is.												  */

				/* A different ICI is used whether an output queuing scheme is enabled or not.	*/
				if (ip_queuing_scheme != IpC_No_Queuing)
					{
					/* Get the next_address and set it in the packet ICI.	*/
					if (op_ici_attr_set (iciptr, "next_addr", ip_address_copy (dest_addr)) == OPC_COMPCODE_FAILURE)
            			ip_rte_error ("Unable to set next hop address in ICI.");
					}
				else
					{
					if (op_ici_attr_set (arp_iciptr, "next_addr", ip_address_copy (dest_addr)) == OPC_COMPCODE_FAILURE)
						ip_rte_error ("Unable to set next hop address in ICI.");
					}
				}
			else
				{
				/* A different ICI is used whether an output queuing scheme is enabled or not.	*/
				if (ip_queuing_scheme != IpC_No_Queuing)
					{
					/* Get the next_address and set it in the packet ICI.	*/
					if (op_ici_attr_set (iciptr, "next_addr", ip_address_copy (next_addr)) == OPC_COMPCODE_FAILURE)
            			ip_rte_error ("Unable to set next hop address in ICI.");
					}
				else
					{
					/* Set up the ICI indicating to the lower layer what the next */
					/* IP hop is.												  */
					if (op_ici_attr_set (arp_iciptr, "next_addr", ip_address_copy (next_addr)) == OPC_COMPCODE_FAILURE)
						ip_rte_error ("Unable to set next hop address in ICI.");
					}
				}

			/* A different ICI is used whether an output queuing scheme is enabled or not.	*/
			if (ip_queuing_scheme != IpC_No_Queuing)
				{
				/* Get the connection_class and set it in the packet ICI.	*/
				if (op_ici_attr_set (iciptr, "connection_class", conn_class) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to set connection class in ICI.");
				
				/* Set the corresponding minor port in the ICI.		*/
				if (op_ici_attr_set (iciptr, "minor_port", minor_port) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to set minor port in ICI.");
								
				}
			else
				{			
				/* Set the corresponding connection class in the ICI.		*/
				if (op_ici_attr_set (arp_iciptr, "connection_class", conn_class) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to set connection class in ICI.");
				
				/* Set the corresponding minor port in the ICI.		*/
				if (op_ici_attr_set (arp_iciptr, "minor_port", minor_port) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to set minor port in ICI.");
						
	    		/* If an output queuing scheme is chosen then a 	*/
				/* child process is in charge of sending the 		*/
				/* packets and installing the ICI.					*/
	        	if (ip_queuing_scheme == IpC_No_Queuing)
		    		{
		    		/*	Install the ICI.	*/
				    op_ici_install (arp_iciptr);
				    }
				}
			}

		/* Write the statistic for 'Packets Sent' if there are no output queuing.	*/
		if (ip_queuing_scheme == IpC_No_Queuing)
			{
			/* Update the pk sent statistics.								*/	
			/* These statistics take into account background traffic, if any.	*/
			ip_rte_pk_stats_update (pk_ptr, &sent_last_stat_update_time,
				sent_bgutil_routed_state_ptr, &locl_tot_pkts_sent_hndl); 
		
			/* Write out a zero value to signal the end of the duration to  */
			/* hold the statistic at the previously written out value.		*/
			op_stat_write (locl_tot_pkts_sent_hndl, 0.0);
		
			/* Update the appropriate "Total X Packets Sent" statistic based on		*/
			/* value of the pkt_txtype parameter.									*/
			switch (pkt_txtype)
				{
				case IP_PKT_TXTYPE_UCAST:
					{
					/* No additional stat update is necessary. 					*/
					break;
					}
				case IP_PKT_TXTYPE_MCAST:
					{
					op_stat_write (locl_num_mcasts_sent_hndl, 1.0);

					/* Write out a zero value to signal the end of the duration to  */
					/* hold the statistic at the previously written out value.		*/
					op_stat_write (locl_num_mcasts_sent_hndl, 0.0);
					break;
					}
				case IP_PKT_TXTYPE_BCAST:
					{
					op_stat_write (locl_num_bcasts_sent_hndl, 1.0);

					/* Write out a zero value to signal the end of the duration to  */
					/* hold the statistic at the previously written out value.		*/
					op_stat_write (locl_num_bcasts_sent_hndl, 0.0);
					break;
					}
				default:
					{
					/* This is an error.	*/
					ip_rte_error ("IP Datagram transmission not categorized.");

					/* Write out a zero value to signal the end of the duration to  */
					/* hold the statistic at the previously written out value.		*/
					break;
					}
				}
			}

		/*	Update statistics for the interface on which this datagram is being	*/
		/*	sent. NOTE: Currently, this is only required if IGRP is running as	*/
		/*	the dynamic routing protocol in this node. Hence, for simulation	*/
		/*	efficiency purposes, we will call it only if IGRP is enabled.		*/
		if ((routing_protos & IPC_RTE_PROTO_IGRP) != 0)
			{
			ip_inface_statistic_update (outstrm, frag_size*8.0, pk_ptr);
			}

	    /* If an output queuing scheme is chosen then	*/
		/* a child process is in charge of sending the	*/
		/* packets.										*/	
	    if (ip_queuing_scheme != IpC_No_Queuing)
	     	{
	    	ip_forward_packet_to_output_queues (pk_ptr, outstrm, iciptr, pkt_txtype, interface_index, intf_ici_ptr->major_port_received);
	    	}

		/* Check if the surrounding node is an IP cloud.	*/
	    else if (ipcloud_flag == OPC_TRUE)
			{
			/* Find the delay experienced by the incoming	*/
			/* datagram through this cloud object.			*/
			latency = ip_cloud_latency_determine (speed, outstrm, pk_ptr);

			/* Write the statistics for the Packet Latency time */
			op_stat_write (local_pkt_latency_stat, latency);

			/* Send the packet after the latency delay on the   */
			/* desired output stream.                           */
			op_pk_send_delayed (pk_ptr, outstrm, latency);
			}
		else
		    {
		    /* Send the packet as a forced interrupt so that	*/
			/* the contents of the ICI are not overwritten.		*/
		    op_pk_send_forced (pk_ptr, outstrm);
		    }

		FOUT;
		}

	/* When Per-Interface compression is used, if the			*/
	/* compressed packet is greater than the actual packet,		*/
	/* which may happen based on the compression ratio PDF,		*/
	/* then we need to adjust the MTU for proper fragmentation.	*/
	if ((pk_fd_ptr->compression_method == IpC_Per_Interface_Comp) && ((int) dgram_compressed_size > frag_size * 8))
		mtu = (int) (mtu * ((double) frag_size * 8 / dgram_compressed_size));

	/* The size is greater than the MTU, so break packet up into fragments. */
	num_frags = (data_size + mtu - header_size - 1) / (mtu - header_size);

	/* In debug mode indicate the fragmentation. */
	if (op_prg_odb_ltrace_active ("ip_frag"))
		{
		sprintf (str0, "Breaking datagram into (%d) fragments", num_frags);
		op_prg_odb_print_major (str0, OPC_NIL);
		}

	/* If the fragment is carrying the original datagram given to IP,  */
	/* extract it before copies are made.  Only one fragment can carry */
	/* the original packet for the reassembly model to work properly.  */
	if (op_pk_nfd_is_set (pk_ptr, "ip_dgram"))
		{
		if (op_pk_nfd_get (pk_ptr, "ip_dgram", &ip_pkptr) == OPC_COMPCODE_FAILURE)
			ip_rte_error ("Unable to get datagram from packet.");
		}
	else
		ip_pkptr = OPC_NIL;

	/* If the packet is carrying any encapsulated data (normally this */
	/* would happen only for a packet fragmented for the first time), */
	/* extract this data packet so that it will not appear in each    */
	/* fragment generated by copying.                                 */
	if (op_pk_nfd_is_set (pk_ptr, "data"))
		{
		if (op_pk_nfd_get (pk_ptr, "data", &data_pkptr) == OPC_COMPCODE_FAILURE)
			ip_rte_error ("Unable to get data from packet.");
		}
	else
		data_pkptr = OPC_NIL;

	for (frag_accum = 0, original_size_accum = 0, frag_index = 0; frag_index < num_frags; frag_index++)
		{
		/* Make a copy of the original packet. */
		frag_ptr = op_pk_copy (pk_ptr);
		if (frag_ptr == OPC_NIL)
			ip_rte_error ("Unable to copy packet to be fragmented.");

		op_pk_nfd_access (frag_ptr, "fields", &frag_pk_fd_ptr);

		/* Indicate that the copy is a fragment. */
		frag_pk_fd_ptr->frag = 1;

		/* For all but the last fragment, the size is the MTU */
		/* and the encapsulated IP packet is not included.    */
		if (frag_index < num_frags - 1)
			{
			frag_pk_fd_ptr->frag_len = mtu - header_size;

			if (op_pk_total_size_set (frag_ptr, 8 * mtu) == OPC_COMPCODE_FAILURE)
				ip_rte_error ("Unable to set size of fragment.");
			
			frag_accum += (mtu - header_size);

			/* If payload is compressed then we need to also	*/
			/* adjust the field original_size, which determines */
			/* the datagrams' size after decompression, since	*/
			/* the fragments will first decompressed and then	*/
			/* assembled. Otherwise after decompression all the	*/
			/* fragments would have the size of the original,	*/
			/* unfragmented packet. Made the adjustment based	*/
			/* on the equality of size ratios:					*/
			/* compressed load in fragment / compressed load =	*/
			/* load in fragment / load							*/
			if (frag_pk_fd_ptr->compression_method == IpC_Per_Virtual_Circuit_Comp)
				{
				frag_pk_fd_ptr->original_size = (int) ((frag_pk_fd_ptr->original_size - header_size * 8) * ((double) frag_pk_fd_ptr->frag_len / (double) data_size) + header_size * 8);

				/* Adjust the original size to byte size (i.e.	*/
				/* multiple of eight). This is necessary for	*/
				/* proper re-assembly of the fragments at the	*/
				/* other end.									*/
				frag_pk_fd_ptr->original_size = (frag_pk_fd_ptr->original_size / 8) * 8;

				original_size_accum += frag_pk_fd_ptr->original_size - header_size * 8;
				}

			/* If Per-Interface compression is used then the	*/
			/* datagrams are compressed after fragmentation.	*/
			/* Check the compression method and compress if		*/
			/* necessary.										*/
			else if (frag_pk_fd_ptr->compression_method == IpC_Per_Interface_Comp)
				{
				/* Store the original size of the packet, which	*/
				/* will be used for decompression.				*/
				frag_pk_fd_ptr->original_size = mtu * 8;

				/* Resize the packet proportional to the 		*/
				/* compression ratio.							*/ 
				op_pk_total_size_set (frag_ptr, (int) ((dgram_compressed_size / frag_size) * mtu));

				/* Issue a trace statement.						*/
				if (LTRACE_COMPRESSION_ACTIVE || op_prg_odb_pktrace_active (frag_ptr))
					ip_rte_comp_decomp_trace_print (frag_ptr, frag_pk_fd_ptr->compression_method, frag_pk_fd_ptr->original_size, (int) ((dgram_compressed_size / frag_size) * mtu), "compression");
				}
			}
		else
			{
			/* For the last fragment, set the fragment size to be */
			/* whatever packet size remains plus the header size. */
			len = data_size - frag_accum;
			frag_pk_fd_ptr->frag_len = len;
			if (op_pk_total_size_set (frag_ptr, 8 * (header_size + len)) == OPC_COMPCODE_FAILURE)
				ip_rte_error ("Unable to set size of final fragment.");

			/* If payload is compressed then we need to also	*/
			/* adjust the field original_size, which determines */
			/* the datagrams' size after decompression, since	*/
			/* the fragments will first decompressed and then	*/
			/* assembled. Otherwise after decompression all the	*/
			/* fragments would have the size of the original,	*/
			/* unfragmented packet. The last fragment claims	*/
			/* the remainings of the uncompressed load.			*/ 
			if (frag_pk_fd_ptr->compression_method == IpC_Per_Virtual_Circuit_Comp)
				frag_pk_fd_ptr->original_size -= original_size_accum;

			/* If Per-Interface compression is used then the	*/
			/* datagrams are compressed after fragmentation.	*/
			/* Check the compression method and compress if		*/
			/* necessary.										*/
			else if (frag_pk_fd_ptr->compression_method == IpC_Per_Interface_Comp)
				{
				/* Store the original size of the packet, which	*/
				/* will be used for decompression.				*/
				frag_pk_fd_ptr->original_size =  8 * (header_size + len);

				/* Resize the packet proportional to the 		*/
				/* compression ratio.							*/ 
				op_pk_total_size_set (frag_ptr, (int) ((dgram_compressed_size / frag_size) * (header_size + len)));

				/* Issue a trace statement.						*/
				if (LTRACE_COMPRESSION_ACTIVE || op_prg_odb_pktrace_active (frag_ptr))
					ip_rte_comp_decomp_trace_print (frag_ptr, frag_pk_fd_ptr->compression_method, frag_pk_fd_ptr->original_size, (int) ((dgram_compressed_size / frag_size) * (header_size + len)), "compression");
				}

			/* If the original packet was not a fragment, encapsulate it */
			/* into the last fragment created here.                      */
			frag = pk_fd_ptr->frag;

			if (!frag)
				{
				/* If the packet contained encapsulated data (i.e., from the */
				/* transport), that data will have been removed to avoid its */
				/* duplication in the fragments.  The data should now be     */
				/* reinserted into the original packet.                      */
				if (data_pkptr != OPC_NIL)
					{
					if (op_pk_nfd_set (pk_ptr, "data", data_pkptr) == OPC_COMPCODE_FAILURE)
						ip_rte_error ("Unable to set data in final fragment.");
					}

				/* In either case the original packet is encapsualted in the fragment. */	
				if (op_pk_nfd_set (frag_ptr, "ip_dgram", pk_ptr) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to set datagram in final fragment.");
				}
			else
				{
				/* Otherwise the packet can be discarded. */
				op_pk_destroy (pk_ptr);

				/* Also, if the packet included the original datagram   */
				/* from which it was generated, transfer that datagram  */
				/* into the last fragment created here.  Note that it   */
				/* is possible, in the case where a fragment is itself  */
				/* being fragmented, that none of the created fragments */
				/* will contain the original datagram.                  */
				if (ip_pkptr != OPC_NIL)
					if (op_pk_nfd_set (frag_ptr, "ip_dgram", ip_pkptr) == OPC_COMPCODE_FAILURE)
						ip_rte_error ("Unable to set datagram in packet.");
				}
			}

		/* If an output queuing scheme is enabled associate an ICI to		*/
		/* each datagram. It will carry the arival time of the datagram.	*/
		if (ip_queuing_scheme != IpC_No_Queuing)
			{
			/* Create an ICI pointer to the structure ici_wfq			*/
			/* The structure ici_wfq contains three fields:				*/
			/* arrival_time, connection_class, next_addr.				*/
			iciptr = op_ici_create ("ip_arp_req_v4");
    		}

		/*	Prepare ICI to carry "next_addr" information. This will be used	  */
		/*	by lower layer address resolution layer to convert the IP address */
		/*	to a lower layer address (e.g., ethernet, ATM, etc.)			  */ 
		if (interface_type == IpC_Intf_Type_Smart)
			{
			/* For multicast addresses, the next address should be the actual */
			/* destination, not the next hop.  The reason for this is we want */
			/* ARP to treat this packet as a one-hop broadcast, so as to find */
			/* all IP hosts on the network that are members of the multicast  */
			/* group indicated by the address.                                */
			if (ip_address_is_multicast (dest_addr))
				{
				/* A different ICI is used whether an output queuing scheme	*/
				/* is enabled or not.										*/
				if (ip_queuing_scheme != IpC_No_Queuing)
					{
					/* Get the next_address and set it in the packet ICI.	*/
					if (op_ici_attr_set (iciptr, "next_addr", ip_address_copy (dest_addr)) == OPC_COMPCODE_FAILURE)
            			ip_rte_error ("Unable to set next hop address in ICI.");
					}
				else
					{
					/* Set up the ICI indicating to the lower layer what the next */
					/* IP hop is.												  */
					if (op_ici_attr_set (arp_iciptr, "next_addr", ip_address_copy (dest_addr)) == OPC_COMPCODE_FAILURE)
						ip_rte_error ("Unable to set next hop address in ICI.");
					}
				}
			else
				{
				/* A different ICI is used whether an output queuing scheme is enabled or not.	*/
				if (ip_queuing_scheme != IpC_No_Queuing)
					{
					/* Get the next_address and set it in the packet ICI.	*/
					if (op_ici_attr_set (iciptr, "next_addr", ip_address_copy (next_addr)) == OPC_COMPCODE_FAILURE)
            			ip_rte_error ("Unable to set next hop address in ICI.");
					}
				else
					{
					/* Set up the ICI indicating to the lower layer what the next */
					/* IP hop is.												  */
					if (op_ici_attr_set (arp_iciptr, "next_addr", ip_address_copy (next_addr)) == OPC_COMPCODE_FAILURE)
						ip_rte_error ("Unable to set next hop address in ICI.");
					}
				}

			/* A different ICI is used whether an output queuing scheme is enabled or not.	*/
			if (ip_queuing_scheme != IpC_No_Queuing)
				{
				/* Get the connection_class and set it in the packet ICI.	*/
				if (op_ici_attr_set (iciptr, "connection_class", conn_class) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to set connection class in ICI.");
				
				/* Set the corresponding minor port in the ICI.		*/
				if (op_ici_attr_set (iciptr, "minor_port", minor_port) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to set minor port in ICI.");
				}
			else
				{			
				/* Set the corresponding connection class in the ICI.		*/
				if (op_ici_attr_set (arp_iciptr, "connection_class", conn_class) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to set connection class in ICI.");
				
				/* Set the corresponding minor port in the ICI.		*/
				if (op_ici_attr_set (arp_iciptr, "minor_port", minor_port) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to set minor port in ICI.");

				/* If an output queuing scheme is chosen then a	*/
				/* child process is in charge of sending the 	*/
				/* packets and installing the ICI.				*/
	        	if (ip_queuing_scheme == IpC_No_Queuing)
			    	{
			    	/* Install the ICI.	*/
			    	op_ici_install (arp_iciptr);
			    	}
				}
			}

			/* Update the pk sent statistics.								*/	
			/* These statistics take into account background traffic, if any.	*/
			ip_rte_pk_stats_update (frag_ptr, &sent_last_stat_update_time,
				sent_bgutil_routed_state_ptr, &locl_tot_pkts_sent_hndl); 
		
			/* Write out a zero value to signal the end of the duration to  */
			/* hold the statistic at the previously written out value.		*/
			op_stat_write (locl_tot_pkts_sent_hndl, 0.0);

			/* Write stats for 'Packets Sent' when no output queuing scheme is used.	*/
			if (ip_queuing_scheme == IpC_No_Queuing)
				{	
				/* Write out the appropriate stats for each fragment that is sent.	*/
				switch (pkt_txtype)
					{
					case IP_PKT_TXTYPE_UCAST:
						{
						/* No additional stat update is necessary. 					*/				

						break;
						}
					case IP_PKT_TXTYPE_MCAST:
						{
						op_stat_write (locl_num_mcasts_sent_hndl, 1.0);
						op_stat_write (locl_tot_pkts_sent_hndl, 1.0);

						/* Write out a zero value to signal the end of the duration to  */
						/* hold the statistic at the previously written out value.		*/
						op_stat_write (locl_num_mcasts_sent_hndl, 0.0);
						op_stat_write (locl_tot_pkts_sent_hndl, 0.0);

						break;
						}
					case IP_PKT_TXTYPE_BCAST:
						{
						op_stat_write (locl_num_bcasts_sent_hndl, 1.0);
						op_stat_write (locl_tot_pkts_sent_hndl,1.0);

						/* Write out a zero value to signal the end of the duration to  */
						/* hold the statistic at the previously written out value.		*/
						op_stat_write (locl_num_bcasts_sent_hndl, 0.0);
						op_stat_write (locl_tot_pkts_sent_hndl,0.0);

						break;
						}
					default:
						{
						/* This is an error.	*/
						ip_rte_error ("IP Packet transmission not categorized.");
						break;
						}
					}
				}

		/*	Update statistics for the interface on which this datagram is being	*/
		/*	sent. NOTE: Currently, this is only required if IGRP is running as	*/
		/*	the dynamic routing protocol in this node. Hence, for simulation	*/
		/*	efficiency purposes, we will call it only if IGRP is enabled.		*/
		if ((routing_protos & IPC_RTE_PROTO_IGRP) != 0)
			{
			ip_inface_statistic_update (outstrm, frag_size*8.0, frag_ptr);
			}
		
	    /* If an output queuing scheme is chosen then a			*/
		/* child process is in charge of sending the packets.	*/
	    if (ip_queuing_scheme != IpC_No_Queuing)
		   {
	       ip_forward_packet_to_output_queues (frag_ptr, outstrm, iciptr, pkt_txtype, interface_index, intf_ici_ptr->major_port_received);
		   }
	    else
		   {
		   /* Forward the fragment.	*/
		   op_pk_send_forced (frag_ptr, outstrm);
		   }
		}
	FOUT;
	}

static Boolean
ip_address_multicast_accept (IpT_Address addr, int ip_interface)
	{
	/** Returns OPC_TRUE if this IP module is configured to accept	**/
	/** the given multicast address on the given IP interface.		**/
	FIN (ip_adddress_multicast_accept (addr, ip_interface));

	if (ip_mcast_addr_info_get (mcast_addr_list_ptr, addr, ip_interface) != OPC_NIL)
		{
		FRET (OPC_TRUE);
		}

	FRET (OPC_FALSE);
	}


static Boolean
ip_interface_table_verify (List *intf_list_ptr)
    {
    int                     num_intfs, intf_index, check_index;
    IpT_Address             check_net_addr, net_addr;
    IpT_Interface_Info *    intf_ptr;
    IpT_Interface_Info *    check_intf_ptr;
    IpT_Address_Range *     addr_range_ptr;
    char                    msg [128];

    /** Return OPC_TRUE if the list of interfaces given does not overlap **/
    /** address ranges.  Return OPC_FALSE if two or more interfaces      **/
    /** contain overlapping address ranges.                              **/
    FIN (ip_interface_table_verify (intf_list_ptr));

    /* Loop through all interfaces and check for address range conflicts. */
    num_intfs = op_prg_list_size (intf_list_ptr);

    for (intf_index = 0; intf_index < num_intfs; intf_index++)
        {
        intf_ptr = op_prg_list_access (intf_list_ptr, intf_index);
        addr_range_ptr = intf_ptr->addr_range_ptr;

        /* If this is the first interface, don't check against the others. */
        if (intf_index == 0)
            {
            /* First interface can not compare itself with anybody else */
            continue;
            }

        /* Construct an address to check against other ranges. */
        net_addr = ip_address_mask (addr_range_ptr->address, addr_range_ptr->subnet_mask);

        /* Check this interface's address with others previously seen. */
        for (check_index = 0; check_index < intf_index; check_index++)
            {
            check_intf_ptr = op_prg_list_access (intf_list_ptr, check_index);
            check_net_addr = ip_address_mask (check_intf_ptr->addr_range_ptr->address,
                check_intf_ptr->addr_range_ptr->subnet_mask);

            if (ip_address_equal (net_addr, check_net_addr))
                {
                /* We've detected an address overlap.  Return OPC_FALSE. */
                FRET (OPC_FALSE);
                }
            }
        }

	/* If we get here, no conflicts have been detected. */
	FRET (OPC_TRUE);
	}


static void
ip_rte_total_packets_received_stat_update (int pkt_dest_type, Packet * pk_ptr)
	{
	/** Updates statistics on total packets received based on the	**/
	/** packet type.												**/
	FIN (ip_rte_total_packets_received_stat_update (pkt_dest_type));

	/* Update the pk received statistics.								*/		
	/* These statistics take into account background traffic, if any.	*/
	ip_rte_pk_stats_update (pk_ptr, &received_last_stat_update_time,
		received_bgutil_routed_state_ptr, &locl_tot_pkts_rcvd_hndl);

	/* Write out a zero value to signal the end of the duration to  */
	/* hold the statistic at the previously written out value.		*/
	op_stat_write (locl_tot_pkts_rcvd_hndl, 0.0);
	
	switch (pkt_dest_type)
		{
		case IP_PKT_TXTYPE_UCAST:
			{
			/* No additional stat update is neccessary. 					*/
			break;
			}

		case IP_PKT_TXTYPE_MCAST:
			{
			op_stat_write (locl_num_mcasts_rcvd_hndl, 1.0);

			/* Write out a zero value to signal the end of the duration to  */
			/* hold the statistic at the previously written out value.		*/
			op_stat_write (locl_num_mcasts_rcvd_hndl, 0.0);
			break;
			}

		case IP_PKT_TXTYPE_BCAST:
			{
			op_stat_write (locl_num_bcasts_rcvd_hndl, 1.0);

			/* Write out a zero value to signal the end of the duration to  */
			/* hold the statistic at the previously written out value.		*/
			op_stat_write (locl_num_bcasts_rcvd_hndl, 0.0);
			break;
			}

		default:
			{
			ip_rte_error ("Processing uncategorized IP datagram.");
			}
		}

	FOUT;
	}

static void
ip_rte_dgram_discard (Packet* pkptr, Ici* intf_ici_ptr)
	{
	/** Discards IP datagram and updates the packets	**/
	/** statistics.										**/ 
	FIN (ip_rte_dgram_discard (pkptr, intf_ici_ptr));

	/* Write out a new data point for the "Packets	*/
	/* Dropped" statistics.							*/
	op_stat_write (locl_num_pkts_dropped_hndl, 1.0);
	op_stat_write (globl_num_pkts_dropped_hndl, 1.0);

	/* Write out a zero value to signal the end of the duration to  */
	/* hold the statistic at the previously written out value.		*/
	op_stat_write (locl_num_pkts_dropped_hndl, 0.0);
	op_stat_write (globl_num_pkts_dropped_hndl, 0.0);

	/* Also deallocate the associated ICI and its	*/
	/* fields if the ICI exists.					*/
	ip_rte_intf_ici_destroy (intf_ici_ptr);

	/* Drop the packet.	*/
	op_pk_destroy (pkptr);

	FOUT;
	}

static void 
ip_rte_intf_ici_destroy (Ici* intf_iciptr)
	{
	IpT_Address				intf_addr;
	IpT_Rte_Ind_Ici_Fields*	intf_ici_struct_ptr;

	/**	Deallocate the ICI and memory allocated to the			**/
	/**	contained fields.										**/
	FIN (ip_rte_intf_ici_destroy (intf_iciptr));

	/* Also deallocate the associated ICI and its 		*/
	/* fields if the ICI exists.						*/
	if (intf_iciptr != OPC_NIL)
		{
		op_ici_attr_get (intf_iciptr, "rte_info_fields", &intf_ici_struct_ptr);
		ip_rte_ind_ici_fdstruct_destroy (intf_ici_struct_ptr);
		op_ici_destroy (intf_iciptr);
		}

	FOUT;
	}

static void
ip_inface_statistic_update (int output_strm, double pkt_bitsize, Packet * pkptr)
	{
	int						i_th_iface;
	int						active_interfaces;
	IpT_Interface_Info*		i_th_iface_info_ptr;

	double 					curr_sim_time;
	double					background_utilization_bps;
	double					background_utilization_bits;
	double					bgutil_routed_packets_per_sec;
	double					bgutil_routed_pk_size_std_dev;
	char					msg [512];
	
	/** Updates the statistics maintains on aper interface basis.	**/	
	/** The interface for which the statistics needs to be updated	**/
	/** is determined based on the output stream the datagram is	**/
	/** being forwarded on.											**/
	FIN (ip_inface_statistic_update (output_strm, pkt_bitsize, pkptr));

	/* Obtain the current sim time.	*/
	curr_sim_time = op_sim_time ();
	
	/* Obtain the total number of active interfaces.				*/
	active_interfaces = op_prg_list_size (interface_table_ptr);

	/* Loop thorugh these interfaces to find the one of interest.	*/
	for (i_th_iface = 0; i_th_iface < active_interfaces; i_th_iface++)
		{
		/* Obtain a handle on the i_th interface.					*/
		i_th_iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, i_th_iface);

		/* Check if the output stream on which the packet is being	*/
		/* sent correcponds to this interface.						*/
		if (i_th_iface_info_ptr->port_num == output_strm)
			{
			/* This is the interface of interest. increment the		*/
			/* load statistic accumulator for this interface to		*/
			/* reflect the total number of bits sent to date.		*/
			i_th_iface_info_ptr->load_bits += pkt_bitsize;

			/* Determine if we are using background utilization.	*/
			if (do_bgutil)
				{
				/* We are using background utilization.				*/
				if (i_th_iface_info_ptr->load_bgutil_routed_state_ptr == OPC_NIL)
					{
					/* This background utlization routed state has never 	*/
					/* been used. As an memory optimization, only 			*/
					/* allocate the routed state pointer when the interface */
					/* is first used (which is now).						*/
					i_th_iface_info_ptr->load_bgutil_routed_state_ptr = oms_bgutil_routed_state_create ();
					}

				/* Obtain the background utilization till the current time.						*/
				/* The value returned denotes the background utilization which is valid until 	*/
				/* right before the current time.  This function is efficient if there is no	*/
				/* routed background utilization.												*/
				/* Use a data rate of 1.0 so that this function returns bps instead of 	util.	*/
				background_utilization_bps = oms_bgutil_routed_utilization_get (i_th_iface_info_ptr->load_bgutil_routed_state_ptr, 
						pkptr, curr_sim_time, 1.0, &bgutil_routed_packets_per_sec, 
						&bgutil_routed_pk_size_std_dev, OmsC_Bgutil_Get_Prev);
				
				/* We are only interested in the bits/sec.  Fill the bit usage counter			*/
				/* up with the number of bits due to background utilization since this 			*/
				/* measurement interval started. In the future, a more sophisticated method		*/
				/* of filling the bit counter could be used.									*/
				background_utilization_bits = background_utilization_bps *
					(curr_sim_time - i_th_iface_info_ptr->last_load_update_time);

				/* Add these background utilization bits to the per interface load.			*/
				i_th_iface_info_ptr->load_bits += background_utilization_bits;

				/* We have now accounted for the background utilization over this inteface	*/
				/* up till the current time.  This will be the starting time the next		*/
				/* time we have to update the load.											*/
				i_th_iface_info_ptr->last_load_update_time = curr_sim_time;
				}
			else
				{
				/* We are not doing background utilization in this simulation.				*/
				background_utilization_bits = 0.0;
				}
				
			i_th_iface_info_ptr->load_bps = i_th_iface_info_ptr->load_bits / curr_sim_time;

			if (op_prg_odb_ltrace_active ("ip_rte_interface_load"))
				{
				sprintf (msg, "Adding explicit (%f) and bgutil (%f) bits to load on interface index (%i)",
					pkt_bitsize, background_utilization_bits, i_th_iface); 
				op_prg_odb_print_major (msg, OPC_NIL);
				}
			}
		}

	FOUT;
	}

static void
ip_rte_qos_information_process ()
	{
	Objid						ip_addr_information_objid, ip_addr_information_child_objid;
	Objid						ip_qos_information_objid, ip_qos_information_child_objid;
	int							iface_table_size, iface_id;
	IpT_Interface_Info*			iface_info_ptr;
	int							incoming_car_stat_index = 0;
	int							outgoing_car_stat_index = 0;
	char						annotation [10];

	/** Creates the child processes for processing packets on the 		**/
	/** output queue. One child process is spawned by interface.		**/
	/** Each of them model a output queuing mechanism such as FIFO,		**/
	/** WFQ, Custom Queuing or Priority Queuing, as well as congestion	**/
	/** avoidance mechanisms such as RED/WRED.							**/
	/** This function initializes also the CAR parameters and state		**/
	/** information on each interface.									**/
	FIN (ip_rte_qos_information_process ());

	/* Allocate memory for the shared memory.	*/
	shared_mem_ptr = (OmsT_Qm_Shared_Memory *) op_prg_mem_alloc (sizeof (OmsT_Qm_Shared_Memory));
	
	/* Store in the shared memory information	*/
	/* about each interface.					*/
	shared_mem_ptr->iface_table_ptr = interface_table_ptr;

	/* Store in the shared memory the handles for		*/
	/* packets dropped and packet sent.					*/
	/* Other state variables are also shared with		*/
	/* the output interface process model in order to 	*/
	/* take into account the background traffic in the	*/
	/* statistics written in the output interface		*/
	/* process model.									*/
	shared_mem_ptr->locl_pk_dropped_hdl_ptr = &locl_num_pkts_dropped_hndl;
	shared_mem_ptr->globl_pk_dropped_hdl_ptr = &globl_num_pkts_dropped_hndl;
	shared_mem_ptr->locl_num_pkts_sent_hdl_ptr = &locl_tot_pkts_sent_hndl;
	shared_mem_ptr->locl_num_mcasts_sent_hdl_ptr = &locl_num_mcasts_sent_hndl;
	shared_mem_ptr->locl_num_bcasts_sent_hdl_ptr = &locl_num_bcasts_sent_hndl;
	shared_mem_ptr->sent_pk_last_update_time = sent_last_stat_update_time;
	shared_mem_ptr->sent_bgutil_state_ptr = sent_bgutil_routed_state_ptr;
	shared_mem_ptr->bgutil = do_bgutil;
	shared_mem_ptr->statistic_index = 0;
	shared_mem_ptr->rsvp_request_ptr = OPC_NIL;

	/* Get the number of interfaces.	*/
	iface_table_size = op_prg_list_size (interface_table_ptr);

	/* Allocates memory for the array of CAR stathandles.	*/
	car_stat_info_ptr = (OmsT_Qm_Car_Stat_Info *) op_prg_mem_alloc (sizeof (OmsT_Qm_Car_Stat_Info) * iface_table_size);

	/* Allocate memory for all the incoming interface CAR profiles.	*/
	car_incoming_profile_ptr = (OmsT_Qm_Car_Profile **) op_prg_mem_alloc (iface_table_size * sizeof (OmsT_Qm_Car_Profile*));

	/* Allocate memory for all the outgoing interface CAR profiles.	*/
	car_outgoing_profile_ptr = (OmsT_Qm_Car_Profile **) op_prg_mem_alloc (iface_table_size * sizeof (OmsT_Qm_Car_Profile*));

	/* Allocate memory for all the incoming interface CAR state information.	*/
	car_incoming_info_ptr = (OmsT_Qm_Car_Information **) op_prg_mem_alloc (iface_table_size * sizeof (OmsT_Qm_Car_Information*));

	/* Allocate memory for all the outgoing interface CAR state information.	*/
	car_outgoing_info_ptr = (OmsT_Qm_Car_Information **) op_prg_mem_alloc (iface_table_size * sizeof (OmsT_Qm_Car_Information*));

	/* Get the "IP Address Information" interface table.	*/
	op_ima_obj_attr_get (own_id, "ip addr info", &ip_addr_information_objid);

	/* Loop through the interfaces to initialize all QoS related parameters	*/
	/* such as queuing schemes, CAR and RED/WRED.							*/
	for (iface_id = 0; iface_id < iface_table_size; iface_id ++)
		{
		/* Get the interface information from the IP interface list.	*/
		iface_info_ptr = op_prg_list_access (interface_table_ptr, iface_id);

		/* Get the QoS information for one interface in the interface table.	*/
		ip_addr_information_child_objid = op_topo_child (ip_addr_information_objid, OPC_OBJTYPE_GENERIC, iface_info_ptr->addr_index);
		op_ima_obj_attr_get (ip_addr_information_child_objid, "QoS info", &ip_qos_information_objid);

		/* Get the queuing scheme specified on the interface: None, FIFO,	*/
		/* WFQ, Priority Queuing or Custom QUeuing.							*/
		ip_qos_information_child_objid = op_topo_child (ip_qos_information_objid, OPC_OBJTYPE_GENERIC, 0);
		op_ima_obj_attr_get (ip_qos_information_child_objid, "Queuing Scheme", &(iface_info_ptr->queuing_scheme));

		/* If a queuing scheme is chosen then a child process	*/
		/* will be in charge of sending packets.				*/
		if (iface_info_ptr->queuing_scheme != IpC_No_Queuing)
			{
			/* Check the existence of ip qos attribute object. We will read the queuing	*/
			/* profiles for each interface from the attribute database. The special 	*/
			/* object defines all the queuing profiles and CAR profiles. Although this	*/
			/* function gets called from each IP process instance in the network, 		*/
			/* functionally	it only gets executed only once for each simulation.		*/
			ip_rte_qos_attr_config_info ();

			/* Spawn a child process for the interface.	*/
		    iface_info_ptr->output_iface_prohandle = op_pro_create ("ip_output_iface", shared_mem_ptr);

			/* Invoke the child process in charge of the output queues for initialization.	*/
			shared_mem_ptr->iface_index = iface_id;
			op_pro_invoke (iface_info_ptr->output_iface_prohandle, OPC_NIL);
    		}

		/* Get the Incoming CAR profile.	*/
		 if (ip_rte_car_profile_get (car_incoming_profile_ptr, car_incoming_info_ptr, iface_id,
								"Incoming CAR Profile", ip_qos_information_child_objid))
			{
			/* Register statistic handle for traffic dropped by CAR if the	*/
			/* interface supports CAR.										*/
			car_stat_info_ptr [iface_id].in_traffic_dropped_in_pps_stathandle = 
				op_stat_reg ("IP Interface.CAR Incoming Traffic Dropped (packets/sec)", incoming_car_stat_index, OPC_STAT_LOCAL);
			car_stat_info_ptr [iface_id].in_traffic_dropped_in_bps_stathandle =
				op_stat_reg ("IP Interface.CAR Incoming Traffic Dropped (bits/sec)", incoming_car_stat_index, OPC_STAT_LOCAL);

			/* Renaming statistics to include the interface index.	*/
			sprintf (annotation, "IF %d", iface_info_ptr->addr_index);
			op_stat_annotate (car_stat_info_ptr [iface_id].in_traffic_dropped_in_pps_stathandle, annotation);
			op_stat_annotate (car_stat_info_ptr [iface_id].in_traffic_dropped_in_bps_stathandle, annotation);

			/* Increments the statistic index.	*/
			incoming_car_stat_index ++;
			}

		/* Get the Outgoing CAR profile.	*/
		if (ip_rte_car_profile_get (car_outgoing_profile_ptr, car_outgoing_info_ptr, iface_id,
								"Outgoing CAR Profile", ip_qos_information_child_objid))
			{
			/* Register statistic handle for traffic dropped by CAR if the	*/
			/* interface supports CAR.										*/
			car_stat_info_ptr [iface_id].out_traffic_dropped_in_pps_stathandle =
				op_stat_reg ("IP Interface.CAR Outgoing Traffic Dropped (packets/sec)", outgoing_car_stat_index, OPC_STAT_LOCAL);
			car_stat_info_ptr [iface_id].out_traffic_dropped_in_bps_stathandle =
				op_stat_reg ("IP Interface.CAR Outgoing Traffic Dropped (bits/sec)", outgoing_car_stat_index, OPC_STAT_LOCAL);

			/* Renaming statistics to include the interface index.	*/
			sprintf (annotation, "IF %d", iface_info_ptr->addr_index);
			op_stat_annotate (car_stat_info_ptr [iface_id].out_traffic_dropped_in_pps_stathandle, annotation);
			op_stat_annotate (car_stat_info_ptr [iface_id].out_traffic_dropped_in_bps_stathandle, annotation);

			/* Increments the statistic index.	*/
			outgoing_car_stat_index ++;
			}
 		}

	FOUT;
	}

static Boolean
ip_rte_car_profile_get (OmsT_Qm_Car_Profile** car_profile, OmsT_Qm_Car_Information** car_info, 
						int iface_id, char* direction, Objid car_parameters_objid)
	{
	char			interface_car_profile [256];
	int				cos;
	/** This function gets the CAR profile for one interface.	**/
	/** It initializes, allocates memory for the two CAR		**/
	/** structures in charge of keeping track of CAR parameters	**/
	/** and states. CAR will be disabled if the specified		**/
	/** does not exist or if the CAR profile is set to "None".	**/
	FIN (ip_rte_car_profile_get (car_profile, car_info, iface_id, direction, ip_qos_info_objid))

	/* Get the CAR profile for the interface in the compound attribute	*/
	/* "IP QoS Information".											*/
	op_ima_obj_attr_get (car_parameters_objid, direction, interface_car_profile);

	/* Get the CAR profile specification from the IP QoS configuration	*/
	/* object if CAR is enabled (profile not set to "None").			*/
	if (strcmp (interface_car_profile, "None"))
		{
		/* Check the existence of ip qos attribute object. We will read the CAR		*/
		/* profiles for each interface from the attribute database. The special 	*/
		/* object defines all the queuing profiles and CAR profiles. Although this	*/
		/* function gets called from each IP process instance in the network, 		*/
		/* functionally	it only gets executed only once for each simulation.		*/
		ip_rte_qos_attr_config_info ();

		/* Get the profile from the IP QoS configuration object.	*/
		car_profile [iface_id] = (OmsT_Qm_Car_Profile *) oms_data_def_entry_access ("CAR Profiles", interface_car_profile);	

		/* Check whether this profile exists or not. If this profile	*/
		/* does not exist in the IP QoS configuration object, then		*/
		/* CAR is disabled on this interface.							*/
		if (car_profile [iface_id] == OPC_NIL)
			{
			/* Write a simulation log warning that the CAR profile doesn't exist.	*/
			carnl_configwarn_missing_profile (interface_car_profile);				

			/* The CAR profile doesn't exist in the IP QoS attribute configuration object.	*/
			/* CAR profile will be set to "None", and write a simulation log.				*/
			strcpy (interface_car_profile, "None");
			}
		else
			{
			/* Allocate memory for each class of service (COS).	*/
			car_info [iface_id] = (OmsT_Qm_Car_Information *) op_prg_mem_alloc (car_profile [iface_id]->number_of_cos * sizeof (OmsT_Qm_Car_Information));

			/* Initialize the traffic state for each COS.	*/
			for (cos = 0; cos < car_profile [iface_id]->number_of_cos; cos ++)
				{
				car_info [iface_id] [cos].bucket_size = 0;
				car_info [iface_id] [cos].last_update_time = 0;
				}

			FRET (OPC_TRUE);
			}
		}

	/* CAR is disabled on this interface. Initialize data structures to	*/
	/* NIL values. No memory is allocated for classes of service.		*/
	car_profile [iface_id] = (OmsT_Qm_Car_Profile *) op_prg_mem_alloc (sizeof (OmsT_Qm_Car_Profile));
	car_profile [iface_id]->name = (char *) op_prg_mem_alloc( (strlen ("None") +1) * sizeof (char));
	strcpy (car_profile [iface_id]->name, "None");
	car_profile [iface_id]->car_status = OPC_FALSE;
	car_profile [iface_id]->number_of_cos = 0;
	car_profile [iface_id]->cos_definition = OPC_NIL;
	car_info [iface_id] = OPC_NIL;

	FRET (OPC_FALSE);
	}

static double
ip_rte_comp_delay_and_size_compute (Packet* pkptr, IpT_Dgram_Fields* pk_fd_ptr, 
	Ici* intf_ici_ptr, IpT_Interface_Info* iface_info_ptr)
	{
	IpT_Compression_Info*		comp_info_ptr;
	double						size, comp_size;
	double						ratio;
	int							instrm, decompress, output_intf_index;
	IpT_Rte_Ind_Ici_Fields*		intf_ici_fdstruct_ptr;

	/** This function computes the datagram's size after 			**/
	/** compression process and the amount of processing time		**/
	/** necessary to compress the packet. It updates the associated	**/
	/** ICI with the compressed datagram size and returns the value	**/
	/** of compression delay.										**/ 
	FIN (ip_rte_comp_delay_and_size_compute (pkptr, pk_fd_ptr, intf_ici_ptr, iface_info_ptr));

	/* Get a handle to the compression scheme used for the output	*/
	/* interface.													*/
	comp_info_ptr = iface_info_ptr->comp_info;

	/* If the packet is already compressed we do not compress again.*/
	if (pk_fd_ptr->compression_method != IpC_No_Compression)
		FRET (0.0);

	/* Get the current size of the datagram. There can be a			*/
	/* decompression scheduled for the datagram which will take 	*/
	/* place before the compression. If this is the case, then the	*/
	/* current size of the packet is not its original size. In this	*/
	/* case get the original size from associated ICI.				*/
	op_ici_attr_get (intf_ici_ptr, "rte_info_fields", &intf_ici_fdstruct_ptr);
	decompress = intf_ici_fdstruct_ptr->decompress;
	if (decompress)
		size = pk_fd_ptr->original_size;
	else
		size = op_pk_total_size_get (pkptr);

	/* Obtain a random compression ratio from the loaded PDF. Get	*/
	/* another value if distrubution returns a negative value,		*/
	/* since we cannot have negative packet size after compression. */
	do
		{
		ratio = op_dist_outcome (comp_info_ptr->comp_ratio_dist_ptr);
		} while (ratio < 0.0);

	/* Set the decompression delay so that it may be used at other	*/
	/* nodes to decompress the compressed information.				*/
	pk_fd_ptr->decompression_delay = iface_info_ptr->comp_info->decompression_delay;

	/* Based on compression method used determine the size and		*/
	/* delay.														*/
	switch (comp_info_ptr->method) 
		{
		case IpC_TCPIP_Header_Comp:
			{
			/* TCP/IP header compression is used. First make sure	*/
			/* the encapsulated packet is a TCP packet.				*/
			if (pk_fd_ptr->protocol != IpC_Protocol_Tcp)
				FRET (0.0);
			
			/* Simply compress the header.	*/
			comp_size = size - (IP_TCP_COMPRESSABLE_HEADER_SIZE * (1 - ratio));

			/* Make sure after compression the datagram is smaller	*/
			/* than mtu.											*/
			if (comp_size / 8 + 1 > (double)(iface_info_ptr->mtu))
				{
				/* Datagram is still greater than mtu which will 	*/
				/* require fragmentation. Header compression is not	*/
				/* applicable. Don't compress the packet and log a	*/
				/* warning.											*/
				output_intf_index = intf_ici_fdstruct_ptr->output_intf_index;
				ipnl_cfgwarn_compcfg (output_intf_index);

				FRET (0.0);
				}
			else
				{
				/* Set the compressed size and compression method	*/
				/* into associated ICI and return the delay.		*/
				intf_ici_fdstruct_ptr->compressed_size = comp_size;
				pk_fd_ptr->compression_method = IpC_TCPIP_Header_Comp;

				FRET ((double) (comp_info_ptr->compression_delay * IP_TCP_COMPRESSABLE_HEADER_SIZE));
				}
			break;
			}

		case IpC_Per_Interface_Comp:
			{
			/* Per-Interface (entire packet) compression is used.	*/
			/* Apply the ratio to entire packet.					*/
			comp_size = size * ratio;

			/* Set the compressed size and compression method into	*/
			/* associated ICI and return the delay.					*/
			intf_ici_fdstruct_ptr->compressed_size = comp_size;
			pk_fd_ptr->compression_method = IpC_Per_Interface_Comp;

			FRET ((double) (comp_info_ptr->compression_delay * size));

			break;
			}

		case IpC_Per_Virtual_Circuit_Comp:
			{
			/* Per-Virtual Circuit (payload) compression is used.	*/
			/* We compress only if the packet is from higher layer.	*/
			instrm = intf_ici_fdstruct_ptr->instrm;
			
			if (instrm == instrm_from_ip_encap || instrm == IpC_Pk_Instrm_Child)
				{
				/* Packet is from higher layer. Apply the ratio		*/
				/* only to payload when computing the compressed	*/
				/* file size.										*/
				comp_size = size - (pk_fd_ptr->orig_len * 8 * (1 - ratio));

				/* Adjust the compressed size to byte size (i.e.	*/
				/* multiple of eight).								*/
				comp_size = ((int) comp_size / 8) * 8;

				/* Update the size of the payload in the packet.	*/
				/* This data will be used for fragmentation if it	*/
				/* performed.										*/
				pk_fd_ptr->frag_len -= (size - (int) comp_size)  / 8;

				/* Set the compressed size and compression method	*/
				/* into associated ICI and return the delay.		*/
				intf_ici_fdstruct_ptr->compressed_size = comp_size;
				pk_fd_ptr->compression_method = IpC_Per_Virtual_Circuit_Comp;

				FRET ((double) (comp_info_ptr->compression_delay * pk_fd_ptr->orig_len * 8));
				}
        	else
				{
				FRET (0.0)
				}
			break;
			}

		default:
			{
			/* No Compression delay and change of datagram packet size.	*/
			FRET (0.0);
			break;
			}
		}
	}

static double
ip_rte_decomp_delay_compute (Packet* pkptr, IpT_Dgram_Fields* pk_fd_ptr)
	{
	int			size;
	int			decompressed_size;
	double		decomp_delay = 0.0;

	/** This fucntion computes the amount of processing time 		**/
	/** necessary to decompress the compressed parts of the input	**/
	/** datagram. The computed delay value is returned.				**/
	FIN (ip_rte_decomp_delay_compute (pkptr, pk_fd_ptr));

	/* Get the current size of the datagram.	*/
	size = op_pk_total_size_get (pkptr);

	/* Based on the method used to compress the datagram, compute	*/
	/* the size of packet's compressed parts.						*/
	switch (pk_fd_ptr->compression_method) 
		{
		case IpC_TCPIP_Header_Comp:
			{
			decompressed_size = IP_TCP_COMPRESSABLE_HEADER_SIZE - (pk_fd_ptr->original_size - size);
			break;
			}
		case IpC_Per_Interface_Comp:
			{
			decompressed_size = size;
			break;
			}
		case IpC_Per_Virtual_Circuit_Comp:
			{
			decompressed_size = pk_fd_ptr->frag_len * 8;
			break;
			}
		default:
			{
			break;
			}
		}

	/* Decompression delay is the multiplication of per-bit			*/
	/* decompression delay (a charecteristic of compression method)	*/
	/* the size of packet's compressed parts.						*/
	decomp_delay = pk_fd_ptr->decompression_delay * decompressed_size; 

	FRET (decomp_delay);
	}

static void
ip_rte_comp_decomp_trace_print (Packet* pkptr, IpT_Compression_Method method, int old_size, int new_size, char action [15])
	{
	char	odb_msg1 [128], odb_msg2 [128], comp_method [64];

	/** This function prints compression related odb trace 	**/
	/** statements.											**/
	FIN (ip_rte_comp_decomp_trace_print (Packet* pkptr, IpT_Compression_Method method, int old_size, int new_size, char action [15]));

	if (strcmp (action, "decompression") == 0)
		{
		sprintf (odb_msg1, "Decompressing the packet: %d  Setting back to its original size:  %d bits", op_pk_id (pkptr), new_size);
		op_prg_odb_print_minor (odb_msg1, OPC_NIL);
		FOUT;
		}

	/* Else the action is compression.	*/
	switch (method)
		{
		case IpC_TCPIP_Header_Comp:
			{
			sprintf (comp_method, "TCP/IP Header Compression"); 
			break;
			}
		case IpC_Per_Interface_Comp:
			{
			sprintf (comp_method, "Per-Interface Compression");
			break;
			}
		case IpC_Per_Virtual_Circuit_Comp:
			{
			sprintf (comp_method, "Per-Virtual Circuit Compression");
			break;
			}
		}

	sprintf (odb_msg1, "Compressing the packet: %d  Method: %s", op_pk_id (pkptr), comp_method);
	sprintf (odb_msg2, "Original size:  %d bits   Compressed size:  %d bits", old_size, new_size);
	op_prg_odb_print_minor (odb_msg1, odb_msg2, OPC_NIL);

	FOUT;
	}

static void
ip_rte_pk_stats_update (Packet* pkptr, double * last_stat_update_time_ptr,
	OmsT_Bgutil_Routed_State * stat_bgutil_routed_state_ptr,
	Stathandle * packet_shandle_ptr)
	{
	int				i;
	int				stat_updates_in_this_interval;
	double			update_time;
	double			routed_packets_per_sec;
	double			routed_pk_size_std_dev;
	double			update_interval;
	double			pks_per_update;
	double			dist_pks_per_update;
	double			curr_sim_time;
	double			pks_per_update_fraction;

	/**	Record the IP stats for packets sent and received.					**/
	/**	These statistics take into account background traffic, if any.		**/
	/** If the packet pointer is non-nil, we examine the packet to			**/
	/** determine if there is new background utilization traffic specified	**/
	/** in the packet.														**/
	FIN (ip_rte_pk_stats_update (pkptr, pksize, ...));
	
	/* Store current simulation time.	*/
	curr_sim_time = op_sim_time ();

	if (do_bgutil == OPC_TRUE)
		{
		/* Check to see if we have a packet. */
		if (pkptr != OPC_NIL)
			{
			/* This packet might contain a background utilization tracer packet.			*/
			/* Obtain the background utilization till the current time.						*/
			/* The value returned denotes the background utilization which is valid until 	*/
			/* right before the current time.  This function is efficient if there is no	*/
			/* routed background utilization.												*/
			oms_bgutil_routed_utilization_get (stat_bgutil_routed_state_ptr, 
				pkptr, curr_sim_time, 1.0, &routed_packets_per_sec, 
				&routed_pk_size_std_dev, OmsC_Bgutil_Get_Prev);
			}
		else
			{
			/* We do not have a packet to examine, but we still need to purge 	*/
			/* any utilization that has expired and determine the current		*/
			/* utilization.	 This function is efficient if there is no			*/
			/* routed background utilization.									*/
			oms_bgutil_routed_table_purge_stale (curr_sim_time,
				&stat_bgutil_routed_state_ptr->table, &routed_packets_per_sec, &routed_pk_size_std_dev);
			}
		}
	
	if (do_bgutil == OPC_FALSE || routed_packets_per_sec == 0.0)
		{
		/* There is only explicitly modeled traffic. Record		*/
		/* statistics w.r.t. only explicit traffic.				*/
		/*	Calculate Statistics. In the model code (below), we	*/
		/*	will record the "<units>/sec" statistic in <units>	*/
		/*	where <units> can be "bits" or "packets". OPNET's	*/
		/*	statistics "capture mode" feature will be used to	*/
		/*	record it in <units>/sec.							*/ 
		op_stat_write (*packet_shandle_ptr,     1.0);
			
		/* Maintain time at which these statistics were last updated.	*/
		*last_stat_update_time_ptr = curr_sim_time;
		}
	else
		{
		/* Compute  statistics for the time upto			*/
		/* the current time. Find the time elapsed since	*/
		/* the last statistic update.						*/
		update_interval = curr_sim_time - *last_stat_update_time_ptr;
		
		/* Determine how many stat updates we should have 	*/
		/* during this interval.							*/
		stat_updates_in_this_interval = oms_bgutil_num_updates_get (update_interval);
		
		/* We will start our updates at the time of last stat update. */
		update_time = *last_stat_update_time_ptr;

		/* Background utilization delays are modeled using the 			*/
		/* op_dist_qwait_est KP where background utilization packet		*/
		/* interarrivals are modeled as exponential interarrivals.  	*/
		/* For efficiency, for the stat updates here we will simplify 	*/
		/* and use a uniform distribution instead of a poisson 			*/
		/* distribution for the number of packet arrivals.				*/
		pks_per_update = routed_packets_per_sec * update_interval /
			(stat_updates_in_this_interval);
	
		/* Calculate the fraction of the packets per update we will use later. */
		pks_per_update_fraction = pks_per_update * OMSC_BGUTIL_DIST_FACTOR;
			
		/* Now we will loop and do several stat updates which represent */
		/* the routed background utilization traffic.					*/
		for (i = 0; i < stat_updates_in_this_interval; i++)
			{
			/* Obtain a utilization uniformly distributed around input_utilization. 			*/
			/* We don't use a utilization less than 0 but allow a utilization greater than 1. 	*/
			dist_pks_per_update = pks_per_update - pks_per_update_fraction + op_dist_uniform (2 * pks_per_update_fraction);
		
			/* Write the stat values for this update. */
			op_stat_write_t (*packet_shandle_ptr, dist_pks_per_update, update_time);
		
			/* Move forward to the next stat update time. */
			update_time += (update_interval / stat_updates_in_this_interval);
			}
		
		/* Update the statistic based on the current packet.	*/
		op_stat_write (*packet_shandle_ptr,     1.0);
		
		/* Maintain time at which this statistic was last updated.	*/
		*last_stat_update_time_ptr = curr_sim_time;
		}

	FOUT;
	}

static void
ip_rte_pk_stats_update_endsim (void * dumlocal_state, int dumlocal_code)
	{
	/** This procedure is scheduled for the end of simulation for the 	**/
	/** purpose of providing a background utilization stat update if 	**/
	/** needed. 														**/  
	FIN (ip_rte_pk_stats_update_endsim (dumlocal_state, dumlocal_code));
	
	/* Update first the load stats, then the traffic received stats. 	*/
	/* A nil packet pointer means that we do not have a new packet 		*/
	/* to examine for background utilization information.				*/ 

	/* Update the pk received statistics.								*/		
	/* These statistics take into account background traffic, if any.	*/
	ip_rte_pk_stats_update (OPC_NIL, &received_last_stat_update_time,
		received_bgutil_routed_state_ptr, &locl_tot_pkts_rcvd_hndl);

	/* Update the pk sent statistics.									*/		
	/* These statistics take into account background traffic, if any.	*/
	ip_rte_pk_stats_update (OPC_NIL, &sent_last_stat_update_time,
		sent_bgutil_routed_state_ptr, &locl_tot_pkts_sent_hndl);
	
    FOUT;
	}

static void
ip_dev_ipcloud_var_init (Objid node_objid, Objid module_objid)
	{
    char        packet_latency_dist_args [512];
    int         i, port_count;
	char		msg [512];

    /** The surrounding node is an IP cloud. The following   **/
	/** function obtains the packet latency and packet drop  **/
	/** ratio attribute values, and registers packet latency **/
	/** statistic handle.                                    **/
    FIN (ip_dev_ipcloud_var_init (node_objid, module_objid));

    /* Obtain the packet discard ratio specification.   */
    op_ima_obj_attr_get (node_objid, "Packet Discard Ratio", &packet_discard_probability);
 
    /* Obtain the packet latency parameters.    */
    op_ima_obj_attr_get (node_objid, "Packet Latency (secs)", packet_latency_dist_args);

	/* Register the statistics for recording the packet latency time 	*/
	/* this statistics will only be promoted for the ipcloud nodes 		*/	
	local_pkt_latency_stat = op_stat_reg ("IP.Packet Latency (sec)", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);

    /* Determine the distribution to be used to generate packet latency values. */
	if (strcmp (packet_latency_dist_args, "None") == 0)
		{
		packet_latency_dist_handle = oms_dist_load ("constant", 0.0, 0.0);
		}
	else
		{
		packet_latency_dist_handle = oms_dist_load_from_string (packet_latency_dist_args);
		}
 
    /* Determine the number of transmitters connected to the    */
    /* cloud module.                                            */
    port_count = op_topo_assoc_count (module_objid, OPC_TOPO_ASSOC_OUT, OPC_OBJTYPE_STRM);

	/* Print debugging information if tracing is on.			*/
	if (op_prg_odb_ltrace_active ("ip_rte"))
		{
		sprintf (msg, "Number of output ports from the ipcloud = %d", port_count);
		op_prg_odb_print_minor (msg, OPC_NIL);
		}
 
    /* Allocate an array for keeping track of ports (in terms   */
    /* of the transmitters attached to the respective streams   */
    /* connected to this module). For a particular stream       */
    /* number, this variable will remain BUSY for the duration  */
    /* of a frame transmission from the transmitter attached.   */
    port_last_txn_end_time = (double *) op_prg_mem_alloc ((port_count + 1) * sizeof (double));
 
    /* Initialize the times at which these ports indicate the   */
    /* times at which packet transmission ended.                */
    for (i = 0; i <= port_count; i++)
        {
        port_last_txn_end_time [i] = 0.0;
        }

	FOUT;
	}


static double 
ip_cloud_latency_determine (int access_rate, int strm_out, Packet *pkptr)
	{
	double		packet_latency;
	double		current_time = op_sim_time(); 
	int			packet_size;
	double		trans_delay;
	double		delay_beyond_previous_pkt_txn = 0.0;

    /** This function determines the latency experienced by	**/
	/** the current IP datagram. Packet latency is based on	**/
	/** the following algorithm:							**/
	/**  1. check if the previous packet sent to the		**/
	/**     transmitter is still pending/ongoing its		**/
	/**     transmission. If yes, then we delay the current	**/
	/**     packet by the transmission end time of the		**/
	/**     previous datagram.								**/
	/**  2. If the previous packet has been transmitted,	**/
	/**     then simply sent the current packet after		**/
	/**     including a packet latency.						**/
	FIN (ip_cloud_latency_determine (access_rate, strm_out, pkptr));

	/* Obtain the size of the packet from the packet pointer*/
	packet_size = op_pk_total_size_get (pkptr);	

	/* Calculate the transmission delay the current 	*/
	/* packet will incur on the output port.			*/
	trans_delay = (double) packet_size / access_rate;

	/* The packet must be forwarded. Compute the delay	*/
	/* that this packet should experience.              */
	packet_latency = oms_dist_outcome (packet_latency_dist_handle);

	/* If packet latency is negative make it zero.		*/
	if (packet_latency < 0.0)
		packet_latency = 0.0;

	/* Check the whether the transmission of the 		*/
	/* previous datagram was complete. If no, then the 	*/
	/* current datagram would be forwarded to the 		*/
	/* transmitter after modeling the transmission		*/
	/* completion time of the first datagram. This might*/
	/* result in higher latency values than expected.	*/
	/* This is performed to maintain a strict FIFO 		*/
	/* ordering for datagrams traversing through the 	*/
	/* same	output port of this node.                   */
	if ((packet_latency + current_time) < port_last_txn_end_time [strm_out])
		{
		/* The current packet needs to wait extra time	*/
		/* as the previously submitted datagram to the	*/
		/* port transmitter has not been completely		*/
		/* transmitted yet.								*/
		packet_latency = port_last_txn_end_time [strm_out] - current_time;
		}
	else
		{
		/* The previous datagram has already been 		*/
		/* transmitted. All that this packet needs to	*/
		/* wait before getting transmitted is the		*/
		/* earlier computed packet latency.				*/
		}

	/* Update this port' transmission end time to reflect	*/
	/* the time tt which it will become free now.			*/
	port_last_txn_end_time [strm_out] = current_time + packet_latency + trans_delay;

	/* The variable "delay_beyond_previous_pkt_txn" actually	*/
	/* contains the time for which the packet should be delayed	*/
	/* before it reaches the transmitter.						*/
	FRET (packet_latency);
	}

static void
ip_unnumbered_intf_router_id_assign ()
	{
	int						i, iface_table_size;
    IpT_Interface_Info *	iface_elem_ptr;
	IpT_Address				router_id;
	char					router_id_str [128];

	/* Store the router_id of the neighboring router connected	*/
	/* through this interface if the current interface is a 	*/
	/* unnumbered interface.									*/
	FIN (ip_unnumbered_intf_router_id_assign ());

	/* Obtain the size of the interface table on the IP layer 	*/
	iface_table_size = op_prg_list_size (interface_table_ptr);
	for (i = 0; i < iface_table_size; i++)
		{
		/* Access each and every element from the interface		*/
		iface_elem_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, i);

		if (iface_elem_ptr->intf_unnumbered == OPC_TRUE)
			{
			/* Obtain the neighbor's router identifier. This is	*/
			/* a complex process in which the neighboring node 	*/
			/* is obtained and then its OSPF module id is 		*/
			/* fetch to get the state variable value of the 	*/
			/* OSPF Router ID.									*/
			if ((router_id = ip_obtain_neighbor_router_id (iface_elem_ptr->connected_link_objid)) == 
				IPC_ADDR_INVALID)
				{
				/* No OSPF module present on the neighbor interface. */
				continue;
				}
			else
				{
				/* Store the neighboring router identification 	*/
				/* in the interface structure for future		*/
				/* verification.								*/
				iface_elem_ptr->neighboring_rtr_id = ip_address_copy (router_id);
				}
			}
		else
			continue;
		}	

	FOUT;
	}

static IpT_Address 
ip_obtain_neighbor_router_id (Objid link_objid)
	{
	Objid					local_objid;	
	Objid					local_node_objid;
	Objid					node_objid;
	int						num_of_nodes;
	int						num_of_modules;
	int						index, mod_index;
	Objid 					mod_objid;
	IpT_Address*			router_id_ptr;
	
	/** The idea here is to go through all the nodes 	**/
	/** connected to a link (For point to point there	**/
	/** should not be more than two nodes connected to	**/
	/** a single link). After the initial scanning we	**/
	/** would obtain two node objects. We are more		**/
	/** concerned with the remote node's object. The	**/
	/** test here thus is to compare the obtained node's**/
	/** object with the current node object. If they 	**/
	/** happen to be equal then obtain the OSPF state 	**/
	/** variable called \"ospf_router_id\".				**/
	FIN (ip_obtain_neighbor_router_id (link_objid));

	local_objid = op_id_self ();
	local_node_objid = op_topo_parent (local_objid);

	num_of_nodes = op_topo_assoc_count (link_objid , OPC_TOPO_ASSOC_OUT, OPC_OBJTYPE_NDFIX);
	if (num_of_nodes != 2)
		{
		ip_rte_error ("The link either is unconnected or connected to just one node\n");
		FRET (IPC_ADDR_INVALID);
		}

	for (index = 0; index < num_of_nodes; ++index)
		{
		/* Obtain the object id's of both the nodes.	*/
		node_objid = op_topo_assoc (link_objid, OPC_TOPO_ASSOC_OUT, OPC_OBJTYPE_NDFIX, index);

		/* There are two nodes connected to a point to point link. 	*/
		/* We are interested only about the remote node.			*/
		if (local_node_objid == node_objid)
			continue;
		else
			{
			/* Obtain the module objid of the ospf protocol from the*/
			/* Node object itself. If no name matches that means 	*/
			/* the current node does not have a OSPF module on it.	*/
			mod_objid = op_id_from_name (node_objid, OPC_OBJTYPE_PROC, "ospf");

			if (mod_objid == OPC_OBJID_INVALID)
				{
				FRET (IPC_ADDR_INVALID);
				}
			else
				{
				router_id_ptr = (IpT_Address *) op_ima_obj_svar_get (mod_objid, "ospf_router_id");
				FRET (*router_id_ptr);
				}
			}
		}

	FRET (IPC_ADDR_INVALID);
	}	

static void
ip_register_routerid_as_local_netaddr ()
	{
	int 					unnumbered_size = 0;
	IpT_Interface_Info* 	iface_info_ptr;
	int						index;
	int						intf_table_size;
	Objid					local_objid;
	Objid					node_objid;
	Objid					mod_objid;
	char					msg [128];
	IpT_Address 			router_id_int;
	char 					router_id_str [20];
	IpT_Address*			router_id_ptr;
    List*               	proc_record_handle_list_ptr;
    OmsT_Pr_Handle      	process_record_handle;
	int						proc_record_list_size = 0;
	
	/** In case of a Router running OSPF with all connected interfaces	**/
	/** as unnumbered link interfaces, the router ID is registered as 	**/
	/** local network address. This function initially checks if all the**/
	/** interfaces of the router are unnumbered and if so gets the 		**/
	/** Router ID from the OSPF model attribute called "Router ID". 	**/
	FIN (ip_register_routerid_as_local_netaddr ());

	/* Loop through the available interface list to find	*/
	/* whether all the OSPF interfaces are unnumbered or not*/
	/* Also store the interface pointer into a local var	*/
	/* to be used later for accessing interface information	*/
	intf_table_size = op_prg_list_size (interface_table_ptr);
	for (index = 0; index < intf_table_size ; ++index)
		{
		iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, index);

		if (iface_info_ptr->intf_unnumbered == OPC_TRUE && iface_info_ptr->routing_proto == IpC_Rte_Ospf)
			{
			++unnumbered_size;
			}
		}

	/* Check whether the number of unnumbered interface 	*/
	/* equals the interface table size. If so the Router ID	*/
	/* is registered as the local network address.			*/			 
	if (intf_table_size > 0 && unnumbered_size == intf_table_size)
		{
		/* Obtain the Object Identifier for the current 	*/
		/* module and the surrounding node. 				*/	
		local_objid = op_id_self ();
		node_objid = op_topo_parent (local_objid);

		/*  Search through the process registry to find the     */
		/*  appropriate process.                                */
		proc_record_handle_list_ptr = op_prg_list_create ();

		oms_pr_process_discover (OPC_OBJID_INVALID, proc_record_handle_list_ptr,
				"node objid",   OMSC_PR_OBJID,  node_objid,
				"protocol",     OMSC_PR_STRING, "ospf",
				OPC_NIL);

		/* Store the size of the process list in the temporary var */
		proc_record_list_size = op_prg_list_size (proc_record_handle_list_ptr);

		/* Sanity check.                                        */
		if (proc_record_list_size > 1)
			{
			/* An error should be created if there are more than    */
			/* one process record for a single routing protocol has */
			/* been registered in OMS PR - in the the local node.   */
                op_sim_end (
                    "Error: Found none, or more than one OMS Process Record(s) for",
                    "a OSPF routing protocol in this routing node.", "", "");
			}
		else if (proc_record_list_size == 0)
			{
			/* No OSPF process in the current node */
			FOUT;
			}
		else
			{
			/* Get a reference to the process record.                   */
			process_record_handle = (OmsT_Pr_Handle) op_prg_list_access (
										proc_record_handle_list_ptr, OPC_LISTPOS_HEAD);

			/* Obtain the "router id" of the OSPF router registered	*/
			/* in the init enter execs of the OSPF process model.	*/
			oms_pr_attr_get (process_record_handle,
				"router id", OMSC_PR_ADDRESS, &router_id_ptr);

			/* Obtain the router id from the router id pointer		*/
			/* We pass the pointer to the router id so that even if	*/
			/* the router id is changed the current valid router id	*/
			/* would only be obtained.								*/
			router_id_int = (IpT_Address)*router_id_ptr;

			/* Now register the Router ID as the local 		*/
			/* network address								*/
			ip_rtab_local_addr_register (router_id_int);
			}
		}	

	FOUT;
	}

static int
ip_interface_routing_protocol_obtain (Objid iface_description_objid, char* rte_protocol_label_ptr)
	{
	int						routing_protocol;
	int				        rte_protocol = IpC_Rte_None;
	char					routing_protocol_label [256];
	
	/** What is the routing protocol that the user has set up    **/
	/** on this interface?  Note that:                           **/
	/**  1. Router nodes may specify different routing protocols **/
	/**     on different router interfaces.                      **/
	/**  2. These specifications may be overridden by the        **/
	/**     "IP Dynamic Routing Protocol", if a routing protocol **/
	/**     is specified there.                                  **/
	/**  3. The end nodes (client workstations and servers) do   **/
	/**     not run any dynamic rotuing protocols.               **/
	/** The second parameter, rte_protocol_label_ptr, will store **/
	/** the label of the routing protocol set up on this		 **/
	/** interface, if any.									 	 **/
	FIN (ip_interface_routing_protocol_obtain (iface_description_objid, rte_protocol_label_ptr));

	/* Check first if this node is a router node.            		*/
	if (gateway_status == OPC_TRUE)
		{
		/* This is a router node. Determine the routing protocol to be used */
		/* on the various interfaces. The routing protocol specified using  */
		/* the simulation attribute "IP Dynamic Routing Protocol" takes     */
		/* precedence over local specification.                             */
		rte_protocol = ip_dyn_rte_protocol_obtain (rte_protocol_label_ptr);
		if (rte_protocol == IpC_Rte_Default)
			{
			/* The dynamic routing protocol as specified for this   */
			/* interface should be used.                            */
			op_ima_obj_attr_get (iface_description_objid, "routing protocol", routing_protocol_label);
			
			/* Assign the protocol id based on its value.				*/
			if (strcmp (routing_protocol_label, "RIP") == 0)
            	{
            	/* RIP protocol has been specified to be used on this	*/
				/* interface.											*/
            	routing_protocol = IpC_Rte_Rip;
            	}
        	else if (strcmp (routing_protocol_label, "IGRP") == 0)
            	{
            	/* IGRP protocol has been specified to be used on this	*/
				/* interface.											*/
            	routing_protocol = IpC_Rte_Igrp;
            	}
        	else if (strcmp (routing_protocol_label, "EIGRP") == 0)
				{
				/* EIGRP protocol has been specified to be used on this  */
				/* interface.                         */
				routing_protocol = IpC_Rte_Eigrp;
				}
        	else if (strcmp (routing_protocol_label, "OSPF") == 0)
            	{
            	/* OSPF protocol has been specified to be used on this	*/
				/* interface.											*/
            	routing_protocol = IpC_Rte_Ospf;
            	}
        	else if (strcmp (routing_protocol_label, "BGP") == 0)
            	{
            	/* BGP protocol has been specified to be used on this	*/
				/* interface.											*/
            	routing_protocol = IpC_Rte_Bgp;
            	}
			else if (strcmp (routing_protocol_label, "None") == 0)
            	{
            	/* No protocol has been specified to be used on this	*/
				/* interface.											*/
            	routing_protocol = IpC_Rte_None;
            	}
			else 
				{
				/* Custom routing protocol has been specified to be 	*/
				/* used on this interface. Obtain protocol id for this	*/
				/* protocol label.										*/
				routing_protocol = ip_cmn_rte_table_custom_rte_protocol_id_get (routing_protocol_label);
				}

			/* Copy the routing protocol label.							*/
			strcpy (rte_protocol_label_ptr, routing_protocol_label);
			}
		else
			{
			/* The simulation attribute has been set to use a specfic   */
			/* routing protocol. All IP interfaces (in router) nodes    */
			/* will use this dynamic routing protocol.  Note that all   */
			/* end nodes (e.g, workstations and servers) do not run any */
			/* dynamic routing protocol on their IP interfaces.         */
			routing_protocol = rte_protocol;
			}
		}
	else
		{
		/* This is an end-node or a non-router node (servers or		*/
		/* workstation) -- since it does not have any capability of */
		/* supporting a routing protocol, we do not need to perform */
		/* any checks.                                              */
		routing_protocol = IpC_Rte_None;
		}

	FRET (routing_protocol);
	}

static void
ip_rte_igmp_host_create_init (void)
	{
	/** Creates and initializes an IGMP Host process for this IP	**/
	/** process. A shared memory is installed for communication		**/
	/** between the IP process and the created IGMP	Host process	**/
	FIN (ip_rte_igmp_host_init (void));

	/* Create an IGMP Host process and install a parent-to-child memory */
	igmp_host_process_handle = op_pro_create ("ip_igmp_host", ip_ptc_mem_ptr);

	/* Invoke the IGMP Host process to allow it	*/
	/* to initialize itself						*/
	op_pro_invoke (igmp_host_process_handle, OPC_NIL);

	FOUT;
	}

static void
ip_rte_igmp_rte_intf_create_init (void)
	{
	IpT_Igmp_Rte_Arg_Memory*		igmp_rte_arg_mem_ptr;
	int 							i, num_ip_intfs;
	IpT_Interface_Info*				intf_info_ptr;

	/** Creates and initializes an IGMP Router Interface process for each	**/
	/** IP interface, which is enabled for multicasting. Stores the process	**/
	/** handle for the created process in IpT_Interface_Info object of the	**/
	/** interface. A shared memory is installed for communication between	**/
	/** IP and the created IGMP Router Interface process					**/
	FIN (ip_rte_igmp_rte_intf_create_init (void));

	/* Determine the number of IP interfaces for this node	*/
	num_ip_intfs = op_prg_list_size (interface_table_ptr);

	/* Allocate memory for the argument memory used to initialize the IGMP Router Interface process	*/
	igmp_rte_arg_mem_ptr = (IpT_Igmp_Rte_Arg_Memory *) op_prg_mem_alloc (sizeof (IpT_Igmp_Rte_Arg_Memory));

	/** Create and initialize an IGMP Router Interface process for each	**/
	/**	IP interface of this node, which is enabled for multicasting	**/
	for (i=0; i<num_ip_intfs; i++)
		{
		/* Get the ith IpT_Interface_Info object from the list	*/
		intf_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, i);
		
		/* Create an IGMP Router Interface process for this interface, only if multicast is enabled */
		if (intf_info_ptr->multicast_enabled == OPC_TRUE)
			{
			/* Create an IGMP Router Interface process	*/
			intf_info_ptr->igmp_rte_iface_ph = op_pro_create ("ip_igmp_rte_intf", ip_ptc_mem_ptr);

			/** Invoke the IGMP Router Interface process with argument memory, so that	**/
			/** it can initialize itself. The argument memory contains the interface	**/
			/** number, interface IP address and the process handle of PIM-SM process	**/
	
			/* Set the field of this argument memory */
			igmp_rte_arg_mem_ptr->interface_number = intf_info_ptr->addr_index;
			igmp_rte_arg_mem_ptr->ip_address = ip_address_copy (intf_info_ptr->addr_range_ptr->address);
			igmp_rte_arg_mem_ptr->pim_sm_ph = pim_sm_process_handle;

			/* Invoke the IGMP Router Interface process to allow it to initialize itself */
			op_pro_invoke (intf_info_ptr->igmp_rte_iface_ph, igmp_rte_arg_mem_ptr);
			}
		}

	/* Deallocate memory for the argument memory */
	op_prg_mem_free (igmp_rte_arg_mem_ptr);
	
	FOUT;
	}


static void
ip_rte_pim_sm_create_init (void)
	{
	/** Creates and initializes a PIM-SM process for this IP	**/
	/** process. A shared memory is installed for communication	**/
	/** between the IP process and the created PIM-SM process	**/
	FIN (ip_rte_pim_sm_create_init (void));

	/* Create a PIM-SM process and install a parent-to-child memory */
	pim_sm_process_handle = op_pro_create ("ip_pim_sm", ip_ptc_mem_ptr);

	/* Invoke the PIM-SM process to allow it to initialize itself	*/
	op_pro_invoke (pim_sm_process_handle, OPC_NIL);

	FOUT;
	}

static void
ip_rte_custom_mrp_create_init (void)
	{
	/** Creates and initializes the ip_custom_mrp process	**/
	/** for this IP	process. A shared memory is installed	**/
	/** for communication between the IP process and the	**/
	/** created ip_custom_mrp process.						**/
	FIN (ip_rte_custom_mrp_create_init (void));

	/* Create the ip_custom_mrp process and install a	*/
	/* parent-to-child memory.							*/
	custom_mrp_process_handle = op_pro_create ("ip_custom_mrp", ip_ptc_mem_ptr);

	/* Invoke the ip_custom_mrp process to allow it to	*/
	/* initialize itself.								*/
	op_pro_invoke (custom_mrp_process_handle, OPC_NIL);

	FOUT;
	}


static void
ip_rte_default_mcast_addr_register (void)
	{
	int						i;
	int						num_ip_intfs;
	IpT_Interface_Info*		intf_info_ptr;
	IpT_Address				all_node_mcast_addr;
	IpT_Address				all_rte_mcast_addr;
	IpT_Address				all_pim_rte_mcast_addr;
	Objid					node_objid;

	/** Registers the default multicast addresses, 224.0.0.1, 224.0.0.2	**/
	/** and 224.0.0.13 for each IP interface, which is enabled for		**/
	/** multicast. 224.0.0.2 and 224.0.0.13 are registered only for		**/
	/** multicast routers												**/
	FIN (ip_rte_default_mcast_address_register (void));

	/* Create an ip address from the dotted decimal notation	*/
	all_node_mcast_addr = ip_address_create (IPC_ALL_SYSTEMS_MULTICAST_ADDR);
	all_rte_mcast_addr = ip_address_create (IPC_ALL_ROUTERS_MULTICAST_ADDR);
	all_pim_rte_mcast_addr = ip_address_create (IPC_ALL_PIM_ROUTERS_MULTICAST_ADDR);

	/* Obtain this node's object ID	*/
	node_objid = op_topo_parent (own_id);

	/* Determine the size of the interface table	*/
	num_ip_intfs = op_prg_list_size (interface_table_ptr);

	/* Traverse through the list and register the default	*/
	/* multicast addresses for each IP interface which is	*/
	/* enabled for multicast								*/
	for (i=0; i<num_ip_intfs; i++)
		{
		/* Access ith element from the list	*/
		intf_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, i);

		/* Check if this interface is enabled for multicast	*/
		if (intf_info_ptr->multicast_enabled == OPC_TRUE)
			{
			/* This interface is enabled for multicast.	*/
			/* Register the default addresses			*/
			Ip_Address_Multicast_Register (all_node_mcast_addr, intf_info_ptr->addr_index, node_objid);

			/* If this node is a multicast router, register the	*/
			/* all routers and PIM router addresses too			*/
			if (multicast_router == OPC_TRUE)
				{
				Ip_Address_Multicast_Register (all_rte_mcast_addr, intf_info_ptr->addr_index, node_objid);
				Ip_Address_Multicast_Register (all_pim_rte_mcast_addr, intf_info_ptr->addr_index, node_objid);
				}
			}
		}

	/* Destroy the ip addresses */
	ip_address_destroy (all_node_mcast_addr);
	ip_address_destroy (all_rte_mcast_addr);
	ip_address_destroy (all_pim_rte_mcast_addr);

	FOUT;
	}
			

static Boolean
ip_rte_intf_mcast_enabled (int intf_num)
	{
	int							i, list_size;
	IpT_Interface_Info*			intf_info_ptr;

	/** Returns OPC_TRUE if multicast is enabled on the given interface	**/
	FIN (ip_rte_intf_mcast_enabled (intf_num));

	/* Determine the size of the interface table	*/
	list_size = op_prg_list_size (interface_table_ptr);

	/* Traverse through the list to locate the IpT_Interface_Info	*/
	/* object for the given interface								*/
	for (i=0; i<list_size; i++)
		{
		/* Access ith element from the list	*/
		intf_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, i);

		/* Check if this is the interface object we are looking for */
		if (intf_info_ptr->addr_index == intf_num)
			{
			/* We found the interface object. Now check if	*/
			/* multicast is enabled on this interface		*/
			if (intf_info_ptr->multicast_enabled == OPC_TRUE)
				{
				/* Multicast is enabled on the given interface */
				FRET (OPC_TRUE);
				}
			else
				{
				/* Multicast is disabled on the given interface */
				FRET (OPC_FALSE);
				}
			}
		}

	/* There is no IpT_Interface_Info object for the given interface. This	*/
	/* means that either the interface is not connected to any link or the	*/
	/* given interface number is invalid									*/
	FRET (OPC_FALSE);
	}

static Compcode
ip_rte_mcast_datagram_dest_get (Packet* pkptr, Ici* rsvp_ici_ptr, IpT_Rte_Ind_Ici_Fields* intf_ici_fdstruct_ptr, 
	IpT_Address dest_addr, IpT_Address* next_addr_ptr, Boolean* higher_layer_ptr, Boolean* destroy_pkt_ptr, 
	int protocol_type,  int* output_intf_index_ptr, IpT_Interface_Info** interface_pptr)
	{
	int							i;
	int							num_of_intfs;
	char						warn_str [256];
	char						warn_str2 [256];
	char						warn_str3 [256];
	IpT_Interface_Info*			intf_info_ptr;
	IpT_Rte_Rsvp_Route*			rsvp_route_info_ptr;
	
	/** Retrieve and return the outstream, outslot and mtu to which we should	**/
	/** multicast the datagram. This function may also return status flags		**/
	/** indicating that the datagram should be forwarded to the higher layer.	**/
	/** If OPC_COMPCODE_SUCCESS is returned, the datagram can be dispatched		**/
	/** by the client of this procedure; if OPC_COMPCODE_FAILURE is returned,	**/
	/** a routing message error shoud be generated, and the datagram should		**/
	/** be destroyed. RSVP packets are treated as a special case, when the	  	**/
	/** routing parameters are set based on the parameters set in the intf_ici.	**/
	/** The parameters in intf_ici were previously set based on ICI 			**/
	/** accompanying the RSVP packet.											**/
	FIN (ip_rte_mcast_datagram_dest_get (pkptr, intf_ici_fdstruct_ptr, dest_addr, protocol_type, rsvp_ici_ptr,
		next_addr_ptr, higher_layer_ptr, destroy_pkt_ptr, output_intf_index_ptr, interface_pptr));

	/* Initialize the flags to OPC_FALSE.	*/
	*higher_layer_ptr = OPC_FALSE;
	*destroy_pkt_ptr = OPC_FALSE;

	/* Determine the size of the interface table.	*/
	num_of_intfs = op_prg_list_size (interface_table_ptr);

	/* Check if the packet is received from higher or lower layer	*/
	if (intf_ici_fdstruct_ptr->instrm == instrm_from_ip_encap || intf_ici_fdstruct_ptr->instrm == IpC_Pk_Instrm_Child)
		{
		/** The packet came from higher layer or a child process **/

		/* If this is an RSVP packet, do not perform route query, 	*/
		/* but rather set the routing parameters.					*/
		if ((protocol_type == IpC_Protocol_Rsvp) && (intf_ici_fdstruct_ptr->instrm != IpC_Pk_Instrm_Child))
			{
			/** This is an RSVP packet.		**/

			/* The packet should be accompanied by ICI.		*/
			/* Read the routing information in the ICI.		*/
			op_ici_attr_get (rsvp_ici_ptr, "RSVP Packet Route Info", &rsvp_route_info_ptr);

			/* Destroy the RSVP ICI.							*/
			op_ici_destroy (rsvp_ici_ptr);

			/* Store the index of this interface object in output_intf_index	*/
			*output_intf_index_ptr = rsvp_route_info_ptr->output_intf_index;

			/* Find the interface pointer.	*/
			intf_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, rsvp_route_info_ptr-> output_intf_index);

			/* Set the next address to the ip address of this interface	*/
			*next_addr_ptr = ip_address_copy (intf_info_ptr->addr_range_ptr->address);

			/* Store this interface object in interface_ptr.	*/
			*interface_pptr = intf_info_ptr;

			/* Deallocate memory allocated for the ICI DS.	*/
			op_prg_mem_free (rsvp_route_info_ptr);

			/* Set the out port information in the packet ICI	*/
			intf_ici_fdstruct_ptr->multicast_major_port =  intf_info_ptr->addr_index;
			intf_ici_fdstruct_ptr->minor_port_out =  IPC_MINOR_PORT_DEFAULT;

			FRET (OPC_COMPCODE_SUCCESS);
			}

		/* Traverse through the interface table to find the IpT_Interface_Info	*/
		/* object interface on which this packet should be multicasted.			*/
		for (i=0; i<num_of_intfs; i++)
			{
			/* Obtain ith interface object from the list */
			intf_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, i);

			/* Check if this is the interface object we are interested in	*/
			if (intf_info_ptr->addr_index == intf_ici_fdstruct_ptr->multicast_major_port)
				{
				/** We found the interface object we are interested in	**/

				/* Check if this interface is enabled for multicasting	*/
				if (intf_info_ptr->multicast_enabled == OPC_TRUE)
					{
					/** Multicasting is enabled on this interface	*/

					/* Is the stream valid? */
					if (intf_info_ptr->port_num == IP_OUTSTRM_INVALID)
						{
						/* Write out a message to the sim. log.	*/
						ip_rte_next_hop_error (intf_info_ptr->addr_range_ptr->address);

						FRET (OPC_COMPCODE_FAILURE);
						}

					/** The multicast packet should be forwarded to this interface **/

					/* Set the next address to the ip address of this interface	*/
					*next_addr_ptr = ip_address_copy (intf_info_ptr->addr_range_ptr->address);

					/* Store the index of this interface object in output_intf_index	*/
					*output_intf_index_ptr = i;

					/* Store this interface object in interface_ptr	*/
					*interface_pptr = intf_info_ptr;

					FRET (OPC_COMPCODE_SUCCESS);
					}
				else
					{
					/** This interface is not enabled for multicasting	**/

					/* Report a log message	*/
					ipnl_protwarn_mcast_cannot_fwd_pkt_to_intf (pkptr, intf_ici_fdstruct_ptr->multicast_major_port);

					/* Discard the packet	*/		
					FRET (OPC_COMPCODE_FAILURE);
					}
				}
			}

		/* We haven't found the interface object yet, it means the applications	*/
		/* is trying to multicast this packet on an non-existant interface.		*/
		/* Report a log message													*/
		ipnl_protwarn_mcast_cannot_fwd_pkt_to_intf (pkptr, intf_ici_fdstruct_ptr->multicast_major_port);		
			
		/* Discard the packet */
		FRET (OPC_COMPCODE_FAILURE);
		}
	else
		{
		/** The packet came from lower layer	**/

		/* Obtain the interface object for the interface on which this packet was received	*/
		if (intf_ici_fdstruct_ptr->intf_recvd_index != -1)
			{
			intf_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, 
								intf_ici_fdstruct_ptr->intf_recvd_index);
			}
		else
			{
			op_sim_end ("Error in IP routing process model (ip_rte_v4): ",
				"The interface on which the multicast packet was received",
				"is not specified in the packet's ICI.", OPC_NIL);
			}

		/* Check if the interface on which this packet was received is enabled for multicasting	*/
		if (intf_info_ptr->multicast_enabled == OPC_TRUE)
			{
			/** The interface on which this packet was received is enabled for multicasting **/

			if ((protocol_type == IpC_Protocol_Rsvp) && (rsvp_status == OPC_TRUE))
				{
				/** This is an RSVP packet and RSVP is enabled at the node.		**/

				/* All RSVP packets received from the network should be sent to the 	*/
				/* local RSVP process.													*/
				*higher_layer_ptr = OPC_TRUE;

				FRET (OPC_COMPCODE_SUCCESS);
				}

			/* If any application on this node has registered to accept this packet or this	*/
			/* node is a multicast router, forward the packet to upper layer				*/
			if ((ip_address_multicast_accept (dest_addr, intf_ici_fdstruct_ptr->major_port_received) == OPC_TRUE) || 
				(multicast_router == OPC_TRUE))
				{
				/* Forward the packet to upper layer */
				*higher_layer_ptr = OPC_TRUE;
				FRET (OPC_COMPCODE_SUCCESS);
				}
			else
				{
				/* This packet was not filtered by DLL, just discard it.*/
				FRET (OPC_COMPCODE_FAILURE);
				}
			}
		else
			{
			/** The interface on which this packet was received is not enabled for multicasting	**/

			/* This packet was not filtered by DLL, just discard it	*/
			FRET (OPC_COMPCODE_FAILURE);
			}
		}
	}

static void
ip_rte_car_information_print ()
    {
    double      		    current_time; 
	int						number_of_iface, iface_index, cos;
	char					str1 [256], str2 [256], str3 [256], str4 [256], str5 [256], str6 [256];
	IpT_Interface_Info*		interface_info_ptr;

    /** This functions prints the CAR parameters when using ODB. **/
    FIN (ip_rte_car_information_print ())
 
    /* Get the current time.    */
    current_time = op_sim_time (); 

	/* Get the number of connected interfaces in the IP module.	*/     
	number_of_iface = op_prg_list_size (interface_table_ptr);

	/* Loop through all the interfaces in this IP module and print	*/
	/* CAR information for each of them.							*/
	for (iface_index = 0; iface_index < number_of_iface; iface_index++)
		{ 
		/* Get interface information.	*/
		interface_info_ptr = op_prg_list_access (interface_table_ptr, iface_index);

		/* Loop through the class of service for one interface and	*/
		/* print in ODB the CAR parameters for each COS.			*/
	    for (cos = 0; cos < car_incoming_profile_ptr [iface_index]->number_of_cos; cos++)
			{
    		sprintf (str1, "CAR information on incoming interface: %d COS: %d\n", interface_info_ptr->addr_index, cos, OPC_NIL); 
    		sprintf (str2, "Bucket size: %f\n", car_incoming_info_ptr [iface_index] [cos].bucket_size);
    		sprintf (str3, "Actual debt: %f\n", car_incoming_info_ptr [iface_index] [cos].actual_debt);
			sprintf (str4, "Compounded debt: %f\n", car_incoming_info_ptr [iface_index] [cos].compounded_debt);
    		sprintf (str5, "Last update time: %f\n", car_incoming_info_ptr [iface_index] [cos].last_update_time);
			sprintf (str6, "Current time: %f\n\n", current_time);
			op_prg_odb_print_major (str1, str2, str3, str4, str5, str6, OPC_NIL);
    		}

		/* Loop through the class of service for one interface and	*/
		/* print in ODB the CAR parameters for each COS.			*/
	    for (cos = 0; cos < car_outgoing_profile_ptr [iface_index]->number_of_cos; cos++)
			{
    		sprintf (str1, "CAR information on outgoing interface: %d COS: %d\n", interface_info_ptr->addr_index, cos, OPC_NIL);
    		sprintf (str2, "Bucket size: %f\n", car_outgoing_info_ptr [iface_index] [cos].bucket_size);
    		sprintf (str3, "Actual debt: %f\n", car_outgoing_info_ptr [iface_index] [cos].actual_debt);
			sprintf (str4, "Compounded debt: %f\n", car_outgoing_info_ptr [iface_index] [cos].compounded_debt);
    		sprintf (str5, "Last update time: %f\n", car_outgoing_info_ptr [iface_index] [cos].last_update_time);
			sprintf (str6, "Current time: %f\n\n", current_time);
			op_prg_odb_print_major (str1, str2, str3, str4, str5, str6, OPC_NIL);
    		}
    	}
    FOUT;
    }


static Prohandle
ip_rtab_phandle_from_intf_get (RsvpT_TC_Ici_Struct *	ici_data_struct_ptr)
	{
	int						iface_table_size;
	int 					index;
	IpT_Interface_Info *	iface_elem_ptr;

	/** Based on the interface index, get process handle of a child process.	**/
	FIN (ip_rtab_phandle_from_intf_ge (ici_data_struct_ptr));

	/* Get the interface information.	*/
	iface_elem_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, ici_data_struct_ptr->intf_index);

	/* Return process handle.	*/
	FRET (iface_elem_ptr->output_iface_prohandle);
	}

static Boolean
ip_rtab_rsvp_status_set (Objid iface_description_objid)
	{
	Objid				qos_info_objid, qos_info_child_objid;
	Objid				rsvp_info_objid, rsvp_info_child_objid;
	Boolean				rsvp_is_enabled;


	FIN (ip_rtab_rsvp_status_set (iface_description_objid));

	/* Get the handle to the sub-attribute called "QoS info".	*/
	op_ima_obj_attr_get (iface_description_objid, "QoS info", &qos_info_objid);
	qos_info_child_objid = op_topo_child (qos_info_objid, OPC_OBJTYPE_GENERIC, 0);

	/* Get the handle to the sub-attribute called "RSVP Info".	*/
	op_ima_obj_attr_get (qos_info_child_objid, "RSVP Info", &rsvp_info_objid);
	rsvp_info_child_objid = op_topo_child (rsvp_info_objid, OPC_OBJTYPE_GENERIC, 0);

	/* Get the handle to the sub-attribute called "RSVP Status".	*/
	op_ima_obj_attr_get (rsvp_info_child_objid, "RSVP Status", &rsvp_is_enabled);

	FRET (rsvp_is_enabled);
	}


static void
ip_rte_rsvp_init_notify (void)
	{
	Objid				rsvp_module_id;
	List*				proc_rec_handle_list_ptr;
	OmsT_Pr_Handle		process_record_handle;
	int 				record_handle_list_size;

	/** This function is called after IP interface table is built and 	**/
	/** RSVP is supported at at least one interface.					**/
	/** RSVP module object id is found from the database and a remote	**/
	/** interrupt is sent to RSVP local process.						**/
	FIN (ip_rte_rsvp_init_notify ());

	/** 1. Find the object ID of the RSVP local process.	**/

	/* Create a temporary list to store discovered processe information.	*/
	proc_rec_handle_list_ptr =  op_prg_list_create ();

	/* Obtain the process record handle of the IP process residing in the local node.	*/
	oms_pr_process_discover (OPC_OBJID_INVALID, proc_rec_handle_list_ptr, 
		"node objid", 		OMSC_PR_OBJID, 		own_node_objid, 
		"protocol", 		OMSC_PR_STRING, 	"rsvp",
		OPC_NIL);

	/* An error should be created if there are more than one ip process in the local node	*/
	record_handle_list_size = op_prg_list_size (proc_rec_handle_list_ptr);

	if (record_handle_list_size > 1)
		{
		op_sim_end ("Error: Several RSVP processes found in the local node", "", "", "");
		}
	else if (record_handle_list_size == 1)
		{
		process_record_handle = (OmsT_Pr_Handle) op_prg_list_access (proc_rec_handle_list_ptr, OPC_LISTPOS_HEAD);

		/* Obtain a reference to the IpT_Cmn_Rte_Table object   		*/
		/* for this node. This object is created and registered by IP.	*/
		oms_pr_attr_get (process_record_handle, "module id", 		  OMSC_PR_OBJID,  &rsvp_module_id);

		/** 2. Send a remote interrupt to RSVP.					**/
		op_intrpt_schedule_remote (op_sim_time (), 0, rsvp_module_id);
		}
	else
		{
         /** There is no RSVP module.	**/

		/* Set RSVP status to FALSE.	*/
		rsvp_status = OPC_FALSE;
		}

	/* Free the list.	*/
	op_prg_mem_free (proc_rec_handle_list_ptr); 

	FOUT;
	}



/* End of Function Block */

#if defined (__cplusplus)
extern "C" {
#endif
	void ip_rte_v4_vc (void);
	Compcode ip_rte_v4_vc_init (void **);
	void ip_rte_v4_vc_diag (void);
	void ip_rte_v4_vc_terminate (void);
	void ip_rte_v4_vc_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
ip_rte_v4_vc (void)
	{
	int _block_origin = 0;
	FIN (ip_rte_v4_vc ());
	if (1)
		{
		int						iface_id;
		IpT_Dgram_Fields*		pk_fd_ptr;
		double          		pk_svc_time;
		int             		insert_ok;
		int						instrm;
		int 					slot_index = -1;
		int						inslot = -1, outslot = -1;
		double					iface_data_rate;
		int						packet_size;
		int						scheme = 0;
		int						status = -1;
		Compcode				return_status = OPC_COMPCODE_FAILURE;
		int						pkt_id, pkt_tree_id;
		Ici*					pk_ici_ptr = OPC_NIL;
		int						outstrm = IP_OUTSTRM_INVALID;
		int						mtu = -1;
		int						i, frag, frag_accum, num_frags, k, instrm_index;
		int						frag_size, data_size, len;
		int						header_size, ttl;
		char					str0 [512], str1 [512];
		Packet					*pkptr, *ip_pkptr, *frag_ptr, *pkcopy;
		Packet					*data_pkptr;
		int						num_output_streams, num_input_streams;
		int						instrm_ip_addr_index;
		Objid					strm_objid, ip_encap_objid, instrm_objid;
		IpT_Interface_Info*		iface_info_ptr;
		IpT_Interface_Info*		bcast_iface_info_ptr;
		IpT_Interface_Info*		input_intf_info_ptr;
		IpT_Interface_Info*		temp_iface_info_ptr;
		IpT_Interface_Info*		interface_ptr = OPC_NIL;
		OmsT_Dv_Slot_Info*		slot_info_ptr;
		Objid					slot_info_objid;
		Objid					node_objid;
		Ici*					rip_iciptr;
		Ici*					rsvp_ici_ptr = OPC_NIL;
		Ici*					mcast_ici_ptr;
		int						ip_fast_addr = -1;
		Boolean					broadcast_mode, entry_included;
		List*					proc_record_handle_list_ptr;
		int						record_handle_list_size;
		OmsT_Pr_Handle			process_record_handle;
		Compcode				route_status;
		Evhandle				evh;
		Boolean					ip_dest_local_network;
		int						rip_rte_table_size;
		Objid					iface_description_objid;
		Objid					line_objid;
		Objid					link_objid;
		char					dyn_route [512];
		int						conn_class;
		int						proto_num;
		char					ip_packet_format [256];
		char					ip_addr_str [IPC_ADDR_STR_LEN];
		char					subnet_mask_str [IPC_ADDR_STR_LEN];
		IpT_Address				ip_addr;
		IpT_Address				subnet_mask_addr;
		IpT_Address				dest_addr;
		IpT_Address				next_addr = IPC_ADDR_INVALID;
		Boolean					broadcast = OPC_FALSE;
		Boolean					higher_layer = OPC_FALSE;
		Boolean					destroy_pkt = OPC_FALSE;
		Boolean					in_port_found;
		char					dest_addr_str [IPC_ADDR_STR_LEN];
		Objid					static_rte_table_objid, routing_entry_objid;
		Ici*					intf_ici_ptr = OPC_NIL;
		Ici*					ici_ptr;
		int						mcast_major_port = 0;
		int 					mcast_minor_port = 0;
		char					ici_format_str [128];
		char					trace_msg [128];
		char					intf_addr_str [IPC_ADDR_STR_LEN];
		Boolean					broadcast_addr = OPC_FALSE;
		int						broadcast_intf_index = OPC_INT_INVALID;
		int						intf_num;
		char					strm_name [128];
		int						iface_table_size;
		char					error_string [512];
		char					default_gtwy_str [IPC_ADDR_STR_LEN];
		IpT_Address				intf_addr;
		IpT_Interface_Type		interface_type = IpC_Intf_Type_Unspec;
		double 					interface_speed = OPC_DBL_INFINITY;
		Objid					creation_node_objid;
		Boolean					force_fwd = OPC_FALSE;
		int						pkt_dest_type;
		int						invoke_mode;
		IpT_Compression_Info*	data;
		char					comp_info_str [256];
		double					decomp_delay = 0.0;
		double					comp_delay = 0.0;
		double					comp_decomp_delay = 0.0;
		int						output_intf_index = -1;
		Boolean					decompress = OPC_FALSE;
		char*					scenario_name;
		Boolean					multicast_enabled;
		
		/* Variable to keep track of we are processing a packet	*/
		/* from any of the child process models.				*/
		Prohandle				child_prohandle;
		Boolean					pk_from_child_process = OPC_FALSE;
		
		/* Delay servicing a packet due to the background 		*/
		/* utilization of one of the servers.					*/
		double					bgutil_delay;
		
		int						intrpt_type = -1;
		double					current_time = 0.0;
		
		/* Delay introduced to a forwarded packet by the proxy  */
		/* server if the node is configured as a firewall.		*/
		double					proxy_delay = 0.0;
		
		/* Flag to track whether any ip addresses have been		*/
		/* created on this node.								*/
		Boolean					ip_addr_created;
		
		/* Placeholder for value of "routing protocol" column	*/
		/* of a row in the "ip addr info" compound attribute.	*/
		int						rte_protocol;
		int						routing_proto;
		
		/* ICMP packets are handled differently by IP. Keep a	*/
		/* variable to track the kind of encapsulated packet in	*/
		/* the IP datagram.										*/
		Boolean					dgram_encapsulates_icmp_pkt = OPC_FALSE;
		
		/* IP datagrams maintain an ICI to record information	*/
		/* required for proper routing (e.g., slot on which the	*/
		/* datagram arrived, output interface on which it		*/
		/* should be forwarded, etc.) -- all that information	*/
		/* is stored in a single structure field of the			*/
		/* ip_rte_ind_v4 ICI.									*/
		IpT_Rte_Ind_Ici_Fields*		intf_ici_fdstruct_ptr = OPC_NIL;
		
		/* Store the packet latency for the ipcloud node		*/
		double					pkt_latency;
		
		/* store the random number between zero and one			*/
		double					test_outcome;
		
		/* Store information about unnumbered interface in the	*/
		/* local variable to be copied finally into the 		*/
		/* interface table.										*/
		int 					intf_unnumbered = OPC_FALSE;
		int						size;
		int						intf_table_size = 0;
		int						unnumbered_size = 0;
		int						index;
		
		Boolean					ip_rte_trace;
		
		Boolean					car_packet_drop = OPC_FALSE;
		IpT_Rte_App_Ici_Type	ici_type;
		RsvpT_TC_Ici_Struct *	ici_data_struct_ptr;
		Prohandle				intf_phandle;
		
		/* Temporary variables used for invoking custom routing	*/
		/* protocols. Labels of the custom routing protocols	*/
		/* active in this node are maintained in a list, which	*/
		/* is freed after the custom routing protocols are		*/
		/* invoked.												*/
		List*					active_custom_rte_proto_label_lptr;
		char					rte_protocol_label [256];
		char*					custom_rte_protocol_label_ptr;
		int 					low_index, high_index;
		int						active_custom_rte_protos_size;
		
		Ici*					iciptr;
		int						minor_port_in;
		int 					minor_port_out = IPC_MINOR_PORT_DEFAULT;
		


		FSM_ENTER (ip_rte_v4_vc)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (arrival) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "arrival", "ip_rte_v4_vc () [arrival enter execs]")
				{
				/* obtain whether the labelel trace for "ip_rte" is enabled		*/
				ip_rte_trace = op_prg_odb_ltrace_active ("ip_rte");
				
				/* Acquire the arriving packet. The packet could have arrived via a stream	*/
				/* interrupt, or from one of the child process (ip_basetraf_src or ip_icmp)	*/
				/* A packet from the ip_basetraf process indicates that the child had a		*/
				/* self-interrupt and generated a tracer packet to send bandwidth usage		*/
				/* information across the network. A packet from ip_icmp process indicates	*/
				/* a IP control message needs to be sent.									*/
				if (pk_from_child_process == OPC_TRUE)
					{
					/* Get the packet from the parent-to-child shared memory between IP and	*/
					/* the invoking child process (ip_basetraf_src or ip_icmp)				*/
					pkptr = ip_ptc_mem_ptr->child_pkptr;	
					
					/* Set the instream to the symbolic constant indicating 	*/
					/* this packet is from the ip_basetraf_src child process.	*/
					/* instrm is later checked to determine the source of the 	*/
					/* the packet.												*/
					instrm = IpC_Pk_Instrm_Child;
					}
				else
					{
					/* Get the packet from the strm.  Multiple arriving streams	*/
					/* are supported.											*/
					instrm = op_intrpt_strm ();
					pkptr = op_pk_get (instrm);
					if (pkptr == OPC_NIL)
						ip_rte_error ("Unable to get packet from input stream.");
					}
				
				/*	Obtain the format of the packet to verify that it is an		*/
				/*	IP datagram.												*/
				op_pk_format (pkptr, ip_packet_format);
				
				/* Ignore if this is not a valid IP datagram.	*/
				if (strcmp (ip_packet_format, "ip_dgram_v4") != 0)
					{
					/*	Print this error message only once.	*/
					if (ip_error_message_printed == OPC_FALSE)
						{
						/* Print a warning message in the simulation log.	*/	
						ipnl_protwarn_pkformat (op_pk_id (pkptr), op_pk_tree_id (pkptr), ip_packet_format);
						}
				
					/* Destroy the packet and update statistics.	*/
					ip_rte_dgram_discard (pkptr, OPC_NIL);
				
					/* Indicate that the packet insertion failed.	*/
					insert_ok = 0;
					}
				else
					{
				    /* If the the surrounding node is an IP cloud. Check if	*/
				    /* the packet discard probability is more than the one  */
				    /* drawn from a distribution -- if yes, then the packet	*/
					/* will be discarded.									*/
					if ((ipcloud_flag == OPC_TRUE) && (op_dist_uniform (100.0) < packet_discard_probability))
						{
						/* Drop the current IP datagram.	*/
						ip_rte_dgram_discard (pkptr, OPC_NIL);
				
						insert_ok = 0;
						}
				
					/* If the node containing this IP module is a firewall then */
					/* we need to check whether the arriving packet will be 	*/
					/* accepted by the proxy servers.							*/
					else if ((firewall_flag == OPC_TRUE) && 
						(!oms_dv_firewall_accept (pkptr, proxy_info_table_lptr, &proxy_delay)))
						{
						/* The datagram could not make through the firewall.	*/
						/* Destroy the packet and update the statistics. Also	*/
						/* record that into the simulation log.					*/		
						ip_rte_dgram_discard (pkptr, OPC_NIL);
						ipnl_firewall_dgram_reject_log_write ();
				
						/* Indicate that the packet insertion failed.			*/
						insert_ok = 0;
						}
					else
						{
						/* Get a handle to the data structure stored in "fields"	*/
						/* field. This structure contains all the protocol header	*/
						/* information as well as some internal information 		*/
						/* attached to each IP datagram for simulation efficiency.  */
						op_pk_nfd_access (pkptr, "fields", &pk_fd_ptr);
				
						/* Create an ICI and associate it with the datagram.	*/
						/* The ICI will carry information about the datagram	*/
						/* that will be used later when processing the packet	*/
						/* after queueing and forwarding to the output			*/
						/* interface.											*/
						intf_ici_ptr = op_ici_create ("ip_rte_ind_v4");
				
						/*	Create ip_rte_ind ICI fields data structure that 	*/
						/*	contains routing information which is used during	*/
						/* the life-cycle of the ICI in this process.			*/
						intf_ici_fdstruct_ptr = ip_rte_ind_ici_fdstruct_create ();
				
						/*	Set the rte_info_fields in the ICI.	*/
						op_ici_attr_set (intf_ici_ptr, "rte_info_fields", intf_ici_fdstruct_ptr);
				
						/* If this node is configured as a firewall then the 	*/
						/* datagram may have an additional delay caused by		*/
						/* proxy server besides the routing delay. Associate	*/
						/* this delay, which is computed earlier, with the		*/
						/* packet. If the node is not a firewall then the delay	*/
						/* is always zero.										*/
						intf_ici_fdstruct_ptr->proxy_delay = proxy_delay;
					
						/* Check if this packet came from a higher layer or from 	*/
						/* ip_basetraf_src.  Conceptually, both cases imply that 	*/
						/* this process must route the pk to the lower layers.		*/
						if (instrm == instrm_from_ip_encap || instrm == IpC_Pk_Instrm_Child)
							{
							/* Assign a unique identity to this packet - unique among	*/
							/* packets injected into the net by this host. This	is used	*/
							/* while reassembling data fragments on the destination.	*/
							/* However, ip_basetraf_src model set it to "-1" as bgutil	*/
							/* tracer packets never get fragmented.						*/
							/* Note: IP datagrams which are already assigned an			*/
							/* identifier (e.g. fragmented multicast data packets) may 	*/
							/* be received from ip_pim_sm child process. Datagrams which*/
							/* are not yet assigned an identifier will have their ident	*/
							/* field set to 0.											*/
							if ((pk_fd_ptr->ident != -1) && (pk_fd_ptr->ident == 0))
								{
								pk_fd_ptr->ident = dgram_id++;
								}
				
							/* Indicate that the packet has not been processed yet.	*/
							/* This will be used while servicing the datagram in	*/
							/* the "svc_cmpl" state.								*/
							intf_ici_fdstruct_ptr->processed = OPC_FALSE;
							intf_ici_fdstruct_ptr->slot_index = CENTRAL_CPU;
							intf_ici_fdstruct_ptr->instrm = instrm;
										
							/* Set the packet insertion time.  This will be later	*/
							/* used to compute packet latency.						*/
							current_time = op_sim_time ();
							intf_ici_fdstruct_ptr->pkt_insertion_time = current_time;
				
							if (pk_fd_ptr->protocol == IpC_Protocol_Rsvp)
								{
								/* The packet is accompanied by an ICI. Get the ICI.	*/
								rsvp_ici_ptr = 	op_intrpt_ici ();
								}
							else if ((ip_address_is_multicast (pk_fd_ptr->dest_addr) == OPC_TRUE)
									&& (pk_fd_ptr->protocol != IpC_Protocol_Rsvp))
								{
								/**	The higher layer has specified multicast, so	**/
								/**	get the major and minor port information to 	**/
								/** which we want to send the multicast packet.		**/
								/** The major and minor port information will be	**/
								/** specified either in an ICI or in the			**/
								/** parent-to-child memory.							**/
								
								/* Check whether port information was specified		*/
								/* in the ICI										*/
								mcast_ici_ptr = op_intrpt_ici ();
								if (mcast_ici_ptr != OPC_NIL)
									{
									op_ici_attr_get (mcast_ici_ptr, "multicast_major_port", &mcast_major_port);
									op_ici_attr_get (mcast_ici_ptr, "multicast_minor_port", &mcast_minor_port);
				
									/* Destroy the multicast ICI.						*/
									op_ici_destroy (mcast_ici_ptr);
									}
								else
									{
									/* The major and minor port information has been	*/
									/* specified in the parent-to-child memory.			*/
									mcast_major_port = ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port;	
									mcast_minor_port = ip_ptc_mem_ptr->ip_igmp_ptc_info.minor_port;
									}				
												
								/* Store the multicast major and minor port information in	*/
								/* the ICI that will be associated with the packet			*/
								/* throughout its life cycle within IP.						*/
								intf_ici_fdstruct_ptr->multicast_major_port =  mcast_major_port;
								intf_ici_fdstruct_ptr->minor_port_out =  mcast_minor_port;
								}
							}
						else
							{
							/*	This packet came from a lower layer (e.g., ARP.)	*/
							/*	Check to see which interface it arrived on, so we	*/
							/*	can potentially forward this information to the		*/
							/*	higher layer (if the packet is eventually bound for	*/
							/*	the higher layer).									*/
							iface_table_size = op_prg_list_size (interface_table_ptr);
							for (i = 0; i < iface_table_size; i++)
								{
								/*	Get current interface.							*/
								iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, i);
				
								/*	Does the input port match the port the packet	*/
								/*	was received on.								*/
								if (iface_info_ptr->in_port_num == instrm)
									{
									/* When the stream is found also get the slot	*/
									/* index of the interface.						*/
									slot_index =  iface_info_ptr->slot_index;
				            	
									/* Store the information about the interface	*/
									/* into the ICI.								*/
									intf_ici_fdstruct_ptr->interface_received = 
										ip_address_copy (iface_info_ptr->addr_range_ptr->address);
									intf_ici_fdstruct_ptr->major_port_received = iface_info_ptr->addr_index;
									intf_ici_fdstruct_ptr->intf_recvd_index = i;
									intf_ici_fdstruct_ptr->slot_index = slot_index;
									intf_ici_fdstruct_ptr->instrm = instrm;
				
									/** Retrieve the ICI (ip_arp_ind_v4) associated with the		**/
									/** packet on this instream. Obtain the minor port information	**/
									/** and set this information in the ICI associated with the		**/
									/** datagram. If no ICI is associated with the incoming packet,	**/
									/** OPC_INT_UNDEF will be used for minor_port_in. We use 		**/
									/** OPC_INT_UNDEF, so that interfaces running standard routing	**/
									/** protocols do not destroy the packet, if the packet is being **/
									/** sent on the same major and minor port it came on (in the 	**/
									/** function ip_rte_datagram_interface_forward).				**/
				
									/* Obtain the ICI.										*/
									iciptr = op_intrpt_ici ();
									
									/* Is there an ICI associated with the incoming packet?	*/					
									if (iciptr != OPC_NIL)
										{
										/* Obtain the minor port value.		*/
										if (op_ici_attr_get (iciptr, "minor_port", &minor_port_in) == OPC_COMPCODE_FAILURE)
											{
											op_sim_end ("Error in IP routing process model (ip_rte_v4):",
												"Unable to obtain minor_port from the ICI",
												"associated with the incoming packet.",
												OPC_NIL);
											}
										
										/* Destroy the incoming ICI.	*/
										op_ici_destroy (iciptr);
										}
									else
										{
										/* No minor port information is specified. Use the value 	*/
										/* OPC_INT_UNDEF.											*/
										minor_port_in = OPC_INT_UNDEF;
										}
				
									/* Set additional information about the interface on which this	*/
									/* IP datagram arrived. This information may be used by the		*/
									/* higher layers (e.g., routing protocols like IGRP)			*/
									intf_ici_fdstruct_ptr->mtu 					= iface_info_ptr->mtu;
									intf_ici_fdstruct_ptr->iface_load 			= iface_info_ptr->load_bps;
									intf_ici_fdstruct_ptr->iface_reliability 	= iface_info_ptr->reliability;
									intf_ici_fdstruct_ptr->iface_speed 		    = iface_info_ptr->speed;
				
									/* Set the minor port information.				*/
									intf_ici_fdstruct_ptr->minor_port_received	= minor_port_in;
				
									/* Set the packet insertion time.  This will be	*/
									/* later used to compute packet latency.		*/
									intf_ici_fdstruct_ptr->pkt_insertion_time = op_sim_time ();
				
									/* Set the processed field of ICI to false to	*/
									/* indicate that the packet is freshly received	*/
									/* and not processed yet.						*/
									intf_ici_fdstruct_ptr->processed = OPC_FALSE;
				
									/*	Issue trace statement.						*/
									if ((ip_rte_trace == OPC_TRUE) && op_prg_odb_pktrace_active (pkptr))
										{
										ip_address_print (intf_addr_str, iface_info_ptr->addr_range_ptr->address);
										if (processing_scheme == OmsC_Dv_Slot_Based)
											{
											sprintf (trace_msg, "Packet ID (%d) [Tree ID %d] arrived on interface %s slot %d",
												op_pk_id (pkptr), op_pk_tree_id (pkptr), intf_addr_str, slot_index);
											}
										else
											{
											sprintf (trace_msg, "Packet ID (%d) [Tree ID %d] arrived on interface %s",
												op_pk_id (pkptr), op_pk_tree_id (pkptr), intf_addr_str);
											}
				
										/* Print the trace message.					*/
										op_prg_odb_print_minor (trace_msg, OPC_NIL);
										}
				
									/* Store the handle for further use.			*/
									input_intf_info_ptr = iface_info_ptr;
									
									/* IF CAR (Committed Access Rate) is enabled om this interface	*/
									/* check whether this packet conforms the traffic contract.		*/
									/* If it doesn't, this packet might be dropped or set to a	low	*/
									/* type of service (TOS).										*/
									if (car_incoming_profile_ptr [i]->car_status == OPC_TRUE)
										{
										/* Returns whether the packet has to dropped to follow the	*/
										/* policy. If the packet doesn't comply the policy, it is	*/
										/* necessarily dropped but only set to a lower precedence.	*/
										car_packet_drop = Ip_Qos_Car_Policy_Limit (pkptr, i, car_incoming_profile_ptr [i], car_incoming_info_ptr [i]);
				                        }
				
									break;
									}
								}
							}
				
						/* If the packet did not match a CAR policy specifiyng that	*/
						/* all non-conforming traffic has to be dropped, the packet	*/
						/* is dropped.												*/
						if (car_packet_drop)
							{
							/* Write a statistic for packet dropped on this interface.	*/
							op_stat_write (car_stat_info_ptr [i].in_traffic_dropped_in_bps_stathandle, op_pk_total_size_get (pkptr));
							op_stat_write (car_stat_info_ptr [i].in_traffic_dropped_in_bps_stathandle, 0);
				
							op_stat_write (car_stat_info_ptr [i].in_traffic_dropped_in_pps_stathandle, 1);
							op_stat_write (car_stat_info_ptr [i].in_traffic_dropped_in_pps_stathandle, 0);
				
							if (op_prg_odb_ltrace_active ("car"))
								{
								sprintf (str0, "CAR drops packet %d to conform rate policies.", op_pk_id (pkptr));
								op_prg_odb_print_major (str0, OPC_NIL);
								}
				
							/* Drop the current IP datagram.	*/
							ip_rte_dgram_discard (pkptr, intf_ici_ptr);
				
							/* Warns that the packet has not been accepted.	*/
							insert_ok = 0;
							}
						else
							{
							/*	If the received packet does not yet have a time-to-live	*/
							/*	field assignment, place the default value in this field	*/
							/*	In this model, TTL is treated as a hop allowance		*/
							/*	decremented by one prior to each transmission. If the	*/
							/*	decremented counter reaches zero, the packet is not		*/
							/*	transmitted.											*/
							if (pk_fd_ptr->ttl == IPC_TTL_UNSET)
								{
								pk_fd_ptr->ttl = IP_DEFAULT_TTL;
								}
				
							/* Determine the interface to which the packet should be	*/
							/* forwarded. Store this information within the ICI since	*/
							/* it will be also used in the svc_comp state.				*/
				    	
							/*	Obtain the destination IP address information.				*/
							dest_addr = pk_fd_ptr->dest_addr;
				
							/*	Obtain the fast address from the packet if it is set. This	*/
							/*	should only be done if no broadcast addresses are involved,	*/
							/*	because fast addresses are assigned only to addresses whose	*/
							/*	IP addresses are not broadcast addresses.					*/
				
							/*  Intialize the broadcast flag to false.						*/
							broadcast_addr = OPC_FALSE;
				
							/*  Check to see if the destination is a broadcast address for	*/
							/* 	all interfaces, i.e. 255.255.255.255. If so, set the 		*/
							/*	variable representing the interface on which the broadcast 	*/
							/* 	is to be sent out to IP_BROADCAST_ALL_INTERFACES.			*/
							if (ip_address_equal (dest_addr, IpI_Broadcast_Addr)) 
								{
								broadcast_addr = OPC_TRUE;
								broadcast_intf_index = IP_BROADCAST_ALL_INTERFACES;
				
								/* Also set the pkt_dest_type attr. in the packet's ICI to	*/
							    /* the value indicating that this is a broadcast packet.	*/
								intf_ici_fdstruct_ptr->pkt_dest_type = IP_PKT_TXTYPE_BCAST;	
								}
				
							/*  We need to check against every connected interface to see   */
							/*  the destination is a broadcast address (assuming it's not   */
							/*  IpI_Broadcast_Addr). If the datagram is a broadcast on AN	*/
							/*	interface then initialize broadcast_intf_index to the		*/
							/*	position in the IP interface list of the said interface.	*/
							else
								{
								intf_table_size = op_prg_list_size (interface_table_ptr);
								for (i = 0; i < intf_table_size; i++)
									{
									iface_info_ptr = op_prg_list_access (interface_table_ptr, i);
									if ((ip_address_range_check (dest_addr, iface_info_ptr->addr_range_ptr)) &&
										(ip_address_is_broadcast (dest_addr, iface_info_ptr->addr_range_ptr->subnet_mask)))
										{
										broadcast_addr = OPC_TRUE;
										broadcast_intf_index = i;
				
										/* Also set the pkt_dest_type attr. in the packet's ICI to	*/
										/* the value indicating that this is a broadcast packet	*/
										intf_ici_fdstruct_ptr->pkt_dest_type = IP_PKT_TXTYPE_BCAST;
				
										break;
										}
									}
								}
				
							/* Check to see if a NATO fast lookup index is associated with	*/
							/* the destination IP address. If it is not, obtain one from	*/
							/* NATO package and set the corresponding field in the packet.	*/
							/* Do not do fast lookup for RSVP packets.						*/
							if (!ip_address_is_multicast (dest_addr) && !broadcast_addr) 
								{
								/* Set the pkt_dest_type attribute of the packet's ICI		*/
								/* indicating that this is a unicast packet.				*/
								intf_ici_fdstruct_ptr->pkt_dest_type = IP_PKT_TXTYPE_UCAST;
				
								/* Do not do fast lookup for RSVP packets.					*/
								if (pk_fd_ptr->protocol != IpC_Protocol_Rsvp)
									{
									if (pk_fd_ptr->dest_internal_addr != IPC_DEST_INTERNAL_ADDR_UNSET)
										ip_fast_addr = pk_fd_ptr->dest_internal_addr;
									else
										{
										/*	Obtain the fast address from the global table.		*/
										pk_fd_ptr->dest_internal_addr = ip_rtab_addr_convert (dest_addr);
				
										/* Store the fast address in the temp. var. ip_fast_addr*/
										/* This is required in case this node is a router using	*/
										/* RIP, in which case, this variable's value is used to	*/
										/* a subscript into the route table entry array			*/
										/* maintained by RIP.									*/
										ip_fast_addr = pk_fd_ptr->dest_internal_addr;
										}
									}
					    		}
				
							else if (ip_address_is_multicast (dest_addr))
								{
				
								/* Set the pkt_dest_type attribute of the packet's ICI		*/
								/* indicating that this is a multicast packet.				*/
								intf_ici_fdstruct_ptr->pkt_dest_type = IP_PKT_TXTYPE_MCAST;
								}
				
							/* What kind of packet are we dealing with?	*/
							pkt_dest_type = intf_ici_fdstruct_ptr->pkt_dest_type;
				
							/* Determine the stream from which the packet arrived. If it	*/
							/* arrived from the higher layer, then:							*/
							/*   - if the surrounding node is a LAN node, it will always be	*/
							/*	   forwarded to the lower layer;							*/
							/*   - if is not a LAN node, it will be sent to the higher or	*/
							/*     lower layer depending upon where it is destined for.		*/
							if (instrm == instrm_from_ip_encap || instrm == IpC_Pk_Instrm_Child)
								{
								if (within_lan_node == OPC_TRUE)
									{
									/* The surrounding node is a LAN node. The IP datagram		*/
									/* should be forwarded to the lower layer, irrespective of	*/
									/* the ultimate destination.								*/
									force_fwd = OPC_TRUE;
									}
								else
									{
									/* The surrounding node is not a LAN node. The decision to	*/
									/* forward the datagram to lower layer depends on where the	*/
									/* datagram is destined for (if it is destined for this		*/
									/* node, itself, then it is forwarded directly to the upper	*/
									/* layer.													*/
									force_fwd = OPC_FALSE;
									}
								}
							else
								{
								/* The IP datagram arrived from lower layer, then the routing	*/
								/* decision determines its forwarding to the lower/upper layer	*/
								/* depending upon the destination of the IP datagram (if it is	*/
								/* destined for this node, itself, then will be forwarded to	*/
								/* higher layers.)												*/
								force_fwd = OPC_FALSE;
				
								/* As the packet that is currently being processed was			*/
								/* received from the network the corresponding statistic needs  */
								/* to be written out.											*/
				
								/* Update statistics on total packets received based on the 	*/
								/* packet type.													*/
								ip_rte_total_packets_received_stat_update (pkt_dest_type, pkptr);
								}
				        	
							/*	Determine the interface the datagram should be forwarded to.	*/
							/*	Also determine whether the datagram should be broadcast, and/or	*/
							/*	the datagram should be forwarded to the higher layer.			*/
							if ((ip_address_is_multicast (dest_addr) && ip_rte_mcast_datagram_dest_get (pkptr, rsvp_ici_ptr, intf_ici_fdstruct_ptr, dest_addr, 
								&next_addr, &higher_layer, &destroy_pkt, pk_fd_ptr->protocol,  &output_intf_index, &interface_ptr) == OPC_COMPCODE_FAILURE) || 
								(!ip_address_is_multicast (dest_addr) && ip_rte_datagram_dest_get (pkptr, rsvp_ici_ptr, force_fwd, 
								broadcast_addr, dest_addr, instrm, ip_fast_addr, pk_fd_ptr->protocol, &next_addr, &broadcast, &higher_layer, &destroy_pkt, 
								&output_intf_index, &interface_ptr, &minor_port_out) == OPC_COMPCODE_FAILURE))
								{
								/*	Issue a trace message and destroy the packet.				*/
								if (ip_rte_trace == OPC_TRUE)
									{
									ip_address_print (dest_addr_str, dest_addr);
									sprintf (str0, "Routing error: Unable to route packet destined for (%s)", dest_addr_str);
									op_prg_odb_print_major (str0, OPC_NIL);
									}
								/* Drop this unroutable IP datagram.	*/
								ip_rte_dgram_discard (pkptr, intf_ici_ptr);
				
								/* Set the insert_ok temp. variable such that we will not		*/
								/* transition to the svc_start state because of this destroyed	*/
								/* packet.														*/
								insert_ok = 0;
								}
							else
								{
								/* Check if any IP options have been set -- e.g., record route	*/
								/* option. If set, then process the options.					*/
								if (pk_fd_ptr->options_field_set == OPC_TRUE)
									{
									/* It is required to set certain options in the IP datagram	*/
									ip_rte_dgram_options_process (higher_layer, pkptr, output_intf_index);
									}
								/* Place the information collected into the ICI that is			*/
								/* associated with the packet. This information will be also 	*/
								/* used in the svc_comp state to forward the packet to the 		*/
								/* output interface. In case of the packet to be broadcasted,	*/
								/* only the broadcast index is of use and the interface_ptr		*/
								/* does not point to a valid memory area.						*/
								if (interface_ptr != OPC_NIL)
									{
									intf_ici_fdstruct_ptr->interface_type = interface_ptr->intf_type;
									intf_ici_fdstruct_ptr->outstrm 		  = interface_ptr->port_num;
									intf_ici_fdstruct_ptr->outslot 		  = interface_ptr->slot_index;
									intf_ici_fdstruct_ptr->output_mtu 	  = interface_ptr->mtu;
									intf_ici_fdstruct_ptr->iface_speed 	  = interface_ptr->speed;
									}
				        	
								/* Interface pointer is NIL. Hence the packet is broadcast or	*/
								/* it will be forwarded to the higher layer. Update the ICI		*/
								/* with the interface information if it is an broadcast pakcet	*/
								/* just for a certain interface.								*/
								else if ((broadcast_addr == OPC_TRUE) && (broadcast_intf_index != IP_BROADCAST_ALL_INTERFACES))
									{
									bcast_iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, broadcast_intf_index);
									intf_ici_fdstruct_ptr->interface_type = bcast_iface_info_ptr->intf_type;
									intf_ici_fdstruct_ptr->outstrm		  = bcast_iface_info_ptr->port_num;
									intf_ici_fdstruct_ptr->output_mtu 	  = bcast_iface_info_ptr->mtu;
									intf_ici_fdstruct_ptr->outslot 		  = bcast_iface_info_ptr->slot_index;
									intf_ici_fdstruct_ptr->iface_speed	  = bcast_iface_info_ptr->speed;
									}
				
								/* Fill the rest of the ICI fields with generic packet info.	*/
								intf_ici_fdstruct_ptr->dest_addr 			= dest_addr;
								intf_ici_fdstruct_ptr->next_addr 			= next_addr;
								intf_ici_fdstruct_ptr->broadcast 			= broadcast;
								intf_ici_fdstruct_ptr->higher_layer 		= higher_layer;
								intf_ici_fdstruct_ptr->destroy_pkt 			= destroy_pkt;
								intf_ici_fdstruct_ptr->broadcast_intf_index = broadcast_intf_index;
								intf_ici_fdstruct_ptr->output_intf_index 	= output_intf_index;
								
								/* If it is not a multicast packet, set the minor port value	*/
								/* obtained from the route lookup function.						*/
								if (intf_ici_fdstruct_ptr->pkt_dest_type != IP_PKT_TXTYPE_MCAST)
									{
									intf_ici_fdstruct_ptr->minor_port_out 	= minor_port_out;
									}
				
								/* Check whether the packet should be decompressed.			*/
								/* Decompression is necessary if:							*/
								/* a) Packet is compressed with TCP/IP Header compression.	*/
								/* b) Packet is compressed with Per Interface compression	*/
								/*    (entire packet compressed).           				*/
								/* c) Packet is compressed with Per Virtual Circuit 		*/
								/*    compression (payload compressed) and this node is the */
								/*    destination of the datagram; i.e. datagram will be 	*/
								/*    forwarded to higher layer.							*/ 
								if ((pk_fd_ptr->compression_method == IpC_TCPIP_Header_Comp) ||
									(pk_fd_ptr->compression_method == IpC_Per_Interface_Comp) ||
									((pk_fd_ptr->compression_method == IpC_Per_Virtual_Circuit_Comp) && (higher_layer)))
									{
									/* Decompression is necessary. Compute its delay.		*/
									decomp_delay = ip_rte_decomp_delay_compute (pkptr, pk_fd_ptr);
				
									/* If we will decompress the payload then we need to 	*/
									/* also update the frag_len field to reflect the size	*/
									/* of the payload correctly.							*/
									if (pk_fd_ptr->compression_method == IpC_Per_Virtual_Circuit_Comp)
										{
										packet_size = op_pk_total_size_get (pkptr);
										pk_fd_ptr->frag_len = (pk_fd_ptr->original_size - (packet_size - pk_fd_ptr->frag_len * 8)) / 8;
										}
				
									/* Reset the compression flag.							*/
									pk_fd_ptr->compression_method = IpC_No_Compression;
				        	
									/* Set the decompression flag so that the packet is set	*/
									/* to its original size after service completion.		*/
									intf_ici_fdstruct_ptr->decompress = OPC_TRUE;
									}
								else
									{
									/* The packet is not compressed */
									decomp_delay = 0.0;
									}	
				
								/* If the datagram will be serviced once  (i.e. central		*/
								/* processing or port-to-port forward) and a compression 	*/
								/* will be applied then we need to compute also the			*/
								/* compression delay now, so that it can be added to the	*/
								/* service time in the "svc_start" state. Datagrams to be	*/
								/* forwarded to higher layer are not compressed, and		*/
								/* broadcast datagrams to be forwarded to all interfaces 	*/
								/* are compressed per interface basis after they are		*/
								/* duplicated.												*/
								if (((processing_scheme == OmsC_Dv_Centralized) || 
									((slot_index == intf_ici_fdstruct_ptr->outslot) && (intf_ici_fdstruct_ptr->outslot != -1))) && 
					        		(!broadcast || (broadcast_intf_index != IP_BROADCAST_ALL_INTERFACES)) && (!higher_layer))
									{
									/* Datagram will be serviced once. 						*/
									/* First determine whether we use compression at the	*/
									/* output interface.									*/
									if (!broadcast)
										iface_info_ptr = interface_ptr; 
									else
										iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, broadcast_intf_index);
						    	
									/* If compression is used then compute its delay. If 	*/
									/* the compression will not be applied then the 		*/
									/* function will return 0.0. The function will also		*/
									/* store the new size into ICI if the datagram will be	*/
									/* compressed. First determine whether we use 			*/
									/* compression at the output interface.					*/
									if (iface_info_ptr == OPC_NIL || iface_info_ptr->comp_info == OPC_NIL || iface_info_ptr->comp_info->method == IpC_No_Compression)
										comp_delay = 0.0;
									else
										comp_delay = ip_rte_comp_delay_and_size_compute (pkptr, pk_fd_ptr, intf_ici_ptr, iface_info_ptr);
									}
				
								/* Store the compression & decompression delays into the	*/
								/* if they exists. These delays be added later to the 		*/
								/* service time in the "svc_start" state.					*/
								if (comp_delay + decomp_delay != 0.0) 
									intf_ici_fdstruct_ptr->comp_decomp_delay = comp_delay + decomp_delay;
					
								/* Attempt the enqueue the received packet. Each slot has 	*/
								/* its own buffer (subqueue) contained in the slot info 	*/
								/* table. If the packet is from higher layer then insert 	*/
								/* the packet into subqueue zero of the module. These 		*/
								/* packets will be processed first by the central CPU and 	*/
								/* then forwarded to the output slot. If the processing 	*/
								/* scheme is centralized (i.e. not slot based) then every	*/
								/* received packet will be processed by the central CPU. 	*/
				
								/* Set the ICI.		*/		
								op_pk_ici_set (pkptr, intf_ici_ptr);
				
								if (ipcloud_flag == OPC_TRUE)
									{
									/* In case of node being an IP cloud object, we do not schedule	*/
									/* any events for servicing this datagram; instead, it is sent	*/
									/* out on the appropriate interface(s) right away. The only		*/
									/* delay incurred here is the "packet latency" (plus any		*/
									/* additional delay dur to the transmitter not available for	*/
									/* packet transmission.)										*/
									if (!destroy_pkt)
										{
										/*  The packet is not to be destroyed. Process it based on  */
										/*  the type of packet.                                     */
										if (broadcast)
											{
											/*  This is a broadcast datagram. Forward it on the     */
											/*  relevant interface.                                 */
											ip_rte_datagram_broadcast (dest_addr, pkptr, broadcast_intf_index, intf_ici_fdstruct_ptr);
											}
										else if (higher_layer)
											{
											/*  The datagram has reached its destination, forward   */
											/*  it to the higher layer.                             */
											ip_rte_datagram_higher_layer_forward (pkptr, dest_addr);
											}
										else
											{
											/*  Otherwise, forward the datagram on the appropriate  */
											/*  interface.                                          */
											ip_rte_datagram_interface_forward (dest_addr, next_addr, 
												pkptr, intf_ici_fdstruct_ptr->output_intf_index, intf_ici_fdstruct_ptr);
											}
										}
									else
										{
										/* Destroy the packet and update statistics.    */
										ip_rte_dgram_discard (pkptr, intf_ici_ptr);
										}
				
				                	/* Since this is the case of being an IP cloud, set the	*/
									/* server status to busy (as there is no transition		*/
									/* required to go to "svc_start".)						*/
									server_status = OmsC_Dv_Processor_Busy;
									}	
				
								/* Check the processing scheme and whether the packet is 	*/
								/* from higher layer or not.								*/	 
								else if ((processing_scheme == OmsC_Dv_Centralized) || 
									(instrm == instrm_from_ip_encap) || 
									(instrm == IpC_Pk_Instrm_Child))
									{
									/*	Attempt to enqueue the packet at tail of subqueue 0.*/
									if (op_subq_pk_insert (0, pkptr, OPC_QPOS_TAIL) != OPC_QINS_OK)
										{
										/*	The insertion failed (due to a full queue).		*/
										/*  Get a printable version of the interface addr.	*/
										ip_address_print (intf_addr_str, iface_info_ptr->addr_range_ptr->address);
				
										/*	Issue a warning message to the sim. log.		*/
										ipnl_reswarn_pktinsert (op_pk_id (pkptr), op_pk_tree_id (pkptr), intf_addr_str);
				
										/* Update packets dropped statistics and destroy	*/
										/* the IP datagram.									*/
										ip_rte_dgram_discard (pkptr, intf_ici_ptr);
				
										/*	Set flag indicating insertion fail. The flag is	*/
										/*	used to determine transition out of this state.	*/
										insert_ok = 0;
										}
									else
										{
										/*	Insertion was successful.						*/
										insert_ok = 1;
				
										/* Since we inserted packet into the central 		*/
										/* processor's queue we are interested in the 		*/
										/* status of central processor. Set the 			*/
										/* server_status, which will be used to determine 	*/
										/* the transition out of this state, based on the	*/
										/* status of the central server.					*/
										server_status = central_server_status;
				
										/* Set the CPU code to central CPU. If it is idling,*/
										/* it can start processing the packet immediately.	*/
										cpu_code = CENTRAL_CPU;
										}
									}
								else 
									/* Slot based processing scheme is used and the packet	*/
									/* is received through the port of one of the slots.	*/
									/* The slot_index specifies the index of the receiving	*/
									/* slot. Hence, insert the packet into this slot's 		*/
									/* and schedule the service completion if the slot's	*/
									/* server is available.									*/
									{
									/* Get a handle to the slot information.				*/
									slot_info_ptr = op_prg_list_access (slot_table_ptr, slot_index);
				
									/* Try to enqueue the packet into slot's buffer.		*/
									packet_size = op_pk_total_size_get (pkptr);
				
									if (slot_info_ptr->buffer_usage + packet_size <= slot_info_ptr->buffer_capacity)
										{
										/* There is space in the buffer for the received	*/
										/* packet. Insert it to the tail of slot's buffer.	*/
										op_prg_list_insert (slot_info_ptr->packet_queue, pkptr, OPC_LISTPOS_TAIL);
										slot_info_ptr->buffer_usage += packet_size;
										slot_info_ptr->pkts_in_queue++;
				
										/* Set flag indicating insertion was successful. 	*/
										/* The flag is used to determine transition out of 	*/
										/* this state.										*/
										insert_ok = 1;
				
										/* Since we inserted packet into a slot buffer we 	*/
										/* are interested in the status of that slot's		*/
										/* processor status. Set the server_status, which 	*/
										/* will be used to determine the transition out of 	*/
										/* this state, based on the status of the slot's	*/
										/* processor.										*/
										server_status = slot_info_ptr->slot_proc_status;
				
										/* Set the CPU code to index of the slot. If the 	*/
										/* slot's CPU is not busy we will immediately start */
										/* processing the packet.							*/
										cpu_code = slot_index;
										}
									else
										{
										/*	The insertion failed (due to a full queue).		*/
										/* We need to drop the packet.						*/
				
										/*	Set flag indicating insertion fail. The flag is	*/
										/*	used to determine transition out of this state.	*/
										insert_ok = 0;
				
										/*	Issue trace statement.							*/
										if ((ip_rte_trace == OPC_TRUE) && op_prg_odb_pktrace_active (pkptr))
											{
											ip_address_print (intf_addr_str, iface_info_ptr->addr_range_ptr->address);
				
											sprintf (trace_msg,
												"Packet ID (%d) [Tree ID %d] arrived on interface %s slot"
												"%d has been dropped because of full buffer (subqueue)",
											op_pk_id (pkptr), op_pk_tree_id (pkptr), intf_addr_str, slot_index);
				
											op_prg_odb_print_minor (trace_msg, OPC_NIL);
											}
				
										/* Get a printable version of the interface's IP	*/
										/* address.											*/
										ip_address_print (intf_addr_str, iface_info_ptr->addr_range_ptr->address);
				                	
										/* Issue a warning message into the simulation log.	*/
										ipnl_reswarn_slot_pktinsert (op_pk_id (pkptr), op_pk_tree_id (pkptr), intf_addr_str, slot_index);
				
										/* Drop this unroutable IP datagram.	*/
										ip_rte_dgram_discard (pkptr, intf_ici_ptr);
										}
					    			}
								}
							}
						}
					}
				}


			/** state (arrival) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "arrival", "ip_rte_v4_vc () [arrival exit execs]")
				{
				
				}


			/** state (arrival) transition processing **/
			FSM_INIT_COND (SERVICE_NEW_PK)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("arrival")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "ip_rte_v4_vc () [idle enter execs]")
				{
				/* Set the CPU Utilization to 0, if the central	*/
				/* processor is idle, i.e., we come from the	*/
				/* "svc_comp" state after serving the central	*/
				/* queue.										*/
				if ((central_server_status == OmsC_Dv_Processor_Idle) &&
					((cpu_code == CENTRAL_CPU) || (cpu_code == SLOT_TO_CENTRAL_FORWARD)))
					{
					/* The central CPU is idle -- mark	*/
					/* the utilization as 0.0.			*/
					op_stat_write (local_utilization_stathandle, 0.0);
					}
				
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,ip_rte_v4_vc)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle", "ip_rte_v4_vc () [idle exit execs]")
				{
				/* determine the interuppt type */
				intrpt_type = op_intrpt_type ();
				
				/* Determine if we are being invoked by one of the child proceses	*/
				/* maintained by IP. Note that "ip_icmp" is used for ICMP messages	*/
				/* (currently only supports "ping") and "ip_basetraf_src" is used	*/
				/* background utilization traffic specification generation.			*/
				child_prohandle = op_pro_invoker (own_prohandle, &invoke_mode);
				if (invoke_mode == OPC_PROINV_INDIRECT)
					{
					/* A child process invoked IP.	*/
					pk_from_child_process = OPC_TRUE;
					}
				else if (invoke_mode == OPC_PROINV_DIRECT)
					{
					pk_from_child_process = OPC_FALSE;
					}
				else
					{
					ip_rte_error ("Unable to determine if how IP process got invoked."); 	
					}
				
				}


			/** state (idle) transition processing **/
			FSM_INIT_COND (ARRIVAL)
			FSM_TEST_COND (SVC_COMPLETION)
			FSM_TEST_COND (MCAST_RSVP)
			FSM_TEST_LOGIC ("idle")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 0, state0_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;)
				FSM_CASE_TRANSIT (2, 8, state8_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (svc_start) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "svc_start", "ip_rte_v4_vc () [svc_start enter execs]")
				{
				/* First determine which cpu is starting the service. It can be */
				/* the central CPU or one of the slot CPU's.					*/
				if (cpu_code == CENTRAL_CPU) 
					{
					/* Get a handle to the packet at the top of the queue. This	*/
					/* is the packet whose service is about to start. The		*/
					/* packet is in the central processor's buffer.				*/
					pkptr = op_subq_pk_access (0, OPC_QPOS_HEAD);
					if (pkptr == OPC_NIL)
						{
						ip_rte_error ("Unable to get packet from head of queue.");
						}
				
					/*	Determine the time required to complete service of the	*/
					/*	enqueued packet.										*/
					pk_svc_time = 1.0 / service_rate;
				
					/* Retrieve the decompression and/or compression delay 		*/
					/* associated with the packet. This delay will be added to 	*/
					/* the service time when scheduling the end of the service. */
					/* If the packet will not be decompressed or compressed at 	*/
					/* this processing, then the value of the delay is zero.	*/
					pk_ici_ptr = op_pk_ici_get (pkptr);
					/*	Get the rte_info_fields from the ici.	*/
					op_ici_attr_get (pk_ici_ptr, "rte_info_fields", &intf_ici_fdstruct_ptr);
					comp_decomp_delay = intf_ici_fdstruct_ptr->comp_decomp_delay;
				
					/* Reset the attribute.										*/
					if (comp_decomp_delay)
						{
						intf_ici_fdstruct_ptr->comp_decomp_delay = 0.0;
						}
				
					/* If the node is configured as a firewall, there can be	*/
					/* also a proxy server delay associated with the datagram.	*/
					/* Retrieve this delay, too.								*/
					if (firewall_flag == OPC_TRUE)
						{
						/* We can safely add the proxy delay to the compression	*/
						/* and decompression delay, since all of them are 		*/
						/* additional delays besides the routing delay and they	*/
						/* all will be summed up when the service completion	*/
						/* is scheduled.										*/
						comp_decomp_delay += intf_ici_fdstruct_ptr->proxy_delay;
				
						/* Reset the ICI field.									*/
						intf_ici_fdstruct_ptr->proxy_delay = 0.0;
						}
				
					/* Check if we are doing background utilization. 			*/
					if (do_bgutil)
						{
						/* This packet is about to start service.  We will 		*/
						/* consider as part of it's service time the time the 	*/
						/* packet spent waiting for background utilization		*/
						/* packets to be serviced.								*/
						bgutil_delay = oms_bgutil_router_delay_calculate (pkptr, op_sim_time (), pk_svc_time, &bgutil_routed_state_ptr);
						}
					else
						{
						bgutil_delay = 0.0;
						}
				
					/*	Schedule an interrupt for this process at the time 		*/
					/*	service ends.											*/
				
					/* First check whether the packet has been processed before */
					/* or not. The status of the packet will determine the code */
					/* of the self interrupt.									*/
					status = intf_ici_fdstruct_ptr->processed;
				
					/* Schedule the end-of-service interrupt with correct code.	*/
					if (status == OPC_FALSE)  
						{					  
						/* The packet is not processed before. That means it is */
						/* a fresh packet sent to the central CPU from higher	*/
						/* layer or we are using centralized processing scheme. */
						/* Schedule the interrupt with CENTRAL_CPU code.		*/
						evh = op_intrpt_schedule_self (op_sim_time () + pk_svc_time + 
							comp_decomp_delay + bgutil_delay, CENTRAL_CPU);
				 		} 
					else
						{     
						/* The packet is processed before. That means it first	*/
						/* received and processed by the processor of the input	*/
						/* and then forwarded to the central CPU. Hence			*/
						/* schedule the interrupt with the code 				*/
						/* SLOT_TO_CENTRAL_FORWARD.								*/
						evh = op_intrpt_schedule_self (op_sim_time () + pk_svc_time + comp_decomp_delay + bgutil_delay, SLOT_TO_CENTRAL_FORWARD);
						}	
				
					if (op_ev_valid (evh) == OPC_FALSE)
						{
						ip_rte_warn ("Unable to schedule service completion.");
						}
					else
						{
						/* Set the CPU Utilization to 100 if a new packet arrives	*/
						/* when the central CPU is idle. It means that the 		*/
						/* previous state was "arrival" if centralized			*/
						/* processing is used, or it means that the packet		*/
						/* comes from an input slot if slot processing is used.	*/
						if (queue_empty)
							{													
							op_stat_write (local_utilization_stathandle, 100.0);
							}													
				
						/*	Mark the server to be busy now.						*/
						central_server_status = OmsC_Dv_Processor_Busy;
				    	}
					}
				else
					{
					/* We are starting a service with a slot CPU. The cpu_code	*/
					/* contains the index of the slot.							*/
				
					/*	Determine the time required to complete service of the	*/
					/*	enqueued packet.										*/
					slot_info_ptr = op_prg_list_access (slot_table_ptr, cpu_code);
					pk_svc_time = 1.0 / slot_info_ptr->forwarding_rate;
				
					/* Retrieve the decompression and/or compression delay 		*/
					/* associated with the packet. This delay will be added to 	*/
					/* the service time when scheduling the end of the service. */
					/* If the packet will not be decompressed or compressed at 	*/
					/* this processing, then the value of the delay is zero.	*/
					/* The packet is on the top of the slot's packet queue.		*/		
					pkptr = op_prg_list_access (slot_info_ptr->packet_queue, OPC_QPOS_HEAD);
					if (pkptr == OPC_NIL)
						ip_rte_error ("Unable to get packet from head of slot queue.");
					pk_ici_ptr = op_pk_ici_get (pkptr);
				
					/*	Get the rte_info_fields from the ici.	*/
					op_ici_attr_get (pk_ici_ptr, "rte_info_fields", &intf_ici_fdstruct_ptr);
					comp_decomp_delay = intf_ici_fdstruct_ptr->comp_decomp_delay;
				
					/* Reset the attribute.		*/
					intf_ici_fdstruct_ptr->comp_decomp_delay = 0.0;
				
					/* If the node is configured as a firewall, there can be	*/
					/* also a proxy server delay associated with the datagram.	*/
					/* Retrieve this delay, too.								*/
					if (firewall_flag == OPC_TRUE)
						{
						/* We can safely add the proxy delay to the compression	*/
						/* and decompression delay, since all of them are 		*/
						/* additional delays besides the routing delay and they	*/
						/* all will be summed up when the service completion	*/
						/* is scheduled.										*/
						comp_decomp_delay += intf_ici_fdstruct_ptr->proxy_delay;
				
						/* Reset the ICI field.									*/
						intf_ici_fdstruct_ptr->proxy_delay = 0.0;
						}
				
					if (do_bgutil)
						{
						/* This packet is about to start service.  We will 		*/
						/* consider as part of it's service time the time the 	*/
						/* packet spent waiting for background utilization		*/
						/* packets to be serviced.								*/
						bgutil_delay = oms_bgutil_router_delay_calculate (pkptr, op_sim_time (), pk_svc_time, &bgutil_routed_state_ptr);
						}
					else
						{
						/* No background utilization. */
						bgutil_delay = 0.0;
						}
				
					/*	Schedule an interrupt for this process at the time 		*/
					/*	service ends.											*/
					evh = op_intrpt_schedule_self (op_sim_time () + pk_svc_time + comp_decomp_delay + bgutil_delay, cpu_code);
					if (op_ev_valid (evh) == OPC_FALSE)
						{
						ip_rte_warn ("Unable to schedule service completion.");
						}
					else
						{
						/*	Mark the slot's processor to be busy now.			*/
						slot_info_ptr->slot_proc_status = OmsC_Dv_Processor_Busy;
				    	}
					}
				}


			/** state (svc_start) exit executives **/
			FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "svc_start", "ip_rte_v4_vc () [svc_start exit execs]")
				{
				
				}


			/** state (svc_start) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (svc_compl) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "svc_compl", "ip_rte_v4_vc () [svc_compl enter execs]")
				{
				/* Extract packet at head of queue - this is the packet just	*/
				/* finishing service. First we need to determine which CPU		*/
				/* has completed the service and then extract the packet from	*/
				/* the queue of that CPU. The code of the self interrupt 		*/
				/* contains the information about which CPU has completed the	*/
				/* service.														*/
				cpu_code = op_intrpt_code ();
				if ((cpu_code == CENTRAL_CPU) || (cpu_code == SLOT_TO_CENTRAL_FORWARD))
					{
					/* The central processor completed the service. Extract the	*/
					/* packet from the module's queue which is the central		*/
					/* procssor's buffer.										*/
					pkptr = op_subq_pk_remove (0, OPC_QPOS_HEAD);
				
					if (pkptr == OPC_NIL)
						ip_rte_error ("Unable to get packet from head of queue.");
				
					/* Get the packet size. This data will be used below.	*/
					packet_size = op_pk_total_size_get (pkptr);
				
					/* Update the queue status.	*/
					queue_empty = op_q_empty ();
				
					/* The central cpu becomes available again.	*/
					central_server_status = OmsC_Dv_Processor_Idle;
					}
				else
					{
					/* One of the slot CPUs has completed the service. Extract 	*/
					/* the packet from the slot's queue.						*/
				
					/* Get a handle to access the slot related information.		*/
					slot_info_ptr = op_prg_list_access (slot_table_ptr, cpu_code);
				
					/* Extract the packet from slot's packet queue.				*/
					pkptr = op_prg_list_remove (slot_info_ptr->packet_queue, OPC_LISTPOS_HEAD);
					if (pkptr == OPC_NIL)
						{
						sprintf (error_string, "Unable to get packet from head of queue belonging to slot %d.", cpu_code);
						ip_rte_error (error_string);
						}
				
					/* Update the status of packet queue and CPU availability.	*/
					packet_size = op_pk_total_size_get (pkptr);
					slot_info_ptr->buffer_usage -= packet_size;
					slot_info_ptr->pkts_in_queue--;
					queue_empty = (slot_info_ptr->pkts_in_queue == 0.0);
					slot_info_ptr->slot_proc_status = OmsC_Dv_Processor_Idle;
					}
				
				/* Retrieve the ICI associated with the packet.	*/
				pk_ici_ptr = op_pk_ici_get (pkptr);
				
				/*	Get the data structure stored in the "rte_info_fields" field.	*/
				if (op_ici_attr_exists (pk_ici_ptr, "rte_info_fields") == OPC_TRUE)
					{
					op_ici_attr_get (pk_ici_ptr, "rte_info_fields", &intf_ici_fdstruct_ptr);
					}
				
				/* Get a handle to the data structure stored in "fields" field. */
				/* This structure contains all the protocol header information 	*/
				/* as well as some internal information attached to each IP 	*/
				/* datagram for simulation efficiency. 			 				*/
				op_pk_nfd_access (pkptr, "fields", &pk_fd_ptr);
				
				/* Decompress the packet if necessary.	*/
				decompress = intf_ici_fdstruct_ptr->decompress;
				if (decompress)
					{
					/* Set the size of the packet to its original size.	*/
					op_pk_total_size_set (pkptr, pk_fd_ptr->original_size);
				
					/* Update the packet size. */
					packet_size = op_pk_total_size_get (pkptr);
				
					/* Reset the decompress field to prevent re-decompression.	*/
					intf_ici_fdstruct_ptr->decompress = OPC_FALSE;
				
					/* Issue a trace statement.	*/
					if (LTRACE_COMPRESSION_ACTIVE || op_prg_odb_pktrace_active (pkptr))
						ip_rte_comp_decomp_trace_print (pkptr, pk_fd_ptr->compression_method, 0, pk_fd_ptr->original_size, "decompression");
					}
				
				/* Compress datagram if specified. Compression is necessary if:	*/
				/* 1) Compression method field of the packet is not "None" AND	*/
				/* 2) if Per-Virtual Circuit compression is used then the		*/
				/*    packet must be from higher layer.							*/
				instrm = intf_ici_fdstruct_ptr->instrm;
				
				if ((pk_fd_ptr->compression_method != IpC_No_Compression) &&
					((pk_fd_ptr->compression_method != IpC_Per_Virtual_Circuit_Comp) || 
					 (instrm == instrm_from_ip_encap || instrm == IpC_Pk_Instrm_Child)))
					{
					/* Size after compression is computed earlier. Retrieve		*/
					/* this data.												*/
					dgram_compressed_size = intf_ici_fdstruct_ptr->compressed_size;
				
					/* If Per-Interface compression is used and the size of the	*/
					/* datagram will be still greater than mtu after			*/
					/* compression, then we will not compress the packet now,	*/
					/* but will compress it after the fragmentation. Also check */
					/* this case before compressing the datagram.				*/
					mtu = intf_ici_fdstruct_ptr->output_mtu;
					if (mtu == -1)
						{
						/* Packet is a broadcast packet. Obtain the mtu info 	*/
						/* from interface info table.							*/
						broadcast_intf_index = intf_ici_fdstruct_ptr->broadcast_intf_index;
						iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, broadcast_intf_index);
				        mtu = iface_info_ptr->mtu;
						}
				
					/* We obtained the mtu size, compare it with the size of	*/
					/* datagram after compression.								*/
					if (!((pk_fd_ptr->compression_method == IpC_Per_Interface_Comp) && ((int) dgram_compressed_size > mtu * 8)))
						{
						/* Store the original size of the packet, which will be	*/
						/* used for decompression.								*/
						pk_fd_ptr->original_size = packet_size;
				
						/* Compress the packet with resizing.					*/
						op_pk_total_size_set (pkptr, (int) dgram_compressed_size);
				
						/* Issue a trace statement.								*/
						if (LTRACE_COMPRESSION_ACTIVE || op_prg_odb_pktrace_active (pkptr))
							ip_rte_comp_decomp_trace_print (pkptr, pk_fd_ptr->compression_method, packet_size, (int) dgram_compressed_size, "compression");
						}
				
					/* Reset the ICI field.										*/
					intf_ici_fdstruct_ptr->compressed_size = IPC_COMPRESSION_NOT_USED;
					}	
				else
					{
					/* No compression is used.	*/
					dgram_compressed_size = IPC_COMPRESSION_NOT_USED;
					}
				
				/* First check whether the central cpu completed serving a 		*/
				/* packet that was initially received by an input slot and then	*/
				/* forwarded to central cpu. If this is the case then all we 	*/
				/* need to do is to place the packet into output slot's buffer,	*/  
				/* then set the cpu code to CENTRAL_CPU in case packets are		*/
				/* queued in the central cpu and we transition back to the		*/
				/* the service start state at the end of this state.			*/
				if (cpu_code == SLOT_TO_CENTRAL_FORWARD)
					{
					/* Determine the output slot.								*/	
					outslot = intf_ici_fdstruct_ptr->outslot;
				
					slot_info_ptr = op_prg_list_access (slot_table_ptr, outslot);
				
					/* In output slot the datagram will be processed for the 	*/
					/* the last time and then will be forwarded. Compute the	*/
					/* compression delay if the output interface uses a 		*/
					/* compression scheme. If the compression will not be 		*/
					/* applied then the function will return 0.0. The function	*/
					/* will also store the new size into ICI if the datagram 	*/
					/* will be compressed. The broadcast packets to be 			*/
					/* forwarded to all interfaces are not compressed now. They */
					/* will be compressed later per interface basis after		*/
					/* duplication.												*/
					broadcast = intf_ici_fdstruct_ptr->broadcast;
					broadcast_intf_index =  intf_ici_fdstruct_ptr->broadcast_intf_index;
					if (!broadcast || (broadcast_intf_index != IP_BROADCAST_ALL_INTERFACES))
						{
						/* First determine whether we use compression at the	*/
						/* output interface.									*/
						if (broadcast)
							iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, broadcast_intf_index);
						else
							{
							output_intf_index = intf_ici_fdstruct_ptr->output_intf_index;
							iface_info_ptr = (IpT_Interface_Info *) op_prg_list_access (interface_table_ptr, output_intf_index);
							}
				
						if (iface_info_ptr->comp_info->method == IpC_No_Compression)
							comp_delay = 0.0;
						else
							comp_delay = ip_rte_comp_delay_and_size_compute (pkptr, pk_fd_ptr, pk_ici_ptr, iface_info_ptr);
						}
				
					/* Insert the packet into slot's queue.						*/
					if (slot_info_ptr->buffer_usage + packet_size <= slot_info_ptr->buffer_capacity)
						{
						/* There is space in the buffer for the received		*/
						/* packet. Insert it to the tail of slot's buffer.		*/
						op_prg_list_insert (slot_info_ptr->packet_queue, pkptr, OPC_LISTPOS_TAIL);
						slot_info_ptr->buffer_usage += packet_size;
						slot_info_ptr->pkts_in_queue++;
				
						/* Check the status of the slot's processor. If it		*/
						/* is available, then it can immediately start 			*/
						/* processing the new packet. In that case schedule		*/
						/* the self interrupt to indicate the end of the		*/
						/* service.												*/
						if (slot_info_ptr->slot_proc_status == OmsC_Dv_Processor_Idle)
							{
							/*	Determine the time required to complete service */
							/* of the enqueued packet.							*/
							pk_svc_time = 1.0 / slot_info_ptr->forwarding_rate;
				
							if (do_bgutil)
								{
								/* This packet is about to start service.  We will 		*/
								/* consider as part of it's service time the time the 	*/
								/* packet spent waiting for background utilization		*/
								/* packets to be serviced.								*/
								bgutil_delay = oms_bgutil_router_delay_calculate (pkptr, op_sim_time (), pk_svc_time, &bgutil_routed_state_ptr);
								}
							else
								{
								bgutil_delay = 0.0;
								}
				
							/*	Schedule an interrupt for this process at the	*/
							/*	time service ends.								*/
							evh = op_intrpt_schedule_self (op_sim_time () + pk_svc_time + comp_delay + bgutil_delay, outslot);
							if (op_ev_valid (evh) == OPC_FALSE)
								ip_rte_warn ("Unable to schedule service completion.");
							else
								/*	Mark the server to be busy now.			*/
								slot_info_ptr->slot_proc_status = OmsC_Dv_Processor_Busy;
				 			}
						else
							{
							/* Slot's server is busy, so the datagram will be	*/
							/* processed later. Associate the compression delay	*/
							/* with the datagram. This delay will be added to	*/
							/* the service time when the service is scheduled.	*/
							intf_ici_fdstruct_ptr->comp_decomp_delay = comp_delay;
							}
						}
					else
						{
						/*	The insertion failed (due to a full queue). We	*/
						/*	need drop the packet. Obtain trace information	*/
						/*	about this packet.								*/
						pkt_id      = op_pk_id (pkptr);
						pkt_tree_id = op_pk_tree_id (pkptr);
				
						/*	Issue trace statement.							*/
						if ((op_prg_odb_ltrace_active ("ip_rte") && op_prg_odb_pktrace_active (pkptr)))
							{
							sprintf (str0, "Packet ID (%d) [Tree ID %d] being forwarded from central", pkt_id, pkt_tree_id);
							sprintf (str1, "processor to output slot %d dropped because of full queue.", outslot);
				
							op_prg_odb_print_minor (str0, str1, OPC_NIL);
							}
				
						/* Get a printable version of the interface's IP	*/
						/* address.											*/
						ip_address_print (intf_addr_str, iface_info_ptr->addr_range_ptr->address);
				
						/* Issue a warning message into the simulation log.	*/
						ipnl_reswarn_slot_pktinsert (pkt_id, pkt_tree_id, intf_addr_str, outslot);
				
						/* Destroy the packet and update statistics.	*/
						ip_rte_dgram_discard (pkptr, pk_ici_ptr);
						}
				
					/* After placing the packet in the output buffer, we may 	*/
					/* need to start service on any packets that were queued	*/
					/* in the central cpu behind the packet we just placed		*/
					/* in the output buffer.  If we need to do this, we will 	*/
					/* transition back to the start service state.  In 			*/
					/* preparation for that case, we must set the cpu code to 	*/
					/* indicate that we wish to start a job on the central cpu.	*/
					cpu_code = CENTRAL_CPU;	
					}
				else
					{
					/* The packet is not one of the packets serviced by the	*/
					/* central cpu and to be forwarded to output slot.		*/
				
					/* Now, first check whether the packet has been 		*/
					/* processed before or not, which is possible if slot 	*/
					/* based processing scheme is used. If the packet has 	*/
					/* been processed then that means it first received by 	*/
					/* another slot and forwarded to its output slot 		*/
					/* through the central processor. In this case all we 	*/
					/* need to do is to extract the routing information 	*/
					/* from associated ICI, which is computed by the first 	*/
					/* slot, and forward the packet to the output port.		*/
					status = intf_ici_fdstruct_ptr->processed;
					if (status == OPC_TRUE)
						{
						/* This is a packet processed before and ready to	*/
						/* be forwarded. Extract the routing information	*/
						/* from associated ICI.								*/
						inslot 			= intf_ici_fdstruct_ptr->slot_index;
						dest_addr 		= intf_ici_fdstruct_ptr->dest_addr;
						next_addr 		= intf_ici_fdstruct_ptr->next_addr;
				
						/*	Issue trace statement.							*/
						if ((op_prg_odb_ltrace_active ("ip_rte") && op_prg_odb_pktrace_active (pkptr)))
							{
							if (inslot == CENTRAL_CPU)
								sprintf (str0, "Packet ID (%d) [Tree ID %d] originally received from higher layer", 
									 	op_pk_id (pkptr), op_pk_tree_id (pkptr));
							else
								sprintf (str0, "Packet ID (%d) [Tree ID %d] originally received by slot %d", 
									 	op_pk_id (pkptr), op_pk_tree_id (pkptr), instrm);
							sprintf (str1, "forwarded to output port of slot %d", outslot);
				
							op_prg_odb_print_minor (str0, str1, OPC_NIL);
							}
				
						/* Forward the packet.	*/
						ip_rte_datagram_interface_forward (dest_addr, next_addr, pkptr, 
							intf_ici_fdstruct_ptr->output_intf_index, intf_ici_fdstruct_ptr);
				
						/* Free the memory allocated in the IP address 		*/
						/* variable of the ICI. The ICI itself is destroyed */
						/* within the call of the function 					*/
						/* ip_rte_datagram_interface_forward() above. We 	*/
						/* do not destroy the other IP address variable,	*/
						/* dest_addr, here since this information is stored	*/
						/* into the corresponding field of the forwarded	*/
						/* packet.											*/ 
						ip_address_destroy (next_addr);
						}
					else
						{ 
						/* An IP packet has completed service and it has not been 		*/
						/* processed before, which means we are either using			*/
						/* "centralized processing scheme" or "slot based scheme" and	*/
						/* the packet just got dequeued by the input slot's server.		*/
				
						/* Information regarding the next destination of the datagram	*/
						/* is obtained in "arrival" state and stored into the ICI that	*/
						/* is associated with the datagram. Retrieve this information.	*/ 
						dest_addr 			 = intf_ici_fdstruct_ptr->dest_addr;
						next_addr 			 = intf_ici_fdstruct_ptr->next_addr;
						broadcast			 = intf_ici_fdstruct_ptr->broadcast;
						higher_layer		 = intf_ici_fdstruct_ptr->higher_layer;
						destroy_pkt			 = intf_ici_fdstruct_ptr->destroy_pkt;
						broadcast_intf_index = intf_ici_fdstruct_ptr->broadcast_intf_index;
				
						/* 	The IP broadcast case has already been processed before the	*/
						/*	call to ip_rte_datagram_dest_get. ip_rte_datagram_dest_get	*/
						/*	blindly returns OPC_COMPCODE_SUCCESS if the packet is an	*/
						/*	outgoing broadcast packet. If the packet is not to be		*/
						/*	destroyed, then process it further.							*/
						if (!destroy_pkt)
							{
							/*	The packet is not to be destroyed. Process it based on	*/
							/*	the type of packet.										*/
							if (broadcast)
								{
								/*	This is a broadcast datagram. Forward it on the		*/
								/*	relevant interface.									*/
								ip_rte_datagram_broadcast (dest_addr, pkptr, broadcast_intf_index, intf_ici_fdstruct_ptr);
								}
							else if (higher_layer)
								{
					   			/*	The datagram has reached its destination, forward	*/
								/*	it to the higher layer.								*/
								ip_rte_datagram_higher_layer_forward (pkptr, dest_addr);
								}
							else
								{
								/*	Otherwise, forward the datagram on the appropriate	*/
				    			/*	interface.											*/
				
								ip_rte_datagram_interface_forward (dest_addr, next_addr, pkptr, 
									intf_ici_fdstruct_ptr->output_intf_index, intf_ici_fdstruct_ptr);
								}
							}
				        else
							{
							/* Destroy the packet and update statistics.	*/
							ip_rte_dgram_discard (pkptr, pk_ici_ptr);
							}
						}
					}
				
				}


			/** state (svc_compl) exit executives **/
			FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "svc_compl", "ip_rte_v4_vc () [svc_compl exit execs]")
				{
				
				}


			/** state (svc_compl) transition processing **/
			FSM_INIT_COND (SERVICE_QUEUED_PK)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("svc_compl")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (init) enter executives **/
			FSM_STATE_ENTER_UNFORCED (4, state4_enter_exec, "init", "ip_rte_v4_vc () [init enter execs]")
				{
				/*	Initialize the IP address package.							*/
				ip_address_pkg_init ();
					
				/*	Initialize important state variables for this process.		*/
				ip_rte_v4_sv_init ();
				
				/*	Initialize the global address table.						*/
				ip_rtab_init ();
				
				/*	Initialize statistic handles to be used for collecting IP	*/
				/*	layer statistics.											*/
				ip_rte_stathandle_init ();
				
				/* Initialize the Sim. Log notification handles that will be	*/
				/* used in this process model. This initialization is done via	*/
				/* an external C file.											*/
				ip_notif_log_handles_init ();
				
				/*	The interface table pointer is made available to other		*/
				/*	processes by registering it in the model-wide registry.		*/
				/*	Allocate memory for the data structure used to store this	*/
				/*	information and set the interface table information.		*/
				ip_info_ptr = (IpT_Info *) op_prg_mem_alloc (sizeof (IpT_Info));
				ip_info_ptr->ip_iface_table_ptr = interface_table_ptr;
				
				/*	Initially all the servers are idle.							*/
				central_server_status = OmsC_Dv_Processor_Idle;
				server_status = OmsC_Dv_Processor_Idle;
				
				/*	Initially the local gateway is not known.					*/
				gateway_known = OPC_FALSE;
				
				/* Initially there is no slots discovered (slot_count 0 means   */
				/* there is one slot whose index is 0.)							*/
				slot_count = -1;
				
				/* Initialize the state variable cpu_code. cpu_code is used to	*/
				/* determine which cpu is completed its service: the central 	*/
				/* CPU or one of the slot's CPU.								*/
				cpu_code = CENTRAL_CPU;
				
				/* Initially all the queues are empty.							*/
				queue_empty = OPC_TRUE;
								
				/* Determine whether the IP is using slots, which have their 	*/
				/* own CPUs and buffers, or it has only one centralized CPU 	*/
				/* and buffer.													*/
				op_ima_obj_attr_get (own_id, "ip processing scheme", &scheme);
				if (scheme == 0)
					processing_scheme = OmsC_Dv_Centralized;
				else 
					processing_scheme = OmsC_Dv_Slot_Based;
				
				/* Imitialize the slot interface map table.						*/
				slot_iface_map_lptr = OPC_NIL;
				
				/* Check out whether the node containing this IP module is		*/
				/* configured as a firewall. If it is a firewall, then also		*/
				/* build proxy server information table.						*/
				proxy_info_table_lptr = OPC_NIL;
				firewall_flag = oms_dv_device_is_firewall (own_node_objid, &proxy_info_table_lptr);
				
				/* Check whether the packet latency compound attribute is 		*/
				/* present on the surrounding node. If so, then the node is 	*/
				/* assumed to be an IP cloud object. 							*/
				ipcloud_flag = oms_dv_device_is_ipcloud (own_node_objid, own_id);
				if (ipcloud_flag == OPC_TRUE)
					{
					/* The surrounding node is an IP cloud. The following	*/
					/* function obtains the packet latency and packet drop	*/
					/* ratio attribute values, and registers packet latency	*/
					/* statistic handle.									*/
					ip_dev_ipcloud_var_init (own_node_objid, own_id);
				    }
				
				/*	Get assigned value of server processing rate.				*/
				if (op_ima_obj_attr_get (own_id, "service_rate", &service_rate) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to get server processing rate from attribute.");
				
				/*	Determine whether this IP node is a gateway.				*/
				if (op_ima_obj_attr_get (own_id, "gateway", &gateway_status) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to get gateway status from attribute.");
				
				/*	Obtain the ip_rte process's prohandle.						*/
				own_prohandle = op_pro_self ();
				
				/*	Obtain the name of the process. It is the "process model"	*/
				/*	attribute of the module.									*/
				op_ima_obj_attr_get (own_id, "process model", proc_model_name);
				
				/*	Register the process in the model-wide registry.			*/
				own_process_record_handle = (OmsT_Pr_Handle) oms_pr_process_register 
								(own_node_objid, 
								own_id, 
								own_prohandle, 
								proc_model_name);
				
				/*	Create the list of multicast addresses this node can		*/
				/*	handle -- publish that list through the process registry.	*/
				mcast_addr_list_ptr = op_prg_list_create ();
				
				/* Create list to store radio interfaces for this node.	*/
				radio_intf_list_ptr = op_prg_list_create ();
				
				/*	Register the following attributes in the process registery:	*/
				/*		1. subnet information -- to allow gateways in the local	*/
				/*		   OPNET subnet to be found.							*/
				/*		2. protocol -- which is "ip" in this case				*/
				/* 		3. the address information maintained by this process	*/
				/*		4. multicast addresses list handles by this node		*/
				/*		5. The radio interface list, used by the auto assignmet */
				/*         procedure, will be destroyed after IP Auto Assignment*/
				/*		   is completed. (exit exec of Wait state)				*/
				/*		6. module information -- to allow applications to		*/
				/*		   register multicast addresses using remote interrupt	*/
				oms_pr_attr_set (own_process_record_handle, 
					"subnet",					OMSC_PR_OBJID,		subnet_objid, 
					"protocol",					OMSC_PR_STRING,		"ip", 
					"address",					OMSC_PR_ADDRESS,	&interface_table_ptr,
					"interface information", 	OMSC_PR_ADDRESS,	ip_info_ptr,
					"multicast address list",	OMSC_PR_ADDRESS,	mcast_addr_list_ptr,
					"radio interface list",		OMSC_PR_ADDRESS,	radio_intf_list_ptr,
					"module objid", 			OMSC_PR_OBJID,		own_id,
					OPC_NIL);
				
				/*	If this IP node is a gateway, register it as a gateway.		*/
				if (gateway_status == OPC_TRUE)
					{
					oms_pr_attr_set (own_process_record_handle, 
						"gateway node",				OMSC_PR_STRING,		"gateway", 
						OPC_NIL);
					}
				
				/* Allocate memory for the common IP route table that will  */
				/* be populated by the dyn. routing protocols configured    */
				/* by the user.                                             */
				ip_route_table = ip_cmn_rte_table_create (own_node_objid);
				
				/* Publish a pointer to the route table object in the       */
				/* process registry so that whatever dyn. routing protocols */
				/* are going to run in this node, they will have a reference*/
				/* to it.                                                   */
				oms_pr_attr_set (own_process_record_handle,
								 "ip route table", OMSC_PR_ADDRESS, ip_route_table,
								 OPC_NIL);
				
				/*	A global address table is used to associate IP addresses	*/
				/*	with the corresponding lower layer address. This table is	*/
				/*	is managed by the NATO sub-package and optimizes address	*/
				/*	conversion table lookup. The IP routing process registers	*/
				/*	addresses in this table and makes it available (e.g., to 	*/
				/*	the IP ARP process) via process registry.					*/
				ip_rtab_table_handle_register ();
				
				/*	Schedule a self interrupt at the current time to let all	*/
				/*	the ip modules resolve their IP addresses. This involves	*/
				/*	assigning unique addresses and making sure that these are	*/
				/*	unique. Note that dynamically assigned addresses may change	*/
				/*	until all the statically assigned addresses have been		*/
				/*	checked for uniqueness.										*/
				op_intrpt_schedule_self (op_sim_time (), 0);
				
				/*	Create an ICI for communicating destination addresses to	*/
				/*	the address resultion protocol (ARP)						*/
				arp_iciptr = op_ici_create ("ip_arp_req_v4");
				if (arp_iciptr == OPC_NIL)
					ip_rte_error ("Unable to create ICI for communication with ARP.");
				
				/*	Create a datagram list to store datagram fragments until	*/
				/*	the complete datagram can be constructed.					*/
				dgram_list_ptr = ip_frag_sup_setup ();
				
				/*	Obtain the specified "Default Gateway". This specifies an 	*/
				/*	IP interface address to which a datagram needs to be 		*/
				/*	forwarded as its next hop. The attribute gets its name from	*/
				/*	the fact that the next hop would, typically, reside in a	*/
				/*	node acting as a gateway.									*/
				op_ima_obj_attr_get (own_id, "default gateway", default_gtwy_str);
				
				/*	Determine whether the default gateway has been specified 	*/
				/*	a value other than its default value.						*/
				if (strcmp (default_gtwy_str, IPC_AUTO_ADDRESS) == 0)
					{
					/*	No value has been specified to the "default gateway"	*/
					/*	model attribute. This means that an IP datagram may be	*/
					/*	dropped if a possible next hop cannot be determined		*/
					/*	using the routing tables. Store the fact that a default	*/
					/*	gateway information is not available.					*/
					default_gtwy_available = OPC_FALSE;
					}
				else
					{
					/*	Create the IP address of the default gateway from the	*/
					/*	value of the specified attribute.						*/
					default_gtwy_addr = ip_address_create (default_gtwy_str);
				
					/*	Set the variable that contains information on whether	*/
					/*	a default gateway is available.							*/
					default_gtwy_available = OPC_TRUE;
					}
				
				/* The IP auto-address resolution feature (used in the exit		*/
				/* excutives of the "init" state) is called depending upon the	*/
				/* value specified to the simulation attribute -- IP Interface	*/
				/* Addressing Mode. If auto-addressing is not used, then a		*/
				/* default gateway must be specified if the node is not capable	*/
				/* of routing. Generate a message if this condition is not met.	*/
				if (((iface_addressing_mode == IpC_Iface_Manually_Addressed) ||
					(iface_addressing_mode == IpC_Iface_Manual_Address_Export)) && 
					(default_gtwy_available == OPC_FALSE) && 
					(gateway_status == OPC_FALSE))
					{
					/* Generate a message in the simulation notification log	*/
					/* and exit the simulation.									*/
					ipnl_cfgerr_defgtwy ();
					ipnl_sim_terminate ();
					}
				
				/* Read the simulation attribute "IP Routing Table Export/Import" 	*/
				/* The global var. into which this value is store, is initialized	*/
				/* to IP_RTE_TABLE_NON_DET. Checking for this value, eliminates 	*/
				/* multiple calls to op_ima_sim_attr_get ().						*/ 										
				if (routing_table_import_export_flag == IP_RTE_TABLE_NON_DET)
					{
					if (op_ima_sim_attr_exists ("IP Routing Table Export/Import") == OPC_TRUE)
						{
						op_ima_sim_attr_get (OPC_IMA_INTEGER, "IP Routing Table Export/Import",
							&routing_table_import_export_flag);
						}
					}
				
				/* Allocate memory for the parent-to-child data structure used to	*/
				/* pass information betwen IP and its child processes (ip_icmp and	*/
				/* ip_basetraf_src.)												*/
				ip_ptc_mem_ptr = (IpT_Ptc_Memory *) op_prg_mem_alloc (sizeof (IpT_Ptc_Memory));
				
				/* Indicate that the IP process has been initialized.				*/
				is_ip_initialized = OPC_TRUE;
				
				/* Initialize the value of the unnumbered interface flags			*/
				unnumbered_interface_exists	= OPC_FALSE;
				
				/* Determine whether this node is a multicast router	*/
				if (op_ima_obj_attr_get (own_id, "multicast routing", &multicast_router) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to get multicast router status from attribute.");
				
				/* Obtain the "multicast routing protocol" specified in the model attribute.	*/
				if (op_ima_obj_attr_get (own_id, "multicast routing protocol", &mcast_rte_protocol) == OPC_COMPCODE_FAILURE)
					ip_rte_error ("Unable to get multicast routing protocol attribute.");
				
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (9,ip_rte_v4_vc)


			/** state (init) exit executives **/
			FSM_STATE_EXIT_UNFORCED (4, state4_exit_exec, "init", "ip_rte_v4_vc () [init exit execs]")
				{
				/****************************************************************************/
				/* 	At this time, it is assured that all IP and IPX processes in the model	*/
				/*	have registered themselves in the Process Registry. With the			*/
				/*	possibility that an IPX stack may coexist with this IP stack, it is		*/
				/*	necessary to wait for registration to happen before building the 'link	*/
				/*	interface table'. This is because, walking the node's topology from a	*/
				/* 	transceiver to the IP module (given that an IPX stack is present) will	*/
				/*	find MULTIPLE PATHS to the IP module where the last stream used to		*/
				/*	reach the IP module will have the 'ipx addr index' extended attribute.	*/
				/*	In order to eliminate this ambiguity, it is necessary to eliminate		*/
				/*	traversing all paths to the IP module through an INTERMEDIATE IPX		*/
				/*	module. And locating the intermediate IPX module involves identifying	*/
				/*	its presence from the Process Registry.									*/
				/****************************************************************************/
				
				/* Check the existence of ip attribute object. We will read the compression	*/
				/* information for each interface from the attribute database. The special 	*/
				/* object defines all the compession informaiton. Although this function	*/
				/* gets called from each IP process instance in the network, functionally	*/
				/* it only gets executed only once for each simulation.						*/
				ip_rte_attr_config_info ();
				
				/* Check if the surrounding node is acting like a LAN node. This is needed	*/
				/* because if this surrounding node is a LAN object, then all the packets	*/
				/* received from the higher layer will be forwarded to the lower layer		*/
				/* (which may forward it back to the higher layer, if it is destined for	*/
				/* the same node.) If the node is not a LAN object, then higher layer		*/
				/* packets destined	the same node will be directly sent to the higher layer	*/
				ip_rte_determine_lan_node_context ();
				
				/* Build a table relating the process' interfaces to the links attached to	*/
				/* the node.  This is used, among other potential purposes, for the auto-	*/
				/* addressing capability.  Since mobile and satellite nodes do not support	*/
				/* point-to-point or bus link connections, such a table is not built for	*/
				/* those type of nodes. Build the table only if this is a fixed node.		*/
				link_iface_table_ptr = op_prg_list_create ();
				if (op_id_to_type (own_node_objid) == OPC_OBJTYPE_NDFIX)
					{
					ip3_link_iface_table_build (own_node_objid, link_iface_table_ptr);
					}
				
				/* Extracting node object id for building radio interface list.				*/
				node_objid = op_topo_parent (own_id);
				
				/* Create the list that will contain the radio interfaces.					*/
				ip3_radio_iface_table_build (node_objid, radio_intf_list_ptr);
				
				/* Registering the node as radio ip node if it has one or more radio		*/
				/* interfaces.																*/
				if (op_prg_list_size (radio_intf_list_ptr) != 0)
					{
					oms_pr_attr_set (own_process_record_handle, 
					"protocol type",	OMSC_PR_STRING,	 "radio ip", OPC_NIL);
					}
				
				
				/* Schedule a self interrupt to start auto addressing phase of this process	*/
				op_intrpt_schedule_self (op_sim_time (), 0);
				
				/* Initialize the flag to indicate that in the interface structure no		*/
				/* router id has been assigned till now.									*/
				router_id_assigned = OPC_FALSE;
				
				/* Check to see if there is the possibility of background utilization		*/
				/* traffic.																	*/
				if (op_tim_init () == OPC_COMPCODE_FAILURE)
					{
					do_bgutil = OPC_FALSE;
					}
				else
					{
					do_bgutil = OPC_TRUE;
					
					/* Initialize the background utilization state ptr for the central cpu. */	
					bgutil_routed_state_ptr = OPC_NIL;		
				
					/* Initialize the background utilization state ptr for keeping track of */
					/* sent and received background utilization traffic.					*/
					received_bgutil_routed_state_ptr = oms_bgutil_routed_state_create ();
					sent_bgutil_routed_state_ptr = oms_bgutil_routed_state_create ();
					
					/* Init the time at which background utilization statistics generation 	*/
					/* begins to time 0.													*/
					received_last_stat_update_time = 0.0;	
					sent_last_stat_update_time = 0.0;	
				
					/* Schedule a procedure which will be called for this process at the 	*/
					/* end of simulation to update background utilization statistics if		*/
					/* needed.																*/
					op_intrpt_schedule_call (OPC_INTRPT_SCHED_CALL_ENDSIM, 0, 
						ip_rte_pk_stats_update_endsim, OPC_NIL);
					}
				}


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (6, state6_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (init_too) enter executives **/
			FSM_STATE_ENTER_UNFORCED (5, state5_enter_exec, "init_too", "ip_rte_v4_vc () [init_too enter execs]")
				{
				
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (11,ip_rte_v4_vc)


			/** state (init_too) exit executives **/
			FSM_STATE_EXIT_UNFORCED (5, state5_exit_exec, "init_too", "ip_rte_v4_vc () [init_too exit execs]")
				{
				intrpt_type = op_intrpt_type ();
				
				/*	The process will enter this state when all IP interfaces	*/
				/*	have been treated via the "ip3_addr_resolve ()" service.	*/
				/*	Perform cleanup operations (e.g., memory deallocation) for	*/
				/*	the state built while using this service.					*/
				ip3_auto_addr_cleanup ();
				
				/*	Obtain the outstream index to ip_encap module.				*/
				proc_record_handle_list_ptr = op_prg_list_create ();
				
				oms_pr_process_discover (own_id, proc_record_handle_list_ptr, 
								"protocol", OMSC_PR_STRING, "ip_encap", 
								OPC_NIL);
				
				record_handle_list_size = op_prg_list_size (proc_record_handle_list_ptr);
				if (record_handle_list_size != 1)
					{
					/*	An error should be created if there are zero or		*/
					/*	more than one ip_encap process in the local node.	*/
					op_sim_end ("Error: either zero or several ip_encap modules connected to IP.",
						"", "", "");
					}
				else
					{
					process_record_handle = (OmsT_Pr_Handle) op_prg_list_access (proc_record_handle_list_ptr, 
											OPC_LISTPOS_HEAD);
					}
				
				/*	Obtain the ip_encap module objid, and the output stream		*/
				/*	index from IP to IP Encap module.							*/
				oms_pr_attr_get (process_record_handle, "module objid", OMSC_PR_OBJID, &ip_encap_objid);
				oms_tan_neighbor_streams_find (own_id, ip_encap_objid, &instrm_from_ip_encap, &outstrm_to_ip_encap);
				
				/*	Deallocate no longer needed process registry information.	*/
				while (op_prg_list_size (proc_record_handle_list_ptr))
					op_prg_list_remove (proc_record_handle_list_ptr, OPC_LISTPOS_HEAD);
				op_prg_mem_free (proc_record_handle_list_ptr);
				
				/* Determine if we are being invoked by one of the child proceses	*/
				/* maintained by IP. Note that "ip_icmp" is used for ICMP messages	*/
				/* (currently only supports "ping") and "ip_basetraf_src" is used	*/
				/* background utilization traffic specification generation.			*/
				child_prohandle = op_pro_invoker (own_prohandle, &invoke_mode);
				if (invoke_mode == OPC_PROINV_INDIRECT)
					{
					/* A child process invoked IP.	*/
					pk_from_child_process = OPC_TRUE;
					}
				else if (invoke_mode == OPC_PROINV_DIRECT)
					{
					pk_from_child_process = OPC_FALSE;
					}
				else
					{
					ip_rte_error ("Unable to determine if how IP process got invoked."); 	
					}
				
				/* Determine the queuing managment: FIFO, WFQ, Priority Queuing		*/
				/* or Custom Queuing. The IP process will deleguate	its tasks 		*/
				/* to a child process on each interface for sending the packets.	*/
				ip_rte_qos_information_process ();
				}


			/** state (init_too) transition processing **/
			FSM_INIT_COND (ARRIVAL)
			FSM_TEST_COND (MCAST_RSVP)
			FSM_TEST_LOGIC ("init_too")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 0, state0_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 8, state8_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (wait) enter executives **/
			FSM_STATE_ENTER_UNFORCED (6, state6_enter_exec, "wait", "ip_rte_v4_vc () [wait enter execs]")
				{
				
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (13,ip_rte_v4_vc)


			/** state (wait) exit executives **/
			FSM_STATE_EXIT_UNFORCED (6, state6_exit_exec, "wait", "ip_rte_v4_vc () [wait exit execs]")
				{
				/* At this point, the enter executives of the 'init' state are	*/
				/* guaranteed to have completed for all IP modules across the 	*/
				/* entire network model. This allows us to know that certain 	*/
				/* initializations have been performed on a global level. In 	*/
				/* particular, all IP modules have registered their primary 	*/
				/* process registry attributes. In the exit executives of 'wait'*/
				/* we can now perform a second wave of initializations that 	*/
				/* rely on this first wave having completed. These activities 	*/
				/* include: 													*/
				/* 1) verifying consistency of interface addreess and subnet 	*/
				/*    mask assignments (consistency with other nodes as well). 	*/
				/* 2) choosing values for all "auto-assigned" inteface			*/
				/*    addresses and subnet masks. 								*/
				/* 3) checking for certain construcion problems in the node		*/
				/*	  model. 													*/
				/* 4) Construction of an interface table in the form of a state	*/
				/*    variable that reflects the assignments to the interface 	*/
				/*    attributes of the IP object. 								*/
				/* 5) Registration of each IP interface address into a global 	*/
				/*    address table to support a simulation efficiency method.	*/
				/* 6) Discovery of dynamic vs. static routing configuration and	*/
				/*    notification of dynamic routing processes that IP is 		*/
				/*    "ready" (i.e., fully configured.)							*/
				intrpt_type = op_intrpt_type ();
				
				/* Obtain a handle on the interface table. This attribute is 	*/
				/* a compound attribute (i.e., an  object) whose sub-objects	*/
				/* are individual interfaces. 									*/
				op_ima_obj_attr_get (own_id, "ip addr info", &comp_attr_objid);
				
				/* Determine the number of interfaces in the table.			*/
				num_interfaces = op_topo_child_count (comp_attr_objid, OPC_OBJTYPE_GENERIC);
				
				/* If the processing scheme is slot based then:					*/
				/*  1) Create the slot info table, and							*/
				/*  2) Create the interface-slot map and verify that each 		*/
				/*     interface belongs to one slot.							*/
				if (processing_scheme == OmsC_Dv_Slot_Based)
					{
					op_ima_obj_attr_get (own_id, "slot info", &slot_info_objid);
					oms_dv_slot_table_build (slot_table_ptr, slot_info_objid);
					slot_iface_map_lptr = oms_dv_iface_slot_map_create (slot_info_objid, num_interfaces);
					oms_dv_iface_slot_map_verify (slot_iface_map_lptr, num_interfaces);
				
					if (op_prg_odb_ltrace_active ("ip_rte_slot"))
						{
						oms_dv_slot_table_print (slot_table_ptr);
						oms_dv_iface_slot_map_print (slot_iface_map_lptr, num_interfaces);
						}
					}		
				
				/* Examine each interface in turn to: 							*/
				/*  1) verify that it is configured appropriately.				*/
				/*  2) complete its specifcation if necessary.					*/
				/*  3) extract information from it to construct an interface	*/
				/*     table in a state variable for faster access.				*/
				
				/* Set the flag to indicate that no interface has yet			*/
				/* registered an IP address.									*/
				ip_addr_created = OPC_FALSE;
				
				/* Create the list for maintaining active custom protocol labels.	*/
				active_custom_rte_proto_label_lptr = op_prg_list_create ();
				
				/* Loop over the rows in the "ip addr info" compound attribute	*/
				/* and process each one.										*/
				for (i = 0; i < num_interfaces; i++)
					{
					/* Initialize the variable used to track if the i_th iface	*/
					/* is unnumbered.											*/
					intf_unnumbered = OPC_FALSE;
				
					/* Obtain the object representing the i_th interface in the table. */
					iface_description_objid = op_topo_child (comp_attr_objid, OPC_OBJTYPE_GENERIC, i);
				
					/* Verify that at least one stream exists to support this interface. If not, issue	*/
					/* a warning. The system can still function, but it is probably not what the node	*/
					/* model developer intended. 														*/
					ip_stream_from_iface_index (i, &instrm, &outstrm, &interface_type);
				
					/*	The existencce of an outstream to support an interface is required. Otherwise, 	*/
					/*	IP might try to send packet on an attached stream, which will generate errors.	*/
					if (outstrm == -1)
						{
						ipnl_cfgwarn_intfcfg (i);
						continue;
						}
					else
						{
						/* Determine the routing protocol to be used on the various 		*/
						/* interfaces. The routing protocol specified using	the simulation 	*/
						/* attribute "IP Dynamic Routing Protocol" takes precedence over 	*/
						/* local specification.												*/
								
						/* Obtain the routing protocol id, and its label for the ith interface.	*/
						routing_proto = ip_interface_routing_protocol_obtain (iface_description_objid, rte_protocol_label);
				
						/* Check if a custom routing protocol is being used.				*/
						if (routing_proto >= IPC_INITIAL_CUSTOM_RTE_PROTOCOL_ID)
							{
							/* Insert this label in the list, which maintains active list	*/
							/* of custom routing protocols, if not inserted yet. 			*/
							if (op_prg_list_elem_find (active_custom_rte_proto_label_lptr, strcmp, rte_protocol_label, &low_index, &high_index) == OPC_NIL)
								{
								/* Allocate memory.										*/
								custom_rte_protocol_label_ptr = (char *) op_prg_mem_alloc ((strlen (rte_protocol_label) + 1) * sizeof (char));			
								
								/* Check if memory has been allocated */
								if (custom_rte_protocol_label_ptr == OPC_NIL)
									{
									/* Memory is not allocated. Report an error message and terminate the simulation */
									op_sim_end ("Error in IP routing process model (ip_rte_v4):",
										"Could not allocate memory for custom routing protocol label field.",
										OPC_NIL, OPC_NIL); 
									}
				
								/* Assign the custom routing protocol label value to be inserted.	*/
								strcpy (custom_rte_protocol_label_ptr, rte_protocol_label);
				
								/* Insert the label in the list.									*/
								op_prg_list_insert (active_custom_rte_proto_label_lptr, custom_rte_protocol_label_ptr, OPC_LISTPOS_TAIL);
								}
							}
						
						/* If this interface uses OSPF, multicast is enabled on the interface	*/
						if (routing_proto == IpC_Rte_Ospf)
							{
							multicast_enabled = OPC_TRUE;
							}
						else
							{
							/* Otherwise, obtain the "multicast" information for this interface */
							/* from the attribute												*/
							op_ima_obj_attr_get (iface_description_objid, "multicast", &multicast_enabled);
							}
				
						/* Print debugging information	*/
						if (op_prg_odb_ltrace_active ("ip_interfaces") == OPC_TRUE)
							{
							printf ("\n");
							sprintf (trace_msg, "Routing protocol for this interface = %d",routing_proto);
							op_prg_odb_print_minor (trace_msg, OPC_NIL);
							}
				
						/* The address resolution feature is used depending	*/
						/* upon the value specified to the simulation		*/
						/* attribute - "IP Interface Addressing Mode".		*/
						if ((iface_addressing_mode != IpC_Iface_Manually_Addressed) &&
							(iface_addressing_mode != IpC_Iface_Manual_Address_Export))
							{
							return_status = ip3_addr_resolve (iface_description_objid, i, link_iface_table_ptr,
								routing_proto, &intf_unnumbered, interface_table_ptr, &line_objid);
							
							/* Here the interface is not connected to a valid	*/
							/* link. The goal is to avoid the further interface	*/
							/* assignments.										*/
							if (return_status == OPC_COMPCODE_FAILURE && (i != (num_interfaces - 1)) && 
							   (ip3_interface_is_radio_verify (radio_intf_list_ptr, i, num_interfaces) == OPC_FALSE))
								{
								continue;
								}
							else if (intf_unnumbered == OPC_TRUE && unnumbered_interface_exists == OPC_FALSE)
								{
								/* If the interface is unnumbered then we set 		*/
								/* the unnumbered interafce flag if not already set */
								unnumbered_interface_exists = OPC_TRUE;
								}
							}
						else
							{
							/* As Auto Addressing resolution code is not invoked 	*/
							/* in case of Manually addresses mode, the link objid is*/
							/* to be obtained to determine the validity of the 		*/
							/* current interface.									*/
							line_objid = ip3_link_iface_link_from_index (link_iface_table_ptr, i, 0);
							}
						
						/* Build an internal representation of the interface table. */
						/* This provides faster access and allows the table to be	*/
						/* transparently shared by other processes in the IP procss	*/
						/* group (for example, ARP). 								*/
						op_ima_obj_attr_get (iface_description_objid, "address", ip_addr_str);
						op_ima_obj_attr_get (iface_description_objid, "subnet mask", subnet_mask_str);
				
						/* Obtain the MTU size and compression information setting	*/
						/* on this interface.										*/
						op_ima_obj_attr_get (iface_description_objid, "mtu",				&mtu);
						op_ima_obj_attr_get (iface_description_objid, "compression info",	comp_info_str);
				
						/* The address resolution feature is used depending			*/
						/* upon the value specified to the simulation				*/
						/* attribute - "IP Interface Addressing Mode".				*/
						/* Auto Assigning IP address to radio interfaces if needed. */
						if ((iface_addressing_mode != IpC_Iface_Manually_Addressed) &&
							(iface_addressing_mode != IpC_Iface_Manual_Address_Export) &&
							(op_prg_list_size (radio_intf_list_ptr) != 0))
							{
							ip3_radio_address_resolve (radio_intf_list_ptr, subnet_objid, own_id); 
				
							/* Get the IP address and subnet mask after Auto Assigning it.	*/
							op_ima_obj_attr_get (iface_description_objid, "address", ip_addr_str);
							op_ima_obj_attr_get (iface_description_objid, "subnet mask", subnet_mask_str);			
							}
						
						/* If the address and or subnet mask are still auto assigned, 	*/
						/* then it must mean that the interface is not connected to any	*/
						/* links. Rather than leaving an unconfigured interface in the 	*/
						/* the interface table, simply do not create an interface entry.*/
						if (!strcmp (ip_addr_str, IPC_AUTO_ADDRESS))
							{
							/* If this is the last interface, and no addresses have been	*/
							/* assigned, assign an address to this interface.				*/
							if ((ip_addr_created == OPC_FALSE) && (i == (num_interfaces - 1)))
								{
								ip3_addr_unconn_node_create (iface_description_objid, 0, link_iface_table_ptr);
				
								/* Build an internal representation of the interface table. */
								/* This provides faster access and allows the table to be   */
								/* transparently shared by other processes in the IP procss */
								/* group (for example, ARP).                                */
								op_ima_obj_attr_get (iface_description_objid, "address",        	ip_addr_str);
								op_ima_obj_attr_get (iface_description_objid, "subnet mask",    	subnet_mask_str);
								op_ima_obj_attr_get (iface_description_objid, "mtu",            	&mtu);
								op_ima_obj_attr_get (iface_description_objid, "compression info",	comp_info_str);
								}
							else
								{
								/* This interface did not receive an assignment. Do not continue 	*/
								/* setup for it. 													*/
								continue;
								}
							}
						else
							{
							/* At least one ip_address has been assigned for this node.	*/
							ip_addr_created = OPC_TRUE;
							}
				
						/* At this point, we have found a row in the "IP Address	*/
						/* Information" comp. attr. that has non-default values for	*/
						/* the "address" and "subnet mask" subattributes. These		*/
						/* values may be the result of the auto addressing scheme	*/
						/* having set these values, or, the user setting these		*/
						/* values - in which case the auto addressing scheme leaves	*/
						/* them unaltered. There is the possibility that the user	*/
						/* may have assigned values to an interface that is not		*/
						/* connected to any link. Failure to check this and execute	*/
						/* the code below will result in the creation of			*/
						/* IpT_Interface_Info objects for interfaces that cannot be	*/
						/* used to forward IP datagrams. Check for this now.		*/
						/*															*/
						/* There is one exception that we need to allow for. This	*/
						/* is the case where a stand-alone node (typically a LLM	*/
						/* node) is part of the network. This case is supported via	*/
						/* the if check that is done above - and shown below.		*/ 
						/* "(ip_addr_created == OPC_FALSE) &&						*/
						/*  (i == (num_interfaces - 1))"							*/
				
						/* Create an interface object and enter it into the IP		*/
						/* interface table if:										*/
						/* 1. The link connected to this interface is valid.		*/
						/* 2. The interface is connected to a radio transceiver and */
						/*    a valid address assignment has been made.				*/
						/* 3. This is the last interface of an unconnected node.	*/
						if ((line_objid != OPC_OBJID_INVALID) ||
							((ip3_interface_is_radio_verify (radio_intf_list_ptr, i, num_interfaces) == OPC_TRUE) &&
							 (strcmp (ip_addr_str, IPC_AUTO_ADDRESS) != 0)) ||
							((line_objid == OPC_OBJID_INVALID) && (ip_addr_created == OPC_FALSE) &&
							 (i == (num_interfaces - 1))))
							{
							/* Convert the string representations of the address/mask	*/
							/* to IP internal form. These will be stored as part of the	*/
							/* interface's 'address range' created below.				*/
							ip_addr = ip_address_create (ip_addr_str);
							subnet_mask_addr = ip_address_create (subnet_mask_str);
				
							/* A global address table is used to associate IP addresses	*/
							/* with the corresponding lower layer address. This table	*/
							/* IS Managed by the NATO sub-package. The IP routing		*/
							/* process registers addresses in this table and makes it	*/
							/* available to other processes (e.g., IP ARP) via process	*/
							/* registry.												*/
							if (intf_unnumbered == OPC_FALSE)
								{
								ip_rtab_local_addr_register (ip_addr);
								}
				
							/*	Create and initialize a new cell to hold the interface	*/
							/*	information.											*/
							iface_info_ptr = ip_interface_info_create ();
							iface_info_ptr->addr_index = i;
							iface_info_ptr->addr_range_ptr = ip_address_range_create (ip_addr, subnet_mask_addr);
							iface_info_ptr->network_address = ip_address_mask (ip_addr, subnet_mask_addr);
							iface_info_ptr->mtu	= mtu;
							iface_info_ptr->port_num = outstrm;
							iface_info_ptr->in_port_num = instrm;
							iface_info_ptr->intf_unnumbered = intf_unnumbered;
							iface_info_ptr->multicast_enabled = multicast_enabled;
				
							/* Find out whether RSVP is enabled on the interface.	*/
				
							iface_info_ptr->rsvp_enabled = ip_rtab_rsvp_status_set (iface_description_objid);
				
							if (iface_info_ptr->rsvp_enabled == OPC_TRUE) 
								{
								rsvp_status = OPC_TRUE;
								}
				
							/* Retrieve the information about the compression scheme	*/
							/* used for this interface from the network-wide attribute	*/
							/* database. Use the comp_info_str (name) as the reference.	*/
							iface_info_ptr->comp_info = oms_data_def_entry_access (
															"IP Compression Information", comp_info_str);
				
							if (iface_info_ptr->comp_info == OPC_NIL)
								{
								/* The specified compression scheme does not exists		*/
								/* in the attribute database. Add an entry into			*/
								/* the simulation notification log.						*/
								ipnl_cfgwarn_unknown_comp_scheme (i, comp_info_str);
				
								/* Set the compression scheme to "None" as default for	*/
								/* the interface.										*/
								iface_info_ptr->comp_info = oms_data_def_entry_access ("IP Compression Information", "None");
								}
				
							/* Store the object ID of the link to which this interface	*/
							/* is connected.											*/
							iface_info_ptr->connected_link_objid = line_objid;
				
							/*	Determine and set the speed at which this interface operates	*/
							/*  only if we are not processing a stand-alone node.				*/
							if (line_objid != OPC_OBJID_INVALID)
								{
								op_ima_obj_attr_get (
									iface_info_ptr->connected_link_objid, "data rate", &iface_data_rate);
								iface_info_ptr->speed = iface_data_rate;
								}
				
							/* Based on what has been set up, initialize the			*/
							/* routing_proto member of the corresponding				*/
							/* IpT_Interface_Info object. At the same time, set the		*/
							/* corresponding bit in the routing_options SV. This SV		*/
							/* will be used later in determining which routing protocol	*/
							/* modules IP is going to "remote interrupt".				*/
							if (routing_proto >= IPC_INITIAL_CUSTOM_RTE_PROTOCOL_ID)
								{
								iface_info_ptr->routing_proto = routing_proto;
								}
							else
								{
								switch (routing_proto)
									{
									case 0:
										iface_info_ptr->routing_proto = IpC_Rte_Rip;
										routing_protos |= IPC_RTE_PROTO_RIP;
										break;
									case 1:
										iface_info_ptr->routing_proto = IpC_Rte_Igrp;
										routing_protos |= IPC_RTE_PROTO_IGRP;
										break;
									case 2:
										iface_info_ptr->routing_proto = IpC_Rte_Ospf;
										routing_protos |= IPC_RTE_PROTO_OSPF;
										break;
									case 3:
										iface_info_ptr->routing_proto = IpC_Rte_Bgp;
										routing_protos |= IPC_RTE_PROTO_BGP;
										break;
									case 4:
										iface_info_ptr->routing_proto = IpC_Rte_Eigrp;
										routing_protos |= IPC_RTE_PROTO_EIGRP;
										break;
									case -1:
										/* Corresponds to the value 'None' for routing 		*/
										/* protocol.										*/
										break;
									default:
										ip_rte_error ("Invalid routing protocol specified for IP Interface.");
										break;
									}
								}
				
							/*	Initialize the outbound load from this interface. Also	*/
							/*	setteh reliability of the interface as 100% reliable.	*/
							iface_info_ptr->load_bits = 0.0;
							iface_info_ptr->load_bps = 0.0;
							iface_info_ptr->reliability = 1.0;
				
							/*	Like the above global table for interface address,		*/
							/*	another global table is maintained for all the possible	*/
							/*	IP networks in the model.								*/
							if (intf_unnumbered == OPC_FALSE)
								ip_rtab_local_network_register (iface_info_ptr->network_address);
				
							/* If the slot based processing scheme is used then			*/
							/* determine the slot to which the interface belongs to.	*/
							if (processing_scheme == OmsC_Dv_Slot_Based)
								{
								iface_info_ptr->slot_index = slot_iface_map_lptr [i];
				
								/* Check the slot assignment. It should exist.			*/
								if (iface_info_ptr->slot_index == OMSC_DV_UNSPECIFIED_SLOT)
									{
									/* Error situation: IP is using slot based			*/
									/* processing scheme and at least one of the "used"	*/
									/* interfaces does not have a slot assigned (i.e.	*/
									/* the slot it belongs to is not specified.) Prompt	*/
									/* the error and terminate the simulation.			*/
									sprintf (error_string, "The used interface %d does not have any slot assigned.", i); 
									ip_rte_error (error_string);
									}
								}	  
							else
								{
								/* Processing is centralized, hence slot index will not	*/
								/* be used. Set it to unspecified.						*/
								iface_info_ptr->slot_index = OMSC_DV_UNSPECIFIED_SLOT;
								}
						
							/* Store the type of this interface. This is required in 	*/
							/* determining whether a ICI is to be associated with the	*/
							/* packets sent throug this interface. We do not have to 	*/
							/* associate any ICI with packets sent out through "slip"	*/
							/* interfaces.												*/
							iface_info_ptr->intf_type = interface_type;
				
							/*	Insert the cell into the interface table. */
							op_prg_list_insert (interface_table_ptr, iface_info_ptr, OPC_LISTPOS_TAIL);
							}
						}
					}
				
				/* Now that the addressing is done deallocate the memory for the 	*/
				/* radio interface table and its entries.							*/
				while (op_prg_list_size (radio_intf_list_ptr))
					{
					ip3_link_iface_entry_destroy (op_prg_list_remove (radio_intf_list_ptr, OPC_LISTPOS_HEAD));
					}
				
				/* Free the memory for the list itself	*/
				op_prg_mem_free (radio_intf_list_ptr);
				
				/* In case of a Router running OSPF with all connected interfaces	*/
				/* as unnumbered link interfaces, the router ID is registered as 	*/
				/* local network address. This function initially checks if all the	*/
				/* interfaces of the router are unnumbered and if so gets the 		*/
				/* Router ID from the OSPF model attribute called "Router ID". 		*/
				ip_register_routerid_as_local_netaddr ();
				
				/* Verify that the interface addresses don't overlap. */
				if (intf_unnumbered == OPC_FALSE && !ip_interface_table_verify (interface_table_ptr))
					{
					/* We have multiple IP interfaces that are connected to the	*/
					/* same IP subnet. Issue a warning message.					*/
					ipnl_cfgwarn_intfcfg2 ();
					}
				
				/** At this time, the routing_protos SV has bits set for those	**/
				/** routing protocols that have been "individually" activated	**/
				/** on those interfaces that have been discovered in this node.	**/
				/** For each such routing protocol, the following must now be	**/
				/** done:														**/
				/**		1.	Get a reference to the OMS PR record for the		**/
				/**			routing protocol.									**/	
				/**		2.	Store the result from 1 (above) in the appropriate	**/
				/**			member of the IpT_Cmn_Rte_Table object that			**/
				/**			represents the IP Routing Table for this node.		**/
				/**		3.	Get the parent module object ID of the routing		**/
				/**			protocol process instance in this node and issue	**/
				/**			a remote interrupt to it.							**/
				/**																**/
				/**	NOTE:	Step 3. is not carried out if we are importing the	**/
				/**			routing tables in the simulation. This is determined**/
				/**			by the value to which the global var.				**/
				/**			routing_table_import_export_flag is set.			**/
				/**																**/
				/** All of this is done by the ip_local_dyn_route_protos_invoke	**/
				/** procedure that is invoked below.							**/
				/** The ip_local_dyn_route_protos_invoke procedure takes a list	**/
				/** as an argument, which has the custom routing protocol labels**/
				/** running on this node. For each of the custom routing		**/
				/** protocol label in this list the procedure issues a remote	**/
				/** interrupt.													**/
				
				/* Get the no of active custom routing protocols running on this node.	*/
				active_custom_rte_protos_size = op_prg_list_size (active_custom_rte_proto_label_lptr);
				
				/* If we are not importing our routing tables, "wake up" the	*/
				/* routing protocols configured on this node.					*/
				if ((routing_table_import_export_flag != IP_RTE_TABLE_IMPORT) && 
					(gateway_status == OPC_TRUE) && ((routing_protos != 0) || (active_custom_rte_protos_size != 0)))
					{
					/* The common route table for this node maintains state		*/
					/* about what routing protocols have been set up on this	*/
					/* node. Initialize that info. element appropriately.		*/
					ip_route_table->protocols = routing_protos;
					ip_local_dyn_route_protos_invoke (routing_protos, OPC_TRUE, active_custom_rte_proto_label_lptr);
					}	
				
				/* Else, if we are importing our routing tables, do steps 1		*/
				/* and 2 above but not 3.										*/
				else if ((routing_table_import_export_flag == IP_RTE_TABLE_IMPORT) && 
					(gateway_status == OPC_TRUE) && ((routing_protos != 0) || (active_custom_rte_protos_size != 0)))
					{
					/* The common route table for this node maintains state		*/
					/* about what routing protocols have been set up on this	*/
					/* node. Initialize that info. element appropriately.		*/
					ip_route_table->protocols = routing_protos;
					ip_local_dyn_route_protos_invoke (routing_protos, OPC_FALSE, active_custom_rte_proto_label_lptr);
					}	
				
				/* Check to see if the traffic information model is opened and 	*/
				/* available. This function	is known to be safe against 		*/
				/* multiple calls.												*/
				if (oms_basetraf_tim_open () == OPC_COMPCODE_SUCCESS)
					{
					/* Spawn ip_basetraf_src.  This child process will generate 	*/
					/* tracer packets containing traffic information about          */
					/* src/dest conversation pairs as specified in the TIM file.    */
					/* If this node has no TIM destinations or if there is no 		*/
					/* TIM file, the ip_basetraf_src child process will not have 	*/
					/* any effect.													*/
					/* When we create the child process, we install shared memory,  */
					/* which we will later use to receive a packet from the child.  */
					child_prohandle = op_pro_create ("ip_basetraf_src", ip_ptc_mem_ptr);
					op_pro_invoke (child_prohandle, OPC_NIL);
					
					/* Store the process ID of this child process for later use. It	*/
					/* will be later used to distinguish that a packet came from	*/
					/* basetraf child process (as opposed to ICMP child process.	*/
					ip_basetraf_process_id = op_pro_id (child_prohandle);
					}
				
				}


			/** state (wait) transition processing **/
			FSM_TRANSIT_ONLY ((SELF_NOTIFICATION), 7, state7_enter_exec, ;, "wait")
				/*---------------------------------------------------------*/



			/** state (cmn_rte_tbl) enter executives **/
			FSM_STATE_ENTER_UNFORCED (7, state7_enter_exec, "cmn_rte_tbl", "ip_rte_v4_vc () [cmn_rte_tbl enter execs]")
				{
				/** This state is used to initiate the initial redistribution of routing	**/
				/** information between the routing protocols configured on this router.	**/
				/** This is done via an invocation of the ip_cmn_rte_table_redistribute		**/
				/** function in the exit executives of this state.							**/
				
				/* Schedule a self-interrupt so we can move into the exit executives of		*/
				/* this state.																*/
				op_intrpt_schedule_self (op_sim_time (), 0);
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (15,ip_rte_v4_vc)


			/** state (cmn_rte_tbl) exit executives **/
			FSM_STATE_EXIT_UNFORCED (7, state7_exit_exec, "cmn_rte_tbl", "ip_rte_v4_vc () [cmn_rte_tbl exit execs]")
				{
				/* If the node is set up to be a router, parse the static 		*/
				/* routing table compound attribute and incorporate	those 		*/
				/* entries into the common routing table.						*/
				if ((gateway_status == OPC_TRUE) &&
					(routing_table_import_export_flag != IP_RTE_TABLE_IMPORT))
					{
					op_ima_obj_attr_get (own_id, "static routing table", &static_rte_table_objid);
				
					/* If we are exporting routing table into an external file, create the	*/
					/* file, write header into it and export routing static IP table now.	*/
					/* Also, insert the routing table into IP common routing table.			*/
					if (routing_table_import_export_flag == IP_RTE_TABLE_EXPORT)
						{
						scenario_name = ip_cmn_rte_table_file_create ();
						ip_rte_table_static_table_export (static_rte_table_objid, ip_route_table,
														scenario_name, routing_table_file_ptr, own_id);
						}
				
					/* Parse the static routing table and add any entries		*/
					/* therein to the common routing table.						*/
					ip_rte_table_parse (static_rte_table_objid, ip_route_table);
					}
				
				/* At this stage all the interface information must	*/
				/* have been setup. Check if it is needed to export	*/
				/* this information to an external file.			*/
				if ((iface_addressing_mode == IpC_Iface_Auto_Address_Export) ||
					(iface_addressing_mode == IpC_Iface_Manual_Address_Export))
					{
					ip_iface_address_export (own_node_objid, interface_table_ptr);
					}
				
				/* Initialize ICMP message processing from this node.	*/
				ip_rte_icmp_init ();
				
				/** If the simulation attribute "IP Routing table Export/Import" is set to	**/
				/** "Import" we send a remote interrupt to processes whose routing 			**/
				/** tables are imported from an external file.								**/
				/** Upon receiving the interrupt, the processes will read their routing		**/
				/** tables from the file.													**/
				if ((ip_routing_table_from_file_imported == OPC_FALSE) && 
					(routing_table_import_export_flag == IP_RTE_TABLE_IMPORT))
					{
					/* Now we know that 1/ simulation attribute "IP Routing Table		*/
					/* Export/Import" is set to "Import" and 2/ nobody has read 		*/
					/* the routing table from an external file. We can create a 		*/
					/* list of all routing tables and send interrupts to the 			*/ 
					/* routing processes to tell them where read their routing tables.	*/
				
					/* Mark that routing table has been imported. It will prevent	*/
					/* other routers from reading it and sending interrupts to		*/ 
					/* routing modules.												*/				
					ip_routing_table_from_file_imported = OPC_TRUE;
				
					/* Generate a log message reminding the user that we are 		*/
					/* importing the routing tables from an external file.					*/
					ipnl_rte_table_from_file_log_write ();
				
					/* Read the table and send interrupts to routing processes to 	*/
					/* read it. This is the only process that reads the whole table,*/
					/* all other processes read only their portion of the global 	*/
					/* table.														*/ 
					ip_cmn_rte_table_export_import_intrpt_send ();
					} 
				
				/** At this time, all routing protocols that have been configured on this	**/
				/** router have received and processed the remote-interrupt schedule by IP	**/
				/** in the exit executives of the previous state, i.e. 'wait'. This			**/
				/** constitutes a "Wake up, you have been asked to run on these interfaces."**/
				/** statement from IP. One of the functional elements of each routing		**/
				/** protocol upon receiving this wake-up call is, to add entries for the	**/
				/** networks attached to the interfaces on which they have been set up into **/
				/** the common route table. This initial routing information must be		**/
				/** redistributed among the routing protocols in this node.					**/ 
				
				/* Capture the type of interrupt into this place-holder. It is used in the	*/
				/* Header Block (HB) to define the transition out of here.					*/
				intrpt_type = op_intrpt_type ();
				
				if ((gateway_status == OPC_TRUE) && (routing_table_import_export_flag != IP_RTE_TABLE_IMPORT))
					ip_cmn_rte_table_redistribute (ip_route_table);
				
				/** Based on the model attribute "multicast routing protocol", either PIM-SM**/
				/** or custom multicast child process will be used. If PIM-SM is specified,	**/
				/** standard IGMP model is also used. If custom multicast routing protocol	**/
				/** is specified we do not use standard IGMP and RSVP is disabled.			**/
						
				/* If the model attribute "multicast routing protocol" is set to */
				/* PIM-SM, we will use PIM-SM and the standard IGMP model.		 */
				if (mcast_rte_protocol == IpC_Rte_Pim_Sm)
					{
					/* Create and initialize the IGMP Host or IGMP Router child process	*/
					/* depending on whether this node is a multicast router or not.		*/
					if (multicast_router == OPC_FALSE)
						{
						/** This node is not a multicast router	**/
					
						/* Create and initialize an IGMP Host process	*/
						ip_rte_igmp_host_create_init ();
						}
					else
						{
						/** This node is a multicast router **/
				
						/* Create and initialize a PIM-SM process		*/
						/* Note: Create and Initialize PIM-SM process	*/
						/* before initializing IGMP Router process as	*/
						/* we need to pass the process handle of PIM-SM	*/
						/* process to IGMP Router process				*/
						ip_rte_pim_sm_create_init ();
				
						/* Create and initialize an IGMP Router process	*/
						/* for each multicast enabled IP interface		*/
						ip_rte_igmp_rte_intf_create_init ();			
						}
				
					/* Register the default multicast addresses for each	*/
					/* IP interface which is enabled for multicast			*/
					ip_rte_default_mcast_addr_register ();
					}
				else
					{
					/* Custom multicast routing protocol is specified.	*/
					if (multicast_router == OPC_TRUE)
						{
						/** This node is a multicast router. **/
						
						/* Create and initialize "ip_custom_mrp" process.*/
						ip_rte_custom_mrp_create_init ();
						}
				
				    /* Custom multicasting is being used. Set the rsvp_status*/
					/* to OPC_FALSE so that RSVP is disabled.				 */
					rsvp_status = OPC_FALSE;		
					}
				
				if (rsvp_status == OPC_TRUE)
					{
					/** RSVP is enabled on the node.	*/
				
					/* Send a remote interrupt to RSVP process. Upon receiving this	*/
					/* notification, RSVP will finish its initialization process.	*/
					/* It is important that this interrupt is received after 		*/
					/* IP PIM process registers itself in the process registry,		*/
					/* because RSVP will try to get a pointer to IP PIM routing		*/
					/* table.														*/
					/* However, if there is no RSVP module, the function does not	*/
					/* send an interrupt to RSVP, and it sets its status to FALSE.	*/
					ip_rte_rsvp_init_notify ();
					}
				
				}


			/** state (cmn_rte_tbl) transition processing **/
			FSM_TRANSIT_ONLY ((SELF_NOTIFICATION), 5, state5_enter_exec, ;, "cmn_rte_tbl")
				/*---------------------------------------------------------*/



			/** state (MCAST_RSVP) enter executives **/
			FSM_STATE_ENTER_FORCED (8, state8_enter_exec, "MCAST_RSVP", "ip_rte_v4_vc () [MCAST_RSVP enter execs]")
				{
				/** A Join/Leave from an application, or RSVP request 	**/
				/** to modify queue parameters has been received.		**/
				/** If this is a  multicast request,	 				**/
				/** registers/deregisters the multicast	address and 	**/
				/** invokes the IGMP host (child) process, so that it 	**/
				/** can send an IGMP Report/Leave message to the 		**/
				/** multicast routers									**/ 
				/** If this is an RSVP request, forward the request to	**/
				/** the appropriate interface process.					**/
				
				/* Get the ICI associated with the interrupt	*/
				ici_ptr = op_intrpt_ici ();
				
				/* Find whether this is a multicast or an RSVP ICI.	*/
				op_ici_attr_get (ici_ptr, "type", &ici_type);
				
				if (ici_type == IpC_Rte_Mcast_Ici)
					{
					if (mcast_rte_protocol != IpC_Rte_Pim_Sm)
						{
						/* Custom multicast routing protocol is being used.	*/
						/* A Join/Leave request can not be sent, as standard*/
						/* IGMP is disabled. Generate a log message and		*/
						/* ignore the Join/Leave request.					*/
						ipnl_protwarn_mcast_custom_invalid_application_req ();
						}
					else
						{
						/** This is a multicast request and PIM-SM is the multicast routing protocol.				**/
						/** Obtain the information provided in the ICI and store it in the parent-to-child memory 	**/
				
						/* Obtain the value of "multicast_major_port" attribute */
						op_ici_attr_get (ici_ptr, "multicast_major_port", &(ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port));
				
						/* Obtain the value of "multicast_group_address" attribute */
						op_ici_attr_get (ici_ptr, "multicast_group_address", &(ip_ptc_mem_ptr->ip_igmp_ptc_info.ip_grp_addr));
				
						/* Obtain the value of "type" attribute */
						op_ici_attr_get (ici_ptr, "mcast_type", &(ip_ptc_mem_ptr->ip_igmp_ptc_info.type));
				
						/* Check if this node is a multicast router	*/
						if (multicast_router == OPC_TRUE)
							{
							/** This node is a multicast router	**/
				
							/* Report a log message and ignore the Join/Leave request	*/
							ip_address_print (ip_addr_str, ip_ptc_mem_ptr->ip_igmp_ptc_info.ip_grp_addr);
							ipnl_protwarn_mcast_rte_cannot_join_leave_grp (ip_addr_str, ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port);
							}
						else
							{
							/** This node is not a multicast router	**/
				
							/* Check the type of request */
							switch (ip_ptc_mem_ptr->ip_igmp_ptc_info.type)
								{
								case IpC_Igmp_Host_Join_Req:
									{
									/** A Join request has been received from an application	**/
						
									/* Only if the interface on which the application wants to join	*/
									/* the IP group is multicast enabled, register it				*/
									if (ip_rte_intf_mcast_enabled (ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port) == OPC_TRUE)
										{
										/** Multicast is enabled on the interface	**/
				
										/* Register the IP group address on the interface	*/
										Ip_Address_Multicast_Register (ip_ptc_mem_ptr->ip_igmp_ptc_info.ip_grp_addr, 
												ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port, op_topo_parent (own_id));
				
										/* Invoke the IGMP Host process, so that it can send	*/
										/* an IGMP Report message to the multicast routers		*/
										op_pro_invoke (igmp_host_process_handle, OPC_NIL);
										}
									else
										{
										/** The interface number is either invalid or multicast is disabled	**/
				
										/* Report a log message and ignore the request	*/
										ipnl_protwarn_mcast_invalid_intf (ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port);
										}			
				
									break;	
									}
				
								case IpC_Igmp_Host_Leave_Req:
									{
									/** A Leave request has been received from an application	**/
				
									/* The group address is registered on the interface only if the interface	*/
									/* is enabled for multicast. So, do the deregistration only if multicast is	*/
									/* is enabled on the interface												*/
									if (ip_rte_intf_mcast_enabled (ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port) == OPC_TRUE)
										{
										/* Deregister the IP group address on the interface	*/
										Ip_Address_Multicast_Deregister (ip_ptc_mem_ptr->ip_igmp_ptc_info.ip_grp_addr, 
												ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port, op_topo_parent (own_id));
				
										/* Invoke the IGMP Host process, so that it can send	*/
										/* an IGMP Leave message to the multicast routers		*/
										op_pro_invoke (igmp_host_process_handle, OPC_NIL);
										}
									else
										{
										/* Report a log message and ignore the request	*/
										ipnl_protwarn_mcast_invalid_intf (ip_ptc_mem_ptr->ip_igmp_ptc_info.major_port);
										}
				
									break;
									}
				
								default:
									{
									/** An invalid request has been received	**/
				
									/* Report a log message and ignore the request */
									ipnl_protwarn_mcast_invalid_application_req ();
				
									break;
									}
								}
							}
				    	}
				
					/* Destroy the ICI */
					op_ici_destroy (ici_ptr);
					}
				else
					{
					/** This request was sent from RSVP.	**/
				
					/* Get the interface index from the ICI.	*/
					op_ici_attr_get (ici_ptr, "RSVP Traffic Control Request", &ici_data_struct_ptr);
				
					/* Find the process handle of the interface process.	*/
					intf_phandle = ip_rtab_phandle_from_intf_get (ici_data_struct_ptr);
				
					/* Set a pointer to the ICI data structure in the module shared memory.	*/
					/* This memory will be accessed by the interface process to get the 	*/
					/* request parameters.													*/
					shared_mem_ptr->rsvp_request_ptr = ici_data_struct_ptr;
				
					/* Invoke the interface traffic control process.	*/
					op_pro_invoke (intf_phandle, OPC_NIL);
					}
				
				}


			/** state (MCAST_RSVP) exit executives **/
			FSM_STATE_EXIT_FORCED (8, state8_exit_exec, "MCAST_RSVP", "ip_rte_v4_vc () [MCAST_RSVP exit execs]")
				{
				}


			/** state (MCAST_RSVP) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (4,ip_rte_v4_vc)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
ip_rte_v4_vc_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (ip_rte_v4_vc_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (ip_rte_v4_vc)",
			sizeof (ip_rte_v4_vc_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((ip_rte_v4_vc_state *)(*gen_state_pptr))->current_block = 8;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
ip_rte_v4_vc_diag (void)
	{
	int _block_origin = __LINE__;

	FIN (ip_rte_v4_vc_diag ())

	if (1)
		{
		int						iface_id;
		IpT_Dgram_Fields*		pk_fd_ptr;
		double          		pk_svc_time;
		int             		insert_ok;
		int						instrm;
		int 					slot_index = -1;
		int						inslot = -1, outslot = -1;
		double					iface_data_rate;
		int						packet_size;
		int						scheme = 0;
		int						status = -1;
		Compcode				return_status = OPC_COMPCODE_FAILURE;
		int						pkt_id, pkt_tree_id;
		Ici*					pk_ici_ptr = OPC_NIL;
		int						outstrm = IP_OUTSTRM_INVALID;
		int						mtu = -1;
		int						i, frag, frag_accum, num_frags, k, instrm_index;
		int						frag_size, data_size, len;
		int						header_size, ttl;
		char					str0 [512], str1 [512];
		Packet					*pkptr, *ip_pkptr, *frag_ptr, *pkcopy;
		Packet					*data_pkptr;
		int						num_output_streams, num_input_streams;
		int						instrm_ip_addr_index;
		Objid					strm_objid, ip_encap_objid, instrm_objid;
		IpT_Interface_Info*		iface_info_ptr;
		IpT_Interface_Info*		bcast_iface_info_ptr;
		IpT_Interface_Info*		input_intf_info_ptr;
		IpT_Interface_Info*		temp_iface_info_ptr;
		IpT_Interface_Info*		interface_ptr = OPC_NIL;
		OmsT_Dv_Slot_Info*		slot_info_ptr;
		Objid					slot_info_objid;
		Objid					node_objid;
		Ici*					rip_iciptr;
		Ici*					rsvp_ici_ptr = OPC_NIL;
		Ici*					mcast_ici_ptr;
		int						ip_fast_addr = -1;
		Boolean					broadcast_mode, entry_included;
		List*					proc_record_handle_list_ptr;
		int						record_handle_list_size;
		OmsT_Pr_Handle			process_record_handle;
		Compcode				route_status;
		Evhandle				evh;
		Boolean					ip_dest_local_network;
		int						rip_rte_table_size;
		Objid					iface_description_objid;
		Objid					line_objid;
		Objid					link_objid;
		char					dyn_route [512];
		int						conn_class;
		int						proto_num;
		char					ip_packet_format [256];
		char					ip_addr_str [IPC_ADDR_STR_LEN];
		char					subnet_mask_str [IPC_ADDR_STR_LEN];
		IpT_Address				ip_addr;
		IpT_Address				subnet_mask_addr;
		IpT_Address				dest_addr;
		IpT_Address				next_addr = IPC_ADDR_INVALID;
		Boolean					broadcast = OPC_FALSE;
		Boolean					higher_layer = OPC_FALSE;
		Boolean					destroy_pkt = OPC_FALSE;
		Boolean					in_port_found;
		char					dest_addr_str [IPC_ADDR_STR_LEN];
		Objid					static_rte_table_objid, routing_entry_objid;
		Ici*					intf_ici_ptr = OPC_NIL;
		Ici*					ici_ptr;
		int						mcast_major_port = 0;
		int 					mcast_minor_port = 0;
		char					ici_format_str [128];
		char					trace_msg [128];
		char					intf_addr_str [IPC_ADDR_STR_LEN];
		Boolean					broadcast_addr = OPC_FALSE;
		int						broadcast_intf_index = OPC_INT_INVALID;
		int						intf_num;
		char					strm_name [128];
		int						iface_table_size;
		char					error_string [512];
		char					default_gtwy_str [IPC_ADDR_STR_LEN];
		IpT_Address				intf_addr;
		IpT_Interface_Type		interface_type = IpC_Intf_Type_Unspec;
		double 					interface_speed = OPC_DBL_INFINITY;
		Objid					creation_node_objid;
		Boolean					force_fwd = OPC_FALSE;
		int						pkt_dest_type;
		int						invoke_mode;
		IpT_Compression_Info*	data;
		char					comp_info_str [256];
		double					decomp_delay = 0.0;
		double					comp_delay = 0.0;
		double					comp_decomp_delay = 0.0;
		int						output_intf_index = -1;
		Boolean					decompress = OPC_FALSE;
		char*					scenario_name;
		Boolean					multicast_enabled;
		
		/* Variable to keep track of we are processing a packet	*/
		/* from any of the child process models.				*/
		Prohandle				child_prohandle;
		Boolean					pk_from_child_process = OPC_FALSE;
		
		/* Delay servicing a packet due to the background 		*/
		/* utilization of one of the servers.					*/
		double					bgutil_delay;
		
		int						intrpt_type = -1;
		double					current_time = 0.0;
		
		/* Delay introduced to a forwarded packet by the proxy  */
		/* server if the node is configured as a firewall.		*/
		double					proxy_delay = 0.0;
		
		/* Flag to track whether any ip addresses have been		*/
		/* created on this node.								*/
		Boolean					ip_addr_created;
		
		/* Placeholder for value of "routing protocol" column	*/
		/* of a row in the "ip addr info" compound attribute.	*/
		int						rte_protocol;
		int						routing_proto;
		
		/* ICMP packets are handled differently by IP. Keep a	*/
		/* variable to track the kind of encapsulated packet in	*/
		/* the IP datagram.										*/
		Boolean					dgram_encapsulates_icmp_pkt = OPC_FALSE;
		
		/* IP datagrams maintain an ICI to record information	*/
		/* required for proper routing (e.g., slot on which the	*/
		/* datagram arrived, output interface on which it		*/
		/* should be forwarded, etc.) -- all that information	*/
		/* is stored in a single structure field of the			*/
		/* ip_rte_ind_v4 ICI.									*/
		IpT_Rte_Ind_Ici_Fields*		intf_ici_fdstruct_ptr = OPC_NIL;
		
		/* Store the packet latency for the ipcloud node		*/
		double					pkt_latency;
		
		/* store the random number between zero and one			*/
		double					test_outcome;
		
		/* Store information about unnumbered interface in the	*/
		/* local variable to be copied finally into the 		*/
		/* interface table.										*/
		int 					intf_unnumbered = OPC_FALSE;
		int						size;
		int						intf_table_size = 0;
		int						unnumbered_size = 0;
		int						index;
		
		Boolean					ip_rte_trace;
		
		Boolean					car_packet_drop = OPC_FALSE;
		IpT_Rte_App_Ici_Type	ici_type;
		RsvpT_TC_Ici_Struct *	ici_data_struct_ptr;
		Prohandle				intf_phandle;
		
		/* Temporary variables used for invoking custom routing	*/
		/* protocols. Labels of the custom routing protocols	*/
		/* active in this node are maintained in a list, which	*/
		/* is freed after the custom routing protocols are		*/
		/* invoked.												*/
		List*					active_custom_rte_proto_label_lptr;
		char					rte_protocol_label [256];
		char*					custom_rte_protocol_label_ptr;
		int 					low_index, high_index;
		int						active_custom_rte_protos_size;
		
		Ici*					iciptr;
		int						minor_port_in;
		int 					minor_port_out = IPC_MINOR_PORT_DEFAULT;
		

		/* Diagnostic Block */


		BINIT
		if (is_ip_initialized == OPC_FALSE)
			{
			printf ("\t\t***************************************************************\n");
			printf ("\t\t* The IP process in this node has not been intialized.        *\n");
			printf ("\t\t* Any process has to receive atleast its \"BEGSIM\" interrupt   *\n");
			printf ("\t\t* before it can be queried.								   *\n");
			printf ("\t\t***************************************************************\n");
			}
		else
			{
			if (op_prg_odb_ltrace_active ("ip_frag"))
				{
				ip_frag_sup_print (dgram_list_ptr);
				}	
		
			if (op_prg_odb_ltrace_active ("global_table"))
				{
				ip_rtab_print ();
				}
		
			if (op_prg_odb_ltrace_active ("global_ip_networks"))
				{
				ip_networks_print ();
				}
		
			if (op_prg_odb_ltrace_active ("ip_rte_table"))
				{
				ip_cmn_rte_table_print (ip_route_table);
				}
		
			if (op_prg_odb_ltrace_active ("ip_interfaces"))
				{
				ip_interface_table_print (interface_table_ptr);
				}
		
			if (op_prg_odb_ltrace_active ("ip_rte_slot"))
				{
				oms_dv_slot_table_print (slot_table_ptr);
				oms_dv_iface_slot_map_print (slot_iface_map_lptr, num_interfaces);
				}
		
			if (op_prg_odb_ltrace_active ("car"))
				{
				ip_rte_car_information_print ();
				}
			}

		/* End of Diagnostic Block */

		}

	FOUT;
	}




void
ip_rte_v4_vc_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (ip_rte_v4_vc_terminate (void))

	if (1)
		{
		int						iface_id;
		IpT_Dgram_Fields*		pk_fd_ptr;
		double          		pk_svc_time;
		int             		insert_ok;
		int						instrm;
		int 					slot_index = -1;
		int						inslot = -1, outslot = -1;
		double					iface_data_rate;
		int						packet_size;
		int						scheme = 0;
		int						status = -1;
		Compcode				return_status = OPC_COMPCODE_FAILURE;
		int						pkt_id, pkt_tree_id;
		Ici*					pk_ici_ptr = OPC_NIL;
		int						outstrm = IP_OUTSTRM_INVALID;
		int						mtu = -1;
		int						i, frag, frag_accum, num_frags, k, instrm_index;
		int						frag_size, data_size, len;
		int						header_size, ttl;
		char					str0 [512], str1 [512];
		Packet					*pkptr, *ip_pkptr, *frag_ptr, *pkcopy;
		Packet					*data_pkptr;
		int						num_output_streams, num_input_streams;
		int						instrm_ip_addr_index;
		Objid					strm_objid, ip_encap_objid, instrm_objid;
		IpT_Interface_Info*		iface_info_ptr;
		IpT_Interface_Info*		bcast_iface_info_ptr;
		IpT_Interface_Info*		input_intf_info_ptr;
		IpT_Interface_Info*		temp_iface_info_ptr;
		IpT_Interface_Info*		interface_ptr = OPC_NIL;
		OmsT_Dv_Slot_Info*		slot_info_ptr;
		Objid					slot_info_objid;
		Objid					node_objid;
		Ici*					rip_iciptr;
		Ici*					rsvp_ici_ptr = OPC_NIL;
		Ici*					mcast_ici_ptr;
		int						ip_fast_addr = -1;
		Boolean					broadcast_mode, entry_included;
		List*					proc_record_handle_list_ptr;
		int						record_handle_list_size;
		OmsT_Pr_Handle			process_record_handle;
		Compcode				route_status;
		Evhandle				evh;
		Boolean					ip_dest_local_network;
		int						rip_rte_table_size;
		Objid					iface_description_objid;
		Objid					line_objid;
		Objid					link_objid;
		char					dyn_route [512];
		int						conn_class;
		int						proto_num;
		char					ip_packet_format [256];
		char					ip_addr_str [IPC_ADDR_STR_LEN];
		char					subnet_mask_str [IPC_ADDR_STR_LEN];
		IpT_Address				ip_addr;
		IpT_Address				subnet_mask_addr;
		IpT_Address				dest_addr;
		IpT_Address				next_addr = IPC_ADDR_INVALID;
		Boolean					broadcast = OPC_FALSE;
		Boolean					higher_layer = OPC_FALSE;
		Boolean					destroy_pkt = OPC_FALSE;
		Boolean					in_port_found;
		char					dest_addr_str [IPC_ADDR_STR_LEN];
		Objid					static_rte_table_objid, routing_entry_objid;
		Ici*					intf_ici_ptr = OPC_NIL;
		Ici*					ici_ptr;
		int						mcast_major_port = 0;
		int 					mcast_minor_port = 0;
		char					ici_format_str [128];
		char					trace_msg [128];
		char					intf_addr_str [IPC_ADDR_STR_LEN];
		Boolean					broadcast_addr = OPC_FALSE;
		int						broadcast_intf_index = OPC_INT_INVALID;
		int						intf_num;
		char					strm_name [128];
		int						iface_table_size;
		char					error_string [512];
		char					default_gtwy_str [IPC_ADDR_STR_LEN];
		IpT_Address				intf_addr;
		IpT_Interface_Type		interface_type = IpC_Intf_Type_Unspec;
		double 					interface_speed = OPC_DBL_INFINITY;
		Objid					creation_node_objid;
		Boolean					force_fwd = OPC_FALSE;
		int						pkt_dest_type;
		int						invoke_mode;
		IpT_Compression_Info*	data;
		char					comp_info_str [256];
		double					decomp_delay = 0.0;
		double					comp_delay = 0.0;
		double					comp_decomp_delay = 0.0;
		int						output_intf_index = -1;
		Boolean					decompress = OPC_FALSE;
		char*					scenario_name;
		Boolean					multicast_enabled;
		
		/* Variable to keep track of we are processing a packet	*/
		/* from any of the child process models.				*/
		Prohandle				child_prohandle;
		Boolean					pk_from_child_process = OPC_FALSE;
		
		/* Delay servicing a packet due to the background 		*/
		/* utilization of one of the servers.					*/
		double					bgutil_delay;
		
		int						intrpt_type = -1;
		double					current_time = 0.0;
		
		/* Delay introduced to a forwarded packet by the proxy  */
		/* server if the node is configured as a firewall.		*/
		double					proxy_delay = 0.0;
		
		/* Flag to track whether any ip addresses have been		*/
		/* created on this node.								*/
		Boolean					ip_addr_created;
		
		/* Placeholder for value of "routing protocol" column	*/
		/* of a row in the "ip addr info" compound attribute.	*/
		int						rte_protocol;
		int						routing_proto;
		
		/* ICMP packets are handled differently by IP. Keep a	*/
		/* variable to track the kind of encapsulated packet in	*/
		/* the IP datagram.										*/
		Boolean					dgram_encapsulates_icmp_pkt = OPC_FALSE;
		
		/* IP datagrams maintain an ICI to record information	*/
		/* required for proper routing (e.g., slot on which the	*/
		/* datagram arrived, output interface on which it		*/
		/* should be forwarded, etc.) -- all that information	*/
		/* is stored in a single structure field of the			*/
		/* ip_rte_ind_v4 ICI.									*/
		IpT_Rte_Ind_Ici_Fields*		intf_ici_fdstruct_ptr = OPC_NIL;
		
		/* Store the packet latency for the ipcloud node		*/
		double					pkt_latency;
		
		/* store the random number between zero and one			*/
		double					test_outcome;
		
		/* Store information about unnumbered interface in the	*/
		/* local variable to be copied finally into the 		*/
		/* interface table.										*/
		int 					intf_unnumbered = OPC_FALSE;
		int						size;
		int						intf_table_size = 0;
		int						unnumbered_size = 0;
		int						index;
		
		Boolean					ip_rte_trace;
		
		Boolean					car_packet_drop = OPC_FALSE;
		IpT_Rte_App_Ici_Type	ici_type;
		RsvpT_TC_Ici_Struct *	ici_data_struct_ptr;
		Prohandle				intf_phandle;
		
		/* Temporary variables used for invoking custom routing	*/
		/* protocols. Labels of the custom routing protocols	*/
		/* active in this node are maintained in a list, which	*/
		/* is freed after the custom routing protocols are		*/
		/* invoked.												*/
		List*					active_custom_rte_proto_label_lptr;
		char					rte_protocol_label [256];
		char*					custom_rte_protocol_label_ptr;
		int 					low_index, high_index;
		int						active_custom_rte_protos_size;
		
		Ici*					iciptr;
		int						minor_port_in;
		int 					minor_port_out = IPC_MINOR_PORT_DEFAULT;
		

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in ip_rte_v4_vc_svar function. */
#undef is_ip_initialized
#undef shared_mem_ptr
#undef child_ptr
#undef queue_empty
#undef cpu_code
#undef num_interfaces
#undef service_rate
#undef own_id
#undef arp_iciptr
#undef dgram_list_ptr
#undef default_ttl
#undef interface_table_ptr
#undef radio_intf_list_ptr
#undef slot_table_ptr
#undef ip_info_ptr
#undef dynamic_routing_enabled
#undef ip_route_table
#undef link_iface_table_ptr
#undef own_node_objid
#undef own_prohandle
#undef own_process_record_handle
#undef proc_model_name
#undef instrm_from_ip_encap
#undef outstrm_to_ip_encap
#undef gateway_status
#undef gateway_known
#undef next_addr_gateway
#undef comp_attr_objid
#undef subnet_objid
#undef interface_table_size
#undef mcast_addr_list_ptr
#undef do_bgutil
#undef bgutil_routed_state_ptr
#undef received_bgutil_routed_state_ptr
#undef sent_bgutil_routed_state_ptr
#undef received_last_stat_update_time
#undef sent_last_stat_update_time
#undef ip_ptc_mem_ptr
#undef default_gtwy_addr
#undef default_gtwy_available
#undef slot_count
#undef server_status
#undef central_server_status
#undef processing_scheme
#undef slot_iface_map_lptr
#undef local_utilization_stathandle
#undef locl_tot_pkts_sent_hndl
#undef locl_num_mcasts_sent_hndl
#undef locl_num_bcasts_sent_hndl
#undef locl_tot_pkts_rcvd_hndl
#undef locl_num_mcasts_rcvd_hndl
#undef locl_num_bcasts_rcvd_hndl
#undef locl_num_pkts_dropped_hndl
#undef locl_tot_pkts_sent
#undef locl_num_mcasts_sent
#undef locl_num_bcasts_sent
#undef locl_tot_pkts_rcvd
#undef locl_num_mcasts_rcvd
#undef locl_num_bcasts_rcvd
#undef locl_num_pkts_dropped
#undef globl_num_pkts_dropped_hndl
#undef globl_num_pkts_dropped
#undef ip_rte_pkt_latency_stathandle
#undef routing_protos
#undef globl_tracer_ete_delay_hndl
#undef local_tracer_in_ete_hndl
#undef dgram_compressed_size
#undef iface_addressing_mode
#undef within_lan_node
#undef ip_icmp_process_id
#undef icmp_process_handle
#undef ip_basetraf_process_id
#undef dgram_id
#undef routing_table_file_ptr
#undef tcpip_header_comp_info_ptr
#undef per_interface_comp_info_ptr
#undef per_virtual_circuit_comp_info_ptr
#undef firewall_flag
#undef proxy_info_table_lptr
#undef ipcloud_flag
#undef port_last_txn_end_time
#undef packet_discard_probability
#undef packet_latency_dist_handle
#undef local_pkt_latency_stat
#undef router_id_assigned
#undef unnumbered_interface_exists
#undef igmp_host_process_handle
#undef multicast_router
#undef pim_sm_process_handle
#undef car_incoming_profile_ptr
#undef car_incoming_info_ptr
#undef car_outgoing_profile_ptr
#undef car_outgoing_info_ptr
#undef car_stat_info_ptr
#undef custom_mrp_process_handle
#undef mcast_rte_protocol
#undef rsvp_status
#undef node_is_cache_server



void
ip_rte_v4_vc_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	ip_rte_v4_vc_state		*prs_ptr;

	FIN (ip_rte_v4_vc_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT;
		}
	prs_ptr = (ip_rte_v4_vc_state *)gen_ptr;

	if (strcmp ("is_ip_initialized" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->is_ip_initialized);
		FOUT;
		}
	if (strcmp ("shared_mem_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->shared_mem_ptr);
		FOUT;
		}
	if (strcmp ("child_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->child_ptr);
		FOUT;
		}
	if (strcmp ("queue_empty" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->queue_empty);
		FOUT;
		}
	if (strcmp ("cpu_code" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->cpu_code);
		FOUT;
		}
	if (strcmp ("num_interfaces" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->num_interfaces);
		FOUT;
		}
	if (strcmp ("service_rate" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->service_rate);
		FOUT;
		}
	if (strcmp ("own_id" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->own_id);
		FOUT;
		}
	if (strcmp ("arp_iciptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->arp_iciptr);
		FOUT;
		}
	if (strcmp ("dgram_list_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->dgram_list_ptr);
		FOUT;
		}
	if (strcmp ("default_ttl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->default_ttl);
		FOUT;
		}
	if (strcmp ("interface_table_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->interface_table_ptr);
		FOUT;
		}
	if (strcmp ("radio_intf_list_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->radio_intf_list_ptr);
		FOUT;
		}
	if (strcmp ("slot_table_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->slot_table_ptr);
		FOUT;
		}
	if (strcmp ("ip_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_info_ptr);
		FOUT;
		}
	if (strcmp ("dynamic_routing_enabled" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->dynamic_routing_enabled);
		FOUT;
		}
	if (strcmp ("ip_route_table" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_route_table);
		FOUT;
		}
	if (strcmp ("link_iface_table_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->link_iface_table_ptr);
		FOUT;
		}
	if (strcmp ("own_node_objid" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->own_node_objid);
		FOUT;
		}
	if (strcmp ("own_prohandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->own_prohandle);
		FOUT;
		}
	if (strcmp ("own_process_record_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->own_process_record_handle);
		FOUT;
		}
	if (strcmp ("proc_model_name" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->proc_model_name);
		FOUT;
		}
	if (strcmp ("instrm_from_ip_encap" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->instrm_from_ip_encap);
		FOUT;
		}
	if (strcmp ("outstrm_to_ip_encap" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->outstrm_to_ip_encap);
		FOUT;
		}
	if (strcmp ("gateway_status" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->gateway_status);
		FOUT;
		}
	if (strcmp ("gateway_known" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->gateway_known);
		FOUT;
		}
	if (strcmp ("next_addr_gateway" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->next_addr_gateway);
		FOUT;
		}
	if (strcmp ("comp_attr_objid" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->comp_attr_objid);
		FOUT;
		}
	if (strcmp ("subnet_objid" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->subnet_objid);
		FOUT;
		}
	if (strcmp ("interface_table_size" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->interface_table_size);
		FOUT;
		}
	if (strcmp ("mcast_addr_list_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->mcast_addr_list_ptr);
		FOUT;
		}
	if (strcmp ("do_bgutil" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->do_bgutil);
		FOUT;
		}
	if (strcmp ("bgutil_routed_state_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->bgutil_routed_state_ptr);
		FOUT;
		}
	if (strcmp ("received_bgutil_routed_state_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->received_bgutil_routed_state_ptr);
		FOUT;
		}
	if (strcmp ("sent_bgutil_routed_state_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->sent_bgutil_routed_state_ptr);
		FOUT;
		}
	if (strcmp ("received_last_stat_update_time" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->received_last_stat_update_time);
		FOUT;
		}
	if (strcmp ("sent_last_stat_update_time" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->sent_last_stat_update_time);
		FOUT;
		}
	if (strcmp ("ip_ptc_mem_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_ptc_mem_ptr);
		FOUT;
		}
	if (strcmp ("default_gtwy_addr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->default_gtwy_addr);
		FOUT;
		}
	if (strcmp ("default_gtwy_available" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->default_gtwy_available);
		FOUT;
		}
	if (strcmp ("slot_count" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->slot_count);
		FOUT;
		}
	if (strcmp ("server_status" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->server_status);
		FOUT;
		}
	if (strcmp ("central_server_status" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->central_server_status);
		FOUT;
		}
	if (strcmp ("processing_scheme" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->processing_scheme);
		FOUT;
		}
	if (strcmp ("slot_iface_map_lptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->slot_iface_map_lptr);
		FOUT;
		}
	if (strcmp ("local_utilization_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->local_utilization_stathandle);
		FOUT;
		}
	if (strcmp ("locl_tot_pkts_sent_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_tot_pkts_sent_hndl);
		FOUT;
		}
	if (strcmp ("locl_num_mcasts_sent_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_mcasts_sent_hndl);
		FOUT;
		}
	if (strcmp ("locl_num_bcasts_sent_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_bcasts_sent_hndl);
		FOUT;
		}
	if (strcmp ("locl_tot_pkts_rcvd_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_tot_pkts_rcvd_hndl);
		FOUT;
		}
	if (strcmp ("locl_num_mcasts_rcvd_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_mcasts_rcvd_hndl);
		FOUT;
		}
	if (strcmp ("locl_num_bcasts_rcvd_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_bcasts_rcvd_hndl);
		FOUT;
		}
	if (strcmp ("locl_num_pkts_dropped_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_pkts_dropped_hndl);
		FOUT;
		}
	if (strcmp ("locl_tot_pkts_sent" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_tot_pkts_sent);
		FOUT;
		}
	if (strcmp ("locl_num_mcasts_sent" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_mcasts_sent);
		FOUT;
		}
	if (strcmp ("locl_num_bcasts_sent" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_bcasts_sent);
		FOUT;
		}
	if (strcmp ("locl_tot_pkts_rcvd" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_tot_pkts_rcvd);
		FOUT;
		}
	if (strcmp ("locl_num_mcasts_rcvd" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_mcasts_rcvd);
		FOUT;
		}
	if (strcmp ("locl_num_bcasts_rcvd" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_bcasts_rcvd);
		FOUT;
		}
	if (strcmp ("locl_num_pkts_dropped" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->locl_num_pkts_dropped);
		FOUT;
		}
	if (strcmp ("globl_num_pkts_dropped_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->globl_num_pkts_dropped_hndl);
		FOUT;
		}
	if (strcmp ("globl_num_pkts_dropped" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->globl_num_pkts_dropped);
		FOUT;
		}
	if (strcmp ("ip_rte_pkt_latency_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_rte_pkt_latency_stathandle);
		FOUT;
		}
	if (strcmp ("routing_protos" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->routing_protos);
		FOUT;
		}
	if (strcmp ("globl_tracer_ete_delay_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->globl_tracer_ete_delay_hndl);
		FOUT;
		}
	if (strcmp ("local_tracer_in_ete_hndl" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->local_tracer_in_ete_hndl);
		FOUT;
		}
	if (strcmp ("dgram_compressed_size" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->dgram_compressed_size);
		FOUT;
		}
	if (strcmp ("iface_addressing_mode" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->iface_addressing_mode);
		FOUT;
		}
	if (strcmp ("within_lan_node" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->within_lan_node);
		FOUT;
		}
	if (strcmp ("ip_icmp_process_id" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_icmp_process_id);
		FOUT;
		}
	if (strcmp ("icmp_process_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->icmp_process_handle);
		FOUT;
		}
	if (strcmp ("ip_basetraf_process_id" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->ip_basetraf_process_id);
		FOUT;
		}
	if (strcmp ("dgram_id" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->dgram_id);
		FOUT;
		}
	if (strcmp ("routing_table_file_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->routing_table_file_ptr);
		FOUT;
		}
	if (strcmp ("tcpip_header_comp_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->tcpip_header_comp_info_ptr);
		FOUT;
		}
	if (strcmp ("per_interface_comp_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->per_interface_comp_info_ptr);
		FOUT;
		}
	if (strcmp ("per_virtual_circuit_comp_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->per_virtual_circuit_comp_info_ptr);
		FOUT;
		}
	if (strcmp ("firewall_flag" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->firewall_flag);
		FOUT;
		}
	if (strcmp ("proxy_info_table_lptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->proxy_info_table_lptr);
		FOUT;
		}
	if (strcmp ("ipcloud_flag" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->ipcloud_flag);
		FOUT;
		}
	if (strcmp ("port_last_txn_end_time" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->port_last_txn_end_time);
		FOUT;
		}
	if (strcmp ("packet_discard_probability" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->packet_discard_probability);
		FOUT;
		}
	if (strcmp ("packet_latency_dist_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->packet_latency_dist_handle);
		FOUT;
		}
	if (strcmp ("local_pkt_latency_stat" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->local_pkt_latency_stat);
		FOUT;
		}
	if (strcmp ("router_id_assigned" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->router_id_assigned);
		FOUT;
		}
	if (strcmp ("unnumbered_interface_exists" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->unnumbered_interface_exists);
		FOUT;
		}
	if (strcmp ("igmp_host_process_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->igmp_host_process_handle);
		FOUT;
		}
	if (strcmp ("multicast_router" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->multicast_router);
		FOUT;
		}
	if (strcmp ("pim_sm_process_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->pim_sm_process_handle);
		FOUT;
		}
	if (strcmp ("car_incoming_profile_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->car_incoming_profile_ptr);
		FOUT;
		}
	if (strcmp ("car_incoming_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->car_incoming_info_ptr);
		FOUT;
		}
	if (strcmp ("car_outgoing_profile_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->car_outgoing_profile_ptr);
		FOUT;
		}
	if (strcmp ("car_outgoing_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->car_outgoing_info_ptr);
		FOUT;
		}
	if (strcmp ("car_stat_info_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->car_stat_info_ptr);
		FOUT;
		}
	if (strcmp ("custom_mrp_process_handle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->custom_mrp_process_handle);
		FOUT;
		}
	if (strcmp ("mcast_rte_protocol" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->mcast_rte_protocol);
		FOUT;
		}
	if (strcmp ("rsvp_status" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rsvp_status);
		FOUT;
		}
	if (strcmp ("node_is_cache_server" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->node_is_cache_server);
		FOUT;
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT;
	}
